
/***********************************************************************
 *                                                                     *
 *                             Widget Demo                             *
 *                                                                     *
 ***********************************************************************
   Demonstration of various widgets.
 ***********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <stdarg.h>
#include "gfx.h"
#include "../png/pngio.h"

#define SCR_W     800
#define SCR_H     600
#define BUT_W_BIG 120
#define BUT_W_SMA 80
#define BUT_H     30
#define PAD       10
#define SCR_BG    0xededed

  // actions
enum { 
  AC_BACK= GFXEV_LAST+1, 
  AC_DEMO_MENU,
    AC_MENU1,
    AC_MENU2,
  AC_DEMO_SCROLL,
    AC_SCROLL_HORZ,
    AC_SCROLL_VERT,
  AC_DEMO_LIST,
    AC_LIST1,
    AC_LIST_DELETE,
    AC_LIST_INSERT,
  AC_DEMO_DROPDOWN,
    AC_DROPDOWN_1,
};

static int but_x=PAD, but_y=PAD;
static int last_msg= SCR_H;

static void button(int size, char *text, int action)
{
  int w;
  if (size) w= BUT_W_BIG; else w= BUT_W_SMA;
  if (but_x+w+PAD>SCR_W)
  {
    but_x= PAD;
    but_y+= PAD + BUT_H;
  }
  gfx_button(GFX_UPDATE, but_x, but_y, w, BUT_H, text,action);

  but_x += PAD + w;
}

static int back_button(int w)
{
  button(w, "<Back", AC_BACK);
}

static int message_area(char *title)
{
  int L;
  int w,h;
  int x,y;
  w= SCR_W - PAD - PAD;
  h= BUT_H;
  x= PAD;
  y= last_msg - PAD- h;

  if (title)
  {
    int tw, th;
    gfx_text_size(1, title, &tw,&th);
    gfx_label(GFX_UPDATE,1, 0, SCR_BG, x, y, tw, BUT_H, title);
    x+= tw+ PAD;
    w-= tw+ PAD;
  }

  last_msg= y;
  return gfx_label(GFX_UPDATE,1, 0xffffff, 0x888888, x,y,w,h,"");
}

static void meprintf(int tgt, const char *fmt, ...)
{
  static char buf[10000];
  va_list ap;
  memset(buf,0,sizeof(buf));
  va_start(ap,fmt);
  vsnprintf(buf,sizeof(buf),fmt,ap);
  va_end(ap);
  buf[sizeof(buf)-1]= 0;
  gfx_label_set_text(GFX_UPDATE,tgt,buf);
}

char *poem[]= {
"ALA GEYİK",
"Çocuktum, ufacıktım,",
"Top oynadım,acıktım.",

"Buldum yerde bir erik,",
"Kaptı bir Ala Geyik.",

"Geyik kaçtı ormana,",
"Bindim bir ak doğana.",

"Doğan, yolu şaşırdı,",
"Kaf Dağından aşırdı.",

"Attı beni bir göle;",
"Gölden çıktım bir çöle,",

"Çölde buldum izini,",
"Koştum, tuttum dizini.",

"Geyik beni görünce,",
"Düştü büyük sevince.",

"Verdi bana bir elma,",
"Dedi, dinlenme, durma.",

"Dağdan yürü, kırdan git,",
"Altın Köşke çabuk yet.",

"Seni bekler ezeli,",
"Orda dünya güzeli.",

"Bin yıllık çile doldu!",
"Bunu dedi, kayboldu.",

"Yedim sırlı elmayı,",
"Gördüm gizli dünyayı.",

"Gündüz oldu, geceler;",
"Ak sakallı cüceler,",

"Korkunç devler hortladı,",
"Cinler, cirit oynadı.",

"Kesik başlar yürürdü,",
"Saçlarını sürürdü.",

"Bir de baktım, melekler,",
"Başlarında çiçekler.",

"Devlere el bağlıyor,",
"Gizli gizli ağlıyor.",

"Kılıcımı çıkardım,",
"Perileri kurtardım.",

"Kurtardığım periler,",
"Adım adım geriler,",

"Kanadını açardı,",
"Selam verir, kaçardı.",

"Az, uz gittim, dolaştım,",
"Altın Köşke ulaştım.",

"Bir kapısı açıktı,",
"Öteki kapanıktı.",

"Kapalıyı açarak,",
"Açığa vurdum kapak.",

"At önünde et vardı,",
"İt, ot yemez ağlardı;",

"Otu ata yedirdim,",
"Eti ite yedirdim.",

"Açtım bir elmas oda;",
"Dev şahı uykuda",

"Gördüm, kestim başını,",
"Dedim, Ey dev nerede?",

"Nerede Dünya Güzeli?",
"Dedi, Elinde eli!",

"Döndüm, baktım. Bir Kırgız",
"Elbiseli güzel kız.",

"Durmuş, bakar yanımda,",
"Şimşek çaktı canımda.",

"Güldü, dedi, Türk Beyi!",
"Tanıdın mı geyiği?",

"Kimse, beni bu devden",
"Alamazdı. Ancak sen,",

"Kaya deldin, dağ yardın,",
"Geldin, beni kurtardın.",

"Ah o imiş anladım,",
"Sevincimden ağladım,",

"Dedim, Turan Meleği!",
"Türkün yüce dileği!",

"Yüz milyon Türk bu anda",
"Seni bekler Turanda.",

"Haydi, çabuk varalım,",
"Karanlığı yaralım;",

"Sönük ocak canlansın,",
"Yoksul ülke şanlansın",

"İndik, iti okşadık,",
"At sırtına atladık.",

"Geçtik nice dağ, kaya,",
"Geldik Demirkapıya.",

"Kapanması, çok yıldı,",
"Açıl! dedim, açıldı.",

"Yol verince gizli yurt,",
"Aldı bizi Bozkurt,",

"Kaf Dağından geçirdi,",
"Türk Eline getirdi.",
NULL
};

static int demo_menus()
{
  int x,y;
  gfx_event_t event;

  static TUPiis_t menu1[]= {
  { 1, 0, "One" },
  { 4, 1, "Two" },
  { 9, 1, "Third and the longest one in the sequence, this is quite ridiculous. Most of this shouldn't be shown, but clipped. There is also no way to scroll sideways." },
  { 16, 0, "Four" },
  { 25, 1, "Five" },
};
  static TUPiis_t menu2[500];
  int NENT1,NENT2;
  int L;
  int i;

  NENT1= (sizeof(menu1)/sizeof(menu1[0]));

  for(i=0;poem[i];i++)
  {
   menu2[i].sv= poem[i];
   menu2[i].iv1= i;
   menu2[i].iv2= 0;
  }
  NENT2= i;

  back_button(1);
  button(1,"Show Menu 1", AC_MENU1);
  button(1,"Show Menu 2", AC_MENU2);

  L= message_area(NULL);

  int R;

  while(1)
    if (gfx_event(NULL, &event))
     switch(event.type)
     {
     case GFXEV_QUIT: return 1;
     case AC_MENU1:
       meprintf(L,"Menu Result= %d", gfx_fwmenu(1, NENT1, menu1)); 
       break;
     case AC_MENU2:
       R= gfx_fwmenu(1,NENT2, menu2);
       meprintf(L,"Menu Result= %d %s", R, R!=-1? menu2[R].sv : "(none)"); 
       break;
     case AC_BACK: return 0;
     }
}

static int demo_scrollbar()
{
  gfx_event_t event;
  double T,B;
  int V,H;
  int S1,S2;

  T= 0.1; B=0.3;
  back_button(1);
  
  S1= gfx_scrollbar(GFX_UPDATE|GFX_VERTICAL, 300,50,15, 250,  T, B, 0.1,
                AC_SCROLL_VERT);
  S2= gfx_scrollbar(GFX_UPDATE|GFX_HORIZONTAL, 50, 300, 250, 15, 0.2, 0.6, 0.08,
               AC_SCROLL_HORZ);
  V= message_area("Vertical:  ");
  H= message_area("Horizontal:");

  while(1)
    if (gfx_event(NULL, &event))
     switch(event.type)
     {
     case GFXEV_QUIT: return 1;
     case AC_BACK: return 0;
     case AC_SCROLL_VERT:
           meprintf(V,"%f %f", event.flo0, event.flo1); break;
       break;
     case AC_SCROLL_HORZ:
           meprintf(H,"%f %f", event.flo0, event.flo1); break;
     }
}


static int demo_list()
{
#define NOIC NULL,0,0

static TUPscip_t list1[]=
{
  { "Hello", NOIC, 0, NULL },
  { "World", NOIC, 0, NULL },
  { "This is a nice", NOIC, 1, NULL },
  { "Test for a list", NOIC, 0, NULL },
  { "How", NOIC, 0, NULL },
  { "Does", NOIC, 0, NULL },
  { "It Work?", NOIC, 0, NULL },
  { "Let me see..", NOIC, 0, NULL },
  { "In order to", NOIC, 0, NULL },
  { "Cause an overflow", NOIC, 0, NULL },
  { "I need to enter", NOIC, 1, NULL },
  { "More items", NOIC, 0, NULL },
  { "This way, I can see", NOIC, 0, NULL },
  { "Whether the clipping", NOIC, 0, NULL },
  { "And the scrolling", NOIC, 0, NULL },
  { "Works or not", NOIC, 1, NULL },
  { "I'm also curious about", NOIC, 0, NULL },
  { "Whether the icons work or not", NOIC, 0, NULL },
  { "But that's for another time", NOIC, 0, NULL },
};

#define NENT1  (sizeof(list1)/sizeof(list1[0]))

  gfx_event_t event;
  int L;
  int i;
  int n_items;

  n_items= NENT1;
  
  for(i=0;i<NENT1;i++)
  {
    char buf[200];
    if (i%5==0) continue;
    sprintf(buf,"image%d.png",i%5);
    read_png_image(buf,(void*)&list1[i].icon_width,
                       (void*)&list1[i].icon_height,
                       (void*)&list1[i].icon_data);
  }

  int j;
  int MA;

  back_button(0);
  MA= message_area("Selected:");

  L= gfx_list(GFX_UPDATE,30,50,100,210,NENT1,list1, AC_LIST1);

  button(0,"Delete", AC_LIST_DELETE);
  button(0,"Insert", AC_LIST_INSERT);

  int E1,E2;
  E1= gfx_text_entry(GFX_UPDATE, 130, 290, 150, 30, "");
  E2= gfx_text_entry(GFX_UPDATE, 130, 330, 150, 30, "");

  gfx_print(GFX_UPDATE,1, 0x00, SCR_BG, 30, 290, "Text", NULL,NULL);
  gfx_print(GFX_UPDATE,1, 0x00, SCR_BG, 30, 330, "Position", NULL,NULL);

again:
  while(1)
    if (gfx_event(NULL, &event))
     switch(event.type)
     {
     case GFXEV_QUIT: return 1;
     case AC_BACK: return 0;
     case AC_LIST1:
        meprintf(MA,"%s", list1[event.key].str);
        break;
     case AC_LIST_DELETE:
        for(i=0;i<n_items;i++)
         if (list1[i].iv)
         {
           for(j=i;j<n_items-1;j++) list1[j]= list1[j+1];
           n_items--;
           gfx_list_delete(GFX_UPDATE, L, i, 1);
           goto again;
         }
         break;
     case AC_LIST_INSERT:
        if (n_items==NENT1) continue;
        j= atoi(gfx_text_entry_get(E2));
        for(i=n_items;i>j;i--)
          list1[i]= list1[i-1];
        list1[j].str= strdup(gfx_text_entry_get(E1));
        list1[j].icon_data= NULL;
        gfx_list_insert(GFX_UPDATE, L, list1, j,1);
        n_items++;
        break;
     }
}

static int demo(int (*func)())
{
  int OS;
  int R;
  but_x= PAD;
  but_y= PAD;
  last_msg= SCR_H;

  OS= gfx_push_screen();
  gfx_fill_rect(GFX_UPDATE,0,0,SCR_W,SCR_H,0xededed);
  R= (*func)();
  gfx_restore_screen(OS);
  return R;
}

static int demo_dropdown()
{
  gfx_event_t event;
  int DD;
  char buf[200];
  int i;
  int msg,msg2;
  char *s_str;
  void *s_ptr;

  back_button(1);
  
  DD= gfx_dropdown(50, 100, 100, 30, AC_DROPDOWN_1);
  for(i=0;i<50;i++)
  {
   sprintf(buf,"Choice %d", i);
   gfx_dropdown_insert(DD, -1, buf, strdup(buf));
  }
  gfx_dropdown_select(DD,5);
  gfx_dropdown_show(DD,1);

  msg= message_area(NULL);
  msg2= message_area(NULL);

  int S;
  while(1)
    if (gfx_event(NULL, &event))
     switch(event.type)
     {
     case GFXEV_QUIT: return 1;
     case AC_BACK: return 0;
     case AC_DROPDOWN_1: 
          meprintf(msg,"selected item %d: %s", event.key, event.usr);
          S= gfx_dropdown_selected(DD);
          if (S!=-1)
          {
            gfx_dropdown_get(DD, S, &s_str, &s_ptr);
            meprintf(msg2, "thru _get(): %s: %s", s_str, s_ptr);
          }
          break;
     }
}


int main(int argc,char **argv)
{
  gfx_event_t event;
  
  if (gfx_init(NULL,SCR_W,SCR_H,"Widget Demo")) return 1;
  gfx_fill_rect(GFX_UPDATE,0,0,SCR_W,SCR_H,SCR_BG);

  button(1,"OSD Menu", AC_DEMO_MENU);
  button(1,"Scroll Bar", AC_DEMO_SCROLL);
  button(1,"List", AC_DEMO_LIST);
  button(1,"Dropdown", AC_DEMO_DROPDOWN);

  while(1)
    if (gfx_event(NULL, &event))
     switch(event.type)
     {
     case AC_DEMO_MENU: if (demo(demo_menus)) goto done; break;
     case AC_DEMO_SCROLL: if (demo(demo_scrollbar)) goto done; break;
     case AC_DEMO_LIST: if (demo(demo_list)) goto done; break;
     case AC_DEMO_DROPDOWN: if (demo(demo_dropdown)) goto done; break;
     case GFXEV_QUIT: goto done;
     }

done:
  gfx_close();
  return 0;
}
