#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "pngio.h"

#define MAXIMG 200

int pW[MAXIMG], pH[MAXIMG];
char *pNAME[MAXIMG];
int pN;
int pO[MAXIMG];
int offset;


void print_img(char *fn,unsigned int *img, 
               unsigned int img_w, unsigned int img_h)
{
  int xe,ye,x,y;
  char *pfx,*z;
  fn= strdup(fn);
  if (pN==MAXIMG)
     exit(fprintf(stderr,"maximum number of images is reached (%d)\n"
                         "increase MAXIMG in source and try again\n", pN));
  for(ye=img_h-1;ye>0;ye--)
    for(xe=img_w-1;xe>0;xe--)
      if ((img[xe+ye*img_w] & 0xff0000)!= 0)
        goto found;
  exit(fprintf(stderr,"can't find red pixel in %s\n", fn));
found:
  pfx= strchr(fn,'.');
  if (!pfx)
    exit(fprintf(stderr,"can't find file extension in %s\n",fn));
  while((z=strchr(fn,'-'))) *z= '_';
  *pfx= 0;
  pfx= fn;
 
  pNAME[pN]= fn;
  pW[pN]= xe;
  pH[pN]= ye;
  pO[pN]= offset;
  pN++;
  
  for(y=0;y<ye;y++)
    for(x=0;x<xe;x++)
    {
      if (offset%6==0) printf("\n  ");
      printf("0x%x,", img[x+y*img_w] & 0xffffff);
      offset++;
    }
}


int main(int argc,char **argv)
{
  unsigned int *img, img_w, img_h;
  int i; char *fn;
    char *e;

  printf("static unsigned int _GSDATA[]={");
  for(i=1;i<argc;i++)
  {
    fn= argv[i];
    e= read_png_image(fn, &img_w, &img_h,&img);
    if (e) exit(fprintf(stderr,"error reading image %s: %s\n",fn,e));
    print_img(fn,img, img_w, img_h);
    free(img);
  }
  printf("\n};\n");
  for(i=0;i<pN;i++)
  {
    printf("static const unsigned int GSW%s= %d, GSH%s= %d;\n",
        pNAME[i], pW[i], pNAME[i], pH[i]);
    printf("static unsigned int *GSD%s= _GSDATA+%d;\n", pNAME[i], pO[i]);
  }
  printf("static const unsigned int _GSSIZE= %d;\n", offset);
  return 0;
}
