#line 4 "/home/dodo/tmp/gfx-1.2/src/basics.u"
#include <stdint.h>
#include <alloca.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <sys/socket.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/extensions/XShm.h>
#include <X11/Xatom.h>
#include <X11/Xlocale.h>
#include <X11/Xos.h>
#include <X11/Xproto.h>
#define XK_MISCELLANY
#include <X11/keysymdef.h>

#include "gfx.h"

/***********************************************************************
  Images can be shared on non-shared. They are represented by the
  following struct.
 ***********************************************************************/
typedef struct 
{
  uint32_t *data;
  unsigned int width,height, bpl;
  int shared;
  XShmSegmentInfo shminfo;
  XImage *x11image;
} ximage_t;
#line 13 "/home/dodo/tmp/gfx-1.2/src/event.u"

typedef struct
{
  int  x,y,w,h;
  int  (*func)(void *,gfx_event_t*);
  void *arg;
  int  *enabled;
  int button;
} click_handler_t;

#line 17 "/home/dodo/tmp/gfx-1.2/src/widget.u"

typedef struct
{
  int type;
  int x,y,w,h;
  void (*destroy)(void*);
} gui_widget_t;

enum 
{
#line 21 "/home/dodo/tmp/gfx-1.2/src/button.u"

  GFXCLASS_BUTTON,

#line 28 "/home/dodo/tmp/gfx-1.2/src/textentry.u"
  GFXCLASS_TEXTENTRY,

#line 59 "/home/dodo/tmp/gfx-1.2/src/scrollbar.u"

  GFXCLASS_SCROLLBAR,

#line 36 "/home/dodo/tmp/gfx-1.2/src/dropdown.u"
  GFXCLASS_DROPDOWN,

#line 146 "/home/dodo/tmp/gfx-1.2/src/list.u"
 GFXCLASS_LIST,

#line 28 "/home/dodo/tmp/gfx-1.2/src/widget.u"
  GFXCLASS_LAST
};

#line 11 "/home/dodo/tmp/gfx-1.2/src/button.u"
typedef struct
{
  gui_widget_t widget;
  uint32_t *pic[3];
  int state;  //0 = normal, 1= depressed 2= disabled
  int action;
  int enabled; // this is used to inform the event system
} gui_button_t;

#line 9 "/home/dodo/tmp/gfx-1.2/src/label.u"
typedef struct 
{
  int font, fg, bg, x,y,w,h,flags;
} gui_label_t;

#line 14 "/home/dodo/tmp/gfx-1.2/src/recsel.u"
typedef struct { int x,y; } gfx_point_t;

#line 31 "/home/dodo/tmp/gfx-1.2/src/keyboard.u"

typedef struct xkeyb
{
  int method;
  Window window;
  XIC ic;
  char *buf;
  size_t sbuf;
  uint32_t *wbuf;
  size_t swbuf;
} x_keyboard_t;


#line 12 "/home/dodo/tmp/gfx-1.2/src/focus.u"

typedef struct { int x,y,w,h; 
                 int (*keyhandler)(void *, gfx_event_t *); 
                 void (*focus)(void*,int);
                 void *arg; } focusable_t;

#line 18 "/home/dodo/tmp/gfx-1.2/src/textentry.u"

typedef struct { uint32_t chr; uint8_t  *d; uint32_t w; int x; } glyph_t;

typedef struct 
 { gui_widget_t widget;
   int x,y,w,h; glyph_t *glyphs; int size, len;
   int fonth;
   int has_focus; uint32_t left; int cursor; } text_entry_t;

#line 23 "/home/dodo/tmp/gfx-1.2/src/scrollbar.u"

typedef struct
{
  gui_widget_t widget;
  double start, end;          // start/end points for the sliding button
  double step;                // step amount for up/down left/right buttons
  int tro_c0, tro_c1, tro_dc; // start/end points for trough. can be X or 
                              // Y coordinates dc is the difference between
                              // them, but normalized to prevent divide by zero
  int but_c0, but_c1;         // start/end points for button

  int tro_x, tro_y, tro_w, tro_h; // used for updates
  int last_seen_c;

  int enabled;                // for enabling/disabling clicks

  int orient;

  int action;                 // action is used for reporting changes to user.
  void *reportarg;            // the following two are used for reporting
                              // to other widgets.
  void (*reportfunc)(void *, double, double);
  
  // stepper button position
  int SX[2], SY[2];
  // stepper button images, 0 = Up-normal 1= Up-pressed 2-Down-normal ..
  unsigned int *SD[4], SW[4], SH[4];

    // click handler entries
    // 0= up button 
    // 1= down button
    // 2= trough
  int ch0, ch1, ch2;
} gui_scrollbar_t;

#line 4 "/home/dodo/tmp/gfx-1.2/src/dropdown.u"

typedef struct { void* ptr; char *str; } TUPsp_t;

typedef struct
{
  gui_widget_t widget;
  int shown;
  int n_items, s_items;
  TUPsp_t *items;
  int selected;

  uint32_t *img_pressed;
  uint32_t *img_normal;

  int click;
  int click_enabled;

  // list stuff
  int list_x,list_y,list_w,list_h;
  int list_px, list_py, list_pw, list_ph; // port coords
  unsigned int *list_backup;
  int fh;
  gui_scrollbar_t *scroll;
  int posy;
  int list_cont_h;  // content height

  int but1clicked;
  int selitem;
  int action;
} dropdown_t;

#line 11 "/home/dodo/tmp/gfx-1.2/src/screen.u"

typedef struct
{
  int n_gui_widget;
  int n_click_handler, click_handler_start;
  click_handler_t release_handler;
  click_handler_t motion_handler;

  uint32_t *backstore;
  uint32_t backw, backh;
} screen_t;

#line 43 "/home/dodo/tmp/gfx-1.2/src/list.u"

typedef struct
{
  int y;
  int w,h;
  int icon_y,icon_x,text_y,text_x;
  int text_w, text_h;
} gui_list_item_extra_t;

#line 56 "/home/dodo/tmp/gfx-1.2/src/list.u"

typedef struct
{
  gui_widget_t widget;
  int n_items;
  TUPscip_t *items;
  int s_extra;
  gui_list_item_extra_t *extra;
  int posx, posy; // scrolled position

  int has_scrollv, has_scrollh;
  gui_scrollbar_t *scrollv, *scrollh;

  int content_w, content_h;
  int port_w, port_h;
  int port_x, port_y;

  int max_icon_width;
  int uses_icons;
  int multiselect;

  int enabled;// just a dummy field. it's always 1
  int ch0;    // ID of the click handler, we use this
              // to modify the click area when the
              // scrollbars appear/disappear
  int ch1,ch2; // mouse buttons 4 and 5
  int click_action; // not reported if 0
 
  int x,y,w,h;
} gui_list_t;

#line 254 "gfx.c"
static unsigned int _GSDATA[]={
  0xd2d2cf,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,
  0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,
  0xa5a59f,0xa5a59f,0xd2d2cf,0xa5a59f,0xd2d2cf,0xd2d2cf,
  0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,
  0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0xe5e5e2,0xe8e8e6,0xebebe9,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0xe5e5e2,0xe8e8e6,0xebebe9,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0xe5e5e2,0xe8e8e6,0xebebe9,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0xe5e5e2,0xe8e8e6,0xebebe9,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0x444444,0x0,
  0x0,0x0,0x0,0x0,0x444444,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0x444444,0x0,0x0,0x0,
  0x444444,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0x444444,0x0,0x444444,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0xe5e5e2,0x444444,0xebebe9,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0xe5e5e2,0xe8e8e6,0xebebe9,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0xe5e5e2,0xe8e8e6,0xebebe9,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0xe5e5e2,0xe8e8e6,0xebebe9,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xffffff,
  0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,
  0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,0xa5a59f,
  0xd2d2cf,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,
  0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,
  0xa5a59f,0xa5a59f,0xd2d2cf,0xd2d2cf,0xa5a59f,0xa5a59f,
  0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,
  0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xd2d2cf,
  0xa5a59f,0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,
  0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,
  0xd2d2cf,0xd2d2cf,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0xe5e5e2,0xe8e8e6,0xebebe9,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0xe5e5e2,0xe8e8e6,0xebebe9,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0xe5e5e2,0xe8e8e6,0x444444,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0xe5e5e2,0x444444,0x0,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0x444444,0x0,0x0,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0x444444,
  0x0,0x0,0x0,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0x444444,0x0,0x0,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0xe5e5e2,0x444444,0x0,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0xe5e5e2,0xe8e8e6,0x444444,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0xe5e5e2,0xe8e8e6,0xebebe9,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0xe5e5e2,0xe8e8e6,0xebebe9,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xffffff,0xffffff,0xffffff,0xffffff,
  0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,
  0xffffff,0xffffff,0xa5a59f,0xd2d2cf,0xa5a59f,0xa5a59f,
  0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,
  0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xd2d2cf,
  0xd2d2cf,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,
  0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,
  0xa5a59f,0xa5a59f,0xd2d2cf,0xa5a59f,0xd2d2cf,0xd2d2cf,
  0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,
  0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0xe5e5e2,0xe8e8e6,0xebebe9,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0xe5e5e2,0xe8e8e6,0xebebe9,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0x444444,0xe8e8e6,0xebebe9,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0x0,0x444444,0xebebe9,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0x0,0x0,0x444444,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0x0,0x0,0x0,
  0x444444,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0x0,0x0,0x444444,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0x0,0x444444,0xebebe9,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0x444444,0xe8e8e6,0xebebe9,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0xe5e5e2,0xe8e8e6,0xebebe9,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0xe5e5e2,0xe8e8e6,0xebebe9,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xffffff,
  0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,
  0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,0xa5a59f,
  0xd2d2cf,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,
  0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,
  0xa5a59f,0xa5a59f,0xd2d2cf,0xd2d2cf,0xa5a59f,0xa5a59f,
  0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,
  0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xd2d2cf,
  0xa5a59f,0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,
  0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,0xd2d2cf,
  0xd2d2cf,0xd2d2cf,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0xe5e5e2,0xe8e8e6,0xebebe9,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0xe5e5e2,0xe8e8e6,0xebebe9,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0xe5e5e2,0xe8e8e6,0xebebe9,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0xe5e5e2,0x444444,0xebebe9,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0x444444,0x0,0x444444,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0x444444,
  0x0,0x0,0x0,0x444444,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0x444444,0x0,0x0,0x0,0x0,
  0x0,0x444444,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0xe5e5e2,0xe8e8e6,0xebebe9,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0xe5e5e2,0xe8e8e6,0xebebe9,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0xe5e5e2,0xe8e8e6,0xebebe9,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f6,0xffffff,0xa5a59f,0xa5a59f,0xd2d2cf,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0xe5e5e2,0xe8e8e6,0xebebe9,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f6,0xffffff,0xa5a59f,
  0xa5a59f,0xd2d2cf,0xffffff,0xffffff,0xffffff,0xffffff,
  0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,
  0xffffff,0xffffff,0xa5a59f,0xd2d2cf,0xa5a59f,0xa5a59f,
  0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,
  0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xa5a59f,0xd2d2cf,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0xffffff,0xffffff,
  0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,
  0xffffff,0xffffff,0xffffff,0xffffff,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddb,
  0xdbdad9,0xd9d7d6,0xd6d4d3,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddb,0xdbdad9,0xd9d7d6,0xd6d4d3,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddb,
  0xdbdad9,0xd9d7d6,0xd6d4d3,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddb,0xdbdad9,0xd9d7d6,0xd6d4d3,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0x444444,0x0,
  0x0,0x0,0x0,0x0,0x444444,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0x444444,0x0,0x0,0x0,
  0x444444,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddc,
  0x444444,0x0,0x444444,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddc,0xdbdad9,0x444444,0xd6d4d3,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddb,
  0xdbdad9,0xd9d7d6,0xd6d4d3,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddb,0xdbdad9,0xd9d7d6,0xd6d4d3,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddb,
  0xdbdad9,0xd9d7d6,0xd6d4d3,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcaca,0x9a9694,0x9a9694,0xcdcbca,0xcdcaca,
  0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,
  0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,0x9a9694,
  0x9a9694,0x9a9694,0x9a9594,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,
  0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,
  0xffffff,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddb,0xdbdad9,0xd9d7d6,0xd6d4d3,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddb,
  0xdbdad9,0xd9d7d6,0xd6d4d3,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddb,0xdbdad9,0xd9d7d6,0x444444,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddb,
  0xdbdad9,0x444444,0x0,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddc,0x444444,0x0,0x0,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0x444444,
  0x0,0x0,0x0,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddc,0x444444,0x0,0x0,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddc,
  0xdbdad9,0x444444,0x0,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddb,0xdbdad9,0xd9d7d6,0x444444,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddb,
  0xdbdad9,0xd9d7d6,0xd6d4d3,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddb,0xdbdad9,0xd9d7d6,0xd6d4d3,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcaca,0x9a9694,
  0x9a9694,0xcdcbca,0xcdcaca,0xcdcbca,0xcdcbca,0xcdcbca,
  0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,
  0xcdcbca,0xcdcbca,0x9a9694,0x9a9694,0x9a9694,0x9a9594,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0xffffff,0xffffff,
  0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,
  0xffffff,0xffffff,0xffffff,0xffffff,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddb,
  0xdbdad9,0xd9d7d6,0xd6d4d3,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddb,0xdbdad9,0xd9d7d6,0xd6d4d3,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddb,
  0x444444,0xd9d7d6,0xd6d4d3,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddb,0x0,0x444444,0xd6d4d3,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddc,
  0x0,0x0,0x444444,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddc,0x0,0x0,0x0,
  0x444444,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddc,
  0x0,0x0,0x444444,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddc,0x0,0x444444,0xd6d4d3,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddb,
  0x444444,0xd9d7d6,0xd6d4d3,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddb,0xdbdad9,0xd9d7d6,0xd6d4d3,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddb,
  0xdbdad9,0xd9d7d6,0xd6d4d3,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcaca,0x9a9694,0x9a9694,0xcdcbca,0xcdcaca,
  0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,
  0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,0x9a9694,
  0x9a9694,0x9a9694,0x9a9594,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,
  0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,
  0xffffff,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddb,0xdbdad9,0xd9d7d6,0xd6d4d3,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddb,
  0xdbdad9,0xd9d7d6,0xd6d4d3,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddb,0xdbdad9,0xd9d7d6,0xd6d4d3,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddb,
  0xdbdad9,0x444444,0xd6d4d3,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddc,0x444444,0x0,0x444444,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0x444444,
  0x0,0x0,0x0,0x444444,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0x444444,0x0,0x0,0x0,0x0,
  0x0,0x444444,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddc,
  0xdbdad9,0xd9d7d6,0xd6d4d3,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddb,0xdbdad9,0xd9d7d6,0xd6d4d3,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddb,
  0xdbdad9,0xd9d7d6,0xd6d4d3,0xd3d1d0,0xd0cecd,0xcdcbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddb,0xdbdad9,0xd9d7d6,0xd6d4d3,
  0xd3d1d0,0xd0cecd,0xcdcbca,0xcbc9c7,0xcdcaca,0x9a9694,
  0x9a9694,0xcdcbca,0xcdcaca,0xcdcbca,0xcdcbca,0xcdcbca,
  0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,
  0xcdcbca,0xcdcbca,0x9a9694,0x9a9694,0x9a9694,0x9a9594,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0xd9d7d6,0xd6d6d3,0xd9d9d6,0xdcdcd9,0xdfdfdc,0xe2e2df,
  0xe5e5e2,0xe8e8e6,0xebebe9,0xeeeeec,0xf1f1ef,0xf4f4f2,
  0xf7f7f5,0xfafaf9,0xd9d7d6,0xd9d7d6,0xd6d6d3,0xd9d9d6,
  0xdcdcd9,0xdfdfdc,0xe2e2df,0xe5e5e2,0xe8e8e6,0xebebe9,
  0xeeeeec,0xf1f1ef,0xf4f4f2,0xf7f7f5,0xfafaf9,0xd9d7d6,
  0x9a9694,0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,
  0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,0xcdcbca,
  0xcdcbca,0xcdcbca,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0xffffff,0xe7e6e5,0xe4e3e2,0xe1e0df,0xdedddc,
  0xdcdad9,0xd9d7d6,0xd6d4d3,0xd3d1d0,0xd1cecd,0xcecbca,
  0xcbc9c7,0xcdcbca,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0x9a9694,0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,
  0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,0xffffff,
  0xffffff,0xcdcbca,0x9a9694,0x9a9694,0x9a9694,0x9a9694,
  0xffffff,0x9a9694,0xffffff,0x9a9694,0xffffff,0x9a9694,
  0xffffff,0x9a9694,0xffffff,0x9a9694,0xffffff,0x9a9694,
  0xffffff,0x9a9694,0xffffff,0x9a9694,0xffffff,0x9a9694,
  0xffffff,0x9a9694,0xffffff,0x9a9694,0xffffff,0x9a9694,
  0xcdcbca,0x9a9694,0x9a9694,0x9a9694,0xffffff,0xe7e6e5,
  0xe4e3e2,0xe1e0df,0xdedddc,0xdcdad9,0xd9d7d6,0xd6d4d3,
  0xd3d1d0,0xd1cecd,0xcecbca,0xcbc9c7,0xcdcbca,0x9a9694,
  0x9a9694,0x9a9694,0xcdcbca,0x9a9694,0xcdcbca,0x9a9694,
  0xcdcbca,0x9a9694,0xcdcbca,0x9a9694,0xcdcbca,0x9a9694,
  0xcdcbca,0x9a9694,0xcdcbca,0x9a9694,0xcdcbca,0x9a9694,
  0xcdcbca,0x9a9694,0xcdcbca,0x9a9694,0xcdcbca,0x9a9694,
  0xcdcbca,0x9a9694,0xcdcbca,0x9a9694,0x9a9694,0x9a9694,
};
static const unsigned int GSWrcs_down= 15, GSHrcs_down= 15;
static unsigned int *GSDrcs_down= _GSDATA+0;
static const unsigned int GSWrcs_left= 15, GSHrcs_left= 15;
static unsigned int *GSDrcs_left= _GSDATA+225;
static const unsigned int GSWrcs_right= 15, GSHrcs_right= 15;
static unsigned int *GSDrcs_right= _GSDATA+450;
static const unsigned int GSWrcs_up= 15, GSHrcs_up= 15;
static unsigned int *GSDrcs_up= _GSDATA+675;
static const unsigned int GSWscr_down= 15, GSHscr_down= 15;
static unsigned int *GSDscr_down= _GSDATA+900;
static const unsigned int GSWscr_left= 15, GSHscr_left= 15;
static unsigned int *GSDscr_left= _GSDATA+1125;
static const unsigned int GSWscr_right= 15, GSHscr_right= 15;
static unsigned int *GSDscr_right= _GSDATA+1350;
static const unsigned int GSWscr_up= 15, GSHscr_up= 15;
static unsigned int *GSDscr_up= _GSDATA+1575;
static const unsigned int GSWtro_horz= 1, GSHtro_horz= 15;
static unsigned int *GSDtro_horz= _GSDATA+1800;
static const unsigned int GSWtro_vert= 15, GSHtro_vert= 1;
static unsigned int *GSDtro_vert= _GSDATA+1815;
static const unsigned int GSWsbut_ver_bot= 15, GSHsbut_ver_bot= 2;
static unsigned int *GSDsbut_ver_bot= _GSDATA+1830;
static const unsigned int GSWsbut_ver_mid= 15, GSHsbut_ver_mid= 1;
static unsigned int *GSDsbut_ver_mid= _GSDATA+1860;
static const unsigned int GSWsbut_ver_top= 15, GSHsbut_ver_top= 2;
static unsigned int *GSDsbut_ver_top= _GSDATA+1875;
static const unsigned int GSWsbut_hor_left= 2, GSHsbut_hor_left= 15;
static unsigned int *GSDsbut_hor_left= _GSDATA+1905;
static const unsigned int GSWsbut_hor_mid= 1, GSHsbut_hor_mid= 15;
static unsigned int *GSDsbut_hor_mid= _GSDATA+1935;
static const unsigned int GSWsbut_hor_right= 2, GSHsbut_hor_right= 15;
static unsigned int *GSDsbut_hor_right= _GSDATA+1950;
static const unsigned int _GSSIZE= 1980;
#define UTF8_DECODER_SCOPE static

/*
UTF-8 Table
8421 8421
110x xxxx   2 bytes    mask= e0  result= c0   min= 80       vmask= 1f
1110 xxxx   3 bytes    mask= f0  result= e0   min= 800      vmask= 0f
1111 0xxx   4 bytes    mask= f8  result= f0   min= 10000    vmask= 07
1111 10xx   5 bytes    mask= fc  result= f8   min= 200000   vmask= 03
1111 110x   6 bytes    mask= fe  result= fc   min= 4000000  vmask= 01

10xx xxxx   cont. byte mask= c0  result= 80   vmask= 3f
*/

UTF8_DECODER_SCOPE
int utf8_decode_string
  (uint8_t *input, size_t ilen, uint32_t *output, size_t *olen)
{
   uint8_t *end,*start;
   static const uint32_t bit31= (1<<31);
   size_t L;
   int have_errors;
   int i, contb;
   uint8_t C;
   uint32_t outc; uint32_t min;

   end= input+ilen;
   L= 0;
   have_errors= 0;

   if (ilen==0) goto done;

again:
   C= input[0];
   if ( (C&0x80) ==0)    { outc= C; input++; goto out; }
   if ( (C&0xe0) ==0xc0) goto seq2; 
   if ( (C&0xf0) ==0xe0) goto seq3;
   if ( (C&0xf8) ==0xf0) goto seq4;

   // Here, we don't care about the seq5 and seq6 stuff.
   // they are invalid anyway, either overlong or greater
   // then the unicode limit. We just treat them as unrecognized
   // bytes and output them.
invalid_byte:
   outc= input[0] | bit31;
   input++;
   have_errors= 1;
   goto out;

seq2: outc= C & 0x1f;  min=    0x80; contb= 1; goto do_cont;
seq3: outc= C & 0x0f;  min=   0x800; contb= 2; goto do_cont;
seq4: outc= C & 0x07;  min= 0x10000; contb= 3; goto do_cont;

do_cont:
   start= input;
   input++;
   for(i=0;i<contb;i++)
   {
     if ((input==end) || ( (input[0]&0xc0) !=0x80)) goto reject;
     outc= (outc << 6) | (input[0]&0x3f);
     input++;
   }

   if (outc<min || outc>0x10ffff) goto reject; 
   if (outc>=0xd800 && outc<=0xdfff) goto reject;
   if (outc==0xffff || outc==0xfffe) goto reject;

out:
   output[L++]= outc;
   if (input<end) goto again;
done:
   *olen= L;
   return have_errors;
reject:
   input= start;
   goto invalid_byte; 
}


static unsigned int font_hash(unsigned int V)
{
  static const struct
  { unsigned short val; unsigned char pos; } htable[109]= {
 {0x20,0}, {0x21,1}, {0x22,2}, {0x23,3}, {0x24,4}, {0x25,5}, {0x26,6},
 {0x27,7}, {0x28,8}, {0x29,9}, {0x2a,10}, {0x2b,11}, {0x2c,12},
 {0x2d,13}, {0x2e,14}, {0x2f,15}, {0x30,16}, {0x31,17}, {0x32,18},
 {0x33,19}, {0x34,20}, {0x35,21}, {0x36,22}, {0x37,23}, {0x38,24},
 {0x39,25}, {0x3a,26}, {0x3b,27}, {0x3c,28}, {0x3d,29}, {0x3e,30},
 {0x3f,31}, {0x40,32}, {0x41,33}, {0x42,34}, {0x43,35}, {0x44,36},
 {0x45,37}, {0x46,38}, {0x47,39}, {0x48,40}, {0x49,41}, {0x4a,42},
 {0x4b,43}, {0x4c,44}, {0x4d,45}, {0x4e,46}, {0x4f,47}, {0x50,48},
 {0x51,49}, {0x52,50}, {0x53,51}, {0x54,52}, {0x55,53}, {0x56,54},
 {0x57,55}, {0x58,56}, {0x59,57}, {0x5a,58}, {0x5b,59}, {0x5c,60},
 {0x5d,61}, {0x5e,62}, {0x5f,63}, {0x60,64}, {0x61,65}, {0x62,66},
 {0x63,67}, {0x64,68}, {0x65,69}, {0x66,70}, {0x67,71}, {0x68,72},
 {0x69,73}, {0x6a,74}, {0x6b,75}, {0x6c,76}, {0x6d,77}, {0x6e,78},
 {0x6f,79}, {0x70,80}, {0x71,81}, {0x72,82}, {0x73,83}, {0x74,84},
 {0x75,85}, {0x76,86}, {0x77,87}, {0x78,88}, {0x79,89}, {0x7a,90},
 {0x7b,91}, {0x7c,92}, {0x7d,93}, {0x7e,94}, {0xc7,95}, {0x15f,106},
 {0x11e,101}, {0xdc,97}, {0x11f,102}, {0x15e,105}, {0xd6,96}, {0x20,107},
 {0xe7,98}, {0x131,104}, {0xf6,99}, {0xfc,100}, {0x130,103}, {0x20,107},
  };
  unsigned int A;
  int p;
  A= V;
  p= 0;
  A-= 0x20;
  if (A<=0x5e) { p+= A; goto done; }
  A-= 0xa7;
  p+= 95;
  A^= A>>4;
  A &= 0x3f;
  A= (A&0xf) | ((A&0xffffffe0)>>1);
  A= (A&0x7) | ((A&0xfffffff0)>>1);
  A-= A>>2;
  A-= 0x0;
  if (A<=0xc) { p+= A; goto done; }
  A-= 0x0;
  p+= 13;
done:
  if (htable[p].val!=V) return 107;
  return htable[p].pos;
}
static 
void font1_render
        (uint32_t *str, size_t L, 
        int *RW, int *RH, int *RA,
        unsigned char **Rdata)
{
  static const uint8_t font_data[]= {

0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x70,0x27,0x03,0xff,0x7e,0x00,0xf9,0x74,0x00,0xef,0x6a,0x00,0xe4,
0x5f,0x00,0xd9,0x54,0x00,0xce,0x49,0x00,0xc4,0x3f,0x00,0xaa,0x2a,0x00,0x00,0x00,0x04,0x7c,
0x1e,0x19,0xf8,0x60,0x00,0x0b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x01,0x00,
0x00,0xe6,0x21,0xa0,0x67,0x00,0xef,0x21,0xa7,0x6a,0x00,0xe2,0x12,0x9a,0x5d,0x00,0x9f,0x03,
0x6c,0x38,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,
0xe0,0x00,0x00,0x68,0xb6,0x00,0x00,0x00,0x00,0x00,0x00,0x44,0xe8,0x00,0x00,0x6c,0xbc,0x00,
0x00,0x00,0x00,0x00,0x00,0x44,0xe8,0x00,0x00,0x6c,0xbc,0x00,0x00,0x00,0x00,0xfc,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x90,0x00,0x13,0x14,0x52,0xe9,0x14,0x14,0x77,0xc1,0x14,
0x14,0x0b,0x00,0x00,0x00,0x44,0xe8,0x00,0x00,0x6c,0xbc,0x00,0x00,0x00,0x00,0x46,0x48,0x78,
0xee,0x48,0x48,0x95,0xcf,0x48,0x48,0x28,0x00,0xd0,0xd4,0xdf,0xfb,0xd4,0xd4,0xe6,0xf4,0xd4,
0xd4,0x77,0x00,0x00,0x00,0x44,0xe8,0x00,0x00,0x6c,0xbc,0x00,0x00,0x00,0x00,0x00,0x00,0x44,
0xe8,0x00,0x00,0x6c,0xbc,0x00,0x00,0x00,0x00,0x00,0x00,0x27,0x86,0x00,0x00,0x3e,0x6c,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x01,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x74,0x8c,0x00,0x00,0x00,
0x00,0x2f,0xbf,0xf9,0xfd,0xc2,0x29,0x00,0x10,0xe8,0x95,0x86,0xa1,0x94,0xea,0x17,0x48,0xf8,
0x03,0x70,0x8c,0x00,0x4a,0x01,0x36,0xfe,0x16,0x70,0x8c,0x00,0x00,0x00,0x01,0xb5,0xd7,0xb5,
0x8d,0x00,0x00,0x00,0x00,0x03,0x63,0xcf,0xfb,0xb0,0x33,0x00,0x00,0x00,0x00,0x70,0x9f,0x8f,
0xfa,0x33,0x00,0x00,0x00,0x70,0x8c,0x00,0xc7,0x8b,0x3f,0x52,0x00,0x70,0x8c,0x00,0xbf,0x85,
0x62,0xf5,0x4f,0x71,0x8e,0x5e,0xfc,0x34,0x00,0x6c,0xf1,0xfc,0xfe,0xee,0x5d,0x00,0x00,0x00,
0x06,0x85,0x9c,0x03,0x00,0x00,0x00,0x00,0x00,0x18,0x1e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0f,0x70,0x6a,0x0a,
0x00,0x00,0x19,0x40,0x00,0x00,0x03,0xd0,0x93,0xa5,0xba,0x00,0x00,0xb7,0x69,0x00,0x00,0x25,
0xdc,0x00,0x04,0xf6,0x0e,0x54,0xcc,0x02,0x00,0x00,0x06,0xe3,0x60,0x75,0xd0,0x0c,0xe1,0x35,
0x00,0x00,0x00,0x00,0x25,0x96,0x8e,0x19,0x8c,0x98,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x2d,0xe6,0x12,0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x01,0xc4,0x62,0x4a,0xe4,0xec,0x6d,0x00,
0x00,0x00,0x00,0x62,0xc6,0x02,0xea,0x31,0x1a,0xee,0x1d,0x00,0x00,0x12,0xe7,0x2f,0x03,0xf3,
0x1a,0x05,0xe3,0x25,0x00,0x00,0x88,0x8b,0x00,0x00,0x6e,0xdd,0xd9,0x93,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x15,0x1b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x18,0x81,0xa3,0x78,0x10,0x00,0x00,0x00,0x00,0x19,0xe6,0xb7,0x79,0xba,
0xdb,0x12,0x00,0x00,0x00,0x85,0xc6,0x00,0x00,0x01,0x6e,0x13,0x00,0x00,0x00,0x9d,0xa2,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x55,0xf1,0x2f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x97,0xfd,0xe0,0x30,0x00,0x00,0x00,0x00,0x00,0x61,0xe9,0x72,0x44,0x0e,0x00,0x00,0x00,0x00,
0x08,0xf1,0x4b,0x00,0x00,0x3d,0x48,0x48,0x48,0x04,0x2d,0xff,0x0f,0x00,0x00,0xb2,0xe1,0xfd,
0xd4,0x0d,0x17,0xfe,0x32,0x00,0x00,0x00,0x80,0xd6,0x00,0x00,0x00,0x9b,0xcb,0x1f,0x00,0x3d,
0xf1,0x6a,0x00,0x00,0x00,0x0a,0x9a,0xfd,0xf0,0xf9,0x82,0x00,0x00,0x00,0x00,0x00,0x00,0x18,
0x31,0x0b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x00,0xe6,0x21,0x00,0xef,0x21,
0x00,0xe2,0x12,0x00,0x9f,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x17,0x0f,0x00,0x29,0xfa,0x38,0x00,0xa6,0xa7,0x00,0x0f,0xf7,0x3a,0x00,0x50,0xe8,
0x00,0x00,0x84,0xae,0x00,0x00,0x9f,0x93,0x00,0x00,0xa6,0x8a,0x00,0x00,0x94,0x9d,0x00,0x00,
0x6f,0xc9,0x00,0x00,0x34,0xfb,0x10,0x00,0x00,0xdc,0x6e,0x00,0x00,0x70,0xde,0x07,0x00,0x06,
0x9f,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x1c,0x02,0x00,0x0c,0xe6,0x66,0x00,0x00,0x68,
0xe2,0x02,0x00,0x0c,0xf2,0x45,0x00,0x00,0xac,0x8f,0x00,0x00,0x6e,0xc8,0x00,0x00,0x4e,0xe3,
0x00,0x00,0x42,0xee,0x00,0x00,0x55,0xde,0x00,0x00,0x84,0xb7,0x00,0x00,0xc6,0x7d,0x00,0x28,
0xfe,0x26,0x00,0xa0,0xb7,0x00,0x13,0xa6,0x2b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3e,0xc8,0x01,0x92,0x70,0x00,0x00,0x09,0xda,0x78,0xf2,
0x25,0x00,0x52,0x86,0xad,0xff,0xca,0x83,0x6f,0x59,0x93,0xb7,0xff,0xd1,0x90,0x7a,0x00,0x08,
0xda,0x78,0xf1,0x25,0x00,0x00,0x44,0xcd,0x01,0x96,0x79,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xf8,0x1b,0x00,0x00,0x00,0x00,0x00,0xfc,0x1c,0x00,0x00,0x38,0x90,
0x90,0xfe,0x9c,0x90,0x4a,0x36,0x8c,0x8c,0xfe,0x98,0x8c,0x48,0x00,0x00,0x00,0xfc,0x1c,0x00,
0x00,0x00,0x00,0x00,0xf8,0x1b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x04,0x7c,0x1e,0x19,0xf7,0x73,0x00,0x75,0x36,0x00,0x5f,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x12,0x84,0x84,0x84,0x84,0x84,0x12,0x15,0x98,0x98,0x98,0x98,0x98,0x15,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x04,0x7c,0x1e,0x19,0xf8,0x60,0x00,0x0b,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x09,0x0a,
0x00,0x00,0x00,0x00,0x00,0x01,0xd5,0x64,0x00,0x00,0x00,0x00,0x00,0x4e,0xe6,0x07,0x00,0x00,
0x00,0x00,0x00,0xc5,0x77,0x00,0x00,0x00,0x00,0x00,0x3c,0xf1,0x0f,0x00,0x00,0x00,0x00,0x00,
0xb3,0x8a,0x00,0x00,0x00,0x00,0x00,0x2b,0xf8,0x1a,0x00,0x00,0x00,0x00,0x00,0xa1,0x9c,0x00,
0x00,0x00,0x00,0x00,0x1d,0xf8,0x27,0x00,0x00,0x00,0x00,0x00,0x8f,0xaf,0x00,0x00,0x00,0x00,
0x00,0x12,0xf4,0x38,0x00,0x00,0x00,0x00,0x00,0x7d,0xc1,0x00,0x00,0x00,0x00,0x00,0x09,0xea,
0x4b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x06,0x6d,0xa3,0x7a,0x0b,0x00,0x00,0x00,0x03,0xbb,0xd3,0x7d,0xcb,0xc4,
0x02,0x00,0x00,0x68,0xe3,0x0f,0x00,0x09,0xe0,0x68,0x00,0x00,0xcd,0x7f,0x00,0x00,0x00,0x75,
0xc7,0x00,0x0d,0xfe,0x38,0x00,0x00,0x00,0x38,0xfd,0x04,0x2c,0xff,0x17,0x00,0x00,0x00,0x1e,
0xff,0x1d,0x31,0xff,0x0a,0x00,0x00,0x00,0x0f,0xff,0x2e,0x19,0xff,0x22,0x00,0x00,0x00,0x24,
0xff,0x1d,0x02,0xf3,0x48,0x00,0x00,0x00,0x55,0xef,0x01,0x00,0xa9,0x9c,0x00,0x00,0x00,0xa4,
0xa7,0x00,0x00,0x32,0xf7,0x49,0x00,0x4f,0xf6,0x30,0x00,0x00,0x00,0x68,0xf8,0xf1,0xf1,0x57,
0x00,0x00,0x00,0x00,0x00,0x12,0x32,0x0b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x0a,0x4a,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0xb5,0xc8,0x00,
0x00,0x00,0x00,0x00,0x00,0x3f,0xc4,0xc8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x74,0xc8,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x74,0xc8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x74,0xc8,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x74,0xc8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x74,0xc8,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x74,0xc8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x74,0xc8,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x74,0xc8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x74,0xc8,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x1a,0x82,0xa6,0x7f,0x15,0x00,0x00,0x00,0x37,0xf0,0xab,0x78,0xc6,0xe0,
0x15,0x00,0x00,0xd3,0x80,0x00,0x00,0x04,0xcf,0x80,0x00,0x00,0x1e,0x0a,0x00,0x00,0x00,0x85,
0xaf,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x9d,0x9b,0x00,0x00,0x00,0x00,0x00,0x00,0x3b,0xf3,
0x2f,0x00,0x00,0x00,0x00,0x01,0x70,0xf2,0x57,0x00,0x00,0x00,0x00,0x09,0xb1,0xd4,0x33,0x00,
0x00,0x00,0x00,0x03,0xba,0xbe,0x0c,0x00,0x00,0x00,0x00,0x00,0x74,0xde,0x0d,0x00,0x00,0x00,
0x00,0x00,0x00,0xe1,0x7c,0x1c,0x1c,0x1c,0x1c,0x1a,0x00,0x12,0xff,0xff,0xff,0xff,0xff,0xff,
0xf0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x1a,0x87,0xab,0x7d,0x0f,0x00,0x00,0x00,0x1e,0xe8,0xa6,0x6e,0xc4,0xd7,
0x0d,0x00,0x00,0x1c,0x66,0x00,0x00,0x07,0xdd,0x6d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xb5,
0x8b,0x00,0x00,0x00,0x00,0x00,0x00,0x25,0xf3,0x47,0x00,0x00,0x00,0x00,0x34,0xb7,0xf2,0x90,
0x00,0x00,0x00,0x00,0x00,0x15,0x52,0x98,0xeb,0x32,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x83,
0xcc,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0xfe,0x0c,0x00,0x28,0x11,0x00,0x00,0x00,0x4f,
0xf6,0x04,0x02,0xcd,0xbb,0x17,0x00,0x33,0xdf,0x90,0x00,0x00,0x17,0xb7,0xfb,0xf0,0xfa,0x88,
0x05,0x00,0x00,0x00,0x00,0x1b,0x2f,0x09,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x1d,0xf6,0xc0,
0x00,0x00,0x00,0x00,0x00,0x00,0xa7,0xea,0xc0,0x00,0x00,0x00,0x00,0x00,0x3a,0xe8,0x7e,0xc0,
0x00,0x00,0x00,0x00,0x01,0xca,0x65,0x70,0xc0,0x00,0x00,0x00,0x00,0x5f,0xd1,0x02,0x70,0xc0,
0x00,0x00,0x00,0x0b,0xe5,0x42,0x00,0x70,0xc0,0x00,0x00,0x00,0x84,0xce,0x38,0x38,0x8f,0xcd,
0x34,0x0c,0x15,0xdb,0xe4,0xe4,0xe4,0xf1,0xf9,0xe4,0x35,0x00,0x00,0x00,0x00,0x00,0x78,0xc0,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x78,0xc0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x78,0xc0,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x46,0x60,0x60,0x60,0x60,0x34,0x00,0x00,0x00,0xd4,0xcc,0xb8,0xb8,0xb8,
0x64,0x00,0x00,0x01,0xf6,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x1c,0xfe,0x0a,0x00,0x00,0x00,
0x00,0x00,0x00,0x40,0xe1,0x2e,0x53,0x3b,0x02,0x00,0x00,0x00,0x5e,0xfe,0xea,0xb7,0xe3,0xcf,
0x19,0x00,0x00,0x01,0x47,0x08,0x00,0x08,0xba,0xb8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x31,
0xfe,0x15,0x00,0x00,0x00,0x00,0x00,0x00,0x0d,0xff,0x2c,0x00,0x8c,0x5d,0x00,0x00,0x00,0x3b,
0xfb,0x0f,0x00,0x6b,0xed,0x39,0x00,0x1a,0xcb,0xa1,0x00,0x00,0x00,0x7f,0xf7,0xef,0xfe,0xae,
0x0d,0x00,0x00,0x00,0x00,0x0d,0x31,0x1c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x0f,0x5b,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x8e,0xa8,0x00,
0x00,0x00,0x00,0x00,0x00,0x26,0xf3,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0xb3,0x8a,0x00,0x00,
0x00,0x00,0x00,0x00,0x45,0xeb,0x0f,0x00,0x00,0x00,0x00,0x00,0x04,0xd5,0xcd,0xa7,0x83,0x17,
0x00,0x00,0x00,0x64,0xff,0xb9,0x7f,0xb7,0xed,0x2a,0x00,0x00,0xc7,0x9e,0x00,0x00,0x00,0x97,
0xba,0x00,0x00,0xf4,0x3e,0x00,0x00,0x00,0x2e,0xfc,0x02,0x00,0xe0,0x56,0x00,0x00,0x00,0x4b,
0xeb,0x00,0x00,0x78,0xdf,0x34,0x01,0x34,0xdc,0x76,0x00,0x00,0x02,0x91,0xfc,0xfc,0xfc,0x92,
0x03,0x00,0x00,0x00,0x00,0x12,0x33,0x13,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x0c,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x23,0x19,0xc8,0xc8,0xc8,0xc8,0xc8,0xdb,
0xfd,0x1c,0x00,0x00,0x00,0x00,0x00,0x00,0x95,0xb8,0x00,0x00,0x00,0x00,0x00,0x00,0x0a,0xf0,
0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x5f,0xed,0x07,0x00,0x00,0x00,0x00,0x00,0x00,0xc4,0x93,
0x00,0x00,0x00,0x00,0x00,0x00,0x29,0xff,0x31,0x00,0x00,0x00,0x00,0x00,0x00,0x8e,0xcf,0x00,
0x00,0x00,0x00,0x00,0x00,0x07,0xec,0x6e,0x00,0x00,0x00,0x00,0x00,0x00,0x58,0xf9,0x13,0x00,
0x00,0x00,0x00,0x00,0x00,0xbd,0xaa,0x00,0x00,0x00,0x00,0x00,0x00,0x23,0xfe,0x48,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x14,0x81,0xa9,0x8b,0x21,0x00,0x00,0x00,0x17,0xe6,0xb3,0x71,0xa0,0xf0,
0x2e,0x00,0x00,0x7f,0xc8,0x00,0x00,0x00,0xa2,0xa6,0x00,0x00,0x99,0xa5,0x00,0x00,0x00,0x82,
0xbd,0x00,0x00,0x48,0xf1,0x33,0x00,0x20,0xdf,0x71,0x00,0x00,0x00,0x8c,0xff,0xed,0xfe,0xb0,
0x02,0x00,0x00,0x51,0xec,0x78,0x42,0x6a,0xe6,0x6c,0x00,0x04,0xeb,0x5b,0x00,0x00,0x00,0x31,
0xfb,0x21,0x25,0xff,0x16,0x00,0x00,0x00,0x00,0xe4,0x58,0x10,0xf9,0x40,0x00,0x00,0x00,0x16,
0xfd,0x39,0x00,0x98,0xd9,0x2a,0x00,0x1c,0xc0,0xc5,0x00,0x00,0x06,0x99,0xfc,0xee,0xfe,0xb1,
0x15,0x00,0x00,0x00,0x00,0x10,0x33,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x08,0x69,0x9b,0x83,0x1f,0x00,0x00,0x00,0x12,0xd2,0xd4,0x90,0xb7,0xf5,
0x3a,0x00,0x00,0x90,0xbf,0x05,0x00,0x00,0x7e,0xd6,0x00,0x00,0xd3,0x5b,0x00,0x00,0x00,0x12,
0xff,0x1b,0x00,0xc3,0x72,0x00,0x00,0x00,0x2c,0xff,0x0f,0x00,0x60,0xec,0x38,0x00,0x16,0xc3,
0xca,0x00,0x00,0x00,0x82,0xf9,0xeb,0xfd,0xff,0x55,0x00,0x00,0x00,0x00,0x15,0x40,0xa1,0xc4,
0x00,0x00,0x00,0x00,0x00,0x00,0x1a,0xf4,0x38,0x00,0x00,0x00,0x00,0x00,0x00,0x9f,0xab,0x00,
0x00,0x00,0x00,0x00,0x00,0x30,0xf8,0x24,0x00,0x00,0x00,0x00,0x00,0x00,0xbc,0x92,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x7c,0x1e,0x19,0xf8,0x60,0x00,0x0b,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x7c,0x1e,0x19,0xf8,0x60,0x00,0x0b,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x7c,0x1e,0x19,
0xf8,0x60,0x00,0x0b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x7c,0x1e,0x19,
0xf7,0x73,0x00,0x75,0x36,0x00,0x5f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x6d,0x93,0x05,0x00,0x00,0x00,0x5b,0xf8,0x3b,0x00,0x00,0x00,
0x3a,0xf7,0x5c,0x00,0x00,0x00,0x21,0xea,0x83,0x00,0x00,0x00,0x0f,0xd5,0xa9,0x01,0x00,0x00,
0x00,0x15,0xdf,0x95,0x00,0x00,0x00,0x00,0x00,0x2d,0xf3,0x6b,0x00,0x00,0x00,0x00,0x00,0x4e,
0xf9,0x44,0x00,0x00,0x00,0x00,0x00,0x77,0xef,0x27,0x00,0x00,0x00,0x00,0x00,0x94,0xaa,0x05,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x5e,0xc4,0xc4,0xc4,0xc4,0xc4,0x96,0x28,0x54,0x54,0x54,0x54,0x54,0x40,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x70,0xe8,0xe8,0xe8,0xe8,0xe8,0xb1,0x19,0x34,0x34,0x34,0x34,0x34,0x27,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0x9c,0x5d,0x00,0x00,0x00,
0x00,0x00,0x51,0xf9,0x45,0x00,0x00,0x00,0x00,0x00,0x77,0xef,0x28,0x00,0x00,0x00,0x00,0x00,
0x9f,0xdc,0x13,0x00,0x00,0x00,0x00,0x06,0xc1,0xc2,0x06,0x00,0x00,0x00,0x01,0xae,0xce,0x0a,
0x00,0x00,0x00,0x84,0xe9,0x1d,0x00,0x00,0x00,0x58,0xf8,0x3b,0x00,0x00,0x00,0x35,0xf6,0x62,
0x00,0x00,0x00,0x0c,0xbd,0x87,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,
0x63,0xa3,0x98,0x4b,0x00,0x00,0x01,0xaf,0xde,0x79,0x84,0xec,0x8c,0x00,0x4d,0xe6,0x13,0x00,
0x00,0x37,0xff,0x21,0x30,0x4c,0x00,0x00,0x00,0x01,0xfb,0x40,0x00,0x00,0x00,0x00,0x00,0x37,
0xf9,0x16,0x00,0x00,0x00,0x00,0x36,0xe9,0x77,0x00,0x00,0x00,0x00,0x35,0xf2,0x69,0x00,0x00,
0x00,0x00,0x00,0xaa,0xa0,0x00,0x00,0x00,0x00,0x00,0x00,0xbf,0x7c,0x00,0x00,0x00,0x00,0x00,
0x00,0x24,0x17,0x00,0x00,0x00,0x00,0x00,0x00,0x5c,0x45,0x00,0x00,0x00,0x00,0x00,0x00,0xc7,
0xac,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x09,0x5f,0x95,0xa8,0x89,0x3a,0x00,0x00,0x00,0x00,0x00,0x00,0x45,0xe6,0xad,0x67,0x57,
0x7c,0xdf,0xb9,0x14,0x00,0x00,0x00,0x46,0xe6,0x38,0x00,0x00,0x00,0x00,0x08,0x8d,0xca,0x0b,
0x00,0x08,0xe7,0x3b,0x00,0x00,0x34,0x52,0x13,0x00,0x00,0x9f,0x98,0x00,0x5e,0xb0,0x00,0x00,
0x97,0xda,0xad,0xe7,0x2b,0x00,0x14,0xf2,0x0a,0x93,0x68,0x00,0x35,0xda,0x08,0x00,0x6a,0xac,
0x00,0x00,0xd2,0x30,0xa4,0x57,0x00,0x57,0xae,0x00,0x00,0x33,0xe0,0x01,0x02,0xe5,0x1d,0x88,
0x80,0x00,0x16,0xe9,0x48,0x16,0xa9,0xff,0x86,0x93,0xbc,0x00,0x3d,0xdf,0x02,0x00,0x3d,0xca,
0xea,0x9a,0x28,0x99,0x94,0x11,0x00,0x00,0xbb,0x91,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x17,0xd6,0x99,0x15,0x00,0x00,0x01,0x54,0x4a,0x00,0x00,0x00,0x00,0x00,0x0d,
0x92,0xf1,0xcc,0xbe,0xe7,0xd6,0x4b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x36,0x42,0x24,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x27,0x45,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xa9,0xf0,0x07,0x00,0x00,0x00,0x00,0x00,0x00,0x0e,
0xf6,0xeb,0x54,0x00,0x00,0x00,0x00,0x00,0x00,0x61,0xd1,0x7f,0xb0,0x00,0x00,0x00,0x00,0x00,
0x00,0xbd,0x78,0x24,0xf9,0x12,0x00,0x00,0x00,0x00,0x1c,0xfd,0x20,0x00,0xc9,0x69,0x00,0x00,
0x00,0x00,0x76,0xc8,0x00,0x00,0x6e,0xc5,0x00,0x00,0x00,0x00,0xd2,0xf1,0xdc,0xdc,0xe4,0xff,
0x21,0x00,0x00,0x2e,0xfe,0x43,0x34,0x34,0x34,0xd2,0x7d,0x00,0x00,0x8a,0xc5,0x00,0x00,0x00,
0x00,0x7b,0xd8,0x00,0x02,0xe3,0x6f,0x00,0x00,0x00,0x00,0x27,0xff,0x35,0x42,0xfe,0x1c,0x00,
0x00,0x00,0x00,0x00,0xd2,0x91,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x60,0x60,0x60,0x50,0x2d,0x00,0x00,
0x00,0x0c,0xff,0xc3,0xb8,0xc7,0xf3,0xca,0x13,0x00,0x0c,0xff,0x30,0x00,0x00,0x0d,0xc2,0xa2,
0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x63,0xda,0x00,0x0c,0xff,0x30,0x00,0x00,0x02,0xad,0xa3,
0x00,0x0c,0xff,0xab,0x98,0xa5,0xdb,0xb5,0x13,0x00,0x0c,0xff,0x94,0x7c,0x7d,0x99,0xe8,0x75,
0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x25,0xf7,0x30,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0xc4,
0x73,0x0c,0xff,0x30,0x00,0x00,0x00,0x06,0xe8,0x60,0x0c,0xff,0x46,0x1c,0x1d,0x3b,0xb5,0xe7,
0x0f,0x0c,0xff,0xff,0xff,0xfe,0xeb,0xae,0x26,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x31,
0x8d,0xa7,0x86,0x26,0x00,0x00,0x00,0x00,0x6f,0xfa,0xa1,0x74,0xa8,0xf6,0x48,0x00,0x00,0x37,
0xfa,0x4f,0x00,0x00,0x00,0x71,0xb6,0x00,0x00,0xb0,0xb5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x08,0xf8,0x57,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x24,0xff,0x2d,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x31,0xff,0x1d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1b,0xff,0x3a,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x02,0xe6,0x78,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x8c,0xe1,0x08,
0x00,0x00,0x00,0x1f,0x76,0x04,0x00,0x0f,0xe0,0xb4,0x18,0x00,0x23,0xcb,0xaf,0x00,0x00,0x00,
0x1f,0xb8,0xfc,0xe9,0xfd,0xa8,0x0d,0x00,0x00,0x00,0x00,0x00,0x1c,0x33,0x12,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x60,
0x60,0x60,0x5a,0x33,0x00,0x00,0x00,0x00,0x0c,0xff,0xc5,0xb8,0xc9,0xf6,0xc6,0x1e,0x00,0x00,
0x0c,0xff,0x30,0x00,0x00,0x17,0xbb,0xd6,0x07,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x0f,0xec,
0x6d,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x90,0xc4,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,
0x00,0x5a,0xf3,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x4c,0xfe,0x00,0x0c,0xff,0x30,0x00,
0x00,0x00,0x00,0x5d,0xe9,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x9b,0xb1,0x00,0x0c,0xff,
0x30,0x00,0x00,0x00,0x1a,0xf6,0x4d,0x00,0x0c,0xff,0x46,0x1c,0x25,0x59,0xdb,0xa8,0x00,0x00,
0x0c,0xff,0xff,0xff,0xfb,0xd9,0x76,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x60,0x60,0x60,
0x60,0x60,0x60,0x60,0x0d,0x0c,0xff,0xc5,0xb8,0xb8,0xb8,0xb8,0xb8,0x19,0x0c,0xff,0x30,0x00,
0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,
0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x81,0x64,0x64,0x64,0x64,0x51,0x00,0x0c,0xff,0xc5,0xb8,
0xb8,0xb8,0xb8,0x95,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,
0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x46,0x1c,
0x1c,0x1c,0x1c,0x1c,0x03,0x0c,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x24,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x60,0x60,0x60,
0x60,0x60,0x60,0x60,0x0d,0x0c,0xff,0xc5,0xb8,0xb8,0xb8,0xb8,0xb8,0x19,0x0c,0xff,0x30,0x00,
0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,
0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x81,0x64,0x64,0x64,0x64,0x51,0x00,0x0c,0xff,0xc5,0xb8,
0xb8,0xb8,0xb8,0x95,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,
0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,
0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2a,0x8a,0xa9,0x8f,0x31,0x00,0x00,0x00,0x00,0x00,0x60,
0xfa,0xa7,0x74,0x9e,0xf8,0x5a,0x00,0x00,0x00,0x29,0xf7,0x5f,0x00,0x00,0x00,0x53,0x53,0x00,
0x00,0x00,0xa6,0xc1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0xf4,0x5d,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x23,0xff,0x2e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x32,0xff,
0x1d,0x00,0x00,0x49,0x70,0x70,0x70,0x47,0x00,0x1c,0xff,0x3b,0x00,0x00,0x6e,0xa8,0xa8,0xdc,
0x9b,0x00,0x00,0xe3,0x7f,0x00,0x00,0x00,0x00,0x00,0xaf,0x7a,0x00,0x00,0x82,0xe5,0x0b,0x00,
0x00,0x00,0x12,0xf3,0x2d,0x00,0x00,0x0d,0xda,0xb7,0x18,0x00,0x19,0xbc,0xa7,0x00,0x00,0x00,
0x00,0x1c,0xb6,0xfb,0xe9,0xfd,0xa2,0x0d,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x36,0x19,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x04,0x60,0x12,0x00,0x00,0x00,0x00,0x3f,0x37,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0xa8,0x94,
0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0xa8,0x94,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0xa8,0x94,
0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0xa8,0x94,0x0c,0xff,0x7e,0x60,0x60,0x60,0x60,0xc9,0x94,
0x0c,0xff,0xc8,0xbc,0xbc,0xbc,0xbc,0xe8,0x94,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0xa8,0x94,
0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0xa8,0x94,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0xa8,0x94,
0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0xa8,0x94,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0xa8,0x94,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0x2a,0x00,0xcc,0x70,
0x00,0xcc,0x70,0x00,0xcc,0x70,0x00,0xcc,0x70,0x00,0xcc,0x70,0x00,0xcc,0x70,0x00,0xcc,0x70,
0x00,0xcc,0x70,0x00,0xcc,0x70,0x00,0xcc,0x70,0x00,0xcc,0x70,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x13,0x60,0x03,0x00,0x00,0x00,
0x00,0x00,0x00,0x34,0xff,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x34,0xff,0x08,0x00,0x00,0x00,
0x00,0x00,0x00,0x34,0xff,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x34,0xff,0x08,0x00,0x00,0x00,
0x00,0x00,0x00,0x34,0xff,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x34,0xff,0x08,0x04,0x2f,0x00,
0x00,0x00,0x00,0x34,0xff,0x07,0x0b,0xff,0x13,0x00,0x00,0x00,0x47,0xf9,0x00,0x00,0xd3,0x65,
0x00,0x00,0x00,0x92,0xc5,0x00,0x00,0x62,0xec,0x3f,0x03,0x58,0xfa,0x53,0x00,0x00,0x00,0x84,
0xfc,0xfd,0xf9,0x77,0x00,0x00,0x00,0x00,0x00,0x10,0x33,0x10,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x60,0x12,0x00,0x00,0x00,0x00,0x10,
0x5f,0x21,0x0c,0xff,0x30,0x00,0x00,0x00,0x0f,0xca,0xa6,0x03,0x0c,0xff,0x30,0x00,0x00,0x0e,
0xc8,0xa7,0x03,0x00,0x0c,0xff,0x30,0x00,0x0d,0xc6,0xa8,0x03,0x00,0x00,0x0c,0xff,0x30,0x0c,
0xc4,0xa9,0x04,0x00,0x00,0x00,0x0c,0xff,0x3b,0xc3,0xbd,0x04,0x00,0x00,0x00,0x00,0x0c,0xff,
0xde,0xca,0xf1,0x2a,0x00,0x00,0x00,0x00,0x0c,0xff,0xa5,0x03,0x8f,0xdc,0x12,0x00,0x00,0x00,
0x0c,0xff,0x30,0x00,0x04,0xbf,0xbe,0x04,0x00,0x00,0x0c,0xff,0x30,0x00,0x00,0x15,0xe1,0x96,
0x00,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x33,0xf7,0x6a,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,
0x00,0x5f,0xfb,0x42,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x60,0x12,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,
0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,
0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,
0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,
0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,
0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x46,0x1c,0x1c,0x1c,0x1c,0x1c,0x04,0x0c,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x28,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x04,0x60,0x42,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x60,0x28,0x0c,0xff,0xec,0x05,
0x00,0x00,0x00,0x00,0x00,0x83,0xff,0x6c,0x0c,0xff,0xf8,0x50,0x00,0x00,0x00,0x00,0x01,0xdf,
0xf8,0x6c,0x0c,0xff,0xad,0xaf,0x00,0x00,0x00,0x00,0x40,0xe5,0xc6,0x6c,0x0c,0xff,0x51,0xf9,
0x13,0x00,0x00,0x00,0x9e,0x8c,0xc4,0x6c,0x0c,0xff,0x24,0xd0,0x6c,0x00,0x00,0x0a,0xf2,0x2f,
0xc4,0x6c,0x0c,0xff,0x24,0x74,0xca,0x00,0x00,0x5b,0xd3,0x00,0xc4,0x6c,0x0c,0xff,0x24,0x1a,
0xfd,0x29,0x00,0xba,0x77,0x00,0xc4,0x6c,0x0c,0xff,0x24,0x00,0xbc,0x88,0x1b,0xfb,0x1d,0x00,
0xc4,0x6c,0x0c,0xff,0x24,0x00,0x5f,0xe3,0x7a,0xbe,0x00,0x00,0xc4,0x6c,0x0c,0xff,0x24,0x00,
0x0d,0xf6,0xf3,0x62,0x00,0x00,0xc4,0x6c,0x0c,0xff,0x24,0x00,0x00,0x96,0xdb,0x0e,0x00,0x00,
0xc4,0x6c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x04,0x60,0x18,0x00,0x00,0x00,0x00,0x07,0x60,0x0f,0x0c,0xff,0xb2,0x00,0x00,0x00,0x00,0x14,
0xff,0x28,0x0c,0xff,0xf9,0x55,0x00,0x00,0x00,0x14,0xff,0x28,0x0c,0xff,0x80,0xe7,0x11,0x00,
0x00,0x14,0xff,0x28,0x0c,0xff,0x30,0xb0,0x9c,0x00,0x00,0x14,0xff,0x28,0x0c,0xff,0x30,0x1c,
0xf1,0x40,0x00,0x14,0xff,0x28,0x0c,0xff,0x30,0x00,0x6f,0xda,0x08,0x14,0xff,0x28,0x0c,0xff,
0x30,0x00,0x03,0xcb,0x86,0x14,0xff,0x28,0x0c,0xff,0x30,0x00,0x00,0x31,0xf7,0x42,0xff,0x28,
0x0c,0xff,0x30,0x00,0x00,0x00,0x8d,0xd9,0xff,0x28,0x0c,0xff,0x30,0x00,0x00,0x00,0x0b,0xe1,
0xff,0x28,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x4c,0xff,0x28,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x3f,0x96,0xa8,0x7d,0x17,0x00,0x00,0x00,0x00,0x88,0xf4,0x8f,0x73,
0xbb,0xec,0x2e,0x00,0x00,0x41,0xf6,0x33,0x00,0x00,0x00,0x94,0xcf,0x04,0x00,0xc0,0x8e,0x00,
0x00,0x00,0x00,0x0b,0xef,0x50,0x11,0xfc,0x3d,0x00,0x00,0x00,0x00,0x00,0xa7,0xa0,0x35,0xff,
0x13,0x00,0x00,0x00,0x00,0x00,0x85,0xc5,0x40,0xff,0x0a,0x00,0x00,0x00,0x00,0x00,0x75,0xd4,
0x27,0xff,0x22,0x00,0x00,0x00,0x00,0x00,0x88,0xbd,0x04,0xed,0x56,0x00,0x00,0x00,0x00,0x00,
0xc3,0x83,0x00,0x97,0xbf,0x00,0x00,0x00,0x00,0x30,0xfb,0x2b,0x00,0x14,0xea,0x94,0x0b,0x00,
0x31,0xdb,0x92,0x00,0x00,0x00,0x2e,0xd0,0xf9,0xec,0xf9,0x90,0x05,0x00,0x00,0x00,0x00,0x00,
0x23,0x34,0x0f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x04,0x60,0x60,0x5f,0x4c,0x24,0x00,0x00,0x00,0x0c,0xff,0xc5,0xb8,0xcb,0xf5,0xba,0x14,0x00,
0x0c,0xff,0x30,0x00,0x00,0x11,0xbb,0xb4,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x42,0xfe,0x07,
0x0c,0xff,0x30,0x00,0x00,0x00,0x5c,0xf3,0x02,0x0c,0xff,0x39,0x0c,0x1e,0x59,0xe8,0x86,0x00,
0x0c,0xff,0xff,0xff,0xff,0xd8,0x71,0x02,0x00,0x0c,0xff,0x3d,0x0f,0x05,0x00,0x00,0x00,0x00,
0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,
0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3d,0x95,0xa9,0x7c,0x11,0x00,0x00,
0x00,0x00,0x00,0x81,0xf2,0x91,0x74,0xbb,0xeb,0x2e,0x00,0x00,0x00,0x3a,0xf6,0x32,0x00,0x00,
0x00,0x8e,0xde,0x06,0x00,0x00,0xb9,0x9b,0x00,0x00,0x00,0x00,0x07,0xe6,0x62,0x00,0x0f,0xfa,
0x40,0x00,0x00,0x00,0x00,0x00,0x99,0xae,0x00,0x33,0xff,0x1b,0x00,0x00,0x00,0x00,0x00,0x75,
0xd4,0x00,0x40,0xff,0x0b,0x00,0x00,0x00,0x00,0x00,0x64,0xe6,0x00,0x27,0xff,0x23,0x00,0x00,
0x00,0x00,0x00,0x74,0xd2,0x00,0x04,0xef,0x5b,0x00,0x00,0x01,0x3d,0x00,0xa7,0x9c,0x00,0x00,
0x97,0xc7,0x01,0x00,0x2a,0xf3,0x9b,0xf6,0x40,0x00,0x00,0x19,0xe6,0x9e,0x0e,0x00,0x53,0xff,
0xef,0x23,0x00,0x00,0x00,0x29,0xc4,0xfa,0xed,0xfc,0x92,0x9c,0xcf,0x01,0x00,0x00,0x00,0x00,
0x18,0x35,0x14,0x00,0x00,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x04,0x60,0x60,0x5f,0x49,0x20,0x00,0x00,0x00,0x0c,0xff,0xc5,0xb8,0xcb,
0xf4,0xb3,0x19,0x00,0x0c,0xff,0x30,0x00,0x00,0x12,0xbd,0xbe,0x00,0x0c,0xff,0x30,0x00,0x00,
0x00,0x46,0xff,0x09,0x0c,0xff,0x30,0x00,0x00,0x00,0x57,0xf2,0x01,0x0c,0xff,0x39,0x0c,0x1d,
0x52,0xe7,0x80,0x00,0x0c,0xff,0xff,0xff,0xff,0xdb,0x6e,0x00,0x00,0x0c,0xff,0x3d,0x13,0xd1,
0x9c,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,0x2f,0xf9,0x48,0x00,0x00,0x0c,0xff,0x30,0x00,0x00,
0x7c,0xe3,0x0f,0x00,0x0c,0xff,0x30,0x00,0x00,0x03,0xca,0x9e,0x00,0x0c,0xff,0x30,0x00,0x00,
0x00,0x28,0xf6,0x4a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x45,0x94,0xa4,0x76,0x11,0x00,0x00,0x00,0x7d,0xf3,0x8f,0x77,
0xc0,0xe3,0x22,0x00,0x04,0xf6,0x59,0x00,0x00,0x00,0x94,0x72,0x00,0x10,0xff,0x3a,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xc4,0xc6,0x1e,0x00,0x00,0x00,0x00,0x00,0x00,0x1b,0xbd,0xfa,0xa9,
0x3a,0x00,0x00,0x00,0x00,0x00,0x00,0x36,0xa0,0xfb,0xa6,0x09,0x00,0x00,0x00,0x00,0x00,0x00,
0x2c,0xde,0x9c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x45,0xf9,0x03,0x50,0xa5,0x01,0x00,0x00,
0x00,0x37,0xfe,0x07,0x1f,0xf0,0x9e,0x0e,0x00,0x2b,0xcf,0xb8,0x00,0x00,0x39,0xd7,0xfc,0xef,
0xfe,0xb5,0x15,0x00,0x00,0x00,0x02,0x23,0x34,0x15,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1e,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x15,
0x39,0xb8,0xb8,0xb8,0xe1,0xe7,0xb8,0xb8,0xb8,0x28,0x00,0x00,0x00,0x00,0x94,0xa8,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x94,0xa8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x94,0xa8,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x94,0xa8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x94,0xa8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x94,0xa8,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x94,0xa8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x94,0xa8,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x94,0xa8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x94,0xa8,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x60,0x15,0x00,0x00,0x00,0x00,0x0f,
0x60,0x0a,0x0c,0xff,0x38,0x00,0x00,0x00,0x00,0x28,0xff,0x1c,0x0c,0xff,0x38,0x00,0x00,0x00,
0x00,0x28,0xff,0x1c,0x0c,0xff,0x38,0x00,0x00,0x00,0x00,0x28,0xff,0x1c,0x0c,0xff,0x38,0x00,
0x00,0x00,0x00,0x28,0xff,0x1c,0x0c,0xff,0x38,0x00,0x00,0x00,0x00,0x28,0xff,0x1c,0x0b,0xff,
0x38,0x00,0x00,0x00,0x00,0x28,0xff,0x1b,0x02,0xfc,0x44,0x00,0x00,0x00,0x00,0x2f,0xff,0x13,
0x00,0xe4,0x63,0x00,0x00,0x00,0x00,0x51,0xf4,0x02,0x00,0x9f,0xb8,0x00,0x00,0x00,0x00,0xa4,
0xb6,0x00,0x00,0x2e,0xf7,0x7d,0x05,0x05,0x73,0xfc,0x3e,0x00,0x00,0x00,0x4a,0xe3,0xf8,0xf8,
0xee,0x5b,0x00,0x00,0x00,0x00,0x00,0x03,0x26,0x30,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1e,0x5f,0x01,0x00,0x00,0x00,
0x00,0x06,0x60,0x13,0x1c,0xff,0x36,0x00,0x00,0x00,0x00,0x47,0xf6,0x09,0x00,0xcd,0x83,0x00,
0x00,0x00,0x00,0x94,0xb2,0x00,0x00,0x7f,0xd0,0x00,0x00,0x00,0x00,0xe0,0x65,0x00,0x00,0x30,
0xff,0x1d,0x00,0x00,0x2d,0xfe,0x19,0x00,0x00,0x00,0xe1,0x69,0x00,0x00,0x7a,0xca,0x00,0x00,
0x00,0x00,0x94,0xb6,0x00,0x00,0xc7,0x7d,0x00,0x00,0x00,0x00,0x45,0xf7,0x0b,0x16,0xfd,0x2f,
0x00,0x00,0x00,0x00,0x05,0xf1,0x4f,0x60,0xe1,0x00,0x00,0x00,0x00,0x00,0x00,0xa8,0x9c,0xad,
0x95,0x00,0x00,0x00,0x00,0x00,0x00,0x5a,0xe8,0xf3,0x47,0x00,0x00,0x00,0x00,0x00,0x00,0x10,
0xfb,0xf3,0x07,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x1e,0x59,0x00,0x00,0x00,0x0c,0x18,0x00,0x00,0x00,0x29,0x4e,0x35,0xfe,
0x09,0x00,0x00,0xa6,0xff,0x25,0x00,0x00,0x88,0xb4,0x0d,0xff,0x2c,0x00,0x00,0xde,0xeb,0x5d,
0x00,0x00,0xad,0x8b,0x00,0xe5,0x51,0x00,0x17,0xfb,0x89,0x96,0x00,0x00,0xd2,0x63,0x00,0xbd,
0x76,0x00,0x50,0xce,0x47,0xcf,0x00,0x01,0xf6,0x3b,0x00,0x95,0x9b,0x00,0x88,0x97,0x11,0xfb,
0x0b,0x1c,0xff,0x12,0x00,0x6d,0xc0,0x00,0xc1,0x60,0x00,0xd9,0x40,0x41,0xea,0x00,0x00,0x45,
0xe5,0x04,0xf5,0x28,0x00,0xa1,0x79,0x66,0xc1,0x00,0x00,0x1d,0xff,0x3d,0xf0,0x01,0x00,0x6a,
0xb1,0x8b,0x99,0x00,0x00,0x01,0xf4,0x9b,0xba,0x00,0x00,0x33,0xea,0xb0,0x70,0x00,0x00,0x00,
0xcd,0xf0,0x82,0x00,0x00,0x04,0xf6,0xf0,0x48,0x00,0x00,0x00,0xa4,0xff,0x4b,0x00,0x00,0x00,
0xc4,0xff,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x1d,0x60,0x0a,0x00,0x00,0x00,0x00,0x30,0x57,0x00,0x06,0xd6,0x85,0x00,0x00,0x00,
0x08,0xdf,0x7b,0x00,0x00,0x3c,0xf7,0x25,0x00,0x00,0x7e,0xd5,0x05,0x00,0x00,0x00,0x98,0xb7,
0x00,0x1e,0xf4,0x3c,0x00,0x00,0x00,0x00,0x0f,0xe6,0x50,0xab,0x9b,0x00,0x00,0x00,0x00,0x00,
0x00,0x52,0xec,0xe9,0x11,0x00,0x00,0x00,0x00,0x00,0x00,0x0d,0xf1,0xaa,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x91,0xd2,0xf8,0x3e,0x00,0x00,0x00,0x00,0x00,0x33,0xf8,0x2e,0x85,0xd7,0x07,
0x00,0x00,0x00,0x03,0xcd,0x8c,0x00,0x0a,0xe0,0x80,0x00,0x00,0x00,0x71,0xe3,0x0c,0x00,0x00,
0x50,0xf9,0x28,0x00,0x1c,0xf3,0x52,0x00,0x00,0x00,0x00,0xb5,0xc1,0x01,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x1b,0x5e,0x03,0x00,0x00,0x00,0x00,0x3d,0x3f,0x06,0xd6,0x6c,0x00,0x00,0x00,0x19,0xf1,0x3c,
0x00,0x3c,0xed,0x14,0x00,0x00,0xa5,0x99,0x00,0x00,0x00,0x9b,0x9c,0x00,0x3d,0xe6,0x10,0x00,
0x00,0x00,0x11,0xe7,0x39,0xd1,0x56,0x00,0x00,0x00,0x00,0x00,0x5a,0xf1,0xb5,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xf1,0x4d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf0,0x4c,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xf0,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf0,0x4c,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xf0,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf0,0x4c,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x5e,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x31,0x00,0xb5,0xb8,0xb8,
0xb8,0xb8,0xb8,0xda,0xf2,0x1d,0x00,0x00,0x00,0x00,0x00,0x00,0x0b,0xdd,0x68,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x93,0xbe,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x3e,0xf3,0x22,0x00,0x00,
0x00,0x00,0x00,0x00,0x0a,0xdc,0x6f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x91,0xc4,0x02,0x00,
0x00,0x00,0x00,0x00,0x00,0x3c,0xf5,0x26,0x00,0x00,0x00,0x00,0x00,0x00,0x09,0xdb,0x76,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x8f,0xca,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x3b,0xfb,0x47,
0x1c,0x1c,0x1c,0x1c,0x1c,0x14,0x09,0xd9,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xbc,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xec,0xf4,0xf4,0x1a,0x00,0xf8,0x50,0x24,0x03,0x00,0xf8,0x34,0x00,
0x00,0x00,0xf8,0x34,0x00,0x00,0x00,0xf8,0x34,0x00,0x00,0x00,0xf8,0x34,0x00,0x00,0x00,0xf8,
0x34,0x00,0x00,0x00,0xf8,0x34,0x00,0x00,0x00,0xf8,0x34,0x00,0x00,0x00,0xf8,0x34,0x00,0x00,
0x00,0xf8,0x34,0x00,0x00,0x00,0xf8,0x7a,0x58,0x09,0x00,0xba,0xc0,0xc0,0x15,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x03,0x10,0x02,0x00,0x00,0x00,0x00,0x00,0x0b,0xed,0x62,0x00,0x00,0x00,0x00,0x00,0x00,0x82,
0xd7,0x01,0x00,0x00,0x00,0x00,0x00,0x14,0xf5,0x4f,0x00,0x00,0x00,0x00,0x00,0x00,0x93,0xc6,
0x00,0x00,0x00,0x00,0x00,0x00,0x20,0xfb,0x3d,0x00,0x00,0x00,0x00,0x00,0x00,0xa4,0xb3,0x00,
0x00,0x00,0x00,0x00,0x00,0x2d,0xfd,0x2b,0x00,0x00,0x00,0x00,0x00,0x00,0xb5,0xa1,0x00,0x00,
0x00,0x00,0x00,0x00,0x3e,0xfa,0x1d,0x00,0x00,0x00,0x00,0x00,0x00,0xc7,0x8e,0x00,0x00,0x00,
0x00,0x00,0x00,0x4f,0xf3,0x11,0x00,0x00,0x00,0x00,0x00,0x01,0xd6,0x7c,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf0,0xf4,0xf4,0x16,0x00,
0x23,0x31,0xff,0x18,0x00,0x00,0x10,0xff,0x18,0x00,0x00,0x10,0xff,0x18,0x00,0x00,0x10,0xff,
0x18,0x00,0x00,0x10,0xff,0x18,0x00,0x00,0x10,0xff,0x18,0x00,0x00,0x10,0xff,0x18,0x00,0x00,
0x10,0xff,0x18,0x00,0x00,0x10,0xff,0x18,0x00,0x00,0x10,0xff,0x18,0x00,0x5a,0x66,0xff,0x18,
0x00,0xbd,0xc0,0xc0,0x12,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x12,0xa5,0x57,0x00,
0x00,0x00,0x03,0xba,0xb9,0xf1,0x37,0x00,0x00,0x8d,0xd5,0x0a,0x6d,0xe6,0x1a,0x00,0x00,0x00,
0x00,0x00,0x04,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x17,0x4c,0x4c,0x4c,
0x4c,0x4c,0x4c,0x4c,0x4c,0x0f,0x41,0xd0,0xd0,0xd0,0xd0,0xd0,0xd0,0xd0,0xd0,0x2a,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x08,0x0e,0x00,0x00,0x67,0xe2,0x2a,0x00,0x00,0x6e,0xe6,0x3c,0x00,0x00,0x2c,0x67,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x75,0x5f,0x0b,0x00,0x00,
0x00,0x58,0xd9,0x9a,0xbd,0xd9,0x0f,0x00,0x00,0x01,0x04,0x00,0x00,0xaa,0x82,0x00,0x00,0x01,
0x5b,0x90,0x65,0x64,0xb5,0x00,0x00,0xa8,0xe2,0x83,0xa4,0xde,0xc4,0x00,0x30,0xfb,0x1e,0x00,
0x00,0x90,0xc4,0x00,0x4b,0xe9,0x00,0x00,0x00,0x5e,0xc4,0x00,0x1a,0xf8,0x61,0x00,0x0f,0xc4,
0xc4,0x00,0x00,0x5f,0xf5,0xe3,0xdf,0x88,0xc4,0x00,0x00,0x00,0x0c,0x30,0x0c,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x5a,0x12,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x34,0x00,0x00,0x00,0x00,0x00,
0x00,0xfc,0x34,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x35,0x5a,0x92,0x6a,0x06,0x00,0x00,0xfc,
0xaa,0xbe,0x87,0xe6,0xb3,0x00,0x00,0xfc,0xbe,0x02,0x00,0x2a,0xfd,0x31,0x00,0xfc,0x54,0x00,
0x00,0x00,0xbe,0x79,0x00,0xfc,0x31,0x00,0x00,0x00,0x9d,0x96,0x00,0xfc,0x3b,0x00,0x00,0x00,
0xa8,0x8a,0x00,0xfc,0x74,0x00,0x00,0x01,0xdc,0x62,0x00,0xfc,0xda,0x24,0x00,0x71,0xf6,0x10,
0x00,0xfc,0x6e,0xeb,0xe7,0xf6,0x59,0x00,0x00,0x00,0x00,0x0d,0x32,0x10,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x15,0x69,0x7f,0x31,0x00,0x00,0x32,0xec,0xb8,0x98,0xf2,0x57,0x00,0xd5,0x89,0x00,0x00,
0x41,0x4d,0x37,0xf7,0x0c,0x00,0x00,0x00,0x00,0x5d,0xd7,0x00,0x00,0x00,0x00,0x00,0x56,0xe2,
0x00,0x00,0x00,0x00,0x00,0x20,0xfd,0x23,0x00,0x00,0x01,0x00,0x00,0xa9,0xbc,0x0c,0x01,0x88,
0x88,0x00,0x0d,0xb4,0xf7,0xe7,0xd4,0x22,0x00,0x00,0x00,0x1f,0x2e,0x03,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x5c,0x11,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0x30,0x00,0x00,0x55,0x92,0x6c,0x07,0xff,0x30,0x00,0x7f,0xf6,0x8f,0xa7,0xa5,0xff,0x30,
0x0c,0xf3,0x57,0x00,0x00,0x91,0xff,0x30,0x49,0xee,0x02,0x00,0x00,0x25,0xff,0x30,0x63,0xd0,
0x00,0x00,0x00,0x04,0xfd,0x30,0x59,0xdb,0x00,0x00,0x00,0x0c,0xff,0x30,0x32,0xfa,0x15,0x00,
0x00,0x44,0xff,0x30,0x00,0xd3,0x9f,0x02,0x0f,0xbd,0xff,0x30,0x00,0x35,0xe9,0xed,0xf1,0x5e,
0xff,0x30,0x00,0x00,0x08,0x33,0x17,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x1d,0x76,0x7b,0x23,0x00,0x00,0x00,0x34,0xf2,0xab,0xa4,0xf4,0x3a,0x00,0x00,0xc9,
0x9b,0x00,0x00,0x7a,0xc1,0x00,0x18,0xff,0x2e,0x00,0x00,0x10,0xfe,0x12,0x35,0xff,0xbb,0xb8,
0xb8,0xb8,0xfb,0x31,0x2e,0xff,0x63,0x54,0x54,0x54,0x54,0x13,0x09,0xf8,0x49,0x00,0x00,0x00,
0x00,0x00,0x00,0x9d,0xd0,0x0c,0x01,0x6a,0x99,0x00,0x00,0x0e,0xbd,0xf0,0xe7,0xdd,0x39,0x00,
0x00,0x00,0x00,0x26,0x2c,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x01,0x57,0x81,0x1e,0x00,0x00,0x88,0xc4,0xa5,0x3e,0x00,0x00,0xe5,0x46,
0x00,0x00,0x01,0x64,0xf6,0x8d,0x4e,0x00,0x02,0xac,0xfa,0xc1,0x86,0x00,0x00,0x00,0xf0,0x40,
0x00,0x00,0x00,0x00,0xf0,0x40,0x00,0x00,0x00,0x00,0xf0,0x40,0x00,0x00,0x00,0x00,0xf0,0x40,
0x00,0x00,0x00,0x00,0xf0,0x40,0x00,0x00,0x00,0x00,0xf0,0x40,0x00,0x00,0x00,0x00,0xf0,0x40,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x55,0x92,0x6c,0x07,0x64,0x12,
0x00,0x7f,0xf6,0x8f,0xa7,0xa5,0xff,0x30,0x0c,0xf3,0x57,0x00,0x00,0x91,0xff,0x30,0x49,0xee,
0x02,0x00,0x00,0x25,0xff,0x30,0x63,0xd0,0x00,0x00,0x00,0x04,0xfd,0x30,0x5d,0xdb,0x00,0x00,
0x00,0x0c,0xff,0x30,0x33,0xfa,0x15,0x00,0x00,0x44,0xff,0x30,0x01,0xd5,0x9f,0x02,0x0f,0xbe,
0xff,0x30,0x00,0x31,0xe4,0xed,0xf0,0x5d,0xff,0x30,0x07,0x20,0x08,0x33,0x15,0x0b,0xff,0x26,
0x0e,0xf4,0x32,0x00,0x00,0x60,0xe2,0x02,0x00,0x5e,0xee,0xa1,0xab,0xf1,0x44,0x00,0x00,0x00,
0x27,0x75,0x6a,0x1d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x5e,0x13,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x34,0x00,0x00,0x00,0x00,0x00,
0x00,0xfc,0x34,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x34,0x59,0x92,0x6b,0x05,0x00,0x00,0xfc,
0xb1,0xb0,0x81,0xe7,0xa7,0x00,0x00,0xfc,0xb2,0x00,0x00,0x34,0xff,0x28,0x00,0xfc,0x5c,0x00,
0x00,0x00,0xda,0x60,0x00,0xfc,0x3d,0x00,0x00,0x00,0xbb,0x74,0x00,0xfc,0x34,0x00,0x00,0x00,
0xb4,0x78,0x00,0xfc,0x34,0x00,0x00,0x00,0xb4,0x78,0x00,0xfc,0x34,0x00,0x00,0x00,0xb4,0x78,
0x00,0xfc,0x34,0x00,0x00,0x00,0xb4,0x78,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0e,
0x01,0x00,0xde,0x64,0x00,0x2d,0x0b,0x00,0x52,0x23,0x00,0xd4,0x5c,0x00,0xd4,0x5c,0x00,0xd4,
0x5c,0x00,0xd4,0x5c,0x00,0xd4,0x5c,0x00,0xd4,0x5c,0x00,0xd4,0x5c,0x00,0xd4,0x5c,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05,0x09,0x00,0x00,0x8f,0xaf,0x00,0x00,
0x17,0x20,0x00,0x00,0x35,0x41,0x00,0x00,0x88,0xa8,0x00,0x00,0x88,0xa8,0x00,0x00,0x88,0xa8,
0x00,0x00,0x88,0xa8,0x00,0x00,0x88,0xa8,0x00,0x00,0x88,0xa8,0x00,0x00,0x88,0xa8,0x00,0x00,
0x88,0xa8,0x00,0x00,0x88,0xa8,0x02,0x00,0x98,0x91,0xa0,0xc9,0xe3,0x28,0x19,0x4d,0x10,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5a,0x12,0x00,
0x00,0x00,0x00,0x00,0x00,0xfc,0x34,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x34,0x00,0x00,0x00,
0x00,0x00,0x00,0xfc,0x34,0x00,0x00,0x4d,0x3a,0x00,0x00,0xfc,0x34,0x00,0x59,0xe4,0x1b,0x00,
0x00,0xfc,0x34,0x36,0xed,0x33,0x00,0x00,0x00,0xfc,0x4f,0xe5,0x54,0x00,0x00,0x00,0x00,0xfc,
0xea,0xed,0x15,0x00,0x00,0x00,0x00,0xfc,0xa0,0x99,0xb8,0x01,0x00,0x00,0x00,0xfc,0x34,0x09,
0xd3,0x79,0x00,0x00,0x00,0xfc,0x34,0x00,0x2a,0xf1,0x3c,0x00,0x00,0xfc,0x34,0x00,0x00,0x62,
0xe3,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0x21,0x00,
0x00,0xd4,0x5c,0x00,0x00,0xd4,0x5c,0x00,0x00,0xd4,0x5c,0x00,0x00,0xd4,0x5c,0x00,0x00,0xd4,
0x5c,0x00,0x00,0xd4,0x5c,0x00,0x00,0xd4,0x5c,0x00,0x00,0xd4,0x5c,0x00,0x00,0xd4,0x5c,0x00,
0x00,0xce,0x6a,0x00,0x00,0x7a,0xf7,0x3b,0x00,0x00,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x62,0x17,0x6e,0x8e,0x36,0x00,0x32,0x8d,0x6e,0x05,0x00,0x00,0xfc,0xb2,0x93,0xad,0xf8,
0x53,0xce,0x93,0xeb,0x98,0x00,0x00,0xfc,0x92,0x00,0x00,0xd2,0xf2,0x18,0x00,0x56,0xf7,0x05,
0x00,0xfc,0x4d,0x00,0x00,0x97,0xc6,0x00,0x00,0x1c,0xff,0x1d,0x00,0xfc,0x38,0x00,0x00,0x86,
0xb0,0x00,0x00,0x0b,0xff,0x28,0x00,0xfc,0x34,0x00,0x00,0x84,0xac,0x00,0x00,0x08,0xff,0x28,
0x00,0xfc,0x34,0x00,0x00,0x84,0xac,0x00,0x00,0x08,0xff,0x28,0x00,0xfc,0x34,0x00,0x00,0x84,
0xac,0x00,0x00,0x08,0xff,0x28,0x00,0xfc,0x34,0x00,0x00,0x84,0xac,0x00,0x00,0x08,0xff,0x28,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x62,0x15,0x59,
0x92,0x6b,0x05,0x00,0x00,0xfc,0xb1,0xb0,0x81,0xe7,0xa7,0x00,0x00,0xfc,0xb2,0x00,0x00,0x34,
0xff,0x28,0x00,0xfc,0x5c,0x00,0x00,0x00,0xda,0x60,0x00,0xfc,0x3d,0x00,0x00,0x00,0xbb,0x74,
0x00,0xfc,0x34,0x00,0x00,0x00,0xb4,0x78,0x00,0xfc,0x34,0x00,0x00,0x00,0xb4,0x78,0x00,0xfc,
0x34,0x00,0x00,0x00,0xb4,0x78,0x00,0xfc,0x34,0x00,0x00,0x00,0xb4,0x78,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1b,0x72,0x7f,0x3e,
0x00,0x00,0x00,0x2f,0xf0,0xb0,0x92,0xeb,0x83,0x00,0x00,0xb6,0x8c,0x00,0x00,0x27,0xf8,0x2a,
0x0a,0xfe,0x2c,0x00,0x00,0x00,0xc0,0x79,0x29,0xff,0x0a,0x00,0x00,0x00,0x9f,0x98,0x25,0xff,
0x11,0x00,0x00,0x00,0xa6,0x91,0x05,0xf3,0x44,0x00,0x00,0x00,0xd9,0x65,0x00,0x91,0xc7,0x0c,
0x00,0x6a,0xef,0x12,0x00,0x09,0xae,0xf1,0xe0,0xe8,0x42,0x00,0x00,0x00,0x00,0x1e,0x2f,0x08,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x62,0x15,0x5a,0x92,0x6a,0x06,0x00,
0x00,0xfc,0xaa,0xbe,0x87,0xe6,0xb3,0x00,0x00,0xfc,0xbe,0x02,0x00,0x2a,0xfd,0x31,0x00,0xfc,
0x54,0x00,0x00,0x00,0xbe,0x79,0x00,0xfc,0x31,0x00,0x00,0x00,0x9d,0x96,0x00,0xfc,0x3b,0x00,
0x00,0x00,0xa8,0x8a,0x00,0xfc,0x74,0x00,0x00,0x01,0xdc,0x62,0x00,0xfc,0xda,0x24,0x00,0x71,
0xf6,0x10,0x00,0xfc,0x6e,0xeb,0xe7,0xf6,0x59,0x00,0x00,0xfc,0x34,0x0d,0x32,0x10,0x00,0x00,
0x00,0xfc,0x34,0x00,0x00,0x00,0x00,0x00,0x00,0xfc,0x34,0x00,0x00,0x00,0x00,0x00,0x00,0x56,
0x11,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x55,
0x92,0x6c,0x07,0x64,0x12,0x00,0x00,0x7f,0xf6,0x8f,0xa7,0xa5,0xff,0x30,0x00,0x0c,0xf3,0x57,
0x00,0x00,0x91,0xff,0x30,0x00,0x49,0xee,0x02,0x00,0x00,0x25,0xff,0x30,0x00,0x63,0xd0,0x00,
0x00,0x00,0x04,0xfd,0x30,0x00,0x59,0xdb,0x00,0x00,0x00,0x0c,0xff,0x30,0x00,0x32,0xfa,0x15,
0x00,0x00,0x44,0xff,0x30,0x00,0x00,0xd6,0x9f,0x02,0x0f,0xbd,0xff,0x30,0x00,0x00,0x37,0xea,
0xed,0xf2,0x5d,0xff,0x30,0x00,0x00,0x00,0x09,0x33,0x15,0x00,0xff,0x30,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xfd,0x33,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xca,0xc0,0x0f,0x00,0x00,0x00,
0x00,0x00,0x00,0x16,0x6e,0x0e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x62,0x15,0x59,0x92,0x52,
0x00,0xfc,0xb1,0xb0,0x88,0x3d,0x00,0xfc,0xb2,0x00,0x00,0x00,0x00,0xfc,0x5c,0x00,0x00,0x00,
0x00,0xfc,0x3d,0x00,0x00,0x00,0x00,0xfc,0x34,0x00,0x00,0x00,0x00,0xfc,0x34,0x00,0x00,0x00,
0x00,0xfc,0x34,0x00,0x00,0x00,0x00,0xfc,0x34,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x55,0x89,0x71,
0x14,0x00,0x00,0xa2,0xd9,0x83,0xb5,0xe7,0x1b,0x02,0xfa,0x33,0x00,0x00,0x52,0x18,0x00,0xd8,
0x90,0x08,0x00,0x00,0x00,0x00,0x2c,0xcc,0xef,0x98,0x22,0x00,0x00,0x00,0x00,0x34,0xa1,0xf3,
0x2c,0x00,0x00,0x00,0x00,0x00,0xbc,0x83,0x11,0xd3,0x3a,0x00,0x10,0xdc,0x61,0x00,0x69,0xf3,
0xdc,0xf3,0xa1,0x03,0x00,0x00,0x0e,0x32,0x19,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x08,0x58,0x08,0x00,0x00,0x18,0xff,0x18,0x00,0x14,0x72,0xff,0x72,0x3e,
0x22,0xb3,0xff,0xb3,0x6b,0x00,0x18,0xff,0x18,0x00,0x00,0x18,0xff,0x18,0x00,0x00,0x18,0xff,
0x18,0x00,0x00,0x18,0xff,0x18,0x00,0x00,0x18,0xff,0x18,0x00,0x00,0x10,0xff,0x2b,0x00,0x00,
0x00,0xc4,0xeb,0x6b,0x00,0x00,0x03,0x2d,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x64,0x0c,0x00,0x00,0x00,0x4e,0x28,0x10,0xff,
0x20,0x00,0x00,0x00,0xc8,0x68,0x10,0xff,0x20,0x00,0x00,0x00,0xc8,0x68,0x10,0xff,0x20,0x00,
0x00,0x00,0xc8,0x68,0x0f,0xff,0x20,0x00,0x00,0x00,0xc8,0x68,0x08,0xff,0x2d,0x00,0x00,0x00,
0xdf,0x68,0x00,0xe8,0x5a,0x00,0x00,0x0d,0xfc,0x68,0x00,0x9b,0xcf,0x0d,0x02,0x92,0xf4,0x68,
0x00,0x16,0xd3,0xf2,0xe9,0x95,0xc8,0x68,0x00,0x00,0x03,0x30,0x1f,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x1d,0x5f,0x00,0x00,0x00,0x00,0x49,0x31,0x14,0xfb,0x2c,0x00,
0x00,0x06,0xf0,0x41,0x00,0xb8,0x7e,0x00,0x00,0x4b,0xe6,0x02,0x00,0x61,0xcf,0x00,0x00,0x9f,
0x90,0x00,0x00,0x10,0xf9,0x21,0x04,0xed,0x38,0x00,0x00,0x00,0xb4,0x73,0x47,0xdf,0x00,0x00,
0x00,0x00,0x5d,0xc4,0x9b,0x88,0x00,0x00,0x00,0x00,0x0e,0xf6,0xef,0x30,0x00,0x00,0x00,0x00,
0x00,0xaf,0xd7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x29,0x4d,0x00,0x00,0x0e,0x54,0x07,0x00,0x00,0x55,0x21,
0x3c,0xee,0x01,0x00,0x57,0xff,0x42,0x00,0x0a,0xfb,0x26,0x04,0xf3,0x2c,0x00,0x99,0xdc,0x84,
0x00,0x41,0xe1,0x00,0x00,0xb3,0x68,0x00,0xda,0x5b,0xc6,0x00,0x7d,0x9d,0x00,0x00,0x6f,0xa3,
0x1d,0xdd,0x05,0xef,0x0c,0xb8,0x58,0x00,0x00,0x2b,0xdf,0x5f,0x9a,0x00,0xb7,0x4c,0xef,0x15,
0x00,0x00,0x00,0xe6,0xbb,0x57,0x00,0x75,0xbb,0xcf,0x00,0x00,0x00,0x00,0xa3,0xfe,0x15,0x00,
0x33,0xff,0x8a,0x00,0x00,0x00,0x00,0x5e,0xd1,0x00,0x00,0x02,0xee,0x46,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x2c,0x56,0x00,0x00,0x00,0x45,0x3d,0x18,0xf2,0x3e,0x00,0x1b,0xf5,0x37,0x00,0x75,0xc7,
0x00,0x9b,0xa0,0x00,0x00,0x06,0xd9,0x7a,0xee,0x18,0x00,0x00,0x00,0x51,0xff,0x7e,0x00,0x00,
0x00,0x00,0x8b,0xe5,0xbf,0x00,0x00,0x00,0x26,0xf3,0x27,0xdf,0x55,0x00,0x00,0xb5,0x94,0x00,
0x5a,0xe1,0x09,0x4a,0xf5,0x18,0x00,0x01,0xcc,0x81,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x06,0x64,0x0c,0x00,0x00,0x00,0x4e,0x28,0x10,0xff,0x20,0x00,0x00,0x00,
0xc8,0x68,0x10,0xff,0x20,0x00,0x00,0x00,0xc8,0x68,0x10,0xff,0x20,0x00,0x00,0x00,0xc8,0x68,
0x0f,0xff,0x20,0x00,0x00,0x00,0xc8,0x68,0x08,0xff,0x2d,0x00,0x00,0x00,0xdf,0x68,0x00,0xe8,
0x5a,0x00,0x00,0x0d,0xfc,0x68,0x00,0x9b,0xcf,0x0d,0x02,0x92,0xf4,0x68,0x00,0x16,0xd3,0xf2,
0xe9,0x95,0xc8,0x68,0x00,0x00,0x03,0x30,0x1f,0x00,0xd6,0x5e,0x00,0x22,0x31,0x00,0x00,0x35,
0xf5,0x1e,0x00,0x62,0xf2,0xab,0xa2,0xf0,0x63,0x00,0x00,0x00,0x25,0x73,0x6d,0x24,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x60,0x64,0x64,0x64,0x64,0x5f,0x01,0x00,0xb2,0xb8,0xb8,0xb8,0xfc,0x8d,0x00,
0x00,0x00,0x00,0x00,0x5a,0xe4,0x0c,0x00,0x00,0x00,0x00,0x0e,0xe6,0x56,0x00,0x00,0x00,0x00,
0x00,0x91,0xba,0x00,0x00,0x00,0x00,0x00,0x2f,0xf5,0x26,0x00,0x00,0x00,0x00,0x01,0xc6,0x83,
0x00,0x00,0x00,0x00,0x00,0x63,0xe9,0x25,0x1c,0x1c,0x18,0x00,0x12,0xeb,0xff,0xff,0xff,0xff,
0xdc,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x35,0xcc,0xe6,0x00,0x00,0x00,0xb2,0x9a,0x1a,0x00,0x00,0x00,
0xc2,0x57,0x00,0x00,0x00,0x00,0xcd,0x4b,0x00,0x00,0x00,0x02,0xf1,0x28,0x00,0x00,0x00,0x5f,
0xe7,0x01,0x00,0x00,0x0c,0xc9,0xa7,0x00,0x00,0x00,0x00,0x25,0xfb,0x0e,0x00,0x00,0x00,0x00,
0xe1,0x2e,0x00,0x00,0x00,0x00,0xcb,0x47,0x00,0x00,0x00,0x00,0xbf,0x58,0x00,0x00,0x00,0x00,
0xa7,0xb5,0x44,0x00,0x00,0x00,0x20,0xa5,0xc3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x01,0x5c,0x08,0x04,0xff,0x18,0x04,0xff,0x18,0x04,0xff,0x18,0x04,0xff,
0x18,0x04,0xff,0x18,0x04,0xff,0x18,0x04,0xff,0x18,0x04,0xff,0x18,0x04,0xff,0x18,0x04,0xff,
0x18,0x04,0xff,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xe2,0xcc,0x37,0x00,0x00,0x00,0x19,0x9a,0xb3,0x00,0x00,0x00,0x00,
0x57,0xc2,0x00,0x00,0x00,0x00,0x43,0xd0,0x00,0x00,0x00,0x00,0x28,0xf0,0x02,0x00,0x00,0x00,
0x03,0xe9,0x59,0x00,0x00,0x00,0x00,0xa2,0xc6,0x0a,0x00,0x00,0x08,0xf9,0x29,0x00,0x00,0x00,
0x37,0xe4,0x00,0x00,0x00,0x00,0x50,0xcb,0x00,0x00,0x00,0x00,0x59,0xc2,0x00,0x00,0x00,0x4f,
0xbd,0xa9,0x00,0x00,0x00,0xb4,0x99,0x1c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x17,0x9a,0x74,0x00,0x00,0x10,0x76,0x82,
0xb6,0xbd,0xb1,0x72,0x04,0x00,0x02,0x6d,0x74,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x31,0x8d,0xa7,0x86,0x26,0x00,0x00,
0x00,0x00,0x6f,0xfa,0xa1,0x74,0xa8,0xf6,0x48,0x00,0x00,0x37,0xfa,0x4f,0x00,0x00,0x00,0x71,
0xb6,0x00,0x00,0xb0,0xb5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0xf8,0x57,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x24,0xff,0x2d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x31,0xff,0x1d,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x1b,0xff,0x3a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0xe6,
0x78,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x8c,0xe1,0x08,0x00,0x00,0x00,0x1f,0x76,0x04,
0x00,0x0f,0xe0,0xb4,0x18,0x00,0x23,0xcb,0xaf,0x00,0x00,0x00,0x1f,0xb8,0xfc,0xe9,0xfd,0xa8,
0x0d,0x00,0x00,0x00,0x00,0x00,0x1c,0x6f,0x54,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x74,
0xd1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0xdf,0x88,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x37,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x39,0xc0,0x03,0x00,0x7d,0x85,0x00,0x00,
0x00,0x00,0x1c,0x74,0x00,0x00,0x45,0x46,0x00,0x00,0x00,0x00,0x00,0x3f,0x96,0xa8,0x7d,0x17,
0x00,0x00,0x00,0x00,0x88,0xf4,0x8f,0x73,0xbb,0xec,0x2e,0x00,0x00,0x41,0xf6,0x33,0x00,0x00,
0x00,0x94,0xcf,0x04,0x00,0xc0,0x8e,0x00,0x00,0x00,0x00,0x0b,0xef,0x50,0x11,0xfc,0x3d,0x00,
0x00,0x00,0x00,0x00,0xa7,0xa0,0x35,0xff,0x13,0x00,0x00,0x00,0x00,0x00,0x85,0xc5,0x40,0xff,
0x0a,0x00,0x00,0x00,0x00,0x00,0x75,0xd4,0x27,0xff,0x22,0x00,0x00,0x00,0x00,0x00,0x88,0xbd,
0x04,0xed,0x56,0x00,0x00,0x00,0x00,0x00,0xc3,0x83,0x00,0x97,0xbf,0x00,0x00,0x00,0x00,0x30,
0xfb,0x2b,0x00,0x14,0xea,0x94,0x0b,0x00,0x31,0xdb,0x92,0x00,0x00,0x00,0x2e,0xd0,0xf9,0xec,
0xf9,0x90,0x05,0x00,0x00,0x00,0x00,0x00,0x23,0x34,0x0f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x39,0xc0,0x03,0x00,0x7d,0x85,
0x00,0x00,0x00,0x00,0x1c,0x74,0x00,0x00,0x45,0x46,0x00,0x00,0x04,0x60,0x15,0x00,0x00,0x00,
0x00,0x0f,0x60,0x0a,0x0c,0xff,0x38,0x00,0x00,0x00,0x00,0x28,0xff,0x1c,0x0c,0xff,0x38,0x00,
0x00,0x00,0x00,0x28,0xff,0x1c,0x0c,0xff,0x38,0x00,0x00,0x00,0x00,0x28,0xff,0x1c,0x0c,0xff,
0x38,0x00,0x00,0x00,0x00,0x28,0xff,0x1c,0x0c,0xff,0x38,0x00,0x00,0x00,0x00,0x28,0xff,0x1c,
0x0b,0xff,0x38,0x00,0x00,0x00,0x00,0x28,0xff,0x1b,0x02,0xfc,0x44,0x00,0x00,0x00,0x00,0x2f,
0xff,0x13,0x00,0xe4,0x63,0x00,0x00,0x00,0x00,0x51,0xf4,0x02,0x00,0x9f,0xb8,0x00,0x00,0x00,
0x00,0xa4,0xb6,0x00,0x00,0x2e,0xf7,0x7d,0x05,0x05,0x73,0xfc,0x3e,0x00,0x00,0x00,0x4a,0xe3,
0xf8,0xf8,0xee,0x5b,0x00,0x00,0x00,0x00,0x00,0x03,0x26,0x30,0x06,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x15,0x69,0x7f,0x31,
0x00,0x00,0x00,0x32,0xec,0xb8,0x98,0xf2,0x57,0x00,0x00,0xd5,0x89,0x00,0x00,0x41,0x4d,0x00,
0x37,0xf7,0x0c,0x00,0x00,0x00,0x00,0x00,0x5d,0xd7,0x00,0x00,0x00,0x00,0x00,0x00,0x56,0xe2,
0x00,0x00,0x00,0x00,0x00,0x00,0x20,0xfd,0x23,0x00,0x00,0x01,0x00,0x00,0x00,0xa9,0xbc,0x0c,
0x01,0x88,0x88,0x00,0x00,0x0d,0xb4,0xf7,0xe7,0xd4,0x22,0x00,0x00,0x00,0x00,0x5b,0x70,0x03,
0x00,0x00,0x00,0x00,0x00,0x74,0xd1,0x00,0x00,0x00,0x00,0x00,0x02,0xdf,0x88,0x00,0x00,0x00,
0x00,0x00,0x00,0x37,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x39,0xc0,0x03,0x00,0x7d,
0x85,0x00,0x00,0x1c,0x74,0x00,0x00,0x45,0x46,0x00,0x00,0x00,0x1b,0x72,0x7f,0x3e,0x00,0x00,
0x00,0x2f,0xf0,0xb0,0x92,0xeb,0x83,0x00,0x00,0xb6,0x8c,0x00,0x00,0x27,0xf8,0x2a,0x0a,0xfe,
0x2c,0x00,0x00,0x00,0xc0,0x79,0x29,0xff,0x0a,0x00,0x00,0x00,0x9f,0x98,0x25,0xff,0x11,0x00,
0x00,0x00,0xa6,0x91,0x05,0xf3,0x44,0x00,0x00,0x00,0xd9,0x65,0x00,0x91,0xc7,0x0c,0x00,0x6a,
0xef,0x12,0x00,0x09,0xae,0xf1,0xe0,0xe8,0x42,0x00,0x00,0x00,0x00,0x1e,0x2f,0x08,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x39,0xc0,0x03,0x00,0x7d,0x85,0x00,
0x00,0x1c,0x74,0x00,0x00,0x45,0x46,0x00,0x06,0x64,0x0c,0x00,0x00,0x00,0x4e,0x28,0x10,0xff,
0x20,0x00,0x00,0x00,0xc8,0x68,0x10,0xff,0x20,0x00,0x00,0x00,0xc8,0x68,0x10,0xff,0x20,0x00,
0x00,0x00,0xc8,0x68,0x0f,0xff,0x20,0x00,0x00,0x00,0xc8,0x68,0x08,0xff,0x2d,0x00,0x00,0x00,
0xdf,0x68,0x00,0xe8,0x5a,0x00,0x00,0x0d,0xfc,0x68,0x00,0x9b,0xcf,0x0d,0x02,0x92,0xf4,0x68,
0x00,0x16,0xd3,0xf2,0xe9,0x95,0xc8,0x68,0x00,0x00,0x03,0x30,0x1f,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x13,
0x2e,0x00,0x00,0x16,0x2b,0x00,0x00,0x00,0x00,0x00,0x0e,0xd3,0x1d,0x07,0xb7,0x45,0x00,0x00,
0x00,0x00,0x00,0x00,0x5c,0xf4,0xf3,0x99,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2a,0x99,0xc3,
0x8f,0x31,0x00,0x00,0x00,0x00,0x00,0x60,0xfa,0xa7,0x74,0x9e,0xf8,0x5a,0x00,0x00,0x00,0x29,
0xf7,0x5f,0x00,0x00,0x00,0x53,0x53,0x00,0x00,0x00,0xa6,0xc1,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x06,0xf4,0x5d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x23,0xff,0x2e,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x32,0xff,0x1d,0x00,0x00,0x49,0x70,0x70,0x70,0x47,0x00,0x1c,
0xff,0x3b,0x00,0x00,0x6e,0xa8,0xa8,0xdc,0x9b,0x00,0x00,0xe3,0x7f,0x00,0x00,0x00,0x00,0x00,
0xaf,0x7a,0x00,0x00,0x82,0xe5,0x0b,0x00,0x00,0x00,0x12,0xf3,0x2d,0x00,0x00,0x0d,0xda,0xb7,
0x18,0x00,0x19,0xbc,0xa7,0x00,0x00,0x00,0x00,0x1c,0xb6,0xfb,0xe9,0xfd,0xa2,0x0d,0x00,0x00,
0x00,0x00,0x00,0x00,0x19,0x36,0x19,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x13,0x2e,0x00,0x00,0x16,0x2b,0x00,0x00,0x0e,0xd3,0x1d,0x07,0xb7,
0x45,0x00,0x00,0x00,0x5c,0xf4,0xf3,0x99,0x00,0x00,0x00,0x00,0x55,0xa1,0x87,0x07,0x64,0x12,
0x00,0x7f,0xf6,0x8f,0xa7,0xa5,0xff,0x30,0x0c,0xf3,0x57,0x00,0x00,0x91,0xff,0x30,0x49,0xee,
0x02,0x00,0x00,0x25,0xff,0x30,0x63,0xd0,0x00,0x00,0x00,0x04,0xfd,0x30,0x5d,0xdb,0x00,0x00,
0x00,0x0c,0xff,0x30,0x33,0xfa,0x15,0x00,0x00,0x44,0xff,0x30,0x01,0xd5,0x9f,0x02,0x0f,0xbe,
0xff,0x30,0x00,0x31,0xe4,0xed,0xf0,0x5d,0xff,0x30,0x07,0x20,0x08,0x33,0x15,0x0b,0xff,0x26,
0x0e,0xf4,0x32,0x00,0x00,0x60,0xe2,0x02,0x00,0x5e,0xee,0xa1,0xab,0xf1,0x44,0x00,0x00,0x00,
0x27,0x75,0x6a,0x1d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x39,0xc0,0x03,0x1c,0x74,0x00,
0x00,0x4c,0x2a,0x00,0xcc,0x70,0x00,0xcc,0x70,0x00,0xcc,0x70,0x00,0xcc,0x70,0x00,0xcc,0x70,
0x00,0xcc,0x70,0x00,0xcc,0x70,0x00,0xcc,0x70,0x00,0xcc,0x70,0x00,0xcc,0x70,0x00,0xcc,0x70,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5a,0x1c,
0x00,0xe8,0x48,0x00,0xe8,0x48,0x00,0xe8,0x48,0x00,0xe8,0x48,0x00,0xe8,0x48,0x00,0xe8,0x48,
0x00,0xe8,0x48,0x00,0xe8,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x45,0x94,0xa4,0x76,0x11,0x00,0x00,0x00,0x7d,0xf3,0x8f,0x77,0xc0,0xe3,0x21,0x00,
0x04,0xf6,0x59,0x00,0x00,0x00,0x94,0x71,0x00,0x11,0xff,0x3b,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xc3,0xc6,0x1c,0x00,0x00,0x00,0x00,0x00,0x00,0x1a,0xbe,0xfa,0xa9,0x3c,0x00,0x00,0x00,
0x00,0x00,0x00,0x37,0xa0,0xfa,0xa9,0x09,0x00,0x00,0x00,0x00,0x00,0x00,0x2b,0xdd,0x9d,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x45,0xf8,0x03,0x50,0xa5,0x01,0x00,0x00,0x00,0x37,0xfe,0x07,
0x1f,0xf0,0x9e,0x0e,0x00,0x2b,0xcf,0xb9,0x00,0x00,0x37,0xd5,0xfc,0xef,0xfe,0xb3,0x14,0x00,
0x00,0x00,0x02,0x6b,0xa7,0x13,0x00,0x00,0x00,0x00,0x00,0x00,0x5b,0xee,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xd5,0x73,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x14,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05,0x5d,0x8a,0x6d,
0x0f,0x00,0x00,0xb4,0xd4,0x83,0xbc,0xdf,0x13,0x0d,0xff,0x29,0x00,0x02,0x54,0x13,0x01,0xe2,
0x89,0x06,0x00,0x00,0x00,0x00,0x32,0xd2,0xed,0x93,0x1e,0x00,0x00,0x00,0x01,0x3a,0xa9,0xef,
0x22,0x00,0x00,0x00,0x00,0x00,0xca,0x75,0x1a,0xd4,0x2e,0x00,0x16,0xe7,0x51,0x00,0x76,0xf5,
0xdb,0xf4,0x94,0x01,0x00,0x00,0x14,0xc5,0x3f,0x00,0x00,0x00,0x00,0x00,0xc8,0x83,0x00,0x00,
0x00,0x00,0x44,0xdf,0x25,0x00,0x00,0x00,0x00,0x08,0x0c,0x00,0x00,0x00,
  };
  static const struct {
    uint32_t ds;
    uint16_t width;
  } glinfo[]= {

{0,5}, {100,3}, {160,5}, {260,12}, 
{500,8}, {660,11}, {880,10}, {1080,3}, 
{1140,4}, {1220,4}, {1300,7}, {1440,7}, 
{1580,3}, {1640,7}, {1780,3}, {1840,8}, 
{2000,9}, {2180,9}, {2360,9}, {2540,9}, 
{2720,9}, {2900,9}, {3080,9}, {3260,9}, 
{3440,9}, {3620,9}, {3800,3}, {3860,3}, 
{3920,7}, {4060,7}, {4200,7}, {4340,8}, 
{4500,13}, {4760,10}, {4960,9}, {5140,10}, 
{5340,10}, {5540,9}, {5720,9}, {5900,11}, 
{6120,9}, {6300,3}, {6360,9}, {6540,10}, 
{6740,9}, {6920,12}, {7160,10}, {7360,10}, 
{7560,9}, {7740,11}, {7960,9}, {8140,9}, 
{8320,10}, {8520,10}, {8720,10}, {8920,12}, 
{9160,10}, {9360,9}, {9540,10}, {9740,5}, 
{9840,8}, {10000,5}, {10100,7}, {10240,10}, 
{10440,4}, {10520,8}, {10680,8}, {10840,7}, 
{10980,8}, {11140,8}, {11300,6}, {11420,8}, 
{11580,8}, {11740,3}, {11800,4}, {11880,8}, 
{12040,4}, {12120,12}, {12360,8}, {12520,8}, 
{12680,8}, {12840,9}, {13020,6}, {13140,7}, 
{13280,5}, {13380,8}, {13540,8}, {13700,11}, 
{13920,7}, {14060,8}, {14220,8}, {14380,6}, 
{14500,3}, {14560,6}, {14680,6}, {14800,10}, 
{15000,10}, {15200,10}, {15400,8}, {15560,8}, 
{15720,8}, {15880,11}, {16100,8}, {16260,3}, 
{16320,3}, {16380,9}, {16560,7}, 
  };
  // static const int nmap= sizeof(glmap)/sizeof(glmap[0]);
  int i,j,k,e,x,y,sX,eX;
  int W, X, *Xpos;
  char buf[20];
  int *map, *gl;
  int ngl;
  unsigned int C;
  int glyph_width;
  const unsigned char *glyph_data;
  unsigned char *data;

  map= alloca(L*sizeof(int));

  e= 0;
  ngl= 0;
  for(i=0;i<L;i++)
  {
    C= str[i];
    
    if (C&(1<<31)) { ngl+=2; e= 1; continue; }
    map[i]= font_hash(C);
    if (map[i]!=107) { ngl++; continue; }
    sprintf(buf,"%x",C); ngl+= strlen(buf); e= 1;
  }

  if (e) goto fix_encoding_errors;
  else gl= map;

encoding_errors_fixed:

  W= 0;
  for(i=0;i<ngl;i++) W+= glinfo[gl[i]].width;

  if (Rdata) data= malloc(W*20);
  X= 0;
  if (e && Rdata) Xpos= alloca(sizeof(int)*(ngl+1));
  for(i=0;i<ngl;i++)
  {
    if (e && Rdata) Xpos[i]= X;
    glyph_width= glinfo[gl[i]].width;
    if (Rdata) {
      glyph_data= font_data + glinfo[gl[i]].ds;
      for(y=0;y<20;y++)
         for(x=0;x<glyph_width;x++)
            data[y*W+X+x]= glyph_data[y*glyph_width+x];
    }
    X+= glyph_width;
  }
  if (e && Rdata) Xpos[i]= X;
  if (RW) *RW= W;
  if (RA) *RA= 16;
  if (RH) *RH= 20;
  if (Rdata) *Rdata= data;

  if (!e || !Rdata) return ;

  j= 0;
  for(i=0;i<L;i++)
  {
    if (str[i]&(1<<31))
    {
      sX= Xpos[j]; eX= Xpos[j+2];
      for(x=sX;x<eX;x++)
        for(y=0;y<20;y++)
          data[y*W + x] ^= 0xff;
      j+= 2;
      continue;
    }
    if (map[i]==107)
    {
      sprintf(buf,"%x",str[i]);
      sX= Xpos[j]; eX= Xpos[j+strlen(buf)];
      for(x=sX;x<eX;x++) {
        data[ 0*W + x]= 0xff;
        data[ (20-1)*W + x]= 0xff;
      }
      for(y=0;y<20;y++)
      {
        data[y*W+sX] = 0xff;
        data[y*W+eX-1] = 0xff;
      }
      j+= strlen(buf);
      continue;
    }
    j++;
  }
  return ;


fix_encoding_errors:
  j= 0;
  gl= alloca(sizeof(int)*ngl);
  for(i=0;i<L;i++)
  {
    if (str[i]&(1<<31))
    {
      sprintf(buf,"%02x", str[i]&0xff);
      for(k=0;buf[k];k++)
         gl[j++]= font_hash(buf[k]);
      continue;
    }
    if (map[i]==107)
    {
      sprintf(buf,"%x", str[i]);
      for(k=0;buf[k];k++)
         gl[j++]= font_hash(buf[k]);
      continue;
    }
    gl[j++]= map[i];
  }
  goto encoding_errors_fixed;
}

static 
void font2_render
        (uint32_t *str, size_t L, 
        int *RW, int *RH, int *RA,
        unsigned char **Rdata)
{
  static const uint8_t font_data[]= {

0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xc4,0xd1,0x07,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,
0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xdb,0xe3,0x0b,0x00,
0x6c,0xcb,0x4c,0x00,0xf3,0xff,0xca,0x00,0x91,0xf3,0x6d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xd3,0xe4,0x15,0xdd,0xdc,0x00,0x00,0xff,0xff,
0x28,0xff,0xff,0x00,0x00,0xff,0xff,0x28,0xff,0xff,0x00,0x00,0xe8,0xe8,0x1a,0xe6,0xe3,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x14,0xff,0xff,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x14,0xff,
0xff,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0x00,0x00,0xec,0xec,0xed,0xff,0xff,0xec,0xff,0xff,0xed,0xec,0xec,0x00,0x00,0x00,
0x00,0x14,0xff,0xff,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x14,0xff,0xff,0x00,
0xff,0xff,0x14,0x00,0x00,0x00,0x00,0xec,0xec,0xed,0xff,0xff,0xec,0xff,0xff,0xed,0xec,0xec,
0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x14,
0xff,0xff,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x14,0xff,0xff,0x00,0xff,0xff,
0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x14,0xff,0xff,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x2c,0xfc,0x00,0x00,0x00,0x00,0x00,0x39,0xa8,0xd8,0xff,0xc7,0x48,0x00,0x00,0x69,0xff,
0xff,0xff,0xff,0xff,0xfc,0x3f,0x00,0xeb,0xff,0x84,0x43,0xfc,0x83,0x8d,0x2b,0x00,0xe7,0xff,
0x3b,0x2c,0xfc,0x00,0x00,0x00,0x00,0x8b,0xff,0xf8,0xc4,0xfc,0x02,0x00,0x00,0x00,0x06,0x8a,
0xfa,0xff,0xff,0xde,0x51,0x00,0x00,0x00,0x00,0x0e,0x6c,0xff,0xff,0xfe,0x57,0x00,0x00,0x00,
0x00,0x2c,0xfc,0x71,0xff,0xd1,0x06,0x60,0xa9,0x10,0x2c,0xfc,0x1f,0xff,0xf5,0x03,0xd6,0xff,
0xc9,0x62,0xfc,0x82,0xff,0xd5,0x00,0x2b,0xec,0xff,0xff,0xff,0xff,0xff,0x60,0x00,0x00,0x17,
0x95,0xdd,0xff,0xcb,0x5d,0x00,0x00,0x00,0x00,0x00,0x2c,0xfc,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1e,0xba,0xf3,0xc0,0x23,
0x00,0x06,0x81,0x17,0x00,0x00,0x00,0xbc,0xff,0xfd,0xff,0xcc,0x00,0x6f,0xc5,0x00,0x00,0x00,
0x00,0xf3,0xff,0x43,0xff,0xff,0x15,0xea,0x3e,0x00,0x00,0x00,0x00,0xbf,0xff,0xfc,0xff,0xd1,
0x82,0xb6,0x00,0x00,0x00,0x00,0x00,0x20,0xbc,0xf4,0xc3,0x3e,0xf2,0x30,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x94,0xa7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x23,0xf5,
0x3c,0xb4,0xf3,0xc5,0x27,0x00,0x00,0x00,0x00,0x00,0xa7,0x98,0xa9,0xff,0xda,0xff,0xcf,0x00,
0x00,0x00,0x00,0x31,0xf4,0x1a,0xe0,0xff,0x3a,0xff,0xff,0x08,0x00,0x00,0x00,0xb9,0x89,0x00,
0xab,0xff,0xfd,0xff,0xd2,0x00,0x00,0x00,0x0f,0x7b,0x11,0x00,0x18,0xb6,0xf3,0xc7,0x29,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x9a,0xe9,0xee,0x8f,0x04,0x00,0x00,0x00,
0x00,0x00,0xad,0xff,0xfb,0xfe,0xff,0x82,0x00,0x00,0x00,0x00,0x06,0xfa,0xff,0x26,0x33,0x69,
0x12,0x00,0x00,0x00,0x00,0x03,0xf6,0xff,0x3d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7f,
0xff,0xff,0xff,0x18,0x00,0x00,0x00,0x00,0x00,0x0e,0xbf,0xff,0xf9,0xec,0x16,0x00,0x00,0x00,
0x00,0x00,0x95,0xff,0xb0,0x09,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xe5,0xff,0x2f,0x00,0xff,
0xff,0xff,0xff,0xff,0x00,0x00,0xf8,0xff,0x23,0x00,0xec,0xf6,0xff,0xf8,0xec,0x00,0x00,0xcb,
0xff,0x9f,0x06,0x0c,0xc1,0xff,0x8a,0x00,0x00,0x00,0x43,0xfb,0xff,0xf9,0xfc,0xff,0xee,0x20,
0x00,0x00,0x00,0x00,0x3c,0xbd,0xf4,0xea,0xae,0x29,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xd3,0xe4,0x0b,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,
0xe8,0xe8,0x0d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0xfe,0xe6,0x0e,0x00,0x02,0xd9,
0xff,0x5c,0x00,0x00,0x4c,0xff,0xe4,0x04,0x00,0x00,0x9c,0xff,0x8c,0x00,0x00,0x00,0xd4,0xff,
0x4f,0x00,0x00,0x00,0xef,0xff,0x29,0x00,0x00,0x00,0xfc,0xff,0x19,0x00,0x00,0x00,0xf1,0xff,
0x28,0x00,0x00,0x00,0xd8,0xff,0x4c,0x00,0x00,0x00,0xa5,0xff,0x8c,0x00,0x00,0x00,0x55,0xff,
0xe4,0x04,0x00,0x00,0x04,0xde,0xff,0x5c,0x00,0x00,0x00,0x42,0xfe,0xe6,0x0e,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xdc,0xff,0x4b,0x00,0x00,0x00,0x51,0xff,
0xe3,0x06,0x00,0x00,0x02,0xdf,0xff,0x5b,0x00,0x00,0x00,0x83,0xff,0xad,0x00,0x00,0x00,0x41,
0xff,0xe6,0x00,0x00,0x00,0x18,0xff,0xfe,0x02,0x00,0x00,0x06,0xff,0xff,0x0f,0x00,0x00,0x17,
0xff,0xfe,0x03,0x00,0x00,0x3e,0xff,0xe7,0x00,0x00,0x00,0x80,0xff,0xb1,0x00,0x00,0x01,0xdb,
0xff,0x5f,0x00,0x00,0x4d,0xff,0xe6,0x08,0x00,0x07,0xdb,0xff,0x4d,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x6c,0x10,
0x0c,0x6c,0x18,0x00,0x00,0x00,0x00,0x70,0xff,0x8b,0x85,0xff,0x7d,0x00,0x00,0x00,0x00,0x06,
0xcc,0xf8,0xf5,0xd3,0x08,0x00,0x00,0x00,0xc9,0xec,0xf4,0xff,0xff,0xf5,0xec,0xc3,0x00,0x00,
0xd7,0xff,0xff,0xff,0xff,0xff,0xff,0xdd,0x00,0x00,0x00,0x02,0xc4,0xf9,0xfb,0xbf,0x02,0x00,
0x00,0x00,0x00,0x69,0xff,0x8c,0x93,0xff,0x65,0x00,0x00,0x00,0x00,0x23,0x7c,0x0e,0x10,0x7d,
0x23,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,
0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xec,0xec,0xff,0xff,0xed,0xec,0xec,0x00,
0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x90,0xf3,0x71,0x00,0xf3,0xff,0xc9,0x00,0x5f,0xff,0x85,
0x00,0x2f,0xd3,0x0e,0x00,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xec,0xec,0xec,0xec,0xec,0xec,0x00,
0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x6c,0xcb,0x4c,0x00,0xf3,0xff,0xca,0x00,0x91,0xf3,0x6d,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,
0x7d,0x80,0x1a,0x00,0x00,0x00,0x00,0x00,0x58,0xff,0xe0,0x02,0x00,0x00,0x00,0x00,0x00,0xc7,
0xff,0x77,0x00,0x00,0x00,0x00,0x00,0x36,0xff,0xf7,0x13,0x00,0x00,0x00,0x00,0x00,0xa6,0xff,
0x9f,0x00,0x00,0x00,0x00,0x00,0x1a,0xfa,0xff,0x33,0x00,0x00,0x00,0x00,0x00,0x84,0xff,0xc6,
0x00,0x00,0x00,0x00,0x00,0x08,0xeb,0xff,0x5a,0x00,0x00,0x00,0x00,0x00,0x63,0xff,0xe8,0x06,
0x00,0x00,0x00,0x00,0x00,0xd2,0xff,0x82,0x00,0x00,0x00,0x00,0x00,0x42,0xff,0xfb,0x1a,0x00,
0x00,0x00,0x00,0x00,0xb1,0xff,0xaa,0x00,0x00,0x00,0x00,0x00,0x22,0xfd,0xff,0x3e,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x16,0xa3,0xef,0xf3,0xb3,0x24,0x00,0x00,0x00,0x07,0xd2,0xff,0xfd,0xfb,0xff,0xe4,0x13,
0x00,0x00,0x6a,0xff,0xc2,0x11,0x09,0xa6,0xff,0x83,0x00,0x00,0xbe,0xff,0x48,0x00,0x00,0x30,
0xff,0xd3,0x00,0x00,0xea,0xff,0x21,0x00,0x00,0x0e,0xff,0xfb,0x03,0x00,0xfb,0xff,0x15,0x00,
0x00,0x02,0xff,0xff,0x0f,0x00,0xf4,0xff,0x19,0x00,0x00,0x04,0xff,0xff,0x07,0x00,0xdd,0xff,
0x28,0x00,0x00,0x17,0xff,0xef,0x00,0x00,0xa7,0xff,0x57,0x00,0x00,0x49,0xff,0xb7,0x00,0x00,
0x4e,0xff,0xc9,0x12,0x09,0xb9,0xff,0x5d,0x00,0x00,0x01,0xbb,0xff,0xfd,0xf9,0xff,0xc5,0x04,
0x00,0x00,0x00,0x0e,0x96,0xe9,0xeb,0x9d,0x12,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x89,0xff,0xff,0x14,
0x00,0x00,0x00,0x00,0x04,0xa2,0xff,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x03,0x10,0x10,0xff,
0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1e,0x9f,0xe7,0xf4,0xc4,0x50,0x00,0x00,0x00,0x24,0xe7,
0xff,0xfd,0xf7,0xff,0xff,0x61,0x00,0x00,0x85,0xff,0xd0,0x17,0x02,0x84,0xff,0xd5,0x00,0x00,
0x00,0x1c,0x22,0x00,0x00,0x20,0xff,0xfa,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5a,0xff,0xe7,
0x00,0x00,0x00,0x00,0x00,0x00,0x3f,0xee,0xff,0x8e,0x00,0x00,0x00,0x00,0x06,0x87,0xfd,0xff,
0xbf,0x09,0x00,0x00,0x00,0x1a,0xcb,0xff,0xff,0x93,0x06,0x00,0x00,0x00,0x0e,0xd5,0xff,0xf1,
0x4d,0x00,0x00,0x00,0x00,0x00,0x87,0xff,0xf6,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0xd8,0xff,
0xfb,0xec,0xec,0xec,0xec,0xec,0x00,0x00,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x68,0xd9,0xf7,0xdb,0x7e,0x07,0x00,0x00,0x00,0x64,0xff,0xff,0xf6,0xff,0xff,0x9c,0x00,
0x00,0x00,0x4c,0x9d,0x76,0x00,0x5e,0xff,0xf8,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x0b,0xff,
0xfb,0x07,0x00,0x00,0x00,0x00,0x00,0x04,0x7a,0xff,0xbe,0x00,0x00,0x00,0x00,0x00,0x80,0xff,
0xff,0xff,0x71,0x00,0x00,0x00,0x00,0x00,0x76,0xec,0xfc,0xff,0xfe,0x54,0x00,0x00,0x00,0x00,
0x00,0x00,0x0d,0xa1,0xff,0xd5,0x00,0x00,0x00,0x1d,0x00,0x00,0x00,0x23,0xff,0xf7,0x00,0x1d,
0xe6,0xff,0x6f,0x04,0x07,0x92,0xff,0xc7,0x00,0x00,0x93,0xff,0xff,0xf8,0xfb,0xff,0xf7,0x30,
0x00,0x00,0x00,0x68,0xd1,0xf8,0xf0,0xae,0x27,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x93,0xff,
0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x3b,0xfe,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x07,0xd8,
0xfd,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x86,0xff,0x91,0xff,0xff,0x00,0x00,0x00,0x00,0x31,
0xfb,0xd0,0x19,0xff,0xff,0x00,0x00,0x00,0x04,0xce,0xfb,0x32,0x14,0xff,0xff,0x00,0x00,0x00,
0x79,0xff,0x87,0x00,0x14,0xff,0xff,0x00,0x00,0x00,0xf8,0xff,0xf6,0xf4,0xf4,0xff,0xff,0xf4,
0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x14,0xff,
0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x14,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x14,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xa6,0xff,0xff,0xff,0xff,0xff,0x0c,0x00,0x00,0x00,0xd3,
0xff,0xf0,0xec,0xec,0xec,0x0b,0x00,0x00,0x05,0xfa,0xff,0x1a,0x00,0x00,0x00,0x00,0x00,0x00,
0x2c,0xff,0xe6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x59,0xff,0xf7,0xf6,0xef,0xb4,0x33,0x00,
0x00,0x00,0x60,0xf7,0xff,0xfa,0xfc,0xff,0xf9,0x3a,0x00,0x00,0x00,0x0e,0x4b,0x06,0x0b,0xab,
0xff,0xc7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1b,0xff,0xfd,0x06,0x08,0x4a,0x76,0x0d,0x00,
0x00,0x16,0xff,0xfd,0x06,0x07,0xea,0xff,0xa2,0x09,0x09,0xa2,0xff,0xc5,0x00,0x00,0x50,0xfb,
0xff,0xfa,0xfb,0xff,0xf9,0x39,0x00,0x00,0x00,0x3d,0xb9,0xee,0xf1,0xb6,0x33,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xa3,0xff,0xdd,0x08,0x00,0x00,0x00,0x00,0x00,0x2c,0xfd,0xff,0x4a,0x00,0x00,
0x00,0x00,0x00,0x00,0xb0,0xff,0xae,0x00,0x00,0x00,0x00,0x00,0x00,0x36,0xff,0xf4,0x1e,0x00,
0x00,0x00,0x00,0x00,0x00,0xbe,0xff,0xfd,0xf3,0xc2,0x3d,0x00,0x00,0x00,0x47,0xff,0xff,0xff,
0xff,0xff,0xfa,0x38,0x00,0x00,0xb0,0xff,0xbe,0x1b,0x1f,0xc1,0xff,0xb9,0x00,0x00,0xe6,0xff,
0x2f,0x00,0x00,0x32,0xff,0xf2,0x00,0x00,0xf6,0xff,0x29,0x00,0x00,0x2a,0xff,0xf3,0x00,0x00,
0xc1,0xff,0xaf,0x0c,0x0d,0xb3,0xff,0xa9,0x00,0x00,0x37,0xf8,0xff,0xfb,0xfc,0xff,0xed,0x1b,
0x00,0x00,0x00,0x31,0xb5,0xf1,0xf0,0xab,0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0x86,0x00,0xec,0xec,0xec,0xec,0xec,0xff,0xff,0xf1,0x12,0x00,0x00,0x00,0x00,0x00,
0x4a,0xff,0xff,0x82,0x00,0x00,0x00,0x00,0x00,0x00,0xc9,0xff,0xef,0x10,0x00,0x00,0x00,0x00,
0x00,0x49,0xff,0xff,0x7d,0x00,0x00,0x00,0x00,0x00,0x00,0xc8,0xff,0xed,0x0d,0x00,0x00,0x00,
0x00,0x00,0x47,0xff,0xff,0x78,0x00,0x00,0x00,0x00,0x00,0x00,0xc6,0xff,0xea,0x0b,0x00,0x00,
0x00,0x00,0x00,0x46,0xff,0xff,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0xc5,0xff,0xe7,0x09,0x00,
0x00,0x00,0x00,0x00,0x45,0xff,0xff,0x6f,0x00,0x00,0x00,0x00,0x00,0x00,0xc4,0xff,0xe4,0x08,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0a,0x85,0xdd,0xf6,0xda,0x7e,0x07,0x00,0x00,0x00,0xa5,
0xff,0xff,0xf4,0xff,0xff,0x9e,0x00,0x00,0x06,0xf9,0xff,0x3d,0x00,0x3d,0xff,0xf8,0x05,0x00,
0x03,0xf6,0xff,0x38,0x00,0x3a,0xff,0xf8,0x05,0x00,0x00,0x80,0xff,0xff,0xf2,0xff,0xff,0x85,
0x00,0x00,0x09,0xb6,0xff,0xff,0xff,0xff,0xff,0xb6,0x09,0x00,0x8b,0xff,0xca,0x31,0x0a,0x3c,
0xd8,0xff,0x8d,0x00,0xe7,0xff,0x32,0x00,0x00,0x00,0x39,0xff,0xe7,0x00,0xf6,0xff,0x2c,0x00,
0x00,0x00,0x2d,0xff,0xf5,0x00,0xbe,0xff,0xbd,0x1d,0x00,0x1f,0xc0,0xff,0xbd,0x00,0x35,0xf6,
0xff,0xff,0xf4,0xff,0xff,0xf3,0x33,0x00,0x00,0x2d,0xab,0xea,0xfb,0xe6,0x9b,0x21,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x35,0xb4,0xf2,0xf0,0xb4,0x2f,0x00,0x00,0x00,0x35,0xf9,0xff,0xfb,0xfa,0xff,0xf7,0x33,
0x00,0x00,0xcc,0xff,0x95,0x07,0x07,0x94,0xff,0xbd,0x00,0x00,0xf9,0xff,0x22,0x00,0x00,0x22,
0xff,0xf5,0x00,0x00,0xd6,0xff,0x96,0x08,0x06,0x93,0xff,0xe5,0x00,0x00,0x5b,0xff,0xff,0xfb,
0xfa,0xff,0xff,0xaf,0x00,0x00,0x00,0x4a,0xc7,0xf2,0xfe,0xff,0xff,0x44,0x00,0x00,0x00,0x00,
0x00,0x10,0xf0,0xff,0xbd,0x00,0x00,0x00,0x00,0x00,0x00,0x7e,0xff,0xff,0x35,0x00,0x00,0x00,
0x00,0x00,0x0d,0xed,0xff,0xaf,0x00,0x00,0x00,0x00,0x00,0x00,0x78,0xff,0xfd,0x2b,0x00,0x00,
0x00,0x00,0x00,0x0a,0xea,0xff,0xa3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x91,0xf3,0x6b,0x00,0xf3,0xff,
0xcb,0x00,0x6d,0xcb,0x4f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x6c,0xcb,0x4c,0x00,0xf3,0xff,0xca,0x00,0x91,0xf3,0x6d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x90,0xf3,0x6a,0x00,0xf3,0xff,0xcb,0x00,0x6d,0xcb,0x4f,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x44,0x9b,0x34,0x00,0xef,0xff,
0xc7,0x00,0xac,0xff,0xa6,0x00,0x1c,0xf7,0x2d,0x00,0x12,0x38,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x82,0xff,0xfd,0x40,0x00,0x00,0x38,0xfc,0xff,0x8c,0x00,0x00,0x0c,0xdc,0xff,0xd2,0x07,
0x00,0x00,0x9c,0xff,0xf9,0x2e,0x00,0x00,0x4e,0xff,0xff,0x76,0x00,0x00,0x00,0x41,0xfe,0xff,
0x7a,0x00,0x00,0x00,0x00,0x90,0xff,0xfa,0x30,0x00,0x00,0x00,0x08,0xd7,0xff,0xd3,0x07,0x00,
0x00,0x00,0x34,0xfb,0xff,0x8b,0x00,0x00,0x00,0x00,0x80,0xff,0xfd,0x3d,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xec,0xec,
0xec,0xec,0xec,0xec,0xec,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xec,0xec,0xec,0xec,0xec,0xec,0xec,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x36,0xfb,0xff,0x9d,0x00,0x00,0x00,0x00,
0x7e,0xff,0xff,0x4f,0x00,0x00,0x00,0x03,0xc6,0xff,0xea,0x16,0x00,0x00,0x00,0x22,0xf2,0xff,
0xb2,0x00,0x00,0x00,0x00,0x60,0xff,0xff,0x64,0x00,0x00,0x00,0x6b,0xff,0xff,0x52,0x00,0x00,
0x26,0xf5,0xff,0xa4,0x00,0x00,0x04,0xca,0xff,0xe5,0x11,0x00,0x00,0x81,0xff,0xff,0x48,0x00,
0x00,0x36,0xfb,0xff,0x9a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x17,0x9c,0xe4,0xf6,0xcd,0x67,0x01,0x00,
0x07,0xcf,0xff,0xff,0xf6,0xff,0xff,0x8b,0x00,0x4e,0xff,0xf7,0x33,0x00,0x54,0xff,0xf4,0x02,
0x03,0x23,0x36,0x00,0x00,0x1c,0xff,0xfa,0x05,0x00,0x00,0x00,0x00,0x15,0xc2,0xff,0xb1,0x00,
0x00,0x00,0x00,0x3b,0xe8,0xff,0xc5,0x13,0x00,0x00,0x00,0x00,0xe2,0xff,0x97,0x04,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0x19,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x07,0x00,0x00,0x00,
0x00,0x00,0x00,0x6c,0xcb,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xf3,0xff,0xca,0x00,0x00,0x00,
0x00,0x00,0x00,0x8e,0xf3,0x6d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x48,0xaa,
0xe5,0xf9,0xea,0xb7,0x5f,0x05,0x00,0x00,0x00,0x00,0x00,0x0f,0xb2,0xff,0xff,0xff,0xf2,0xfe,
0xff,0xff,0xd0,0x21,0x00,0x00,0x00,0x02,0xc0,0xff,0xf3,0x77,0x13,0x00,0x09,0x55,0xdd,0xff,
0xdb,0x0c,0x00,0x00,0x63,0xff,0xf4,0x2c,0x66,0xd2,0xf5,0xdb,0x76,0x13,0xd6,0xff,0x82,0x00,
0x00,0xc5,0xff,0x71,0x88,0xff,0xff,0xf4,0xff,0xff,0x8b,0x4b,0xff,0xe1,0x00,0x00,0xf2,0xff,
0x23,0xf1,0xff,0x53,0x00,0x4a,0xff,0xee,0x0e,0xff,0xff,0x09,0x00,0xf2,0xff,0x24,0xe7,0xff,
0x68,0x08,0x67,0xff,0xff,0x51,0xff,0xf6,0x02,0x00,0xc5,0xff,0x72,0x6c,0xff,0xff,0xff,0xff,
0xe8,0xf4,0xff,0xff,0x9b,0x00,0x00,0x65,0xff,0xf0,0x2f,0x4e,0xbf,0xe3,0xbf,0x31,0x58,0xdd,
0xa0,0x0b,0x00,0x00,0x03,0xc2,0xff,0xf8,0x87,0x1c,0x00,0x03,0x24,0x60,0x02,0x00,0x00,0x00,
0x00,0x00,0x10,0xb5,0xff,0xff,0xff,0xf4,0xfb,0xff,0xef,0x27,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x49,0xaa,0xe5,0xfa,0xe8,0xa0,0x1f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xae,0xff,0xff,0x46,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x11,0xf9,0xff,0xff,0xa2,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x67,0xff,0xfb,
0xff,0xf4,0x0b,0x00,0x00,0x00,0x00,0x00,0x00,0xc3,0xff,0x94,0xec,0xff,0x5c,0x00,0x00,0x00,
0x00,0x00,0x21,0xfe,0xff,0x38,0x9a,0xff,0xb8,0x00,0x00,0x00,0x00,0x00,0x7c,0xff,0xdf,0x00,
0x43,0xff,0xfc,0x18,0x00,0x00,0x00,0x00,0xd8,0xff,0x88,0x00,0x03,0xe8,0xff,0x72,0x00,0x00,
0x00,0x35,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xce,0x00,0x00,0x00,0x91,0xff,0xfe,0xf4,0xf4,
0xf4,0xf7,0xff,0xff,0x2b,0x00,0x04,0xe9,0xff,0xac,0x00,0x00,0x00,0x18,0xfc,0xff,0x88,0x00,
0x4a,0xff,0xff,0x4d,0x00,0x00,0x00,0x00,0xb6,0xff,0xe2,0x01,0xa6,0xff,0xea,0x04,0x00,0x00,
0x00,0x00,0x57,0xff,0xff,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0xfe,0xec,0xbe,0x56,0x00,0x00,0x00,0x00,0xff,0xff,0xed,0xee,0xfe,
0xff,0xff,0x6a,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x0b,0x93,0xff,0xe1,0x00,0x00,0x00,0xff,
0xff,0x14,0x00,0x00,0x23,0xff,0xf8,0x00,0x00,0x00,0xff,0xff,0x14,0x01,0x1c,0xa0,0xff,0xc0,
0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xee,0x2b,0x00,0x00,0x00,0xff,0xff,0xed,0xec,
0xf2,0xff,0xff,0xe3,0x27,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x13,0x97,0xff,0xbb,0x00,0x00,
0xff,0xff,0x14,0x00,0x00,0x00,0x24,0xff,0xf4,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x12,0x97,
0xff,0xd3,0x00,0x00,0xff,0xff,0xed,0xec,0xf2,0xff,0xff,0xfd,0x4d,0x00,0x00,0xff,0xff,0xff,
0xff,0xfe,0xed,0xb7,0x45,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x4f,0xc2,0xf4,0xf4,0xb8,0x3a,0x00,0x00,0x00,0x00,0x00,0x6f,
0xff,0xff,0xf6,0xfd,0xff,0xfd,0x5a,0x00,0x00,0x00,0x28,0xf8,0xfa,0x61,0x02,0x14,0xbd,0xff,
0xf6,0x1e,0x00,0x00,0x8e,0xff,0x96,0x00,0x00,0x00,0x10,0xf5,0xff,0x81,0x00,0x00,0xd7,0xff,
0x3f,0x00,0x00,0x00,0x00,0x13,0x18,0x0f,0x00,0x00,0xf4,0xff,0x1c,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xf4,0xff,0x1b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xd9,0xff,
0x3e,0x00,0x00,0x00,0x00,0x0c,0x10,0x0a,0x00,0x00,0x90,0xff,0x94,0x00,0x00,0x00,0x0f,0xf3,
0xff,0x84,0x00,0x00,0x29,0xf9,0xfa,0x60,0x06,0x14,0xb7,0xff,0xf7,0x22,0x00,0x00,0x00,0x72,
0xff,0xff,0xf9,0xfe,0xff,0xfe,0x60,0x00,0x00,0x00,0x00,0x00,0x52,0xc5,0xf5,0xeb,0xb8,0x3e,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0xff,0xea,0xb1,0x36,0x00,0x00,0x00,0x00,0xff,0xff,0xed,0xf1,0xff,0xff,0xfb,0x5d,
0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x1d,0xa5,0xff,0xf7,0x26,0x00,0x00,0xff,0xff,0x14,0x00,
0x00,0x01,0xc5,0xff,0x94,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x4d,0xff,0xdb,0x00,0x00,
0xff,0xff,0x14,0x00,0x00,0x00,0x22,0xff,0xf7,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x2d,
0xff,0xee,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x5a,0xff,0xcd,0x00,0x00,0xff,0xff,0x14,
0x00,0x00,0x02,0xd0,0xff,0x82,0x00,0x00,0xff,0xff,0x14,0x00,0x1e,0xaa,0xff,0xf0,0x18,0x00,
0x00,0xff,0xff,0xed,0xf0,0xff,0xff,0xf8,0x4f,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xe9,0xaf,
0x31,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,
0x00,0xff,0xff,0xed,0xec,0xec,0xec,0xec,0xec,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x80,0x00,0x00,0xff,0xff,0xed,
0xec,0xec,0xec,0xec,0x76,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xff,0xff,0xed,0xec,0xec,0xec,0xec,0xec,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xed,0xec,0xec,
0xec,0xec,0xec,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0x80,0x00,0x00,0xff,0xff,0xed,0xec,0xec,0xec,0xec,0x76,0x00,
0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4a,0xbb,0xf0,0xf5,0xc9,0x5a,0x00,0x00,0x00,
0x00,0x00,0x70,0xff,0xff,0xfb,0xfa,0xff,0xff,0x85,0x00,0x00,0x00,0x2f,0xfa,0xff,0x86,0x08,
0x0b,0x87,0xc2,0x7b,0x02,0x00,0x00,0x98,0xff,0xaa,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xdc,0xff,0x45,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf7,0xff,0x1e,0x00,0x00,
0xec,0xec,0xec,0xec,0xec,0x00,0x00,0xee,0xff,0x27,0x00,0x00,0xff,0xff,0xff,0xff,0xfa,0x00,
0x00,0xce,0xff,0x55,0x00,0x00,0x00,0x00,0x6f,0xff,0xe4,0x00,0x00,0x81,0xff,0xbc,0x00,0x00,
0x00,0x00,0xae,0xff,0xaa,0x00,0x00,0x1e,0xf2,0xff,0x91,0x08,0x07,0x67,0xfe,0xff,0x48,0x00,
0x00,0x00,0x5b,0xfd,0xff,0xfa,0xfb,0xff,0xff,0x9b,0x00,0x00,0x00,0x00,0x00,0x3d,0xb5,0xef,
0xf8,0xd2,0x6e,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,
0x00,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0xff,
0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,
0x00,0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0x14,0x00,0xff,0xff,0xed,0xec,0xec,0xec,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,
0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,
0x00,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0xff,
0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,
0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,
0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,
0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,
0x00,0xf5,0xff,0x1f,0x00,0x00,0x0b,0xff,0xff,0x0a,0x00,0xd9,0xff,0x46,0x00,0x00,0x37,0xff,
0xed,0x00,0x00,0x8e,0xff,0xc2,0x10,0x0a,0xbb,0xff,0xa5,0x00,0x00,0x19,0xe9,0xff,0xfd,0xf9,
0xff,0xf1,0x26,0x00,0x00,0x00,0x25,0xb0,0xf3,0xf0,0xb6,0x2e,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x0b,0xcc,0xff,0xdc,0x15,0x00,0xff,0xff,0x14,0x00,0x03,
0xb5,0xff,0xed,0x26,0x00,0x00,0xff,0xff,0x14,0x00,0x9a,0xff,0xf9,0x3e,0x00,0x00,0x00,0xff,
0xff,0x14,0x7b,0xff,0xff,0x5b,0x00,0x00,0x00,0x00,0xff,0xff,0x71,0xff,0xff,0x7d,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xfd,0xff,0xee,0x0a,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xfe,0xfb,
0xff,0x9b,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x73,0x73,0xff,0xff,0x54,0x00,0x00,0x00,0x00,
0xff,0xff,0x14,0x01,0xb7,0xff,0xef,0x1f,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x16,0xe7,0xff,
0xc5,0x04,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x45,0xfe,0xff,0x84,0x00,0x00,0xff,0xff,0x14,
0x00,0x00,0x00,0x89,0xff,0xfd,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00,0x00,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xfb,0x16,0x00,0x00,0x00,0x00,0x14,0xfa,
0xff,0xff,0x00,0x00,0xff,0xff,0xff,0x6f,0x00,0x00,0x00,0x00,0x6e,0xff,0xff,0xff,0x00,0x00,
0xff,0xff,0xff,0xcc,0x00,0x00,0x00,0x00,0xcd,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,
0x29,0x00,0x00,0x2b,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xdb,0xff,0x86,0x00,0x00,0x8a,
0xff,0xda,0xff,0xff,0x00,0x00,0xff,0xff,0x84,0xff,0xe1,0x01,0x03,0xe5,0xff,0x81,0xff,0xff,
0x00,0x00,0xff,0xff,0x2f,0xfd,0xff,0x41,0x47,0xff,0xfc,0x2b,0xff,0xff,0x00,0x00,0xff,0xff,
0x14,0xc1,0xff,0x9e,0xa6,0xff,0xbb,0x14,0xff,0xff,0x00,0x00,0xff,0xff,0x14,0x6a,0xff,0xf2,
0xf6,0xff,0x62,0x14,0xff,0xff,0x00,0x00,0xff,0xff,0x14,0x16,0xfc,0xff,0xff,0xf9,0x10,0x14,
0xff,0xff,0x00,0x00,0xff,0xff,0x14,0x00,0xbb,0xff,0xff,0xb0,0x00,0x14,0xff,0xff,0x00,0x00,
0xff,0xff,0x14,0x00,0x64,0xff,0xff,0x58,0x00,0x14,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0x56,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0xe8,0x11,0x00,0x00,0x00,0xff,
0xff,0x14,0x00,0xff,0xff,0xff,0x9f,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0xff,0xff,
0x43,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0xaf,0xff,0xdd,0x0a,0x00,0xff,0xff,0x14,0x00,
0xff,0xff,0x26,0xea,0xff,0x8d,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x5e,0xff,0xfc,0x34,
0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xbf,0xff,0xd1,0xff,0xff,0x14,0x00,0xff,0xff,0x14,
0x00,0x28,0xf9,0xff,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,0x84,0xff,0xff,0xff,0x14,
0x00,0xff,0xff,0x14,0x00,0x00,0x08,0xdd,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,0x00,
0x47,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x49,0xbd,0xf2,0xf4,0xc5,0x57,0x00,0x00,0x00,0x00,0x00,0x68,0xff,0xff,0xf9,
0xf8,0xff,0xff,0x7f,0x00,0x00,0x00,0x24,0xf6,0xfe,0x74,0x06,0x02,0x5a,0xf8,0xfc,0x33,0x00,
0x00,0x8a,0xff,0xa1,0x00,0x00,0x00,0x00,0x87,0xff,0x9d,0x00,0x00,0xd4,0xff,0x45,0x00,0x00,
0x00,0x00,0x2f,0xff,0xe7,0x00,0x00,0xf3,0xff,0x1e,0x00,0x00,0x00,0x00,0x0d,0xff,0xff,0x06,
0x00,0xf3,0xff,0x1d,0x00,0x00,0x00,0x00,0x0a,0xff,0xff,0x07,0x00,0xd5,0xff,0x43,0x00,0x00,
0x00,0x00,0x2e,0xff,0xe8,0x00,0x00,0x8c,0xff,0xa0,0x00,0x00,0x00,0x00,0x88,0xff,0x9f,0x00,
0x00,0x26,0xf7,0xfe,0x72,0x0a,0x07,0x61,0xf9,0xfc,0x35,0x00,0x00,0x00,0x6b,0xff,0xff,0xfc,
0xfb,0xff,0xff,0x82,0x00,0x00,0x00,0x00,0x00,0x4c,0xc1,0xf3,0xf5,0xc8,0x5b,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xfc,0xe6,0xb3,0x47,0x00,0x00,
0x00,0xff,0xff,0xed,0xec,0xfb,0xff,0xff,0x69,0x00,0x00,0xff,0xff,0x14,0x00,0x04,0x73,0xff,
0xe5,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x0e,0xff,0xff,0x09,0x00,0xff,0xff,0x14,0x00,0x04,
0x73,0xff,0xe6,0x00,0x00,0xff,0xff,0xed,0xec,0xfa,0xff,0xff,0x6b,0x00,0x00,0xff,0xff,0xff,
0xfc,0xe5,0xb4,0x48,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x46,0xba,0xf1,
0xf6,0xca,0x61,0x00,0x00,0x00,0x00,0x00,0x69,0xff,0xff,0xfa,0xf9,0xff,0xff,0x8e,0x00,0x00,
0x00,0x25,0xf6,0xfb,0x65,0x05,0x03,0x61,0xfa,0xff,0x43,0x00,0x00,0x8f,0xff,0x94,0x00,0x00,
0x00,0x00,0x7f,0xff,0xad,0x00,0x00,0xda,0xff,0x3b,0x00,0x00,0x00,0x00,0x27,0xff,0xf0,0x00,
0x00,0xf7,0xff,0x1c,0x00,0x00,0x00,0x00,0x07,0xff,0xff,0x0a,0x00,0xed,0xff,0x1d,0x00,0x00,
0x00,0x00,0x11,0xff,0xff,0x09,0x00,0xcc,0xff,0x47,0x00,0x00,0x22,0x59,0x35,0xff,0xe8,0x00,
0x00,0x7a,0xff,0xa7,0x00,0x0c,0xd8,0xff,0xe1,0xff,0xa7,0x00,0x00,0x17,0xec,0xff,0x77,0x08,
0x5d,0xfa,0xff,0xff,0x53,0x00,0x00,0x00,0x50,0xfc,0xff,0xfb,0xf7,0xff,0xff,0xff,0xe4,0x07,
0x00,0x00,0x00,0x39,0xb5,0xf0,0xf9,0xd2,0x6e,0x7c,0x61,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0xfc,0xe3,0xaf,0x45,0x00,0x00,0x00,0xff,0xff,0xed,0xec,0xfb,
0xff,0xff,0x69,0x00,0x00,0xff,0xff,0x14,0x00,0x04,0x74,0xff,0xe6,0x00,0x00,0xff,0xff,0x14,
0x00,0x00,0x0e,0xff,0xff,0x0a,0x00,0xff,0xff,0x14,0x00,0x03,0x71,0xff,0xea,0x00,0x00,0xff,
0xff,0xed,0xec,0xfa,0xff,0xff,0x6c,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xec,0x4b,0x00,0x00,
0x00,0xff,0xff,0x14,0x53,0xff,0xfe,0x2f,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0xc4,0xff,0xb4,
0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x38,0xff,0xff,0x39,0x00,0x00,0xff,0xff,0x14,0x00,0x00,
0xa9,0xff,0xbe,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x21,0xf9,0xff,0x45,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x56,0xc2,
0xef,0xed,0xb4,0x34,0x00,0x00,0x00,0x75,0xff,0xff,0xf7,0xfd,0xff,0xf7,0x3d,0x00,0x00,0xe6,
0xff,0x68,0x01,0x0c,0x93,0xae,0x5a,0x00,0x00,0xf1,0xff,0x3b,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xa5,0xff,0xf1,0x82,0x1e,0x00,0x00,0x00,0x00,0x00,0x0c,0xa0,0xfe,0xff,0xfe,0xb8,0x32,
0x00,0x00,0x00,0x00,0x00,0x26,0x89,0xe7,0xff,0xfb,0x51,0x00,0x00,0x00,0x00,0x00,0x00,0x06,
0x91,0xff,0xdf,0x00,0x2b,0x93,0x95,0x00,0x00,0x00,0x10,0xff,0xff,0x0b,0x1e,0xfe,0xff,0x79,
0x04,0x03,0x75,0xff,0xed,0x01,0x00,0x7b,0xff,0xff,0xfa,0xf9,0xff,0xff,0x6c,0x00,0x00,0x00,
0x51,0xc3,0xef,0xec,0xbe,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xec,0xec,0xec,0xec,0xff,
0xff,0xed,0xec,0xec,0xec,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,
0x00,0x00,0x14,0xff,0xff,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x14,0xff,0xff,0x00,0x00,
0xff,0xff,0x14,0x00,0x00,0x00,0x14,0xff,0xff,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x14,
0xff,0xff,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x14,0xff,0xff,0x00,0x00,0xff,0xff,0x14,
0x00,0x00,0x00,0x14,0xff,0xff,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x14,0xff,0xff,0x00,
0x00,0xf5,0xff,0x22,0x00,0x00,0x00,0x1f,0xff,0xf4,0x00,0x00,0xd3,0xff,0x5b,0x00,0x00,0x00,
0x5a,0xff,0xd3,0x00,0x00,0x82,0xff,0xe1,0x2a,0x00,0x30,0xe0,0xff,0x82,0x00,0x00,0x0c,0xd7,
0xff,0xff,0xf5,0xff,0xff,0xd6,0x0c,0x00,0x00,0x00,0x11,0x8f,0xe0,0xf8,0xe0,0x8e,0x10,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x46,0xff,0xff,0x20,0x00,0x00,0x00,0x3d,
0xff,0xfd,0x15,0x07,0xf3,0xff,0x68,0x00,0x00,0x00,0x87,0xff,0xc9,0x00,0x00,0xaf,0xff,0xb0,
0x00,0x00,0x00,0xd1,0xff,0x7f,0x00,0x00,0x63,0xff,0xf3,0x05,0x00,0x1b,0xff,0xff,0x35,0x00,
0x00,0x19,0xfe,0xff,0x41,0x00,0x65,0xff,0xe9,0x01,0x00,0x00,0x00,0xcc,0xff,0x8a,0x00,0xaf,
0xff,0xa1,0x00,0x00,0x00,0x00,0x80,0xff,0xd2,0x06,0xf2,0xff,0x57,0x00,0x00,0x00,0x00,0x35,
0xff,0xff,0x5e,0xff,0xfc,0x10,0x00,0x00,0x00,0x00,0x01,0xe7,0xff,0xe4,0xff,0xc3,0x00,0x00,
0x00,0x00,0x00,0x00,0x9d,0xff,0xff,0xff,0x79,0x00,0x00,0x00,0x00,0x00,0x00,0x52,0xff,0xff,
0xff,0x2f,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0xf9,0xff,0xe4,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x4f,0xff,0xed,0x00,0x00,0xac,0xff,0xff,0x20,0x00,0x7d,0xff,0xbf,0x00,
0x25,0xff,0xff,0x0f,0x00,0xdd,0xff,0xff,0x50,0x00,0x9f,0xff,0x95,0x00,0x03,0xf7,0xff,0x31,
0x0e,0xfe,0xff,0xff,0x80,0x00,0xc1,0xff,0x6b,0x00,0x00,0xd0,0xff,0x54,0x3e,0xff,0xff,0xff,
0xb1,0x00,0xe3,0xff,0x41,0x00,0x00,0xa6,0xff,0x76,0x6f,0xff,0xce,0xff,0xe1,0x06,0xfd,0xff,
0x17,0x00,0x00,0x7b,0xff,0x99,0xa0,0xff,0x75,0xfa,0xff,0x37,0xff,0xed,0x00,0x00,0x00,0x51,
0xff,0xbb,0xd0,0xff,0x41,0xd0,0xff,0x8a,0xff,0xc3,0x00,0x00,0x00,0x27,0xff,0xe4,0xfa,0xff,
0x12,0xa1,0xff,0xdb,0xff,0x99,0x00,0x00,0x00,0x03,0xf8,0xff,0xff,0xe3,0x00,0x72,0xff,0xff,
0xff,0x6f,0x00,0x00,0x00,0x00,0xd2,0xff,0xff,0xb4,0x00,0x42,0xff,0xff,0xff,0x45,0x00,0x00,
0x00,0x00,0xa8,0xff,0xff,0x85,0x00,0x13,0xff,0xff,0xff,0x1b,0x00,0x00,0x00,0x00,0x7d,0xff,
0xff,0x57,0x00,0x00,0xe4,0xff,0xf0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x28,0xfa,0xff,0xa5,0x00,
0x00,0x00,0xa5,0xff,0xfa,0x2b,0x00,0x89,0xff,0xfe,0x31,0x00,0x32,0xfe,0xff,0x8a,0x00,0x00,
0x0b,0xe3,0xff,0xba,0x00,0xbb,0xff,0xe3,0x0c,0x00,0x00,0x00,0x54,0xff,0xff,0x8a,0xff,0xff,
0x54,0x00,0x00,0x00,0x00,0x00,0xb9,0xff,0xff,0xff,0xb9,0x00,0x00,0x00,0x00,0x00,0x00,0x25,
0xf9,0xff,0xf9,0x25,0x00,0x00,0x00,0x00,0x00,0x00,0x29,0xfa,0xff,0xfa,0x29,0x00,0x00,0x00,
0x00,0x00,0x00,0xbe,0xff,0xff,0xff,0xbd,0x00,0x00,0x00,0x00,0x00,0x5a,0xff,0xff,0x81,0xff,
0xff,0x59,0x00,0x00,0x00,0x0e,0xe6,0xff,0xb6,0x00,0xb5,0xff,0xe6,0x0e,0x00,0x00,0x90,0xff,
0xfd,0x2e,0x00,0x2c,0xfd,0xff,0x8f,0x00,0x2e,0xfc,0xff,0xa1,0x00,0x00,0x00,0x9e,0xff,0xfc,
0x2e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x8a,0xff,0xff,0x3b,0x00,0x00,0x30,0xfe,0xff,0x9a,0x0c,0xe3,0xff,
0xc1,0x00,0x00,0xb5,0xff,0xeb,0x12,0x00,0x53,0xff,0xff,0x48,0x3a,0xff,0xff,0x63,0x00,0x00,
0x00,0xb7,0xff,0xcd,0xc0,0xff,0xc7,0x01,0x00,0x00,0x00,0x23,0xf7,0xff,0xff,0xfc,0x30,0x00,
0x00,0x00,0x00,0x00,0x7f,0xff,0xff,0x91,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xff,0xff,0x1b,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfe,0x3c,0x00,0xec,0xec,
0xec,0xec,0xec,0xef,0xff,0xff,0x99,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x8a,0xff,0xe7,0x10,
0x00,0x00,0x00,0x00,0x00,0x00,0x30,0xfb,0xff,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xcb,
0xff,0xb4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x71,0xff,0xf4,0x1f,0x00,0x00,0x00,0x00,0x00,
0x00,0x1f,0xf4,0xff,0x71,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xb5,0xff,0xcc,0x03,0x00,0x00,
0x00,0x00,0x00,0x00,0x58,0xff,0xfc,0x32,0x00,0x00,0x00,0x00,0x00,0x00,0x11,0xe9,0xff,0x8d,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x9d,0xff,0xff,0xf0,0xec,0xec,0xec,0xec,0xec,0x76,0x3f,
0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,
0x00,0xff,0xff,0xed,0xec,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,
0x00,0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,
0x00,0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,
0x00,0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0xed,0xec,0x00,0x00,0xff,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x1c,0x80,0x80,0x19,0x00,0x00,0x00,0x00,0x00,0x04,0xe5,0xff,0x84,0x00,0x00,0x00,0x00,0x00,
0x00,0x80,0xff,0xea,0x07,0x00,0x00,0x00,0x00,0x00,0x1a,0xfb,0xff,0x5e,0x00,0x00,0x00,0x00,
0x00,0x00,0xab,0xff,0xcb,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0xff,0xff,0x39,0x00,0x00,0x00,
0x00,0x00,0x00,0xd6,0xff,0xa6,0x00,0x00,0x00,0x00,0x00,0x00,0x6d,0xff,0xfa,0x19,0x00,0x00,
0x00,0x00,0x00,0x0e,0xf3,0xff,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x98,0xff,0xe7,0x05,0x00,
0x00,0x00,0x00,0x00,0x2e,0xff,0xff,0x5a,0x00,0x00,0x00,0x00,0x00,0x00,0xc4,0xff,0xc7,0x00,
0x00,0x00,0x00,0x00,0x00,0x59,0xff,0xff,0x34,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x14,0x00,0xec,0xec,0xff,0xff,0x14,0x00,0x00,0x00,
0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,
0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,
0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0xec,0xec,
0xff,0xff,0x14,0x00,0xff,0xff,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x1b,0xe9,0xff,0xb6,0x02,0x00,0x00,0x00,0x06,0xc7,0xff,0xe0,0xff,0x81,0x00,0x00,
0x00,0x97,0xff,0xad,0x13,0xe0,0xfe,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xec,0xec,0xec,0xec,0xec,0xec,0xec,0xec,0xec,0x00,
0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x65,0x11,
0x00,0x00,0x4a,0xff,0xd5,0x1d,0x00,0x0c,0xa6,0xff,0xe4,0x23,0x00,0x00,0x5a,0xe0,0x25,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1f,0xa6,0xed,0xf4,0xc6,
0x4b,0x00,0x00,0x00,0x1d,0xf3,0xf9,0xf6,0xff,0xfe,0x59,0x00,0x00,0x00,0x20,0x03,0x03,0x82,
0xff,0xd1,0x00,0x00,0x0a,0x97,0xed,0xde,0x59,0xff,0xfa,0x04,0x00,0x95,0xff,0xff,0xf5,0xf0,
0xff,0xff,0x13,0x00,0xea,0xff,0x5c,0x00,0x42,0xff,0xff,0x14,0x00,0xe9,0xff,0x58,0x00,0x3f,
0xff,0xff,0x14,0x00,0x92,0xff,0xff,0xf4,0xf6,0xff,0xff,0x14,0x00,0x0a,0x98,0xed,0xe0,0x5b,
0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x2f,0xad,0xf5,0xdf,
0x63,0x00,0x00,0x00,0xff,0xff,0xe4,0xfc,0xfb,0xff,0xff,0x40,0x00,0x00,0xff,0xff,0xba,0x12,
0x10,0xba,0xff,0xab,0x00,0x00,0xff,0xff,0x3a,0x00,0x00,0x3c,0xff,0xe1,0x00,0x00,0xff,0xff,
0x1c,0x00,0x00,0x1d,0xff,0xf8,0x00,0x00,0xff,0xff,0x3a,0x00,0x00,0x42,0xff,0xe2,0x00,0x00,
0xff,0xff,0xb8,0x10,0x14,0xc8,0xff,0xaf,0x00,0x00,0xff,0xff,0xe7,0xfc,0xfb,0xff,0xff,0x41,
0x00,0x00,0xff,0xff,0x30,0xae,0xf5,0xdf,0x62,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1f,
0xa9,0xef,0xf0,0xa9,0x1c,0x00,0x00,0x1a,0xe7,0xff,0xfd,0xfc,0xff,0xe4,0x14,0x00,0x9b,0xff,
0xcc,0x17,0x0e,0x98,0x55,0x02,0x00,0xe5,0xff,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0xfb,0xff,
0x1c,0x00,0x00,0x00,0x00,0x00,0x00,0xe8,0xff,0x42,0x00,0x00,0x00,0x00,0x00,0x00,0xa2,0xff,
0xce,0x1d,0x03,0x8d,0x53,0x01,0x00,0x21,0xed,0xff,0xff,0xf5,0xff,0xe1,0x13,0x00,0x00,0x25,
0xab,0xee,0xf4,0xb1,0x1d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x14,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x14,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x14,0xff,0xff,0x00,0x00,0x00,0x63,0xdf,
0xf5,0xad,0x2e,0xff,0xff,0x00,0x00,0x41,0xff,0xff,0xfb,0xfd,0xe4,0xff,0xff,0x00,0x00,0xaf,
0xff,0xb8,0x0f,0x14,0xbc,0xff,0xff,0x00,0x00,0xe4,0xff,0x3b,0x00,0x00,0x3d,0xff,0xff,0x00,
0x00,0xf9,0xff,0x1d,0x00,0x00,0x1e,0xff,0xff,0x00,0x00,0xe3,0xff,0x41,0x00,0x00,0x3d,0xff,
0xff,0x00,0x00,0xb0,0xff,0xc6,0x12,0x11,0xba,0xff,0xff,0x00,0x00,0x41,0xff,0xff,0xfb,0xfc,
0xe2,0xff,0xff,0x00,0x00,0x00,0x63,0xe0,0xf5,0xab,0x2d,0xff,0xff,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1a,0xa3,0xee,0xf1,0xb1,0x26,0x00,0x00,
0x00,0x15,0xe1,0xff,0xf7,0xfb,0xff,0xec,0x1c,0x00,0x00,0x96,0xff,0x6d,0x01,0x08,0x9a,0xff,
0x9b,0x00,0x00,0xe4,0xff,0xed,0xec,0xec,0xf1,0xff,0xe4,0x00,0x00,0xfa,0xff,0xff,0xff,0xff,
0xff,0xff,0xfc,0x00,0x00,0xe1,0xff,0x23,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x8f,0xff,0x9f,
0x07,0x09,0x50,0x0c,0x00,0x00,0x00,0x13,0xdc,0xff,0xf8,0xfb,0xff,0xef,0x1f,0x00,0x00,0x00,
0x0e,0x96,0xeb,0xf5,0xbd,0x3d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x05,0x7c,0xe5,0xf1,0xb1,0x10,0x00,0x00,0x9a,0xff,0xf8,0xf9,0x9c,0x00,0x00,0x00,0xfc,0xff,
0x22,0x06,0x03,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0xec,0xff,0xff,0xed,0xec,
0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0xdf,0xf5,0xad,0x2e,0xff,0xff,0x00,
0x00,0x41,0xff,0xff,0xfb,0xfd,0xe4,0xff,0xff,0x00,0x00,0xaf,0xff,0xb8,0x0f,0x14,0xbc,0xff,
0xff,0x00,0x00,0xe4,0xff,0x3b,0x00,0x00,0x3d,0xff,0xff,0x00,0x00,0xf9,0xff,0x1d,0x00,0x00,
0x1e,0xff,0xff,0x00,0x00,0xe3,0xff,0x41,0x00,0x00,0x3d,0xff,0xff,0x00,0x00,0xb0,0xff,0xc6,
0x12,0x11,0xba,0xff,0xff,0x00,0x00,0x41,0xff,0xff,0xfb,0xfc,0xe2,0xff,0xff,0x00,0x00,0x00,
0x63,0xe0,0xf5,0xab,0x2d,0xff,0xff,0x00,0x00,0x71,0xa8,0x54,0x01,0x01,0x61,0xff,0xe1,0x00,
0x00,0x45,0xfc,0xff,0xf6,0xf6,0xff,0xff,0x5d,0x00,0x00,0x00,0x44,0xbe,0xef,0xf7,0xcb,0x5b,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x35,0xbb,0xf3,
0xac,0x0e,0x00,0x00,0xff,0xff,0xe4,0xf6,0xff,0xff,0x9c,0x00,0x00,0xff,0xff,0x90,0x00,0x6b,
0xff,0xea,0x00,0x00,0xff,0xff,0x2d,0x00,0x14,0xff,0xff,0x0e,0x00,0xff,0xff,0x17,0x00,0x01,
0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,
0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,
0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xa8,0xbd,0x00,0x00,0xf6,0xff,0x0a,0x00,0x83,0x95,0x00,0x00,
0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,
0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xa8,0xbd,0x00,0x00,0x00,0x00,
0xf6,0xff,0x0a,0x00,0x00,0x00,0x83,0x95,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,
0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,
0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,
0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0x13,0x00,0x11,0x1e,0xff,0xf3,0x02,0x50,0xf9,0xf9,
0xff,0x81,0x00,0x8b,0xee,0xeb,0x80,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0x14,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0x14,0x15,0xe2,0xff,0x9e,0x00,0x00,0xff,0xff,0x17,0xbc,0xff,0xc6,0x06,0x00,0x00,0xff,0xff,
0x9c,0xff,0xe3,0x17,0x00,0x00,0x00,0xff,0xff,0xff,0xf6,0x32,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0xf4,0x23,0x00,0x00,0x00,0x00,0xff,0xff,0xa0,0xff,0xc6,0x03,0x00,0x00,0x00,0xff,0xff,
0x1b,0xd6,0xff,0x7b,0x00,0x00,0x00,0xff,0xff,0x14,0x38,0xfd,0xfa,0x32,0x00,0x00,0xff,0xff,
0x14,0x00,0x8c,0xff,0xd6,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,
0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,
0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xfc,0xff,0x20,0x00,0xd7,0xff,0xcb,0x00,0x40,
0xcf,0xce,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x36,0xbd,0xf4,0xba,0x11,0x1d,0xc1,0xf1,0xa2,0x09,0x00,
0x00,0xff,0xff,0xe8,0xf9,0xff,0xff,0x9e,0xdf,0xf9,0xff,0xff,0x7e,0x00,0x00,0xff,0xff,0x85,
0x02,0x88,0xff,0xff,0x71,0x02,0x9b,0xff,0xcc,0x00,0x00,0xff,0xff,0x2a,0x00,0x2c,0xff,0xff,
0x16,0x00,0x40,0xff,0xe7,0x00,0x00,0xff,0xff,0x16,0x00,0x17,0xff,0xff,0x02,0x00,0x2b,0xff,
0xec,0x00,0x00,0xff,0xff,0x14,0x00,0x14,0xff,0xff,0x00,0x00,0x28,0xff,0xec,0x00,0x00,0xff,
0xff,0x14,0x00,0x14,0xff,0xff,0x00,0x00,0x28,0xff,0xec,0x00,0x00,0xff,0xff,0x14,0x00,0x14,
0xff,0xff,0x00,0x00,0x28,0xff,0xec,0x00,0x00,0xff,0xff,0x14,0x00,0x14,0xff,0xff,0x00,0x00,
0x28,0xff,0xec,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x39,0xbe,0xf3,0xac,0x0e,0x00,0x00,0xff,0xff,
0xe8,0xf6,0xff,0xff,0x9c,0x00,0x00,0xff,0xff,0x90,0x00,0x6b,0xff,0xea,0x00,0x00,0xff,0xff,
0x2d,0x00,0x14,0xff,0xff,0x0e,0x00,0xff,0xff,0x17,0x00,0x01,0xff,0xff,0x14,0x00,0xff,0xff,
0x14,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,
0x14,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x36,0xbc,0xf3,0xf4,0xbe,0x37,0x00,0x00,0x00,0x2e,0xf7,
0xff,0xfb,0xfc,0xff,0xf7,0x2e,0x00,0x00,0xab,0xff,0xb0,0x0a,0x0b,0xb0,0xff,0xab,0x00,0x00,
0xea,0xff,0x34,0x00,0x00,0x35,0xff,0xe9,0x00,0x00,0xfc,0xff,0x1a,0x00,0x00,0x1b,0xff,0xfb,
0x00,0x00,0xea,0xff,0x34,0x00,0x00,0x35,0xff,0xe8,0x00,0x00,0xac,0xff,0xaf,0x0a,0x0a,0xb0,
0xff,0xa9,0x00,0x00,0x2f,0xf7,0xff,0xfb,0xfb,0xff,0xf6,0x2c,0x00,0x00,0x00,0x37,0xbd,0xf5,
0xf5,0xbe,0x37,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0x32,0xb0,0xf5,0xdf,0x63,0x00,0x00,0x00,0xff,0xff,0xe8,0xfc,0xfb,0xff,0xff,0x40,
0x00,0x00,0xff,0xff,0xba,0x12,0x10,0xba,0xff,0xab,0x00,0x00,0xff,0xff,0x3a,0x00,0x00,0x3c,
0xff,0xe1,0x00,0x00,0xff,0xff,0x1c,0x00,0x00,0x1d,0xff,0xf8,0x00,0x00,0xff,0xff,0x3a,0x00,
0x00,0x42,0xff,0xe2,0x00,0x00,0xff,0xff,0xb8,0x10,0x14,0xc8,0xff,0xaf,0x00,0x00,0xff,0xff,
0xe2,0xfc,0xfb,0xff,0xff,0x41,0x00,0x00,0xff,0xff,0x2d,0xab,0xf5,0xdf,0x62,0x00,0x00,0x00,
0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0xdf,0xf5,0xad,0x2e,
0xff,0xff,0x00,0x00,0x41,0xff,0xff,0xfb,0xfd,0xe4,0xff,0xff,0x00,0x00,0xaf,0xff,0xb8,0x0f,
0x14,0xbc,0xff,0xff,0x00,0x00,0xe4,0xff,0x3b,0x00,0x00,0x3d,0xff,0xff,0x00,0x00,0xf9,0xff,
0x1d,0x00,0x00,0x1e,0xff,0xff,0x00,0x00,0xe3,0xff,0x41,0x00,0x00,0x3d,0xff,0xff,0x00,0x00,
0xb0,0xff,0xc6,0x12,0x11,0xba,0xff,0xff,0x00,0x00,0x41,0xff,0xff,0xfb,0xfc,0xe2,0xff,0xff,
0x00,0x00,0x00,0x63,0xe0,0xf5,0xab,0x2d,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x12,
0xff,0xff,0x0d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xea,0xff,0xdd,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x42,0xcb,0xd9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0x3c,0xcc,0xec,0x7b,0x00,0xff,0xff,0xe8,0xf7,0xff,0x71,0x00,0xff,0xff,0xac,0x04,
0x2c,0x0d,0x00,0xff,0xff,0x35,0x00,0x00,0x00,0x00,0xff,0xff,0x16,0x00,0x00,0x00,0x00,0xff,
0xff,0x14,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,
0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1e,0xab,0xeb,0xf1,0xb6,0x29,0x00,
0x00,0xc8,0xff,0xfe,0xfa,0xff,0xe7,0x12,0x00,0xf6,0xff,0x30,0x08,0x9d,0x99,0x28,0x00,0xb8,
0xff,0xd0,0x66,0x0d,0x00,0x00,0x00,0x10,0x9c,0xfb,0xff,0xf0,0x68,0x00,0x00,0x00,0x00,0x1c,
0x89,0xfc,0xff,0x3f,0x2c,0xbe,0xb4,0x0d,0x04,0xd5,0xff,0x74,0x07,0xd9,0xff,0xfa,0xf5,0xff,
0xfc,0x38,0x00,0x1c,0xa6,0xeb,0xf2,0xc2,0x46,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,
0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xec,0xff,
0xff,0xed,0xec,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,
0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0xfa,0xff,
0x34,0x00,0x00,0x00,0x00,0xcb,0xff,0xfe,0xee,0x00,0x00,0x00,0x2a,0xb9,0xee,0xfe,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,
0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,
0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,0x00,0xfe,0xff,0x16,0x00,0x03,0xff,0xff,0x14,
0x00,0xf2,0xff,0x2b,0x00,0x1b,0xff,0xff,0x14,0x00,0xcb,0xff,0x74,0x00,0x6f,0xff,0xff,0x14,
0x00,0x78,0xff,0xfb,0xc7,0xf0,0xfe,0xff,0x14,0x00,0x07,0xac,0xf8,0xcb,0x3b,0xfc,0xff,0x14,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x40,0xff,0xf3,0x05,0x00,0x33,0xff,0xd8,0x00,0x03,0xec,0xff,0x3b,0x00,0x7a,0xff,0x88,0x00,
0x00,0xa0,0xff,0x7e,0x00,0xc1,0xff,0x38,0x00,0x00,0x50,0xff,0xc1,0x0d,0xfa,0xe6,0x01,0x00,
0x00,0x0a,0xf6,0xf9,0x59,0xff,0x98,0x00,0x00,0x00,0x00,0xb0,0xff,0xd9,0xff,0x48,0x00,0x00,
0x00,0x00,0x60,0xff,0xff,0xf1,0x06,0x00,0x00,0x00,0x00,0x13,0xfc,0xff,0xa8,0x00,0x00,0x00,
0x00,0x00,0x00,0xc0,0xff,0x58,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0xff,0xb7,
0x00,0x0b,0xfd,0xff,0x14,0x00,0xa5,0xff,0x5a,0x19,0xfe,0xf2,0x03,0x3a,0xff,0xff,0x45,0x00,
0xe6,0xfc,0x12,0x00,0xcd,0xff,0x36,0x6b,0xff,0xff,0x77,0x27,0xff,0xc5,0x00,0x00,0x83,0xff,
0x75,0x9c,0xf0,0xfe,0xa8,0x68,0xff,0x7a,0x00,0x00,0x38,0xff,0xb5,0xce,0xb5,0xd9,0xd9,0xa9,
0xff,0x2f,0x00,0x00,0x02,0xeb,0xf1,0xf9,0x7e,0xa6,0xfe,0xed,0xe4,0x00,0x00,0x00,0x00,0xa3,
0xff,0xff,0x48,0x72,0xff,0xff,0x9a,0x00,0x00,0x00,0x00,0x58,0xff,0xff,0x12,0x3e,0xff,0xff,
0x4f,0x00,0x00,0x00,0x00,0x11,0xfc,0xdb,0x00,0x0c,0xfd,0xf9,0x0b,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x54,0xff,0xf5,0x1b,0x00,0x60,0xff,0xfc,0x34,
0x00,0xbb,0xff,0xa3,0x0a,0xe4,0xff,0x8a,0x00,0x00,0x28,0xfa,0xfe,0xac,0xff,0xda,0x09,0x00,
0x00,0x00,0x89,0xff,0xff,0xfe,0x3e,0x00,0x00,0x00,0x00,0x19,0xfe,0xff,0xcd,0x00,0x00,0x00,
0x00,0x00,0x92,0xff,0xff,0xff,0x4d,0x00,0x00,0x00,0x36,0xfd,0xfd,0xa4,0xff,0xe0,0x0a,0x00,
0x04,0xd1,0xff,0x9b,0x09,0xe2,0xff,0x8a,0x00,0x77,0xff,0xf3,0x18,0x00,0x5c,0xff,0xfb,0x2d,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,
0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,
0x00,0xfe,0xff,0x17,0x00,0x05,0xff,0xff,0x14,0x00,0xf2,0xff,0x30,0x00,0x22,0xff,0xff,0x14,
0x00,0xcb,0xff,0x8f,0x01,0x8e,0xff,0xff,0x14,0x00,0x78,0xff,0xff,0xf6,0xe4,0xff,0xff,0x14,
0x00,0x07,0xac,0xf7,0xc5,0x2b,0xff,0xff,0x11,0x00,0x12,0x67,0x1f,0x00,0x46,0xff,0xdf,0x00,
0x00,0x70,0xff,0xff,0xf1,0xff,0xfd,0x45,0x00,0x00,0x00,0x65,0xd6,0xf8,0xcc,0x3d,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x81,0x00,0xec,0xec,0xec,0xfb,0xff,0xed,0x0f,0x00,
0x00,0x00,0x17,0xf5,0xff,0x77,0x00,0x00,0x00,0x00,0x91,0xff,0xe8,0x0a,0x00,0x00,0x00,0x1d,
0xf8,0xff,0x6d,0x00,0x00,0x00,0x00,0x9a,0xff,0xe2,0x07,0x00,0x00,0x00,0x22,0xfb,0xff,0x64,
0x00,0x00,0x00,0x00,0xa2,0xff,0xff,0xee,0xec,0xec,0x76,0x28,0xfc,0xff,0xff,0xff,0xff,0xff,
0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x4c,0xd1,0xe9,0x00,0x00,0x00,0xe2,0xff,0xff,0x00,0x00,0x00,0xf9,
0xff,0x40,0x00,0x00,0x03,0xff,0xff,0x10,0x00,0x00,0x17,0xff,0xfd,0x03,0x00,0x00,0x48,0xff,
0xd6,0x00,0x00,0x0e,0xc7,0xfe,0x64,0x00,0x00,0x19,0xd3,0xfb,0x54,0x00,0x00,0x00,0x50,0xff,
0xd0,0x00,0x00,0x00,0x1a,0xff,0xfc,0x02,0x00,0x00,0x05,0xff,0xff,0x0f,0x00,0x00,0x00,0xfa,
0xff,0x32,0x00,0x00,0x00,0xe6,0xff,0xfa,0x00,0x00,0x00,0x5e,0xe6,0xfd,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,
0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,
0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x75,0xe5,0xc7,
0x48,0x00,0x00,0x80,0xff,0xff,0xef,0x00,0x00,0x03,0x47,0xff,0xff,0x09,0x00,0x00,0x01,0xfc,
0xff,0x16,0x00,0x00,0x00,0xed,0xff,0x28,0x00,0x00,0x00,0xc2,0xff,0x65,0x00,0x00,0x00,0x52,
0xfc,0xd5,0x14,0x00,0x00,0x45,0xf7,0xdf,0x21,0x00,0x00,0xbd,0xff,0x6e,0x00,0x00,0x00,0xeb,
0xff,0x2b,0x00,0x00,0x00,0xfb,0xff,0x18,0x00,0x00,0x33,0xff,0xff,0x0a,0x00,0x78,0xfe,0xff,
0xf4,0x00,0x00,0x80,0xfd,0xe1,0x5d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x9f,0xf1,0x76,0x03,0x4e,0x00,0x00,0xff,0xf9,0xff,
0xf9,0xff,0x00,0x00,0x47,0x06,0x85,0xf0,0xac,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4d,0xc1,
0xf4,0xf4,0xba,0x3e,0x00,0x00,0x00,0x00,0x6c,0xff,0xff,0xf6,0xfd,0xff,0xfe,0x64,0x00,0x00,
0x27,0xf8,0xfa,0x61,0x02,0x12,0xb8,0xff,0xf9,0x26,0x00,0x8e,0xff,0x93,0x00,0x00,0x00,0x0c,
0xf0,0xff,0x8b,0x00,0xd7,0xff,0x3e,0x00,0x00,0x00,0x00,0x12,0x18,0x10,0x00,0xf4,0xff,0x1c,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf4,0xff,0x1b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xd9,0xff,0x3d,0x00,0x00,0x00,0x00,0x0b,0x10,0x0b,0x00,0x90,0xff,0x91,0x00,0x00,0x00,
0x0b,0xed,0xff,0x8c,0x00,0x29,0xf8,0xfa,0x60,0x06,0x12,0xb1,0xff,0xfa,0x29,0x00,0x00,0x6f,
0xff,0xff,0xf9,0xfe,0xff,0xfe,0x6a,0x00,0x00,0x00,0x00,0x50,0xc3,0xf5,0xec,0xbb,0x42,0x00,
0x00,0x00,0x00,0x00,0x00,0x0f,0xa1,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xf4,
0xeb,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x9f,0xff,0x9e,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x3a,0x5b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x6c,0xcb,0x4c,0x00,0x6c,0xcb,0x4c,0x00,0x00,0x00,0x00,0x00,
0xf3,0xff,0xca,0x00,0xf3,0xff,0xca,0x00,0x00,0x00,0x00,0x00,0x90,0xf3,0x6d,0x00,0x90,0xf3,
0x6d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x49,0xbd,0xf2,0xf4,0xc5,0x57,0x00,0x00,0x00,0x00,0x00,0x68,0xff,0xff,0xf9,0xf8,0xff,0xff,
0x7f,0x00,0x00,0x00,0x24,0xf6,0xfe,0x74,0x06,0x02,0x5a,0xf8,0xfc,0x33,0x00,0x00,0x8a,0xff,
0xa1,0x00,0x00,0x00,0x00,0x87,0xff,0x9d,0x00,0x00,0xd4,0xff,0x45,0x00,0x00,0x00,0x00,0x2f,
0xff,0xe7,0x00,0x00,0xf3,0xff,0x1e,0x00,0x00,0x00,0x00,0x0d,0xff,0xff,0x06,0x00,0xf3,0xff,
0x1d,0x00,0x00,0x00,0x00,0x0a,0xff,0xff,0x07,0x00,0xd5,0xff,0x43,0x00,0x00,0x00,0x00,0x2e,
0xff,0xe8,0x00,0x00,0x8c,0xff,0xa0,0x00,0x00,0x00,0x00,0x88,0xff,0x9f,0x00,0x00,0x26,0xf7,
0xfe,0x72,0x0a,0x07,0x61,0xf9,0xfc,0x35,0x00,0x00,0x00,0x6b,0xff,0xff,0xfc,0xfb,0xff,0xff,
0x82,0x00,0x00,0x00,0x00,0x00,0x4c,0xc1,0xf3,0xf5,0xc8,0x5b,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x4f,0xcb,0x6b,0x00,0x6d,0xcb,0x4d,0x00,0x00,0x00,0x00,0xcb,0xff,0xf3,
0x00,0xf3,0xff,0xcb,0x00,0x00,0x00,0x00,0x6b,0xf3,0x8e,0x00,0x8e,0xf3,0x6a,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x14,
0xff,0xff,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x14,0xff,0xff,0x00,0x00,0xff,0xff,0x14,
0x00,0x00,0x00,0x14,0xff,0xff,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x14,0xff,0xff,0x00,
0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x14,0xff,0xff,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,
0x14,0xff,0xff,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x14,0xff,0xff,0x00,0x00,0xf5,0xff,
0x22,0x00,0x00,0x00,0x1f,0xff,0xf4,0x00,0x00,0xd3,0xff,0x5b,0x00,0x00,0x00,0x5a,0xff,0xd3,
0x00,0x00,0x82,0xff,0xe1,0x2a,0x00,0x30,0xe0,0xff,0x82,0x00,0x00,0x0c,0xd7,0xff,0xff,0xf5,
0xff,0xff,0xd6,0x0c,0x00,0x00,0x00,0x11,0x8f,0xe0,0xf8,0xe0,0x8e,0x10,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1b,0xa1,0xec,0xf4,0xb9,0x32,0x00,0x00,0x17,0xe2,
0xff,0xff,0xfa,0xff,0xf8,0x36,0x00,0x98,0xff,0xd2,0x1e,0x08,0x81,0x71,0x0a,0x00,0xe4,0xff,
0x46,0x00,0x00,0x00,0x00,0x00,0x00,0xfb,0xff,0x1d,0x00,0x00,0x00,0x00,0x00,0x00,0xe6,0xff,
0x45,0x00,0x00,0x00,0x00,0x00,0x00,0x9e,0xff,0xd2,0x22,0x00,0x7c,0x6a,0x07,0x00,0x1d,0xe8,
0xff,0xff,0xf4,0xff,0xf6,0x33,0x00,0x00,0x1e,0xa2,0xe9,0xf7,0xc2,0x34,0x00,0x00,0x00,0x00,
0x20,0xb6,0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0xff,0xea,0x00,0x00,0x00,0x00,0x00,0x04,
0xc6,0xff,0x8c,0x00,0x00,0x00,0x00,0x00,0x00,0x49,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6d,0xf3,0x8f,0x00,0x6d,0xf3,
0x8f,0x00,0x00,0x00,0xcb,0xff,0xf3,0x00,0xcb,0xff,0xf3,0x00,0x00,0x00,0x4b,0xcb,0x6d,0x00,
0x4d,0xcb,0x6d,0x00,0x00,0x00,0x00,0x36,0xbc,0xf3,0xf4,0xbe,0x37,0x00,0x00,0x00,0x2e,0xf7,
0xff,0xfb,0xfc,0xff,0xf7,0x2e,0x00,0x00,0xab,0xff,0xb0,0x0a,0x0b,0xb0,0xff,0xab,0x00,0x00,
0xea,0xff,0x34,0x00,0x00,0x35,0xff,0xe9,0x00,0x00,0xfc,0xff,0x1a,0x00,0x00,0x1b,0xff,0xfb,
0x00,0x00,0xea,0xff,0x34,0x00,0x00,0x35,0xff,0xe8,0x00,0x00,0xac,0xff,0xaf,0x0a,0x0a,0xb0,
0xff,0xa9,0x00,0x00,0x2f,0xf7,0xff,0xfb,0xfb,0xff,0xf6,0x2c,0x00,0x00,0x00,0x37,0xbd,0xf5,
0xf5,0xbe,0x37,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x6d,0xf3,0x8f,0x00,0x6d,0xf3,0x8f,0x00,0x00,0xcb,0xff,0xf3,0x00,0xcb,0xff,0xf3,0x00,
0x00,0x4b,0xca,0x6b,0x00,0x4d,0xcb,0x6a,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,
0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,
0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,0x00,0xfe,0xff,0x16,0x00,0x03,0xff,0xff,0x14,
0x00,0xf2,0xff,0x2b,0x00,0x1b,0xff,0xff,0x14,0x00,0xcb,0xff,0x74,0x00,0x6f,0xff,0xff,0x14,
0x00,0x78,0xff,0xfb,0xc7,0xf0,0xfe,0xff,0x14,0x00,0x07,0xac,0xf8,0xcb,0x3b,0xfc,0xff,0x14,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf2,0xc9,0x13,
0x10,0xc2,0xf1,0x00,0x00,0x00,0x00,0x00,0x00,0x9a,0xff,0xf9,0xf9,0xff,0x9a,0x00,0x00,0x00,
0x00,0x00,0x00,0x0a,0x92,0xed,0xed,0x91,0x09,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4b,0xbc,0xf1,0xf4,0xc6,0x54,0x00,0x00,0x00,
0x00,0x00,0x70,0xff,0xff,0xfa,0xfa,0xff,0xff,0x7b,0x00,0x00,0x00,0x2f,0xfa,0xff,0x82,0x07,
0x0d,0x8e,0xbb,0x72,0x00,0x00,0x00,0x98,0xff,0xaa,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xdc,0xff,0x45,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf7,0xff,0x1e,0x00,0x00,
0xf8,0xf8,0xf8,0xf8,0xf8,0x00,0x00,0xee,0xff,0x27,0x00,0x00,0xff,0xff,0xff,0xff,0xf9,0x00,
0x00,0xce,0xff,0x55,0x00,0x00,0x00,0x00,0x7f,0xff,0xe3,0x00,0x00,0x81,0xff,0xbc,0x00,0x00,
0x00,0x00,0xbe,0xff,0xa9,0x00,0x00,0x1e,0xf2,0xff,0x8c,0x07,0x08,0x73,0xff,0xff,0x48,0x00,
0x00,0x00,0x5b,0xfd,0xff,0xfa,0xfb,0xff,0xff,0x9b,0x00,0x00,0x00,0x00,0x00,0x3d,0xb5,0xef,
0xf8,0xd2,0x6e,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf6,0xdc,0x03,0x00,0x25,
0xf3,0x00,0x00,0x00,0x00,0xc8,0xff,0x7d,0x11,0xbb,0xc8,0x00,0x00,0x00,0x00,0x57,0xff,0xff,
0xff,0xff,0x57,0x00,0x00,0x00,0x00,0x00,0x60,0xd4,0xd4,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0xdf,0xf5,0xad,0x2e,0xff,0xff,0x00,
0x00,0x41,0xff,0xff,0xfb,0xfd,0xe4,0xff,0xff,0x00,0x00,0xaf,0xff,0xb8,0x0f,0x14,0xbc,0xff,
0xff,0x00,0x00,0xe4,0xff,0x3b,0x00,0x00,0x3d,0xff,0xff,0x00,0x00,0xf9,0xff,0x1d,0x00,0x00,
0x1e,0xff,0xff,0x00,0x00,0xe3,0xff,0x41,0x00,0x00,0x3d,0xff,0xff,0x00,0x00,0xb0,0xff,0xc6,
0x12,0x11,0xba,0xff,0xff,0x00,0x00,0x41,0xff,0xff,0xfb,0xfc,0xe2,0xff,0xff,0x00,0x00,0x00,
0x63,0xe0,0xf5,0xab,0x2d,0xff,0xff,0x00,0x00,0x97,0xa8,0x54,0x01,0x01,0x61,0xff,0xe1,0x00,
0x00,0x79,0xff,0xff,0xf6,0xf6,0xff,0xff,0x59,0x00,0x00,0x00,0x61,0xcb,0xf3,0xf5,0xc5,0x54,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x6c,0xcb,0x4c,0x00,0x00,0xf3,0xff,0xca,0x00,0x00,0x93,0xf3,0x6d,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0xff,
0xff,0x14,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,0x00,
0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0xff,0xff,
0x14,0x00,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,
0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,0x14,0x00,0xff,0xff,
0x14,0x00,0xff,0xff,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x56,0xc2,0xef,0xed,0xb4,0x34,0x00,0x00,0x00,0x75,0xff,0xff,0xf7,0xfd,0xff,0xf7,0x3d,
0x00,0x00,0xe6,0xff,0x68,0x01,0x0c,0x93,0xae,0x5a,0x00,0x00,0xf1,0xff,0x3b,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xa5,0xff,0xf1,0x82,0x1e,0x00,0x00,0x00,0x00,0x00,0x0c,0xa0,0xfe,0xff,
0xfe,0xb8,0x32,0x00,0x00,0x00,0x00,0x00,0x26,0x89,0xe7,0xff,0xfb,0x51,0x00,0x00,0x00,0x00,
0x00,0x00,0x06,0x91,0xff,0xdf,0x00,0x2b,0x93,0x95,0x00,0x00,0x00,0x10,0xff,0xff,0x0b,0x1e,
0xfe,0xff,0x79,0x04,0x03,0x75,0xff,0xed,0x01,0x00,0x7b,0xff,0xff,0xfa,0xf9,0xff,0xff,0x6c,
0x00,0x00,0x00,0x51,0xca,0xff,0xff,0xbe,0x48,0x00,0x00,0x00,0x00,0x00,0x02,0xe4,0xfe,0x16,
0x00,0x00,0x00,0x00,0x00,0x00,0x7a,0xfe,0xd7,0x07,0x00,0x00,0x00,0x00,0x00,0x00,0x3d,0x85,
0x0d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1e,0xab,0xeb,0xf1,0xb5,0x27,0x00,0x00,0xc8,0xff,
0xfc,0xfd,0xff,0xe5,0x10,0x00,0xf6,0xff,0x2d,0x23,0xb6,0x93,0x26,0x00,0xb8,0xff,0xd0,0x66,
0x0d,0x00,0x00,0x00,0x10,0x9c,0xfb,0xff,0xf0,0x68,0x00,0x00,0x00,0x00,0x1c,0x89,0xfc,0xff,
0x3f,0x2c,0xbe,0xb4,0x0d,0x04,0xd5,0xff,0x74,0x07,0xd9,0xff,0xfa,0xf5,0xff,0xfc,0x38,0x00,
0x1c,0xa6,0xff,0xff,0xc2,0x46,0x00,0x00,0x00,0x00,0xbc,0xe9,0x00,0x00,0x00,0x00,0x00,0x50,
0xf4,0xbd,0x00,0x00,0x00,0x00,0x00,0x1f,0x8a,0x0b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,
  };
  static const struct {
    uint32_t ds;
    uint16_t width;
  } glinfo[]= {

{0,5}, {105,4}, {189,7}, {336,13}, 
{609,9}, {798,12}, {1050,11}, {1281,4}, 
{1365,6}, {1491,6}, {1617,10}, {1827,9}, 
{2016,4}, {2100,8}, {2268,4}, {2352,9}, 
{2541,10}, {2751,10}, {2961,10}, {3171,10}, 
{3381,10}, {3591,10}, {3801,10}, {4011,10}, 
{4221,10}, {4431,10}, {4641,4}, {4725,4}, 
{4809,7}, {4956,9}, {5145,7}, {5292,9}, 
{5481,15}, {5796,12}, {6048,11}, {6279,12}, 
{6531,11}, {6762,10}, {6972,10}, {7182,12}, 
{7434,10}, {7644,4}, {7728,10}, {7938,11}, 
{8169,10}, {8379,14}, {8673,11}, {8904,12}, 
{9156,10}, {9366,12}, {9618,10}, {9828,10}, 
{10038,12}, {10290,11}, {10521,11}, {10752,14}, 
{11046,11}, {11277,10}, {11487,11}, {11718,6}, 
{11844,9}, {12033,6}, {12159,9}, {12348,11}, 
{12579,5}, {12684,9}, {12873,10}, {13083,9}, 
{13272,10}, {13482,10}, {13692,8}, {13860,10}, 
{14070,9}, {14259,4}, {14343,6}, {14469,9}, 
{14658,4}, {14742,14}, {15036,9}, {15225,10}, 
{15435,10}, {15645,10}, {15855,7}, {16002,8}, 
{16170,7}, {16317,9}, {16506,9}, {16695,12}, 
{16947,9}, {17136,9}, {17325,8}, {17493,6}, 
{17619,4}, {17703,6}, {17829,7}, {17976,11}, 
{18207,12}, {18459,11}, {18690,9}, {18879,10}, 
{19089,9}, {19278,12}, {19530,10}, {19740,5}, 
{19845,4}, {19929,10}, {20139,8}, 
  };
  // static const int nmap= sizeof(glmap)/sizeof(glmap[0]);
  int i,j,k,e,x,y,sX,eX;
  int W, X, *Xpos;
  char buf[20];
  int *map, *gl;
  int ngl;
  unsigned int C;
  int glyph_width;
  const unsigned char *glyph_data;
  unsigned char *data;

  map= alloca(L*sizeof(int));

  e= 0;
  ngl= 0;
  for(i=0;i<L;i++)
  {
    C= str[i];
    
    if (C&(1<<31)) { ngl+=2; e= 1; continue; }
    map[i]= font_hash(C);
    if (map[i]!=107) { ngl++; continue; }
    sprintf(buf,"%x",C); ngl+= strlen(buf); e= 1;
  }

  if (e) goto fix_encoding_errors;
  else gl= map;

encoding_errors_fixed:

  W= 0;
  for(i=0;i<ngl;i++) W+= glinfo[gl[i]].width;

  if (Rdata) data= malloc(W*21);
  X= 0;
  if (e && Rdata) Xpos= alloca(sizeof(int)*(ngl+1));
  for(i=0;i<ngl;i++)
  {
    if (e && Rdata) Xpos[i]= X;
    glyph_width= glinfo[gl[i]].width;
    if (Rdata) {
      glyph_data= font_data + glinfo[gl[i]].ds;
      for(y=0;y<21;y++)
         for(x=0;x<glyph_width;x++)
            data[y*W+X+x]= glyph_data[y*glyph_width+x];
    }
    X+= glyph_width;
  }
  if (e && Rdata) Xpos[i]= X;
  if (RW) *RW= W;
  if (RA) *RA= 17;
  if (RH) *RH= 21;
  if (Rdata) *Rdata= data;

  if (!e || !Rdata) return ;

  j= 0;
  for(i=0;i<L;i++)
  {
    if (str[i]&(1<<31))
    {
      sX= Xpos[j]; eX= Xpos[j+2];
      for(x=sX;x<eX;x++)
        for(y=0;y<21;y++)
          data[y*W + x] ^= 0xff;
      j+= 2;
      continue;
    }
    if (map[i]==107)
    {
      sprintf(buf,"%x",str[i]);
      sX= Xpos[j]; eX= Xpos[j+strlen(buf)];
      for(x=sX;x<eX;x++) {
        data[ 0*W + x]= 0xff;
        data[ (21-1)*W + x]= 0xff;
      }
      for(y=0;y<21;y++)
      {
        data[y*W+sX] = 0xff;
        data[y*W+eX-1] = 0xff;
      }
      j+= strlen(buf);
      continue;
    }
    j++;
  }
  return ;


fix_encoding_errors:
  j= 0;
  gl= alloca(sizeof(int)*ngl);
  for(i=0;i<L;i++)
  {
    if (str[i]&(1<<31))
    {
      sprintf(buf,"%02x", str[i]&0xff);
      for(k=0;buf[k];k++)
         gl[j++]= font_hash(buf[k]);
      continue;
    }
    if (map[i]==107)
    {
      sprintf(buf,"%x", str[i]);
      for(k=0;buf[k];k++)
         gl[j++]= font_hash(buf[k]);
      continue;
    }
    gl[j++]= map[i];
  }
  goto encoding_errors_fixed;
}

static 
void font3_render
        (uint32_t *str, size_t L, 
        int *RW, int *RH, int *RA,
        unsigned char **Rdata)
{
  static const uint8_t font_data[]= {

0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0xb6,0xf2,0x7c,0x00,0x00,0x49,0xff,0xff,
0xfd,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,
0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,
0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,
0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,
0xff,0x00,0x00,0x22,0xcc,0xf1,0xa9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4b,0xe4,0xe4,
0x49,0x00,0x00,0xe5,0xff,0xff,0xe4,0x00,0x00,0xe3,0xff,0xff,0xe3,0x00,0x00,0x47,0xe3,0xe4,
0x49,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x97,0xf5,0xcb,0x1e,0x16,0xc7,0xf2,0xa4,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4b,0x4b,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x4c,0xff,0xff,0xff,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xc2,0xf5,0xd5,0x29,0x22,0xd1,0xf4,0xba,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x30,0xff,
0xff,0xff,0x6d,0x30,0x30,0xff,0xff,0xff,0x6d,0x30,0x30,0x30,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x30,0xff,0xff,0xff,0x6d,0x30,0x30,0xff,0xff,0xff,0x6d,
0x30,0x30,0x30,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x28,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x14,0xff,0xff,0x3f,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x04,0x78,0xe4,0xff,0xff,0xff,0xff,0xee,0x8f,0x17,0x00,0x00,0x00,0x06,0xb8,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe3,0x2d,0x00,0x00,0x7a,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xe0,0x10,0x00,0xda,0xff,0xff,0xd7,0x32,0xff,0xff,0x61,0xbf,0xff,0xd8,
0x85,0x1c,0x00,0xfa,0xff,0xff,0x5c,0x00,0xff,0xff,0x28,0x07,0x2b,0x00,0x00,0x00,0x00,0xec,
0xff,0xff,0x72,0x00,0xff,0xff,0x28,0x00,0x00,0x00,0x00,0x00,0x00,0xb3,0xff,0xff,0xf0,0x5e,
0xff,0xff,0x28,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xfe,0xff,0xff,0xff,0xff,0xff,0x45,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x73,0xfe,0xff,0xff,0xff,0xff,0xff,0xce,0x57,0x01,0x00,0x00,
0x00,0x00,0x00,0x3b,0xbb,0xfd,0xff,0xff,0xff,0xff,0xff,0xc9,0x22,0x00,0x00,0x00,0x00,0x00,
0x00,0x15,0xff,0xff,0xff,0xff,0xff,0xff,0xe4,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0x54,0xac,0xff,0xff,0xff,0x8a,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x28,0x00,0xac,0xff,
0xff,0xdc,0x00,0x18,0x74,0xb2,0x03,0x00,0xff,0xff,0x28,0x00,0x56,0xff,0xff,0xf9,0x1e,0xfb,
0xff,0xff,0x6b,0x00,0xff,0xff,0x28,0x00,0x86,0xff,0xff,0xea,0x00,0xbe,0xff,0xff,0xf6,0x64,
0xff,0xff,0x4a,0x80,0xfa,0xff,0xff,0xab,0x00,0x2d,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xfb,0x33,0x00,0x00,0x60,0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfa,0x5f,0x00,
0x00,0x00,0x00,0x47,0xd6,0xff,0xff,0xff,0xff,0xf8,0xaf,0x31,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x26,0xff,0xff,0x4f,0x09,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0x28,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1d,0x26,0x04,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3e,0xd5,0xff,0xff,
0xed,0x6b,0x00,0x00,0x00,0x00,0x4a,0x64,0x27,0x00,0x00,0x00,0x00,0x00,0x35,0xf8,0xff,0xff,
0xff,0xff,0xff,0x73,0x00,0x00,0x20,0xf9,0xf4,0x16,0x00,0x00,0x00,0x00,0x00,0xba,0xff,0xff,
0xff,0xff,0xff,0xff,0xf5,0x0e,0x00,0x9f,0xff,0x87,0x00,0x00,0x00,0x00,0x00,0x00,0xf5,0xff,
0xff,0x7c,0x31,0xff,0xff,0xff,0x40,0x27,0xfc,0xf1,0x12,0x00,0x00,0x00,0x00,0x00,0x00,0xf1,
0xff,0xff,0x9f,0x62,0xff,0xff,0xff,0x3c,0xa9,0xff,0x81,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xab,0xff,0xff,0xff,0xff,0xff,0xff,0xed,0x38,0xfe,0xee,0x0f,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x22,0xea,0xff,0xff,0xff,0xff,0xfd,0x57,0xb3,0xff,0x7b,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x20,0xa7,0xee,0xf7,0xc3,0x44,0x37,0xff,0xeb,0x0c,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xbc,0xff,0x74,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0xff,0xe7,0x09,0x51,0xb0,0xc4,0x93,
0x1c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xc6,0xff,0x6e,0x81,0xff,0xff,0xff,
0xff,0xeb,0x29,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4b,0xff,0xe3,0x3c,0xfe,0xff,0xff,
0xff,0xff,0xff,0xc9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xce,0xff,0x68,0x8f,0xff,0xff,
0x92,0x49,0xff,0xff,0xff,0x26,0x00,0x00,0x00,0x00,0x00,0x00,0x54,0xff,0xdf,0x05,0xae,0xff,
0xff,0x52,0x07,0xff,0xff,0xff,0x46,0x00,0x00,0x00,0x00,0x00,0x02,0xd6,0xff,0x61,0x00,0x9d,
0xff,0xff,0xa7,0x68,0xff,0xff,0xff,0x33,0x00,0x00,0x00,0x00,0x00,0x5e,0xff,0xda,0x03,0x00,
0x52,0xff,0xff,0xff,0xff,0xff,0xff,0xe3,0x03,0x00,0x00,0x00,0x00,0x05,0xde,0xff,0x5b,0x00,
0x00,0x01,0xb5,0xff,0xff,0xff,0xff,0xfc,0x4d,0x00,0x00,0x00,0x00,0x00,0x06,0x24,0x24,0x02,
0x00,0x00,0x00,0x07,0x89,0xe6,0xf9,0xc8,0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x2f,0x68,0x79,0x60,0x29,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2b,0xc6,
0xff,0xff,0xff,0xff,0xfe,0xad,0x0f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0xf1,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xd0,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0xcd,0xff,0xff,0xff,0xd8,
0xba,0xee,0xff,0xff,0xff,0x69,0x00,0x00,0x00,0x00,0x00,0x26,0xff,0xff,0xff,0x7b,0x00,0x00,
0x0d,0xb6,0xb8,0x43,0x00,0x00,0x00,0x00,0x00,0x00,0x44,0xff,0xff,0xff,0x0e,0x00,0x00,0x00,
0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x29,0xff,0xff,0xff,0x37,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0xd3,0xff,0xff,0xe1,0x63,0x35,0x30,0x30,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x34,0xf0,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5f,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x6d,0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x2f,0xfb,0xff,0xff,0xc9,0x39,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x94,0xff,0xff,0xe9,0x10,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0x00,0x00,0xd6,0xff,0xff,0x7f,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,
0x00,0xf0,0xff,0xff,0x57,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,
0xf3,0xff,0xff,0x75,0x00,0x00,0x00,0x30,0x30,0x7e,0xff,0xff,0xf2,0x30,0x30,0x00,0x00,0xcc,
0xff,0xff,0xe2,0x0f,0x00,0x00,0x00,0x00,0xb6,0xff,0xff,0xc7,0x00,0x00,0x00,0x00,0x6a,0xff,
0xff,0xff,0xde,0x63,0x3a,0x50,0xb4,0xff,0xff,0xff,0x6a,0x00,0x00,0x00,0x00,0x07,0xc4,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xc0,0x05,0x00,0x00,0x00,0x00,0x00,0x12,0xb7,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xc9,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4f,0xac,
0xe2,0xf9,0xed,0xbc,0x61,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x97,0xf5,0xcb,0x1e,0x00,0x00,
0x00,0xff,0xff,0xff,0x4b,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0xc2,0xf5,0xd5,0x29,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x15,0xed,0xff,0xff,0x7e,0x00,0x00,
0x00,0x00,0xa0,0xff,0xff,0xe1,0x09,0x00,0x00,0x00,0x32,0xff,0xff,0xff,0x5a,0x00,0x00,0x00,
0x00,0x9a,0xff,0xff,0xe7,0x04,0x00,0x00,0x00,0x0b,0xf2,0xff,0xff,0x88,0x00,0x00,0x00,0x00,
0x4a,0xff,0xff,0xff,0x2b,0x00,0x00,0x00,0x00,0x82,0xff,0xff,0xec,0x00,0x00,0x00,0x00,0x00,
0xb8,0xff,0xff,0xb3,0x00,0x00,0x00,0x00,0x00,0xd7,0xff,0xff,0x81,0x00,0x00,0x00,0x00,0x00,
0xe7,0xff,0xff,0x6b,0x00,0x00,0x00,0x00,0x00,0xf8,0xff,0xff,0x58,0x00,0x00,0x00,0x00,0x00,
0xf9,0xff,0xff,0x53,0x00,0x00,0x00,0x00,0x00,0xea,0xff,0xff,0x68,0x00,0x00,0x00,0x00,0x00,
0xdb,0xff,0xff,0x7d,0x00,0x00,0x00,0x00,0x00,0xbd,0xff,0xff,0xab,0x00,0x00,0x00,0x00,0x00,
0x8c,0xff,0xff,0xe8,0x00,0x00,0x00,0x00,0x00,0x5b,0xff,0xff,0xff,0x28,0x00,0x00,0x00,0x00,
0x17,0xfd,0xff,0xff,0x86,0x00,0x00,0x00,0x00,0x00,0xb7,0xff,0xff,0xe7,0x04,0x00,0x00,0x00,
0x00,0x42,0xff,0xff,0xff,0x5a,0x00,0x00,0x00,0x00,0x00,0xb4,0xff,0xff,0xe0,0x09,0x00,0x00,
0x00,0x00,0x1d,0xef,0xff,0xff,0x7e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x32,0xfe,0xff,0xff,0x45,0x00,0x00,0x00,0x00,
0x00,0xa0,0xff,0xff,0xda,0x07,0x00,0x00,0x00,0x00,0x1a,0xf8,0xff,0xff,0x75,0x00,0x00,0x00,
0x00,0x00,0xa8,0xff,0xff,0xdd,0x01,0x00,0x00,0x00,0x00,0x46,0xff,0xff,0xff,0x45,0x00,0x00,
0x00,0x00,0x02,0xe6,0xff,0xff,0x92,0x00,0x00,0x00,0x00,0x00,0xa9,0xff,0xff,0xca,0x00,0x00,
0x00,0x00,0x00,0x6c,0xff,0xff,0xf9,0x07,0x00,0x00,0x00,0x00,0x38,0xff,0xff,0xff,0x20,0x00,
0x00,0x00,0x00,0x21,0xff,0xff,0xff,0x31,0x00,0x00,0x00,0x00,0x0a,0xff,0xff,0xff,0x43,0x00,
0x00,0x00,0x00,0x0b,0xff,0xff,0xff,0x43,0x00,0x00,0x00,0x00,0x20,0xff,0xff,0xff,0x33,0x00,
0x00,0x00,0x00,0x36,0xff,0xff,0xff,0x23,0x00,0x00,0x00,0x00,0x68,0xff,0xff,0xfa,0x07,0x00,
0x00,0x00,0x00,0xa5,0xff,0xff,0xce,0x00,0x00,0x00,0x00,0x01,0xe3,0xff,0xff,0x9a,0x00,0x00,
0x00,0x00,0x41,0xff,0xff,0xff,0x51,0x00,0x00,0x00,0x00,0xa4,0xff,0xff,0xeb,0x08,0x00,0x00,
0x00,0x18,0xf6,0xff,0xff,0x80,0x00,0x00,0x00,0x00,0x9e,0xff,0xff,0xe6,0x0c,0x00,0x00,0x00,
0x31,0xfd,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x49,0x6c,0x04,
0x00,0x02,0x6a,0x52,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x68,0xff,0xff,0x66,0x00,0x5f,0xff,
0xff,0x84,0x00,0x00,0x00,0x00,0x00,0x00,0x62,0xff,0xff,0xe5,0x0f,0xde,0xff,0xff,0x6c,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xb2,0xff,0xff,0xcd,0xff,0xff,0xbb,0x01,0x00,0x00,0x00,0x00,
0x10,0x30,0x30,0x45,0xf6,0xff,0xff,0xff,0xfa,0x4c,0x30,0x30,0x0c,0x00,0x00,0xc6,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xbf,0x00,0x00,0xf6,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xf4,0x00,0x00,0xa2,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xad,0x00,0x00,0x00,0x00,0x00,0x32,0xfb,0xff,0xff,0xff,0xf7,0x28,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x06,0xd2,0xff,0xff,0xb4,0xff,0xff,0xc8,0x03,0x00,0x00,0x00,0x00,
0x00,0x00,0x7d,0xff,0xff,0xd5,0x07,0xdf,0xff,0xff,0x6e,0x00,0x00,0x00,0x00,0x00,0x00,0x6f,
0xff,0xff,0x5a,0x00,0x63,0xff,0xff,0x63,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x48,0x6c,0x02,
0x00,0x03,0x6b,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,
0x6d,0xff,0xff,0xff,0x30,0x30,0x30,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x3b,0xe1,0xe1,0x40,0x00,0x00,0xd7,0xff,0xff,0xd8,0x00,0x00,0xf5,0xff,0xff,
0xf8,0x00,0x00,0xad,0xff,0xff,0xcc,0x00,0x00,0x0c,0xb4,0xff,0x6a,0x00,0x00,0x00,0xc5,0xda,
0x0a,0x00,0x00,0x04,0xa1,0x2f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x4b,0xe4,0xe4,0x49,0x00,0x00,0xe5,0xff,0xff,0xe4,0x00,0x00,0xe4,0xff,0xff,
0xe3,0x00,0x00,0x49,0xe4,0xe4,0x49,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x22,0xfe,0xff,0xff,0x68,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x8a,0xff,0xff,0xf4,0x0d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,
0xeb,0xff,0xff,0x9c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5c,0xff,0xff,0xff,0x36,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xc5,0xff,0xff,0xd0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x2e,0xff,0xff,0xff,0x6a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x97,0xff,0xff,0xf5,
0x0e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0d,0xf3,0xff,0xff,0x9e,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x6a,0xff,0xff,0xff,0x38,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xd3,0xff,
0xff,0xd1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3c,0xff,0xff,0xff,0x6b,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xa5,0xff,0xff,0xf5,0x0f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x15,
0xf9,0xff,0xff,0x9f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x77,0xff,0xff,0xff,0x39,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x02,0xde,0xff,0xff,0xd3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x4a,0xff,0xff,0xff,0x6d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xb3,0xff,0xff,0xf6,
0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1f,0xfd,0xff,0xff,0xa1,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x85,0xff,0xff,0xff,0x3b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05,0xe8,0xff,
0xff,0xd4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x57,0xff,0xff,0xff,0x6f,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x22,0x93,0xdc,0xf7,
0xea,0xb9,0x51,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4d,0xf3,0xff,0xff,0xff,0xff,0xff,
0xff,0x9e,0x01,0x00,0x00,0x00,0x00,0x00,0x2f,0xf6,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0x7e,0x00,0x00,0x00,0x00,0x00,0xbf,0xff,0xff,0xe6,0x67,0x38,0x49,0xb0,0xff,0xff,0xf7,0x1c,
0x00,0x00,0x00,0x2f,0xff,0xff,0xfc,0x2b,0x00,0x00,0x00,0x01,0xc5,0xff,0xff,0x80,0x00,0x00,
0x00,0x81,0xff,0xff,0xbb,0x00,0x00,0x00,0x00,0x00,0x65,0xff,0xff,0xd1,0x00,0x00,0x00,0xb6,
0xff,0xff,0x83,0x00,0x00,0x00,0x00,0x00,0x32,0xff,0xff,0xfc,0x07,0x00,0x00,0xdf,0xff,0xff,
0x64,0x00,0x00,0x00,0x00,0x00,0x17,0xff,0xff,0xff,0x2b,0x00,0x00,0xf1,0xff,0xff,0x53,0x00,
0x00,0x00,0x00,0x00,0x08,0xff,0xff,0xff,0x3c,0x00,0x00,0xfc,0xff,0xff,0x4d,0x00,0x00,0x00,
0x00,0x00,0x02,0xff,0xff,0xff,0x47,0x00,0x00,0xf2,0xff,0xff,0x4f,0x00,0x00,0x00,0x00,0x00,
0x05,0xff,0xff,0xff,0x3d,0x00,0x00,0xe1,0xff,0xff,0x58,0x00,0x00,0x00,0x00,0x00,0x0e,0xff,
0xff,0xff,0x2b,0x00,0x00,0xcb,0xff,0xff,0x70,0x00,0x00,0x00,0x00,0x00,0x23,0xff,0xff,0xff,
0x15,0x00,0x00,0x97,0xff,0xff,0x98,0x00,0x00,0x00,0x00,0x00,0x48,0xff,0xff,0xdf,0x00,0x00,
0x00,0x5c,0xff,0xff,0xce,0x00,0x00,0x00,0x00,0x00,0x88,0xff,0xff,0xa3,0x00,0x00,0x00,0x12,
0xf4,0xff,0xff,0x40,0x00,0x00,0x00,0x10,0xea,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x91,0xff,
0xff,0xf4,0x6d,0x37,0x54,0xd0,0xff,0xff,0xd5,0x01,0x00,0x00,0x00,0x00,0x15,0xdf,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xfa,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x2b,0xea,0xff,0xff,0xff,
0xff,0xff,0xfc,0x61,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x91,0xdf,0xfa,0xeb,0xac,
0x35,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x7f,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x8e,
0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x9c,0xff,0xff,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2a,0x70,0x70,0x70,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x46,0xb2,0xec,0xf7,0xdf,0xa8,0x3c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x06,0xa0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x8d,0x00,0x00,0x00,0x00,0x00,0x00,0xa5,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x62,0x00,0x00,0x00,0x00,0x3f,0xff,0xff,0xff,0xda,
0x5b,0x3b,0x73,0xf3,0xff,0xff,0xdc,0x00,0x00,0x00,0x00,0x60,0xec,0xff,0xf6,0x1e,0x00,0x00,
0x00,0x60,0xff,0xff,0xff,0x22,0x00,0x00,0x00,0x00,0x03,0x3c,0x58,0x00,0x00,0x00,0x00,0x14,
0xff,0xff,0xff,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0e,0xff,0xff,
0xff,0x42,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0xff,0xff,0xff,0x29,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1b,0xe9,0xff,0xff,0xe6,0x01,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x27,0xdf,0xff,0xff,0xff,0x6e,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x5a,0xf3,0xff,0xff,0xff,0xb1,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x08,0x9d,0xff,0xff,0xff,0xff,0xb8,0x0a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x13,0xc5,0xff,
0xff,0xff,0xff,0x94,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0a,0xcb,0xff,0xff,0xff,0xf5,
0x5b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x99,0xff,0xff,0xff,0xe9,0x33,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2d,0xfe,0xff,0xff,0xeb,0x24,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x88,0xff,0xff,0xff,0x83,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x00,0x00,0x00,0xc5,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,
0x00,0xe7,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0xf8,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x55,0xbb,0xe4,0xfa,0xe8,0xb4,0x5a,0x02,0x00,0x00,
0x00,0x00,0x00,0x00,0x05,0xab,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xc5,0x12,0x00,0x00,0x00,
0x00,0x00,0x89,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xa7,0x00,0x00,0x00,0x00,0x0a,
0xda,0xff,0xff,0xe0,0x5d,0x39,0x6c,0xea,0xff,0xff,0xfc,0x16,0x00,0x00,0x00,0x00,0x00,0x20,
0x5c,0x22,0x00,0x00,0x00,0x47,0xff,0xff,0xff,0x3f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x0d,0xff,0xff,0xff,0x3c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x55,0xff,0xff,0xf4,0x0c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x30,0x36,0x74,0xf3,
0xff,0xff,0x6d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xff,0xff,0xff,0xff,0xff,0xbc,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xff,0xff,0xff,0xff,0xff,0xff,0x92,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x59,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x21,0x8d,0xfd,0xff,0xff,0xd7,0x01,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x82,0xff,0xff,0xff,0x2a,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x19,0xff,0xff,0xff,0x46,0x00,0x00,0x00,0x0e,0x4f,0x4d,0x00,
0x00,0x00,0x00,0x00,0x1c,0xff,0xff,0xff,0x39,0x00,0x00,0xa9,0xfb,0xff,0xf0,0x26,0x00,0x00,
0x00,0x00,0x87,0xff,0xff,0xf7,0x0c,0x00,0x00,0x6f,0xff,0xff,0xff,0xec,0x78,0x3c,0x4b,0xa3,
0xff,0xff,0xff,0x9b,0x00,0x00,0x00,0x03,0xbe,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xe1,0x16,0x00,0x00,0x00,0x00,0x0f,0xb8,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xd5,0x25,0x00,
0x00,0x00,0x00,0x00,0x00,0x01,0x52,0xb2,0xe7,0xfa,0xed,0xbd,0x65,0x05,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05,0xd7,0xff,
0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x76,0xff,0xff,0xff,0xff,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1b,0xf3,0xff,0xff,0xff,0xff,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xa8,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x41,0xff,0xff,0xfd,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x04,0xd5,0xff,0xff,0x98,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x73,0xff,0xff,0xb2,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0xf2,0xff,
0xf6,0x21,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xa5,0xff,0xff,0x7e,0x00,
0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x3e,0xff,0xff,0xdc,0x07,0x00,0x4c,0xff,
0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x04,0xd3,0xff,0xff,0x4a,0x00,0x00,0x4c,0xff,0xff,0xff,
0x00,0x00,0x00,0x00,0x00,0x71,0xff,0xff,0xb0,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,
0x00,0x00,0x00,0xf1,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,
0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x6d,0xff,0xff,0xff,0x30,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,
0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x55,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xac,0x00,0x00,0x00,0x00,0x00,0x00,0x7e,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xac,0x00,0x00,0x00,0x00,0x00,0x00,0xa8,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xac,0x00,0x00,0x00,0x00,0x00,0x00,0xd1,0xff,0xff,0x98,0x30,0x30,0x30,0x30,0x30,
0x20,0x00,0x00,0x00,0x00,0x00,0x03,0xf7,0xff,0xff,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x24,0xff,0xff,0xff,0x27,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x4d,0xff,0xff,0xf5,0x14,0x2a,0x19,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x77,0xff,0xff,0xfc,0xfd,0xff,0xff,0xf2,0x9b,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0xa0,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf0,0x48,0x00,0x00,0x00,0x00,0x00,0x8a,0xf8,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xf1,0x24,0x00,0x00,0x00,0x00,0x00,0x10,0x66,0xae,0x44,0x0d,
0x19,0x86,0xff,0xff,0xff,0xa5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x9c,0xff,0xff,0xf8,0x0d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2c,0xff,
0xff,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0b,0xff,0xff,0xff,
0x43,0x00,0x00,0x3e,0x76,0xa3,0x9e,0x00,0x00,0x00,0x00,0x00,0x2e,0xff,0xff,0xff,0x2a,0x00,
0x00,0x9d,0xff,0xff,0xff,0x50,0x00,0x00,0x00,0x00,0xa9,0xff,0xff,0xef,0x07,0x00,0x00,0x30,
0xfd,0xff,0xff,0xf8,0x83,0x3e,0x50,0xb4,0xff,0xff,0xff,0x91,0x00,0x00,0x00,0x00,0x7a,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xdf,0x11,0x00,0x00,0x00,0x00,0x00,0x78,0xfd,0xff,
0xff,0xff,0xff,0xff,0xff,0xd6,0x29,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2f,0x9c,0xdf,0xf9,
0xea,0xc4,0x6b,0x0a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xa6,0xff,0xff,0xfc,0x2b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x26,0xfd,0xff,0xff,0x99,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xa0,
0xff,0xff,0xf3,0x17,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x21,0xfb,0xff,0xff,
0x7c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x9a,0xff,0xff,0xe3,0x09,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1d,0xf9,0xff,0xff,0x5e,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x94,0xff,0xff,0xcd,0x01,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x18,0xf7,0xff,0xff,0xfd,0xf8,0xdd,0x97,0x20,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x8e,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf5,0x4b,0x00,0x00,0x00,0x00,0x00,0x13,
0xf5,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf5,0x27,0x00,0x00,0x00,0x00,0x6c,0xff,0xff,
0xff,0xc4,0x49,0x46,0xa6,0xff,0xff,0xff,0xaa,0x00,0x00,0x00,0x00,0xb3,0xff,0xff,0xe2,0x0a,
0x00,0x00,0x00,0xa6,0xff,0xff,0xf9,0x09,0x00,0x00,0x00,0xe3,0xff,0xff,0x78,0x00,0x00,0x00,
0x00,0x2f,0xff,0xff,0xff,0x34,0x00,0x00,0x00,0xfa,0xff,0xff,0x55,0x00,0x00,0x00,0x00,0x0a,
0xff,0xff,0xff,0x46,0x00,0x00,0x00,0xeb,0xff,0xff,0x75,0x00,0x00,0x00,0x00,0x29,0xff,0xff,
0xff,0x34,0x00,0x00,0x00,0xbe,0xff,0xff,0xdd,0x08,0x00,0x00,0x00,0x9e,0xff,0xff,0xf2,0x06,
0x00,0x00,0x00,0x5f,0xff,0xff,0xff,0xcc,0x51,0x44,0xa1,0xff,0xff,0xff,0x90,0x00,0x00,0x00,
0x00,0x02,0xc0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe1,0x11,0x00,0x00,0x00,0x00,0x00,
0x14,0xc0,0xff,0xff,0xff,0xff,0xff,0xff,0xde,0x27,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,
0x5f,0xc2,0xec,0xf5,0xcf,0x78,0x0a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xb5,0x00,
0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x39,0x00,0x00,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xbd,0x00,0x00,0x00,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x61,0xff,0xff,0xff,0xff,0x41,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xab,0xff,0xff,0xff,0xc5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x27,
0xfd,0xff,0xff,0xff,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x9e,0xff,0xff,
0xff,0xcb,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1d,0xfa,0xff,0xff,0xff,0x50,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x91,0xff,0xff,0xff,0xd2,0x01,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x14,0xf5,0xff,0xff,0xff,0x58,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x83,0xff,0xff,0xff,0xd8,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x0d,0xef,0xff,0xff,0xff,0x5f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x76,0xff,0xff,0xff,0xde,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xe7,0xff,
0xff,0xff,0x67,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x69,0xff,0xff,0xff,0xe4,
0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xde,0xff,0xff,0xff,0x6e,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5b,0xff,0xff,0xff,0xe8,0x09,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x01,0xd3,0xff,0xff,0xff,0x76,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x4e,0xff,0xff,0xff,0xed,0x0c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xc7,0xff,0xff,0xff,0x7e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x34,0x9f,0xdd,0xf7,0xf6,0xd9,0x97,0x28,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7d,0xfd,0xff,0xff,0xff,0xff,0xff,0xff,0xf9,0x68,0x00,
0x00,0x00,0x00,0x00,0x56,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x49,0x00,0x00,
0x00,0x00,0xc7,0xff,0xff,0xf6,0x7b,0x3e,0x3f,0x7d,0xf7,0xff,0xff,0xc2,0x00,0x00,0x00,0x00,
0xf5,0xff,0xff,0x77,0x00,0x00,0x00,0x00,0x78,0xff,0xff,0xf4,0x00,0x00,0x00,0x00,0xe8,0xff,
0xff,0x62,0x00,0x00,0x00,0x00,0x63,0xff,0xff,0xee,0x00,0x00,0x00,0x00,0xa8,0xff,0xff,0xdf,
0x44,0x0d,0x0c,0x47,0xe2,0xff,0xff,0xaf,0x00,0x00,0x00,0x00,0x24,0xee,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xef,0x27,0x00,0x00,0x00,0x00,0x00,0x5d,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0x5a,0x00,0x00,0x00,0x00,0x00,0x52,0xfb,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xfb,0x54,0x00,0x00,0x00,0x18,0xf3,0xff,0xff,0xea,0x75,0x43,0x46,0x87,0xf7,0xff,0xff,0xf4,
0x1b,0x00,0x00,0x89,0xff,0xff,0xeb,0x18,0x00,0x00,0x00,0x00,0x2b,0xef,0xff,0xff,0x8d,0x00,
0x00,0xd5,0xff,0xff,0x7d,0x00,0x00,0x00,0x00,0x00,0x00,0x7d,0xff,0xff,0xd5,0x00,0x00,0xf6,
0xff,0xff,0x54,0x00,0x00,0x00,0x00,0x00,0x00,0x52,0xff,0xff,0xf6,0x00,0x00,0xee,0xff,0xff,
0x74,0x00,0x00,0x00,0x00,0x00,0x00,0x75,0xff,0xff,0xeb,0x00,0x00,0xbe,0xff,0xff,0xe4,0x19,
0x00,0x00,0x00,0x00,0x1a,0xe6,0xff,0xff,0xbc,0x00,0x00,0x62,0xff,0xff,0xff,0xed,0x78,0x43,
0x43,0x79,0xee,0xff,0xff,0xff,0x5f,0x00,0x00,0x03,0xc3,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xc1,0x02,0x00,0x00,0x00,0x11,0xb9,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xb2,0x0e,0x00,0x00,0x00,0x00,0x00,0x01,0x4e,0xab,0xe2,0xf8,0xf6,0xdb,0xa2,0x42,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x5a,0xbb,0xed,0xf4,
0xd2,0x7c,0x12,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x13,0xc0,0xff,0xff,0xff,0xff,0xff,0xff,
0xe3,0x34,0x00,0x00,0x00,0x00,0x00,0x03,0xc2,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xec,
0x1b,0x00,0x00,0x00,0x00,0x61,0xff,0xff,0xff,0xc3,0x50,0x41,0x92,0xfe,0xff,0xff,0xa6,0x00,
0x00,0x00,0x00,0xc3,0xff,0xff,0xcc,0x03,0x00,0x00,0x00,0x80,0xff,0xff,0xf8,0x0f,0x00,0x00,
0x00,0xf3,0xff,0xff,0x65,0x00,0x00,0x00,0x00,0x1b,0xff,0xff,0xff,0x36,0x00,0x00,0x00,0xf6,
0xff,0xff,0x61,0x00,0x00,0x00,0x00,0x13,0xff,0xff,0xff,0x46,0x00,0x00,0x00,0xd6,0xff,0xff,
0xb5,0x00,0x00,0x00,0x00,0x67,0xff,0xff,0xff,0x2f,0x00,0x00,0x00,0x8c,0xff,0xff,0xff,0x98,
0x21,0x10,0x5f,0xf3,0xff,0xff,0xf7,0x06,0x00,0x00,0x00,0x1c,0xf2,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xb6,0x00,0x00,0x00,0x00,0x00,0x4c,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0x51,0x00,0x00,0x00,0x00,0x00,0x00,0x2f,0xb2,0xf8,0xff,0xff,0xff,0xff,0xff,0xd5,
0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x09,0x25,0x8b,0xff,0xff,0xff,0x58,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0xe1,0xff,0xff,0xd9,0x02,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x67,0xff,0xff,0xff,0x5f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x05,0xe1,0xff,0xff,0xde,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x66,0xff,0xff,0xff,0x67,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05,0xe0,
0xff,0xff,0xe3,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x65,0xff,0xff,0xff,
0x6e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05,0xdf,0xff,0xff,0xe8,0x09,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x49,
0xe3,0xe3,0x47,0x00,0x00,0xe4,0xff,0xff,0xe2,0x00,0x00,0xe4,0xff,0xff,0xe4,0x00,0x00,0x4b,
0xe4,0xe4,0x4a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x4b,0xe4,0xe4,0x49,0x00,0x00,0xe5,0xff,0xff,0xe4,0x00,0x00,0xe4,
0xff,0xff,0xe3,0x00,0x00,0x49,0xe4,0xe4,0x49,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x49,0xe3,0xe3,0x47,0x00,0x00,0xe4,0xff,0xff,0xe2,0x00,0x00,0xe4,
0xff,0xff,0xe4,0x00,0x00,0x4b,0xe4,0xe4,0x4a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x03,0x61,0x61,0x04,0x00,0x00,0x99,0xff,0xff,0x9e,0x00,0x00,0xf3,
0xff,0xff,0xf4,0x00,0x00,0xde,0xff,0xff,0xe8,0x00,0x00,0x4f,0xee,0xff,0xa0,0x00,0x00,0x00,
0x99,0xfd,0x2e,0x00,0x00,0x03,0xe8,0x85,0x00,0x00,0x00,0x00,0x26,0x02,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3a,0xfd,0xff,0xff,0xfa,0x2d,0x00,
0x00,0x00,0x00,0x08,0xd7,0xff,0xff,0xff,0x80,0x00,0x00,0x00,0x00,0x00,0x87,0xff,0xff,0xff,
0xd3,0x06,0x00,0x00,0x00,0x00,0x32,0xfb,0xff,0xff,0xfc,0x35,0x00,0x00,0x00,0x00,0x05,0xd1,
0xff,0xff,0xff,0x8b,0x00,0x00,0x00,0x00,0x00,0x7e,0xff,0xff,0xff,0xda,0x09,0x00,0x00,0x00,
0x00,0x2c,0xf9,0xff,0xff,0xfe,0x3e,0x00,0x00,0x00,0x00,0x03,0xca,0xff,0xff,0xff,0x95,0x00,
0x00,0x00,0x00,0x00,0x3d,0xff,0xff,0xff,0xff,0x1e,0x00,0x00,0x00,0x00,0x00,0x00,0xb7,0xff,
0xff,0xff,0x9d,0x00,0x00,0x00,0x00,0x00,0x00,0x1e,0xf3,0xff,0xff,0xff,0x43,0x00,0x00,0x00,
0x00,0x00,0x00,0x6e,0xff,0xff,0xff,0xdd,0x0a,0x00,0x00,0x00,0x00,0x00,0x02,0xc7,0xff,0xff,
0xff,0x8c,0x00,0x00,0x00,0x00,0x00,0x00,0x2a,0xf9,0xff,0xff,0xfc,0x34,0x00,0x00,0x00,0x00,
0x00,0x00,0x80,0xff,0xff,0xff,0xd1,0x05,0x00,0x00,0x00,0x00,0x00,0x06,0xd5,0xff,0xff,0xff,
0x7b,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0xfd,0xff,0xff,0xf8,0x28,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0f,0xe4,0xff,0xff,0xff,0x83,
0x00,0x00,0x00,0x00,0x00,0x00,0x4b,0xff,0xff,0xff,0xfa,0x2e,0x00,0x00,0x00,0x00,0x00,0x00,
0xa2,0xff,0xff,0xff,0xcc,0x03,0x00,0x00,0x00,0x00,0x00,0x12,0xe7,0xff,0xff,0xff,0x77,0x00,
0x00,0x00,0x00,0x00,0x00,0x51,0xff,0xff,0xff,0xf7,0x26,0x00,0x00,0x00,0x00,0x00,0x00,0xa8,
0xff,0xff,0xff,0xc2,0x01,0x00,0x00,0x00,0x00,0x00,0x15,0xea,0xff,0xff,0xff,0x6b,0x00,0x00,
0x00,0x00,0x00,0x00,0x56,0xff,0xff,0xff,0xf2,0x1e,0x00,0x00,0x00,0x00,0x00,0x01,0xe1,0xff,
0xff,0xff,0x78,0x00,0x00,0x00,0x00,0x00,0x69,0xff,0xff,0xff,0xe1,0x0b,0x00,0x00,0x00,0x00,
0x1d,0xf2,0xff,0xff,0xff,0x4b,0x00,0x00,0x00,0x00,0x00,0xb5,0xff,0xff,0xff,0xaa,0x00,0x00,
0x00,0x00,0x00,0x5c,0xff,0xff,0xff,0xef,0x18,0x00,0x00,0x00,0x00,0x16,0xec,0xff,0xff,0xff,
0x66,0x00,0x00,0x00,0x00,0x00,0xa9,0xff,0xff,0xff,0xc2,0x01,0x00,0x00,0x00,0x00,0x4e,0xff,
0xff,0xff,0xf9,0x28,0x00,0x00,0x00,0x00,0x0f,0xe5,0xff,0xff,0xff,0x80,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x0f,0x52,0x75,0x71,0x52,0x11,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x73,
0xf2,0xff,0xff,0xff,0xff,0xf7,0x9c,0x0d,0x00,0x00,0x00,0x00,0x89,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xd9,0x1a,0x00,0x00,0x39,0xfe,0xff,0xff,0xff,0xd7,0xbd,0xe7,0xff,0xff,0xff,
0xb2,0x00,0x00,0xa1,0xff,0xff,0xff,0x77,0x00,0x00,0x03,0x97,0xff,0xff,0xfe,0x17,0x00,0x9f,
0xe7,0xff,0xd6,0x00,0x00,0x00,0x00,0x11,0xff,0xff,0xff,0x41,0x00,0x00,0x00,0x10,0x22,0x00,
0x00,0x00,0x00,0x15,0xff,0xff,0xff,0x3b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7a,
0xff,0xff,0xff,0x1a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x46,0xf7,0xff,0xff,0xd3,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5b,0xf9,0xff,0xff,0xfd,0x45,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x58,0xfe,0xff,0xff,0xff,0x6b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0b,0xee,0xff,
0xff,0xfc,0x63,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3b,0xff,0xff,0xff,0x76,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x11,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x29,
0x8c,0x8c,0x8c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4b,0xe4,0xe4,0x49,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xe5,0xff,0xff,0xe4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xe3,0xff,0xff,0xe3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x47,0xe3,0xe4,
0x49,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0b,0x48,
0x66,0x79,0x6a,0x50,0x15,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x38,0xb3,0xf8,0xff,0xff,0xff,0xff,0xff,0xfe,0xc7,0x55,0x02,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x0d,0xa7,0xff,0xff,0xff,0xee,0xc1,0xb0,0xcc,0xf3,0xff,0xff,0xff,0xcc,
0x23,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0xd6,0xff,0xff,0xd7,0x50,0x05,0x00,0x00,0x00,
0x0a,0x65,0xe1,0xff,0xff,0xf1,0x37,0x00,0x00,0x00,0x00,0x00,0x08,0xc9,0xff,0xff,0xa3,0x06,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x12,0xb7,0xff,0xff,0xeb,0x21,0x00,0x00,0x00,0x00,0x81,
0xff,0xff,0xb2,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x09,0xd1,0xff,0xff,0xb3,
0x00,0x00,0x00,0x16,0xf4,0xff,0xf1,0x13,0x00,0x00,0x2b,0x9e,0xe2,0xfa,0xee,0xbc,0x58,0x00,
0x00,0x2e,0xff,0xff,0xff,0x39,0x00,0x00,0x6b,0xff,0xff,0x86,0x00,0x00,0x63,0xf9,0xff,0xff,
0xff,0xff,0xff,0xff,0xae,0x06,0x00,0xbe,0xff,0xff,0x91,0x00,0x00,0xb9,0xff,0xff,0x30,0x00,
0x44,0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x85,0x00,0x79,0xff,0xff,0xd3,0x00,0x00,
0xe0,0xff,0xf6,0x00,0x00,0xc2,0xff,0xff,0xf0,0x6d,0x39,0x64,0xec,0xff,0xff,0xe6,0x00,0x58,
0xff,0xff,0xee,0x00,0x00,0xf8,0xff,0xdf,0x00,0x00,0xf5,0xff,0xff,0x6b,0x00,0x00,0x00,0x65,
0xff,0xff,0xff,0x09,0x5c,0xff,0xff,0xf7,0x00,0x00,0xed,0xff,0xeb,0x00,0x00,0xef,0xff,0xff,
0x73,0x00,0x00,0x00,0x79,0xff,0xff,0xff,0x58,0xac,0xff,0xff,0xd4,0x00,0x00,0xd3,0xff,0xfe,
0x11,0x00,0xb2,0xff,0xff,0xf5,0x72,0x3a,0x6a,0xf3,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x7e,
0x00,0x00,0x95,0xff,0xff,0x5d,0x00,0x36,0xfb,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xd0,0xff,
0xff,0xff,0xff,0xd9,0x0b,0x00,0x00,0x43,0xff,0xff,0xcd,0x01,0x00,0x5a,0xf8,0xff,0xff,0xff,
0xff,0xff,0xb2,0x0b,0xad,0xff,0xff,0xc2,0x1d,0x00,0x00,0x00,0x00,0xc8,0xff,0xff,0x68,0x00,
0x00,0x29,0xa0,0xe4,0xf9,0xdf,0x83,0x06,0x00,0x00,0x1a,0x1e,0x00,0x00,0x00,0x00,0x00,0x00,
0x39,0xfb,0xff,0xf9,0x47,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x6a,0xff,0xff,0xfc,0x7d,0x08,0x00,0x00,0x00,0x00,0x00,0x00,
0x36,0x8d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x67,0xf8,0xff,0xff,0xe5,0x8d,
0x4b,0x30,0x38,0x65,0xb8,0xff,0xff,0x4f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x30,0xb9,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xcf,0x36,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x85,0xc9,0xe7,0xfa,0xf0,0xd6,0x9e,0x47,0x01,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0d,
0xf6,0xff,0xff,0xff,0x70,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x5d,0xff,0xff,0xff,0xff,0xc8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xb5,0xff,0xff,0xff,0xff,0xff,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x12,0xfa,0xff,0xff,0xff,0xff,0xff,0x78,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x65,0xff,0xff,0xff,0xf8,0xff,0xff,0xd0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xbd,0xff,0xff,0xf2,0x8a,0xff,0xff,0xff,0x29,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x18,0xfd,0xff,0xff,0xa7,0x31,0xff,0xff,0xff,0x81,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x6e,0xff,0xff,0xff,0x54,0x00,0xde,0xff,0xff,0xd8,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xc6,0xff,0xff,0xf6,0x0b,0x00,0x8d,0xff,0xff,0xff,0x31,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x1f,0xfe,0xff,0xff,0xae,0x00,0x00,0x3a,0xff,0xff,0xff,0x89,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x76,0xff,0xff,0xff,0x5c,0x00,0x00,0x01,0xe6,0xff,0xff,0xe0,
0x01,0x00,0x00,0x00,0x00,0x00,0x00,0xcf,0xff,0xff,0xfe,0x3f,0x30,0x30,0x30,0xaf,0xff,0xff,
0xff,0x3a,0x00,0x00,0x00,0x00,0x00,0x27,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0x92,0x00,0x00,0x00,0x00,0x00,0x7f,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xe7,0x02,0x00,0x00,0x00,0x00,0xd6,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0x42,0x00,0x00,0x00,0x2f,0xff,0xff,0xff,0xf1,0x08,0x00,0x00,0x00,
0x00,0x00,0x8e,0xff,0xff,0xff,0x9b,0x00,0x00,0x00,0x88,0xff,0xff,0xff,0x9e,0x00,0x00,0x00,
0x00,0x00,0x00,0x33,0xff,0xff,0xff,0xed,0x05,0x00,0x00,0xdf,0xff,0xff,0xff,0x42,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xd8,0xff,0xff,0xff,0x4b,0x00,0x38,0xff,0xff,0xff,0xe3,0x02,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x7d,0xff,0xff,0xff,0xa3,0x00,0x90,0xff,0xff,0xff,0x8a,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x22,0xff,0xff,0xff,0xf2,0x08,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
0xff,0xff,0xfd,0xea,0xd0,0x9c,0x3a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xfe,0x93,0x01,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0x7c,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x6d,0x30,0x31,
0x43,0x83,0xf6,0xff,0xff,0xf1,0x06,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0x00,0x5e,0xff,0xff,0xff,0x36,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,
0x0e,0xff,0xff,0xff,0x44,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x40,
0xff,0xff,0xff,0x28,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x01,0x11,0x4f,0xe2,0xff,
0xff,0xcf,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xdc,
0x28,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xd0,0x53,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x7b,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x6d,0x30,0x30,0x30,0x3d,0x68,0xcc,0xff,0xff,0xff,0x41,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x04,0xbe,0xff,0xff,0xb8,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x5c,0xff,0xff,0xf2,0x00,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x5c,0xff,0xff,0xf2,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x04,0xbe,0xff,0xff,0xd2,0x00,0x00,0x00,0xff,
0xff,0xff,0x6d,0x30,0x30,0x30,0x3c,0x67,0xcb,0xff,0xff,0xff,0x7e,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe2,0x0e,0x00,0x00,0x00,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xda,0x29,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xf8,0xe4,0xb4,0x63,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2f,0x96,0xda,0xf6,0xf2,0xcc,0x7d,0x15,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x8a,0xfd,0xff,0xff,0xff,0xff,0xff,0xff,0xee,0x4b,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x94,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf9,
0x48,0x00,0x00,0x00,0x00,0x00,0x4b,0xff,0xff,0xff,0xd9,0x64,0x38,0x56,0xca,0xff,0xff,0xff,
0xf5,0x23,0x00,0x00,0x00,0x00,0xd4,0xff,0xff,0xcd,0x0c,0x00,0x00,0x00,0x05,0xb3,0xff,0xff,
0xff,0xa7,0x00,0x00,0x00,0x3d,0xff,0xff,0xff,0x33,0x00,0x00,0x00,0x00,0x00,0x15,0xf3,0xff,
0xff,0xfa,0x10,0x00,0x00,0x8b,0xff,0xff,0xcf,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x8d,0xd4,
0xd4,0xd4,0x38,0x00,0x00,0xc4,0xff,0xff,0x8e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xe8,0xff,0xff,0x64,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xfa,0xff,0xff,0x54,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xfa,0xff,0xff,0x53,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xe9,0xff,0xff,0x64,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xc6,0xff,0xff,0x8d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x8d,0xff,0xff,0xce,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x89,0xc8,
0xc8,0xc8,0x35,0x00,0x00,0x3e,0xff,0xff,0xff,0x3d,0x00,0x00,0x00,0x00,0x00,0x15,0xf5,0xff,
0xff,0xfa,0x10,0x00,0x00,0x01,0xd6,0xff,0xff,0xcd,0x0b,0x00,0x00,0x00,0x03,0xb4,0xff,0xff,
0xff,0xa9,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0xd7,0x62,0x37,0x4f,0xc0,0xff,0xff,0xff,
0xf6,0x25,0x00,0x00,0x00,0x00,0x00,0x94,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfa,
0x4e,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x8b,0xfd,0xff,0xff,0xff,0xff,0xff,0xff,0xf0,0x51,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2f,0x97,0xdb,0xf6,0xf3,0xce,0x82,0x18,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0xff,0xff,0xff,0xf7,0xd7,0x91,0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf8,0x6a,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x78,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x6d,
0x30,0x37,0x5a,0xb2,0xff,0xff,0xff,0xfe,0x3b,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0x00,0x59,0xfb,0xff,0xff,0xd0,0x02,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0x78,0xff,0xff,0xff,0x3c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0x00,0x00,0x05,0xe6,0xff,0xff,0x8e,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,
0x00,0x00,0x94,0xff,0xff,0xc9,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,
0x00,0x62,0xff,0xff,0xe2,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x51,0xff,0xff,0xf8,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x59,
0xff,0xff,0xec,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x73,0xff,
0xff,0xd5,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xaa,0xff,0xff,
0xb7,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x0e,0xf5,0xff,0xff,0x70,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x8e,0xff,0xff,0xff,0x23,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x67,0xfe,0xff,0xff,0xb1,0x00,0x00,0x00,
0x00,0xff,0xff,0xff,0x6d,0x30,0x37,0x5b,0xb8,0xff,0xff,0xff,0xf9,0x24,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfc,0x5b,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf4,0x57,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0xff,0xf7,0xd6,0x8c,0x1e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0x6d,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x6d,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x6d,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,
0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0xff,0xff,0xff,0x6d,0x30,0x30,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x6d,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x0a,0x4a,0x6c,0x7a,0x63,0x25,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x12,0x8f,0xf6,0xff,0xff,0xff,0xff,0xff,0xbb,0x23,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x24,0xdc,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xec,0x3a,0x00,
0x00,0x00,0x00,0x00,0x00,0x0d,0xd9,0xff,0xff,0xff,0xf6,0xc4,0xc8,0xfe,0xff,0xff,0xff,0xe6,
0x0e,0x00,0x00,0x00,0x00,0x00,0x8c,0xff,0xff,0xff,0xa7,0x14,0x00,0x00,0x31,0xd5,0xff,0xff,
0xd2,0x3f,0x00,0x00,0x00,0x00,0x13,0xf7,0xff,0xff,0xb8,0x01,0x00,0x00,0x00,0x00,0x1f,0x7a,
0x25,0x00,0x00,0x00,0x00,0x00,0x00,0x6c,0xff,0xff,0xfd,0x27,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xb1,0xff,0xff,0xc0,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xdd,0xff,0xff,0x7e,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf6,0xff,0xff,0x59,0x00,0x00,0x00,0x00,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,0x00,0xfd,0xff,0xff,0x4f,0x00,0x00,0x00,
0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0xf3,0xff,0xff,0x5c,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0xda,0xff,0xff,0x7f,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xee,0x00,0x00,0x00,0xb1,0xff,0xff,0xba,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xe3,0xff,0xff,0xd7,0x00,0x00,0x00,0x72,0xff,0xff,
0xf9,0x16,0x00,0x00,0x00,0x00,0x00,0x00,0x0e,0xfb,0xff,0xff,0xb8,0x00,0x00,0x00,0x1c,0xfd,
0xff,0xff,0x88,0x00,0x00,0x00,0x00,0x00,0x00,0x5e,0xff,0xff,0xff,0x77,0x00,0x00,0x00,0x00,
0xa9,0xff,0xff,0xfb,0x47,0x00,0x00,0x00,0x00,0x14,0xe4,0xff,0xff,0xfc,0x1c,0x00,0x00,0x00,
0x00,0x23,0xf5,0xff,0xff,0xfa,0x90,0x44,0x3a,0x70,0xe3,0xff,0xff,0xff,0x98,0x00,0x00,0x00,
0x00,0x00,0x00,0x5a,0xfe,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xda,0x10,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x54,0xee,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xca,0x1c,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x12,0x7a,0xc8,0xec,0xfa,0xe6,0xb2,0x59,0x02,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x6d,0x30,0x30,
0x30,0x30,0x30,0x30,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x4b,
0x4c,0x4c,0x17,0x00,0x00,0x00,0x00,0x00,0x01,0xff,0xff,0xff,0x4a,0x00,0x00,0xee,0xff,0xff,
0x54,0x00,0x00,0x00,0x00,0x00,0x13,0xff,0xff,0xff,0x3b,0x00,0x00,0xd8,0xff,0xff,0x70,0x00,
0x00,0x00,0x00,0x00,0x31,0xff,0xff,0xff,0x26,0x00,0x00,0xb7,0xff,0xff,0xad,0x00,0x00,0x00,
0x00,0x00,0x7b,0xff,0xff,0xf3,0x05,0x00,0x00,0x72,0xff,0xff,0xfb,0x2c,0x00,0x00,0x00,0x0b,
0xde,0xff,0xff,0xb3,0x00,0x00,0x00,0x15,0xf5,0xff,0xff,0xe8,0x67,0x37,0x52,0xcc,0xff,0xff,
0xff,0x48,0x00,0x00,0x00,0x00,0x74,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xb2,0x00,
0x00,0x00,0x00,0x00,0x00,0x8c,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xb9,0x09,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x3d,0xa9,0xe5,0xfa,0xf0,0xc0,0x61,0x02,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x16,0xe0,0xff,0xff,0xff,
0x76,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x07,0xc5,0xff,0xff,0xff,0xa3,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0xa2,0xff,0xff,0xff,0xc9,0x08,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x79,0xff,0xff,0xff,0xe5,0x19,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x50,0xfe,0xff,0xff,0xf6,0x34,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x30,0xf4,0xff,0xff,0xff,0x59,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x18,0xe2,0xff,0xff,0xff,0x86,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x54,0xc8,0xff,0xff,0xff,0xb1,0x02,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xde,0xff,0xff,0xff,0xd5,0x0d,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe3,0x11,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xa7,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xc0,0xf1,0xff,0xff,0xff,0x58,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xd3,0x0e,0x60,0xff,0xff,0xff,0xee,0x1b,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4f,0x00,0x00,0xae,0xff,0xff,0xff,0xba,0x01,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x14,0xe8,0xff,0xff,0xff,0x6e,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0xf6,0x28,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x9a,0xff,0xff,0xff,0xcb,0x04,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x0c,0xdc,0xff,0xff,0xff,0x83,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x3a,0xfc,0xff,0xff,0xfc,
0x38,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x85,0xff,0xff,0xff,
0xdb,0x0b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x6d,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xc0,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xbd,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xfd,0x1a,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0xfd,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0xff,0xff,0x70,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x71,0xff,0xff,0xff,0xff,0xff,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xc9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xcb,
0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x21,0x00,0x00,
0x00,0x00,0x00,0x24,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,
0xff,0xff,0x79,0x00,0x00,0x00,0x00,0x00,0x7e,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,
0x00,0xff,0xff,0xff,0xfe,0xff,0xff,0xd2,0x00,0x00,0x00,0x00,0x00,0xd7,0xff,0xff,0xfd,0xff,
0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xc4,0xff,0xff,0xff,0x29,0x00,0x00,0x00,0x32,
0xff,0xff,0xff,0xc3,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x72,0xff,0xff,0xff,
0x82,0x00,0x00,0x00,0x8b,0xff,0xff,0xff,0x6e,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0xd3,0xff,0xff,0xda,0x00,0x00,0x01,0xe3,0xff,0xff,0xce,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x80,0xff,0xff,0xff,0x33,0x00,0x3f,0xff,0xff,0xff,0x79,
0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x2d,0xff,0xff,0xff,0x8b,0x00,
0x99,0xff,0xff,0xff,0x25,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0xda,0xff,0xff,0xe2,0x06,0xed,0xff,0xff,0xd0,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x87,0xff,0xff,0xff,0x88,0xff,0xff,0xff,0x7c,0x00,0x4c,0xff,0xff,
0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x34,0xff,0xff,0xff,0xfd,0xff,0xff,0xff,
0x28,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0xe0,0xff,
0xff,0xff,0xff,0xff,0xd3,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x8e,0xff,0xff,0xff,0xff,0xff,0x7f,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x3b,0xff,0xff,0xff,0xff,0xff,0x2a,0x00,0x00,0x4c,
0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x01,0xe6,0xff,0xff,0xff,
0xd6,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x95,0xff,0xff,0xff,0x82,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0x81,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0xf7,0x23,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xb5,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0x50,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0xe0,0x0a,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0xff,0x86,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0xf6,0xff,0xff,0xf9,0x26,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x82,0xfe,0xff,0xff,0xba,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0xa0,0xff,0xff,0xff,0x56,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x19,0xf3,0xff,0xff,0xe4,0x0c,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x77,0xff,0xff,0xff,0x8b,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x06,0xdc,0xff,0xff,0xfb,0x2a,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x4e,0xff,0xff,0xff,0xc0,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0xb9,0xff,0xff,0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0x2a,0xfb,0xff,0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0x00,0x91,0xff,0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0x00,0x10,0xeb,0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x68,0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x03,0xd0,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x3f,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x29,0x90,0xd6,0xf3,0xf4,0xd7,0x92,0x2b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,
0x82,0xfb,0xff,0xff,0xff,0xff,0xff,0xff,0xfc,0x86,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x8c,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x8f,0x00,0x00,0x00,0x00,0x00,0x44,0xff,
0xff,0xff,0xea,0x77,0x3d,0x40,0x79,0xe9,0xff,0xff,0xff,0x47,0x00,0x00,0x00,0x00,0xcd,0xff,
0xff,0xdc,0x19,0x00,0x00,0x00,0x00,0x1b,0xdc,0xff,0xff,0xd0,0x00,0x00,0x00,0x37,0xff,0xff,
0xff,0x43,0x00,0x00,0x00,0x00,0x00,0x00,0x43,0xff,0xff,0xff,0x3c,0x00,0x00,0x89,0xff,0xff,
0xd9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xd5,0xff,0xff,0x8b,0x00,0x00,0xc4,0xff,0xff,
0x95,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x91,0xff,0xff,0xc4,0x00,0x00,0xe8,0xff,0xff,
0x67,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x71,0xff,0xff,0xe8,0x00,0x00,0xfa,0xff,0xff,
0x55,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x59,0xff,0xff,0xf9,0x00,0x00,0xfa,0xff,0xff,
0x54,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x54,0xff,0xff,0xfa,0x00,0x00,0xe9,0xff,0xff,
0x67,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x67,0xff,0xff,0xe9,0x00,0x00,0xc6,0xff,0xff,
0x93,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x93,0xff,0xff,0xc6,0x00,0x00,0x8b,0xff,0xff,
0xd8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xd6,0xff,0xff,0x8d,0x00,0x00,0x39,0xff,0xff,
0xff,0x4e,0x00,0x00,0x00,0x00,0x00,0x00,0x4d,0xff,0xff,0xff,0x3e,0x00,0x00,0x00,0xcf,0xff,
0xff,0xdc,0x17,0x00,0x00,0x00,0x00,0x16,0xdc,0xff,0xff,0xd2,0x00,0x00,0x00,0x00,0x45,0xff,
0xff,0xff,0xe8,0x75,0x3c,0x3c,0x74,0xe7,0xff,0xff,0xff,0x48,0x00,0x00,0x00,0x00,0x00,0x8c,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x90,0x00,0x00,0x00,0x00,0x00,0x00,0x01,
0x82,0xfb,0xff,0xff,0xff,0xff,0xff,0xff,0xfc,0x86,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x29,0x91,0xd7,0xf4,0xf4,0xd8,0x93,0x2b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xfc,0xec,0xce,0x9c,0x40,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xcb,0x28,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe7,0x13,0x00,0x00,0x00,0xff,0xff,0xff,0x6d,
0x30,0x30,0x39,0x59,0xb0,0xff,0xff,0xff,0x81,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0xb5,0xff,0xff,0xd1,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,
0x00,0x59,0xff,0xff,0xf6,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x59,
0xff,0xff,0xf6,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xb6,0xff,0xff,
0xd1,0x00,0x00,0x00,0xff,0xff,0xff,0x6d,0x30,0x30,0x39,0x59,0xb0,0xff,0xff,0xff,0x80,0x00,
0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe1,0x10,0x00,0x00,0x00,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xc0,0x21,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0xfb,0xeb,0xcc,0x97,0x37,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x0e,0x51,0x70,0x75,0x59,0x17,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x12,0x96,0xf8,0xff,0xff,0xff,0xff,0xfd,0xaa,0x1f,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x21,0xdc,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xea,0x32,0x00,0x00,0x00,
0x00,0x00,0x09,0xd3,0xff,0xff,0xff,0xef,0xc1,0xc4,0xf1,0xff,0xff,0xff,0xe3,0x13,0x00,0x00,
0x00,0x00,0x81,0xff,0xff,0xfe,0x83,0x0a,0x00,0x00,0x0d,0x95,0xff,0xff,0xff,0x96,0x00,0x00,
0x00,0x0c,0xf2,0xff,0xff,0x8f,0x00,0x00,0x00,0x00,0x00,0x00,0x9d,0xff,0xff,0xf9,0x16,0x00,
0x00,0x5f,0xff,0xff,0xf4,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x14,0xf6,0xff,0xff,0x6d,0x00,
0x00,0xa7,0xff,0xff,0xab,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xad,0xff,0xff,0xae,0x00,
0x00,0xd8,0xff,0xff,0x7b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x76,0xff,0xff,0xda,0x00,
0x00,0xf4,0xff,0xff,0x62,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5c,0xff,0xff,0xf3,0x00,
0x00,0xfc,0xff,0xff,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x50,0xff,0xff,0xfc,0x00,
0x00,0xf2,0xff,0xff,0x5b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5c,0xff,0xff,0xf1,0x00,
0x00,0xd6,0xff,0xff,0x78,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7b,0xff,0xff,0xdf,0x00,
0x00,0xa8,0xff,0xff,0xa8,0x00,0x00,0x00,0x00,0x00,0x9d,0x48,0x00,0xaa,0xff,0xff,0xb6,0x00,
0x00,0x64,0xff,0xff,0xf0,0x08,0x00,0x00,0x00,0x78,0xff,0xfd,0x80,0xed,0xff,0xff,0x81,0x00,
0x00,0x12,0xf7,0xff,0xff,0x69,0x00,0x00,0x2d,0xfc,0xff,0xff,0xff,0xff,0xff,0xff,0x34,0x00,
0x00,0x00,0x97,0xff,0xff,0xf1,0x26,0x00,0x00,0x5f,0xf1,0xff,0xff,0xff,0xff,0xcb,0x00,0x00,
0x00,0x00,0x16,0xed,0xff,0xff,0xee,0x79,0x3b,0x3f,0xa1,0xff,0xff,0xff,0xff,0xdc,0x28,0x00,
0x00,0x00,0x00,0x49,0xfb,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe3,0x05,
0x00,0x00,0x00,0x00,0x47,0xea,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xb8,0xf2,0xff,0x5d,0x00,
0x00,0x00,0x00,0x00,0x00,0x0f,0x79,0xca,0xef,0xf9,0xe2,0xaa,0x49,0x00,0x33,0x91,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,
0xfd,0xed,0xd1,0x9f,0x42,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xcb,0x28,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xe7,0x13,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x6d,0x30,0x30,0x3a,0x5d,
0xb4,0xff,0xff,0xff,0x83,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x01,
0xb9,0xff,0xff,0xd2,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x5a,
0xff,0xff,0xf6,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x59,0xff,
0xff,0xef,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xb5,0xff,0xff,
0xcf,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x6d,0x30,0x30,0x39,0x59,0xb0,0xff,0xff,0xff,0x7e,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe4,0x14,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xd2,0x25,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xfd,0xff,0xff,0xff,0x87,0x01,0x00,0x00,0x00,0x00,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x43,0xff,0xff,0xff,0xd2,0x01,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0xb2,0xff,0xff,0xff,0x59,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x26,0xfa,0xff,0xff,0xda,0x03,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0x90,0xff,0xff,0xff,0x62,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0x12,0xed,0xff,0xff,0xe0,0x06,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x6e,0xff,0xff,0xff,0x6c,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0x00,0x05,0xd8,0xff,0xff,0xe6,0x09,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x75,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x15,0x7b,0xc6,0xef,0xfa,0xe6,0xad,0x46,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4e,0xf0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xaa,0x0a,
0x00,0x00,0x00,0x00,0x2e,0xfa,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xb4,0x00,0x00,
0x00,0x00,0xaa,0xff,0xff,0xfd,0x90,0x47,0x37,0x5c,0xd3,0xff,0xff,0xff,0x52,0x00,0x00,0x00,
0xea,0xff,0xff,0x85,0x00,0x00,0x00,0x00,0x10,0x9d,0x73,0x41,0x0e,0x00,0x00,0x00,0xf9,0xff,
0xff,0x5a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xda,0xff,0xff,0xd2,
0x1a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7d,0xff,0xff,0xff,0xf2,0x8d,
0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05,0xb0,0xff,0xff,0xff,0xff,0xff,0xc3,
0x60,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x72,0xed,0xff,0xff,0xff,0xff,0xff,0xdc,
0x47,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0x69,0xd0,0xff,0xff,0xff,0xff,0xfe,0x71,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0xa1,0xfc,0xff,0xff,0xfe,0x40,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x35,0xf3,0xff,0xff,0xb1,0x00,0x00,0x00,
0x00,0x12,0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x77,0xff,0xff,0xe4,0x00,0x00,0x75,0xe5,0xff,
0xe4,0x04,0x00,0x00,0x00,0x00,0x00,0x5a,0xff,0xff,0xf8,0x00,0x00,0x61,0xff,0xff,0xff,0x8a,
0x00,0x00,0x00,0x00,0x00,0xaf,0xff,0xff,0xdb,0x00,0x00,0x0a,0xe7,0xff,0xff,0xff,0xb2,0x53,
0x38,0x53,0xb5,0xff,0xff,0xff,0x8d,0x00,0x00,0x00,0x48,0xfb,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xe4,0x13,0x00,0x00,0x00,0x00,0x4a,0xea,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xd3,0x25,0x00,0x00,0x00,0x00,0x00,0x00,0x12,0x78,0xc6,0xf0,0xfb,0xea,0xb8,0x62,0x06,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x30,0x6d,0xff,0xff,0xff,0x30,
0x30,0x30,0x30,0x30,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xfe,0xff,0xff,0x4d,0x00,0x00,0x00,0x00,0x00,0x00,
0x4c,0xff,0xff,0xfe,0x00,0x00,0x00,0x00,0xee,0xff,0xff,0x60,0x00,0x00,0x00,0x00,0x00,0x00,
0x5b,0xff,0xff,0xed,0x00,0x00,0x00,0x00,0xd8,0xff,0xff,0x82,0x00,0x00,0x00,0x00,0x00,0x00,
0x80,0xff,0xff,0xd7,0x00,0x00,0x00,0x00,0xa7,0xff,0xff,0xd5,0x00,0x00,0x00,0x00,0x00,0x00,
0xce,0xff,0xff,0xa5,0x00,0x00,0x00,0x00,0x5c,0xff,0xff,0xff,0x55,0x00,0x00,0x00,0x00,0x63,
0xff,0xff,0xff,0x58,0x00,0x00,0x00,0x00,0x09,0xe0,0xff,0xff,0xfa,0x87,0x3e,0x3d,0x90,0xfe,
0xff,0xff,0xdc,0x07,0x00,0x00,0x00,0x00,0x00,0x4b,0xfd,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xfc,0x47,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x52,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,
0xf6,0x4f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x22,0x93,0xd9,0xf8,0xf8,0xd8,0x91,
0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,
0xed,0xff,0xff,0xde,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x93,0xff,0xff,0xff,0x19,0x00,0xa8,
0xff,0xff,0xff,0x23,0x00,0x00,0x00,0x00,0x00,0x00,0xda,0xff,0xff,0xd2,0x00,0x00,0x60,0xff,
0xff,0xff,0x69,0x00,0x00,0x00,0x00,0x00,0x20,0xff,0xff,0xff,0x8b,0x00,0x00,0x19,0xff,0xff,
0xff,0xae,0x00,0x00,0x00,0x00,0x00,0x66,0xff,0xff,0xff,0x45,0x00,0x00,0x00,0xd0,0xff,0xff,
0xef,0x03,0x00,0x00,0x00,0x00,0xac,0xff,0xff,0xf6,0x08,0x00,0x00,0x00,0x88,0xff,0xff,0xff,
0x39,0x00,0x00,0x00,0x03,0xef,0xff,0xff,0xb8,0x00,0x00,0x00,0x00,0x40,0xff,0xff,0xff,0x7e,
0x00,0x00,0x00,0x39,0xff,0xff,0xff,0x72,0x00,0x00,0x00,0x00,0x05,0xf2,0xff,0xff,0xc3,0x00,
0x00,0x00,0x7f,0xff,0xff,0xff,0x2b,0x00,0x00,0x00,0x00,0x00,0xb0,0xff,0xff,0xfb,0x0d,0x00,
0x00,0xc5,0xff,0xff,0xe4,0x00,0x00,0x00,0x00,0x00,0x00,0x68,0xff,0xff,0xff,0x4e,0x00,0x0f,
0xfb,0xff,0xff,0x9f,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0xff,0xff,0xff,0x93,0x00,0x51,0xff,
0xff,0xff,0x58,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xd8,0xff,0xff,0xd9,0x00,0x98,0xff,0xff,
0xfd,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x90,0xff,0xff,0xff,0x1e,0xdd,0xff,0xff,0xcb,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x48,0xff,0xff,0xff,0x88,0xff,0xff,0xff,0x85,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x09,0xf7,0xff,0xff,0xf7,0xff,0xff,0xff,0x3f,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xb8,0xff,0xff,0xff,0xff,0xff,0xf2,0x05,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x70,0xff,0xff,0xff,0xff,0xff,0xb2,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x28,0xff,0xff,0xff,0xff,0xff,0x6b,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xdf,0xff,0xff,0xff,0xff,0x25,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x98,0xff,0xff,0xff,0xdf,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf3,0xff,0xff,0x9c,0x00,0x00,0x00,0x7b,0xff,0xff,
0xff,0xd7,0x00,0x00,0x00,0x40,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xcc,0xff,0xff,0xbc,0x00,
0x00,0x00,0xaa,0xff,0xff,0xff,0xfc,0x08,0x00,0x00,0x61,0xff,0xff,0xff,0x24,0x00,0x00,0x00,
0xa4,0xff,0xff,0xdd,0x00,0x00,0x00,0xd9,0xff,0xff,0xff,0xff,0x34,0x00,0x00,0x82,0xff,0xff,
0xf8,0x03,0x00,0x00,0x00,0x7c,0xff,0xff,0xfb,0x03,0x00,0x0a,0xfd,0xff,0xff,0xff,0xff,0x63,
0x00,0x00,0xa2,0xff,0xff,0xd4,0x00,0x00,0x00,0x00,0x53,0xff,0xff,0xff,0x1f,0x00,0x37,0xff,
0xff,0xff,0xff,0xff,0x91,0x00,0x00,0xc3,0xff,0xff,0xac,0x00,0x00,0x00,0x00,0x2b,0xff,0xff,
0xff,0x40,0x00,0x66,0xff,0xff,0xff,0xff,0xff,0xc0,0x00,0x00,0xe4,0xff,0xff,0x84,0x00,0x00,
0x00,0x00,0x06,0xfc,0xff,0xff,0x61,0x00,0x95,0xff,0xff,0xed,0xff,0xff,0xee,0x00,0x06,0xfd,
0xff,0xff,0x5c,0x00,0x00,0x00,0x00,0x00,0xdb,0xff,0xff,0x81,0x00,0xc4,0xff,0xff,0x9b,0xff,
0xff,0xff,0x1d,0x25,0xff,0xff,0xff,0x34,0x00,0x00,0x00,0x00,0x00,0xb3,0xff,0xff,0xa2,0x01,
0xf2,0xff,0xff,0x4e,0xf4,0xff,0xff,0x4c,0x46,0xff,0xff,0xff,0x0c,0x00,0x00,0x00,0x00,0x00,
0x8a,0xff,0xff,0xc3,0x22,0xff,0xff,0xff,0x21,0xc9,0xff,0xff,0x7b,0x66,0xff,0xff,0xe4,0x00,
0x00,0x00,0x00,0x00,0x00,0x62,0xff,0xff,0xe4,0x51,0xff,0xff,0xf3,0x01,0x9d,0xff,0xff,0xa9,
0x87,0xff,0xff,0xbc,0x00,0x00,0x00,0x00,0x00,0x00,0x3a,0xff,0xff,0xfe,0x87,0xff,0xff,0xc9,
0x00,0x71,0xff,0xff,0xd8,0xa8,0xff,0xff,0x94,0x00,0x00,0x00,0x00,0x00,0x00,0x12,0xff,0xff,
0xff,0xd5,0xff,0xff,0x9d,0x00,0x44,0xff,0xff,0xfd,0xd2,0xff,0xff,0x6c,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xea,0xff,0xff,0xff,0xff,0xff,0x71,0x00,0x18,0xff,0xff,0xff,0xff,0xff,0xff,
0x44,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xc1,0xff,0xff,0xff,0xff,0xff,0x45,0x00,0x00,0xeb,
0xff,0xff,0xff,0xff,0xff,0x1c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x99,0xff,0xff,0xff,0xff,
0xff,0x19,0x00,0x00,0xc0,0xff,0xff,0xff,0xff,0xf3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x71,0xff,0xff,0xff,0xff,0xec,0x00,0x00,0x00,0x93,0xff,0xff,0xff,0xff,0xcc,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x49,0xff,0xff,0xff,0xff,0xc1,0x00,0x00,0x00,0x67,0xff,0xff,0xff,
0xff,0xa4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x21,0xff,0xff,0xff,0xff,0x95,0x00,0x00,
0x00,0x3b,0xff,0xff,0xff,0xff,0x7c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0xf6,0xff,
0xff,0xff,0x69,0x00,0x00,0x00,0x0f,0xff,0xff,0xff,0xff,0x54,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0xcf,0xff,0xff,0xff,0x9e,0x00,0x00,0x00,
0x00,0x00,0x29,0xfd,0xff,0xff,0xff,0x4e,0x00,0x3f,0xff,0xff,0xff,0xfc,0x25,0x00,0x00,0x00,
0x00,0xab,0xff,0xff,0xff,0xb9,0x00,0x00,0x00,0xac,0xff,0xff,0xff,0xa6,0x00,0x00,0x00,0x30,
0xfe,0xff,0xff,0xfb,0x2a,0x00,0x00,0x00,0x21,0xf7,0xff,0xff,0xfd,0x2c,0x00,0x00,0xb3,0xff,
0xff,0xff,0x93,0x00,0x00,0x00,0x00,0x00,0x85,0xff,0xff,0xff,0xaf,0x00,0x38,0xff,0xff,0xff,
0xed,0x12,0x00,0x00,0x00,0x00,0x00,0x0c,0xe6,0xff,0xff,0xff,0x33,0xbc,0xff,0xff,0xff,0x6b,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5f,0xff,0xff,0xff,0xda,0xff,0xff,0xff,0xd4,0x03,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xca,0xff,0xff,0xff,0xff,0xff,0xff,0x44,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x39,0xff,0xff,0xff,0xff,0xff,0xb0,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xa5,0xff,0xff,0xff,0xf9,0x24,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xaf,0xff,0xff,0xff,0xfb,0x2a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x42,0xff,0xff,0xff,0xff,0xff,0xb9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x03,0xd2,0xff,0xff,0xff,0xff,0xff,0xff,0x4e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x69,0xff,0xff,0xff,0xd1,0xff,0xff,0xff,0xdb,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0xeb,
0xff,0xff,0xfe,0x2d,0xb3,0xff,0xff,0xff,0x76,0x00,0x00,0x00,0x00,0x00,0x00,0x90,0xff,0xff,
0xff,0xa6,0x00,0x30,0xfe,0xff,0xff,0xf2,0x17,0x00,0x00,0x00,0x00,0x28,0xfb,0xff,0xff,0xfc,
0x25,0x00,0x00,0xa9,0xff,0xff,0xff,0x9e,0x00,0x00,0x00,0x00,0xb7,0xff,0xff,0xff,0x9e,0x00,
0x00,0x00,0x28,0xfc,0xff,0xff,0xfe,0x33,0x00,0x00,0x4b,0xff,0xff,0xff,0xf9,0x20,0x00,0x00,
0x00,0x00,0x9f,0xff,0xff,0xff,0xc4,0x00,0x05,0xd8,0xff,0xff,0xff,0x96,0x00,0x00,0x00,0x00,
0x00,0x20,0xfa,0xff,0xff,0xff,0x5a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xcc,0xff,0xff,0xff,0xa0,0x00,
0x00,0x00,0x00,0x00,0x5c,0xff,0xff,0xff,0xf6,0x1f,0x00,0x3b,0xff,0xff,0xff,0xfc,0x24,0x00,
0x00,0x00,0x02,0xd8,0xff,0xff,0xff,0x82,0x00,0x00,0x00,0xa5,0xff,0xff,0xff,0xa0,0x00,0x00,
0x00,0x5b,0xff,0xff,0xff,0xe3,0x0a,0x00,0x00,0x00,0x1c,0xf5,0xff,0xff,0xfc,0x24,0x00,0x02,
0xd7,0xff,0xff,0xff,0x5a,0x00,0x00,0x00,0x00,0x00,0x7d,0xff,0xff,0xff,0xa0,0x00,0x59,0xff,
0xff,0xff,0xc5,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0xdf,0xff,0xff,0xfc,0x26,0xd6,0xff,0xff,
0xfe,0x34,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x54,0xff,0xff,0xff,0xdc,0xff,0xff,0xff,0x9e,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xbf,0xff,0xff,0xff,0xff,0xff,0xf2,0x17,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2e,0xfc,0xff,0xff,0xff,0xff,0x76,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x97,0xff,0xff,0xff,0xdb,0x06,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x13,0xff,0xff,0xff,0x5f,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x45,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xa6,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf0,0x17,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0xc9,0xff,0xff,0xff,0x6a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x4b,0xff,0xff,0xff,0xc9,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x0a,0xdf,0xff,0xff,0xfc,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x88,0xff,0xff,0xff,0x8f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x2c,0xfa,0xff,0xff,0xe4,0x0d,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xc3,0xff,0xff,0xff,0x53,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0xff,0xff,0xff,0xb4,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x14,0xec,0xff,0xff,0xf5,0x20,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xa0,0xff,0xff,0xff,0x78,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3e,0xff,0xff,0xff,0xd4,0x05,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05,0xd5,0xff,0xff,0xfe,0x3c,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7a,0xff,0xff,0xff,0x9d,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x21,0xf6,0xff,0xff,0xeb,0x13,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xb6,0xff,0xff,0xff,0x8b,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x18,0x00,0x00,0x00,0x55,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x80,0x00,0x00,0x0d,0xe5,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x80,0x00,0x00,0x91,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,
0x30,0x30,0x30,0x30,0x18,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x80,0x00,0x00,0x00,
0xff,0xff,0xff,0xff,0xff,0xff,0x80,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x80,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x6d,0x30,0x30,0x18,0x00,0x00,0x00,
0xff,0xff,0xff,0xff,0xff,0xff,0x80,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x80,0x00,
0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x52,0xff,0xff,0xff,0x87,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05,
0xe8,0xff,0xff,0xe8,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x89,0xff,0xff,0xff,0x55,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x25,0xff,0xff,0xff,0xbc,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xc1,0xff,0xff,0xfe,0x25,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5c,
0xff,0xff,0xff,0x8b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0xef,0xff,0xff,0xeb,0x06,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x93,0xff,0xff,0xff,0x59,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x2f,0xff,0xff,0xff,0xc1,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xcb,
0xff,0xff,0xff,0x28,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x66,0xff,0xff,0xff,0x8f,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0d,0xf4,0xff,0xff,0xed,0x08,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x9e,0xff,0xff,0xff,0x5e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x39,0xff,
0xff,0xff,0xc5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xd4,0xff,0xff,0xff,0x2c,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x70,0xff,0xff,0xff,0x93,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x13,0xf8,0xff,0xff,0xf0,0x0a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xa8,0xff,
0xff,0xff,0x62,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x43,0xff,0xff,0xff,0xc9,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xdd,0xff,0xff,0xff,0x30,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x7a,0xff,0xff,0xff,0x98,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x30,0x0e,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0xff,0xff,0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x30,0x30,
0x30,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0xff,0xff,0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x22,0xec,0xff,0xff,0xd4,0x0d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0e,0xd5,0xff,0xff,0xff,
0xff,0xb3,0x02,0x00,0x00,0x00,0x00,0x00,0x03,0xb6,0xff,0xff,0xcb,0xe7,0xff,0xff,0x8a,0x00,
0x00,0x00,0x00,0x00,0x8f,0xff,0xff,0xeb,0x1d,0x38,0xf8,0xff,0xff,0x5f,0x00,0x00,0x00,0x17,
0x7f,0x80,0x80,0x3a,0x00,0x00,0x48,0x80,0x80,0x78,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x30,
0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00,0x00,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x0c,0x69,0x17,0x00,0x00,0x00,0x00,0xb5,0xff,0xde,0x28,0x00,0x00,0x00,0xef,0xff,0xff,
0xed,0x3d,0x00,0x00,0x41,0xe3,0xff,0xff,0xf8,0x57,0x00,0x00,0x10,0xa6,0xff,0xff,0xd6,0x00,
0x00,0x00,0x00,0x57,0xe4,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0d,0x6c,0xbd,0xee,0xf6,0xdb,
0xb2,0x57,0x02,0x00,0x00,0x00,0x00,0x05,0xdc,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xc5,0x16,
0x00,0x00,0x00,0x00,0x6b,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xcc,0x04,0x00,0x00,0x00,
0x00,0x60,0x4c,0x3a,0x35,0x54,0xac,0xff,0xff,0xff,0x60,0x00,0x00,0x00,0x00,0x47,0xbf,0xf3,
0xec,0xad,0x29,0xa4,0xff,0xff,0xb6,0x00,0x00,0x00,0x72,0xff,0xff,0xff,0xff,0xff,0xf1,0x86,
0xff,0xff,0xe8,0x00,0x00,0x39,0xfd,0xff,0xff,0xff,0xff,0xff,0xff,0xf3,0xff,0xff,0xfb,0x00,
0x00,0xac,0xff,0xff,0xff,0xa5,0x48,0x42,0x94,0xfe,0xff,0xff,0xff,0x00,0x00,0xe9,0xff,0xff,
0xa4,0x00,0x00,0x00,0x00,0x9b,0xff,0xff,0xff,0x00,0x00,0xfb,0xff,0xff,0x5a,0x00,0x00,0x00,
0x00,0x59,0xff,0xff,0xff,0x00,0x00,0xe8,0xff,0xff,0x9e,0x00,0x00,0x00,0x00,0x95,0xff,0xff,
0xff,0x00,0x00,0xaa,0xff,0xff,0xff,0x9f,0x46,0x40,0x90,0xfe,0xff,0xff,0xff,0x00,0x00,0x36,
0xfd,0xff,0xff,0xff,0xff,0xff,0xff,0xfa,0xff,0xff,0xff,0x00,0x00,0x00,0x6f,0xff,0xff,0xff,
0xff,0xff,0xf9,0x8c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x45,0xbd,0xf3,0xef,0xb8,0x38,0x4c,
0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x0a,0x81,0xde,0xf6,0xcf,0x5f,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x5c,0xce,0xff,0xff,
0xff,0xff,0xff,0x88,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xe7,0xff,0xff,0xff,0xff,0xff,0xff,
0xfe,0x36,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xd7,0x5a,0x44,0xa7,0xff,0xff,0xff,0xa4,0x00,
0x00,0x00,0xff,0xff,0xff,0xec,0x16,0x00,0x00,0x00,0xb5,0xff,0xff,0xee,0x02,0x00,0x00,0xff,
0xff,0xff,0x91,0x00,0x00,0x00,0x00,0x47,0xff,0xff,0xff,0x21,0x00,0x00,0xff,0xff,0xff,0x5d,
0x00,0x00,0x00,0x00,0x12,0xff,0xff,0xff,0x3e,0x00,0x00,0xff,0xff,0xff,0x4f,0x00,0x00,0x00,
0x00,0x04,0xff,0xff,0xff,0x48,0x00,0x00,0xff,0xff,0xff,0x5d,0x00,0x00,0x00,0x00,0x16,0xff,
0xff,0xff,0x3f,0x00,0x00,0xff,0xff,0xff,0x90,0x00,0x00,0x00,0x00,0x52,0xff,0xff,0xff,0x24,
0x00,0x00,0xff,0xff,0xff,0xec,0x15,0x00,0x00,0x05,0xc6,0xff,0xff,0xf1,0x02,0x00,0x00,0xff,
0xff,0xff,0xff,0xdc,0x5a,0x3f,0xbd,0xff,0xff,0xff,0xa8,0x00,0x00,0x00,0xff,0xff,0xff,0xed,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x3a,0x00,0x00,0x00,0xff,0xff,0xff,0x60,0xd3,0xff,0xff,
0xff,0xff,0xff,0x8d,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x0b,0x83,0xde,0xf6,0xd1,0x64,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3a,0xa9,0xe6,0xf7,0xd9,0x88,0x18,0x00,
0x00,0x00,0x00,0x00,0x00,0x84,0xfe,0xff,0xff,0xff,0xff,0xff,0xeb,0x41,0x00,0x00,0x00,0x00,
0x73,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf4,0x25,0x00,0x00,0x1c,0xf9,0xff,0xff,0xeb,
0x65,0x38,0x73,0xf6,0xff,0xc8,0x36,0x00,0x00,0x83,0xff,0xff,0xfe,0x35,0x00,0x00,0x00,0x48,
0x4c,0x00,0x00,0x00,0x00,0xc7,0xff,0xff,0xae,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xed,0xff,0xff,0x6e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfb,0xff,0xff,
0x54,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xef,0xff,0xff,0x6d,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xcd,0xff,0xff,0xad,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x8c,0xff,0xff,0xfe,0x3c,0x00,0x00,0x00,0x4d,0x50,0x00,0x00,0x00,0x00,0x25,
0xfd,0xff,0xff,0xf1,0x74,0x36,0x56,0xeb,0xff,0xc7,0x31,0x00,0x00,0x00,0x83,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xf1,0x21,0x00,0x00,0x00,0x02,0x91,0xff,0xff,0xff,0xff,0xff,0xff,
0xf1,0x3f,0x00,0x00,0x00,0x00,0x00,0x00,0x3c,0xa6,0xe2,0xf8,0xe3,0x9f,0x21,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x36,0xb7,0xf0,0xeb,0xa5,0x23,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x45,0xf9,0xff,0xff,0xff,0xff,0xf0,0x3a,0xff,0xff,0xff,
0x4c,0x00,0x00,0x07,0xe5,0xff,0xff,0xff,0xff,0xff,0xff,0xe7,0xff,0xff,0xff,0x4c,0x00,0x00,
0x5a,0xff,0xff,0xff,0xd2,0x54,0x48,0xaf,0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0xa5,0xff,0xff,
0xea,0x13,0x00,0x00,0x01,0xb8,0xff,0xff,0xff,0x4c,0x00,0x00,0xd6,0xff,0xff,0x8f,0x00,0x00,
0x00,0x00,0x48,0xff,0xff,0xff,0x4c,0x00,0x00,0xf2,0xff,0xff,0x5d,0x00,0x00,0x00,0x00,0x13,
0xff,0xff,0xff,0x4c,0x00,0x00,0xfc,0xff,0xff,0x4f,0x00,0x00,0x00,0x00,0x04,0xff,0xff,0xff,
0x4c,0x00,0x00,0xf4,0xff,0xff,0x61,0x00,0x00,0x00,0x00,0x13,0xff,0xff,0xff,0x4c,0x00,0x00,
0xdb,0xff,0xff,0x9a,0x00,0x00,0x00,0x00,0x48,0xff,0xff,0xff,0x4c,0x00,0x00,0xac,0xff,0xff,
0xf4,0x1f,0x00,0x00,0x01,0xb7,0xff,0xff,0xff,0x4c,0x00,0x00,0x5f,0xff,0xff,0xff,0xdd,0x52,
0x47,0xb6,0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0x08,0xe8,0xff,0xff,0xff,0xff,0xff,0xff,0xed,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x4a,0xfa,0xff,0xff,0xff,0xff,0xf2,0x41,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0x00,0x3a,0xba,0xf1,0xec,0xa5,0x25,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x35,0xa7,0xe6,0xf7,0xd8,0x90,0x1d,0x00,0x00,0x00,0x00,0x00,
0x00,0x76,0xfd,0xff,0xff,0xff,0xff,0xff,0xf0,0x42,0x00,0x00,0x00,0x00,0x65,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xf6,0x22,0x00,0x00,0x17,0xf5,0xff,0xff,0xb3,0x4b,0x42,0x90,0xfd,
0xff,0xff,0xb2,0x00,0x00,0x7f,0xff,0xff,0xba,0x00,0x00,0x00,0x00,0x7c,0xff,0xff,0xfc,0x15,
0x00,0xc6,0xff,0xff,0x79,0x28,0x28,0x28,0x28,0x3c,0xff,0xff,0xff,0x54,0x00,0xee,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x6f,0x00,0xfb,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0x7f,0x00,0xea,0xff,0xff,0x5d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xbe,0xff,0xff,0x83,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x74,
0xff,0xff,0xde,0x0c,0x00,0x00,0x00,0x07,0x00,0x00,0x00,0x00,0x00,0x10,0xf1,0xff,0xff,0xd0,
0x52,0x3d,0x7f,0xf4,0xa5,0x37,0x00,0x00,0x00,0x00,0x5c,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0x45,0x00,0x00,0x00,0x00,0x6b,0xfa,0xff,0xff,0xff,0xff,0xff,0xfa,0x73,0x00,0x00,
0x00,0x00,0x00,0x00,0x2a,0x9d,0xe2,0xf8,0xdf,0x99,0x2b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x80,0xe3,0xf7,0xc6,
0x3d,0x00,0x00,0x00,0x00,0x05,0xc0,0xff,0xff,0xff,0xff,0xc0,0x00,0x00,0x00,0x00,0x80,0xff,
0xff,0xff,0xff,0xdf,0x16,0x00,0x00,0x00,0x00,0xe8,0xff,0xff,0x93,0x4d,0x2a,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x30,0x30,0xff,0xff,0xff,0x6d,0x30,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x36,0xb7,0xf0,0xeb,0xa6,0x26,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x45,
0xf9,0xff,0xff,0xff,0xff,0xf3,0x44,0xff,0xff,0xff,0x4c,0x00,0x00,0x07,0xe5,0xff,0xff,0xff,
0xff,0xff,0xff,0xee,0xff,0xff,0xff,0x4c,0x00,0x00,0x5a,0xff,0xff,0xff,0xd2,0x54,0x48,0xaf,
0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0xa5,0xff,0xff,0xea,0x13,0x00,0x00,0x01,0xb8,0xff,0xff,
0xff,0x4c,0x00,0x00,0xd6,0xff,0xff,0x8f,0x00,0x00,0x00,0x00,0x48,0xff,0xff,0xff,0x4c,0x00,
0x00,0xf2,0xff,0xff,0x5d,0x00,0x00,0x00,0x00,0x13,0xff,0xff,0xff,0x4c,0x00,0x00,0xfc,0xff,
0xff,0x4f,0x00,0x00,0x00,0x00,0x04,0xff,0xff,0xff,0x4c,0x00,0x00,0xf4,0xff,0xff,0x61,0x00,
0x00,0x00,0x00,0x13,0xff,0xff,0xff,0x4c,0x00,0x00,0xdb,0xff,0xff,0x9a,0x00,0x00,0x00,0x00,
0x48,0xff,0xff,0xff,0x4c,0x00,0x00,0xac,0xff,0xff,0xf4,0x1f,0x00,0x00,0x01,0xb7,0xff,0xff,
0xff,0x4c,0x00,0x00,0x5f,0xff,0xff,0xff,0xdd,0x52,0x47,0xb6,0xff,0xff,0xff,0xff,0x4c,0x00,
0x00,0x08,0xe8,0xff,0xff,0xff,0xff,0xff,0xff,0xe5,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x4a,
0xfa,0xff,0xff,0xff,0xff,0xee,0x38,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x3a,0xba,0xf1,
0xeb,0xa3,0x22,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x11,0x1c,0x1c,0x0d,0x00,0x00,0x00,0x00,
0x05,0xff,0xff,0xff,0x47,0x00,0x00,0x7d,0xff,0xff,0xb2,0x00,0x00,0x00,0x00,0x46,0xff,0xff,
0xff,0x2a,0x00,0x00,0x2f,0xfe,0xff,0xff,0xa0,0x45,0x3a,0x70,0xeb,0xff,0xff,0xde,0x00,0x00,
0x00,0x00,0xa5,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x5a,0x00,0x00,0x00,0x00,0x0a,
0xc3,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x82,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x6a,0xc5,
0xf2,0xf9,0xe1,0xa4,0x38,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x05,0x6f,0xd0,0xf5,0xdb,0x68,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x59,0xc5,0xff,0xff,0xff,0xff,0xff,0x88,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0xe0,0xff,0xff,0xff,0xff,0xff,0xff,0xfe,0x35,0x00,0x00,0x00,0xff,
0xff,0xff,0xff,0xbd,0x47,0x41,0x9a,0xff,0xff,0xff,0x9c,0x00,0x00,0x00,0xff,0xff,0xff,0xdb,
0x09,0x00,0x00,0x00,0xc8,0xff,0xff,0xdc,0x00,0x00,0x00,0xff,0xff,0xff,0x83,0x00,0x00,0x00,
0x00,0x7c,0xff,0xff,0xf7,0x00,0x00,0x00,0xff,0xff,0xff,0x5b,0x00,0x00,0x00,0x00,0x5a,0xff,
0xff,0xff,0x00,0x00,0x00,0xff,0xff,0xff,0x4e,0x00,0x00,0x00,0x00,0x4e,0xff,0xff,0xff,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,
0xff,0xff,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x10,0x6f,0x2e,0x00,0x00,0x00,0x00,0xba,0xff,0xf2,0x13,0x00,0x00,0x00,0xf6,0xff,
0xff,0x41,0x00,0x00,0x00,0xba,0xff,0xf2,0x14,0x00,0x00,0x00,0x11,0x6f,0x2e,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x10,0x6f,0x2e,0x00,0x00,0x00,0x00,0x00,0x00,0xba,0xff,0xf2,0x13,0x00,0x00,
0x00,0x00,0x00,0xf6,0xff,0xff,0x41,0x00,0x00,0x00,0x00,0x00,0xba,0xff,0xf2,0x14,0x00,0x00,
0x00,0x00,0x00,0x11,0x6f,0x2e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x47,0x00,0x00,
0x00,0x00,0x0b,0xff,0xff,0xff,0x28,0x00,0x05,0x87,0x40,0x9a,0xff,0xff,0xd9,0x00,0x02,0xa8,
0xff,0xff,0xff,0xff,0xff,0x59,0x00,0x74,0xff,0xff,0xff,0xff,0xff,0x8c,0x00,0x00,0x0e,0x9b,
0xea,0xf7,0xcb,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x5f,0xff,0xff,0xff,0xbf,0x03,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x29,0xf4,0xff,0xff,0xe4,0x16,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x09,0xd2,0xff,0xff,0xfa,0x39,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x9a,0xff,
0xff,0xff,0x6b,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xa3,0xff,0xff,0xff,0xa2,0x00,0x00,
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xd1,0x09,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0xff,0xff,0xff,0x29,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,
0xff,0xff,0x82,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xd9,0xff,0xff,0xfa,0x2f,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x53,0xd9,0xff,0xff,0xce,0x04,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x41,0xff,0xff,0xff,0x7c,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x9f,0xff,0xff,0xf9,0x2b,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x13,
0xeb,0xff,0xff,0xc9,0x03,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x5d,0xff,0xff,0xff,
0x76,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xbc,0xff,0xff,0xf7,0x27,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0xff,0xff,0xff,0x4e,0x00,0x00,0x00,0xf6,0xff,0xff,0xaa,0x1d,0x00,0x00,0xcf,0xff,0xff,0xff,
0x84,0x00,0x00,0x63,0xff,0xff,0xff,0x84,0x00,0x00,0x00,0x5c,0xc3,0xf0,0x82,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x1b,0xab,
0xf5,0xd5,0x50,0x00,0x00,0x16,0xaa,0xf4,0xd6,0x51,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,
0x66,0xe1,0xff,0xff,0xff,0xfb,0x33,0x15,0xdc,0xff,0xff,0xff,0xfc,0x3d,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0xed,0xff,0xff,0xff,0xff,0xff,0xa6,0xa7,0xff,0xff,0xff,0xff,0xff,0xc0,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0xfa,0x61,0x45,0xdd,0xff,0xff,0xf8,0xfa,0x64,0x46,0xdf,0xff,
0xff,0xfd,0x0f,0x00,0x00,0x00,0xff,0xff,0xff,0xa5,0x00,0x00,0x5e,0xff,0xff,0xff,0xaa,0x00,
0x00,0x62,0xff,0xff,0xff,0x36,0x00,0x00,0x00,0xff,0xff,0xff,0x6e,0x00,0x00,0x24,0xff,0xff,
0xff,0x6f,0x00,0x00,0x26,0xff,0xff,0xff,0x47,0x00,0x00,0x00,0xff,0xff,0xff,0x55,0x00,0x00,
0x0b,0xff,0xff,0xff,0x55,0x00,0x00,0x0b,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,
0x4d,0x00,0x00,0x01,0xff,0xff,0xff,0x4d,0x00,0x00,0x01,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x06,0x72,0xd1,0xf5,0xdb,0x68,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x5c,0xcb,0xff,0xff,0xff,0xff,0xff,0x88,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0xe7,0xff,0xff,0xff,0xff,0xff,0xff,0xfe,0x35,0x00,0x00,0x00,0xff,0xff,0xff,
0xff,0xbd,0x47,0x41,0x9a,0xff,0xff,0xff,0x9c,0x00,0x00,0x00,0xff,0xff,0xff,0xdb,0x09,0x00,
0x00,0x00,0xc8,0xff,0xff,0xdc,0x00,0x00,0x00,0xff,0xff,0xff,0x83,0x00,0x00,0x00,0x00,0x7c,
0xff,0xff,0xf7,0x00,0x00,0x00,0xff,0xff,0xff,0x5b,0x00,0x00,0x00,0x00,0x5a,0xff,0xff,0xff,
0x00,0x00,0x00,0xff,0xff,0xff,0x4e,0x00,0x00,0x00,0x00,0x4e,0xff,0xff,0xff,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,
0xff,0xff,0xff,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x05,0x6e,0xc7,0xf0,0xf7,0xda,0x91,0x1a,0x00,0x00,0x00,0x00,0x00,0x11,0xca,0xff,0xff,
0xff,0xff,0xff,0xff,0xf1,0x3b,0x00,0x00,0x00,0x00,0xb3,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xec,0x15,0x00,0x00,0x40,0xff,0xff,0xff,0xbd,0x48,0x3b,0x90,0xff,0xff,0xff,0x8c,0x00,
0x00,0x9b,0xff,0xff,0xdd,0x07,0x00,0x00,0x00,0x9b,0xff,0xff,0xe7,0x00,0x00,0xd4,0xff,0xff,
0x83,0x00,0x00,0x00,0x00,0x39,0xff,0xff,0xff,0x1f,0x00,0xf1,0xff,0xff,0x59,0x00,0x00,0x00,
0x00,0x0f,0xff,0xff,0xff,0x3c,0x00,0xfc,0xff,0xff,0x4e,0x00,0x00,0x00,0x00,0x03,0xff,0xff,
0xff,0x47,0x00,0xf1,0xff,0xff,0x5a,0x00,0x00,0x00,0x00,0x0f,0xff,0xff,0xff,0x3b,0x00,0xd4,
0xff,0xff,0x84,0x00,0x00,0x00,0x00,0x3a,0xff,0xff,0xff,0x1e,0x00,0x9c,0xff,0xff,0xde,0x08,
0x00,0x00,0x00,0x9c,0xff,0xff,0xe5,0x00,0x00,0x41,0xff,0xff,0xff,0xbd,0x47,0x3a,0x8f,0xff,
0xff,0xff,0x89,0x00,0x00,0x00,0xb6,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xeb,0x13,0x00,
0x00,0x00,0x13,0xcd,0xff,0xff,0xff,0xff,0xff,0xff,0xf0,0x39,0x00,0x00,0x00,0x00,0x00,0x06,
0x71,0xc9,0xf1,0xf7,0xdb,0x91,0x1a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x0b,0x84,0xde,0xf6,0xcf,0x5f,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0x61,0xd6,0xff,0xff,0xff,0xff,0xff,0x88,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xee,
0xff,0xff,0xff,0xff,0xff,0xff,0xfe,0x36,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xd7,0x5a,0x44,
0xa7,0xff,0xff,0xff,0xa4,0x00,0x00,0x00,0xff,0xff,0xff,0xec,0x16,0x00,0x00,0x00,0xb5,0xff,
0xff,0xee,0x02,0x00,0x00,0xff,0xff,0xff,0x91,0x00,0x00,0x00,0x00,0x47,0xff,0xff,0xff,0x21,
0x00,0x00,0xff,0xff,0xff,0x5d,0x00,0x00,0x00,0x00,0x12,0xff,0xff,0xff,0x3e,0x00,0x00,0xff,
0xff,0xff,0x4f,0x00,0x00,0x00,0x00,0x04,0xff,0xff,0xff,0x48,0x00,0x00,0xff,0xff,0xff,0x5d,
0x00,0x00,0x00,0x00,0x16,0xff,0xff,0xff,0x3f,0x00,0x00,0xff,0xff,0xff,0x90,0x00,0x00,0x00,
0x00,0x52,0xff,0xff,0xff,0x24,0x00,0x00,0xff,0xff,0xff,0xec,0x15,0x00,0x00,0x05,0xc6,0xff,
0xff,0xf1,0x02,0x00,0x00,0xff,0xff,0xff,0xff,0xdc,0x5a,0x3f,0xbd,0xff,0xff,0xff,0xa8,0x00,
0x00,0x00,0xff,0xff,0xff,0xe5,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x3a,0x00,0x00,0x00,0xff,
0xff,0xff,0x5b,0xcc,0xff,0xff,0xff,0xff,0xff,0x8d,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x09,0x80,0xde,0xf6,0xd1,0x64,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x36,0xb7,0xf0,0xeb,0xa6,0x26,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,
0x45,0xf9,0xff,0xff,0xff,0xff,0xf3,0x44,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x07,0xe5,0xff,
0xff,0xff,0xff,0xff,0xff,0xee,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x5a,0xff,0xff,0xff,0xd2,
0x54,0x48,0xaf,0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xa5,0xff,0xff,0xea,0x13,0x00,0x00,
0x01,0xb8,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xd6,0xff,0xff,0x8f,0x00,0x00,0x00,0x00,0x48,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xf2,0xff,0xff,0x5d,0x00,0x00,0x00,0x00,0x13,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0xfc,0xff,0xff,0x4f,0x00,0x00,0x00,0x00,0x04,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0xf4,0xff,0xff,0x61,0x00,0x00,0x00,0x00,0x13,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0xdb,0xff,0xff,0x9a,0x00,0x00,0x00,0x00,0x48,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xac,
0xff,0xff,0xf4,0x1f,0x00,0x00,0x01,0xb7,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x5f,0xff,0xff,
0xff,0xdd,0x52,0x47,0xb6,0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x08,0xe8,0xff,0xff,0xff,
0xff,0xff,0xff,0xe5,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4a,0xfa,0xff,0xff,0xff,0xff,
0xee,0x38,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x3a,0xba,0xf1,0xeb,0xa3,0x22,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xee,0xff,0xff,0xa1,0x38,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xb3,0xff,0xff,0xff,0xff,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x31,0xf5,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x28,0x9f,0xdf,0xf9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x1a,0xaa,
0xf4,0xd9,0x6a,0x03,0x00,0x00,0xff,0xff,0xff,0x65,0xe0,0xff,0xff,0xff,0xf8,0x16,0x00,0x00,
0xff,0xff,0xff,0xea,0xff,0xff,0xff,0xff,0xa1,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xbe,0x43,
0x56,0xc5,0x34,0x00,0x00,0x00,0xff,0xff,0xff,0xe7,0x0a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x94,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x61,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x20,0x99,0xdd,0xf9,0xf2,0xbf,0x4c,0x00,0x00,0x00,0x00,0x00,0x31,0xf0,0xff,0xff,0xff,
0xff,0xff,0xff,0x81,0x00,0x00,0x00,0x00,0xbf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x46,
0x00,0x00,0x00,0xf7,0xff,0xff,0xb0,0x3b,0x49,0xd8,0xff,0xff,0xb4,0x00,0x00,0x00,0xf5,0xff,
0xff,0x5f,0x00,0x00,0x41,0x7c,0x50,0x21,0x00,0x00,0x00,0xbb,0xff,0xff,0xec,0x68,0x0d,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x36,0xf5,0xff,0xff,0xff,0xf3,0x94,0x1e,0x00,0x00,0x00,0x00,
0x00,0x00,0x32,0xca,0xff,0xff,0xff,0xff,0xf5,0x64,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,
0xc2,0xff,0xff,0xff,0xfe,0x4e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0xdc,0xff,0xff,
0xc3,0x00,0x00,0x36,0x83,0xae,0x85,0x00,0x00,0x00,0x5f,0xff,0xff,0xef,0x00,0x00,0x4e,0xff,
0xff,0xfe,0x85,0x39,0x43,0xbe,0xff,0xff,0xf1,0x00,0x00,0x04,0xd8,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xa2,0x00,0x00,0x00,0x26,0xed,0xff,0xff,0xff,0xff,0xff,0xff,0xcc,0x13,0x00,
0x00,0x00,0x00,0x1c,0x95,0xdf,0xfb,0xf2,0xc5,0x6b,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,
0x80,0x80,0x26,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0x00,0x00,0x30,0x30,0xff,0xff,0xff,0x6d,0x30,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0xff,
0xff,0xff,0x4f,0x00,0x00,0x00,0x00,0x00,0xf6,0xff,0xff,0xb1,0x35,0x00,0x00,0x00,0x00,0xce,
0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x60,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,
0x5a,0xc5,0xf0,0xfe,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,
0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0xfd,0xff,0xff,0x4c,0x00,0x00,0x00,
0x00,0x4f,0xff,0xff,0xff,0x00,0x00,0xf5,0xff,0xff,0x57,0x00,0x00,0x00,0x00,0x65,0xff,0xff,
0xff,0x00,0x00,0xdf,0xff,0xff,0x79,0x00,0x00,0x00,0x00,0x84,0xff,0xff,0xff,0x00,0x00,0xb8,
0xff,0xff,0xc2,0x00,0x00,0x00,0x02,0xd5,0xff,0xff,0xff,0x00,0x00,0x79,0xff,0xff,0xff,0x70,
0x00,0x09,0x99,0xff,0xff,0xff,0xff,0x00,0x00,0x1d,0xfa,0xff,0xff,0xff,0xed,0xf6,0xff,0xf9,
0xff,0xff,0xff,0x00,0x00,0x00,0x7f,0xff,0xff,0xff,0xff,0xff,0xe2,0x70,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x6e,0xdd,0xf7,0xd9,0x84,0x10,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xe5,0xff,0xff,0xa3,0x00,0x00,0x00,
0x00,0xb2,0xff,0xff,0x8d,0x00,0x00,0x9a,0xff,0xff,0xe2,0x00,0x00,0x00,0x04,0xf1,0xff,0xff,
0x41,0x00,0x00,0x4e,0xff,0xff,0xff,0x22,0x00,0x00,0x3a,0xff,0xff,0xf0,0x04,0x00,0x00,0x0a,
0xf7,0xff,0xff,0x61,0x00,0x00,0x7e,0xff,0xff,0xa8,0x00,0x00,0x00,0x00,0xb5,0xff,0xff,0xa0,
0x00,0x00,0xc2,0xff,0xff,0x5c,0x00,0x00,0x00,0x00,0x69,0xff,0xff,0xe0,0x00,0x0b,0xfa,0xff,
0xfc,0x13,0x00,0x00,0x00,0x00,0x1d,0xff,0xff,0xff,0x1f,0x4a,0xff,0xff,0xc4,0x00,0x00,0x00,
0x00,0x00,0x00,0xd0,0xff,0xff,0x5e,0x8e,0xff,0xff,0x77,0x00,0x00,0x00,0x00,0x00,0x00,0x84,
0xff,0xff,0x9e,0xd2,0xff,0xff,0x2b,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0xff,0xff,0xe9,0xfe,
0xff,0xde,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0xe9,0xff,0xff,0xff,0xff,0x93,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x9f,0xff,0xff,0xff,0xff,0x46,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x53,0xff,0xff,0xff,0xf3,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0d,0xf9,
0xff,0xff,0xae,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xba,0xff,0xff,0x62,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x1d,0xff,0xff,0xff,0x3a,0x00,0x00,0x0d,0xfe,0xff,0xff,0x2f,
0x00,0x00,0x10,0xfd,0xff,0xff,0x20,0x00,0xd6,0xff,0xff,0x76,0x00,0x00,0x3b,0xff,0xff,0xff,
0x5e,0x00,0x00,0x4d,0xff,0xff,0xd9,0x00,0x00,0x8f,0xff,0xff,0xb3,0x00,0x00,0x6a,0xff,0xff,
0xff,0x8d,0x00,0x00,0x8b,0xff,0xff,0x92,0x00,0x00,0x48,0xff,0xff,0xee,0x01,0x00,0x99,0xff,
0xff,0xff,0xbc,0x00,0x00,0xc9,0xff,0xff,0x4b,0x00,0x00,0x09,0xf7,0xff,0xff,0x2c,0x00,0xc8,
0xff,0xff,0xff,0xeb,0x00,0x0b,0xfb,0xff,0xf9,0x0b,0x00,0x00,0x00,0xba,0xff,0xff,0x69,0x02,
0xf5,0xff,0xfc,0xff,0xff,0x1b,0x45,0xff,0xff,0xbd,0x00,0x00,0x00,0x00,0x73,0xff,0xff,0xa6,
0x26,0xff,0xff,0xb1,0xff,0xff,0x4a,0x82,0xff,0xff,0x76,0x00,0x00,0x00,0x00,0x2c,0xff,0xff,
0xe2,0x55,0xff,0xff,0x4c,0xff,0xff,0x79,0xc0,0xff,0xff,0x2f,0x00,0x00,0x00,0x00,0x00,0xe4,
0xff,0xff,0xa4,0xff,0xdc,0x0c,0xfe,0xff,0xaf,0xf7,0xff,0xe7,0x01,0x00,0x00,0x00,0x00,0x00,
0x9e,0xff,0xff,0xf9,0xff,0xa8,0x00,0xd9,0xff,0xfa,0xff,0xff,0xa1,0x00,0x00,0x00,0x00,0x00,
0x00,0x57,0xff,0xff,0xff,0xff,0x74,0x00,0xa7,0xff,0xff,0xff,0xff,0x5a,0x00,0x00,0x00,0x00,
0x00,0x00,0x13,0xfd,0xff,0xff,0xff,0x40,0x00,0x76,0xff,0xff,0xff,0xfe,0x15,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xc9,0xff,0xff,0xfe,0x0e,0x00,0x44,0xff,0xff,0xff,0xcc,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x82,0xff,0xff,0xd9,0x00,0x00,0x13,0xff,0xff,0xff,0x85,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x3b,0xff,0xff,0xa5,0x00,0x00,0x00,0xe1,0xff,0xff,0x3f,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x25,0xfa,
0xff,0xff,0xb1,0x00,0x00,0x00,0x05,0xdb,0xff,0xff,0xfe,0x3a,0x00,0x8e,0xff,0xff,0xff,0x3b,
0x00,0x00,0x6a,0xff,0xff,0xff,0x9a,0x00,0x00,0x10,0xec,0xff,0xff,0xc5,0x00,0x0b,0xe7,0xff,
0xff,0xe9,0x11,0x00,0x00,0x00,0x6b,0xff,0xff,0xff,0x51,0x7c,0xff,0xff,0xff,0x5d,0x00,0x00,
0x00,0x00,0x03,0xd5,0xff,0xff,0xdb,0xf1,0xff,0xff,0xbe,0x00,0x00,0x00,0x00,0x00,0x00,0x47,
0xff,0xff,0xff,0xff,0xff,0xf9,0x27,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xb6,0xff,0xff,0xff,
0xff,0x82,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x49,0xff,0xff,0xff,0xff,0x20,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xbd,0xff,0xff,0xff,0xff,0xa1,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x57,0xff,0xff,0xff,0xff,0xff,0xfe,0x38,0x00,0x00,0x00,0x00,0x00,0x0c,0xe4,0xff,0xff,
0xd1,0xee,0xff,0xff,0xcb,0x02,0x00,0x00,0x00,0x00,0x8b,0xff,0xff,0xff,0x45,0x76,0xff,0xff,
0xff,0x64,0x00,0x00,0x00,0x29,0xfa,0xff,0xff,0xbd,0x00,0x09,0xe4,0xff,0xff,0xea,0x10,0x00,
0x00,0xbd,0xff,0xff,0xff,0x35,0x00,0x00,0x65,0xff,0xff,0xff,0x91,0x00,0x57,0xff,0xff,0xff,
0xac,0x00,0x00,0x00,0x03,0xd8,0xff,0xff,0xfb,0x2c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,
0xff,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,
0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0xfd,0xff,0xff,
0x4e,0x00,0x00,0x00,0x00,0x4f,0xff,0xff,0xff,0x00,0x00,0xf5,0xff,0xff,0x5c,0x00,0x00,0x00,
0x00,0x61,0xff,0xff,0xff,0x00,0x00,0xdf,0xff,0xff,0x87,0x00,0x00,0x00,0x00,0x93,0xff,0xff,
0xff,0x00,0x00,0xb8,0xff,0xff,0xde,0x09,0x00,0x00,0x18,0xec,0xff,0xff,0xff,0x00,0x00,0x79,
0xff,0xff,0xff,0xb9,0x42,0x53,0xd5,0xff,0xff,0xff,0xff,0x00,0x00,0x1d,0xfa,0xff,0xff,0xff,
0xff,0xff,0xff,0xde,0xff,0xff,0xff,0x00,0x00,0x00,0x7f,0xff,0xff,0xff,0xff,0xff,0xc3,0x58,
0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x6e,0xdd,0xf6,0xd3,0x72,0x05,0x4c,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x54,0xff,0xff,0xf1,0x00,0x00,0x00,0x0e,0x8d,
0x3c,0x00,0x00,0x00,0x00,0x9d,0xff,0xff,0xba,0x00,0x00,0x42,0xe7,0xff,0xf0,0x76,0x3c,0x45,
0x9c,0xff,0xff,0xff,0x4b,0x00,0x00,0x1d,0xf1,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xa0,
0x00,0x00,0x00,0x00,0x38,0xe9,0xff,0xff,0xff,0xff,0xff,0xff,0x9d,0x05,0x00,0x00,0x00,0x00,
0x00,0x13,0x7d,0xcf,0xf0,0xf0,0xb6,0x46,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x2f,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xb3,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x38,
0x00,0x00,0x00,0x00,0x30,0x30,0x30,0x30,0x58,0xff,0xff,0xff,0xbd,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xa1,0xff,0xff,0xff,0x42,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1f,
0xfb,0xff,0xff,0xc7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x95,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0xf7,0xff,0xff,0xd0,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x8a,0xff,0xff,0xff,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x11,
0xf2,0xff,0xff,0xd9,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7e,0xff,0xff,0xff,0x60,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0b,0xed,0xff,0xff,0xef,0x35,0x30,0x30,0x30,0x30,
0x00,0x00,0x00,0x00,0x73,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x07,
0xe5,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x67,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x7b,0xda,0xf7,0xfe,0x00,0x00,0x00,
0x00,0x85,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xd9,0xff,0xff,0xff,0xff,0x00,0x00,0x00,
0x00,0xef,0xff,0xff,0xd1,0x44,0x00,0x00,0x00,0x00,0xf8,0xff,0xff,0x60,0x00,0x00,0x00,0x00,
0x03,0xff,0xff,0xff,0x4a,0x00,0x00,0x00,0x00,0x14,0xff,0xff,0xff,0x42,0x00,0x00,0x00,0x00,
0x27,0xff,0xff,0xff,0x2e,0x00,0x00,0x00,0x00,0x50,0xff,0xff,0xfd,0x0c,0x00,0x00,0x00,0x00,
0xa0,0xff,0xff,0xcb,0x00,0x00,0x00,0x00,0x35,0xf9,0xff,0xff,0x5b,0x00,0x00,0x00,0x1b,0xe2,
0xff,0xff,0xb4,0x00,0x00,0x00,0x00,0x00,0x33,0xf9,0xff,0xff,0x5c,0x00,0x00,0x00,0x00,0x00,
0x9f,0xff,0xff,0xcc,0x00,0x00,0x00,0x00,0x00,0x50,0xff,0xff,0xfe,0x0c,0x00,0x00,0x00,0x00,
0x27,0xff,0xff,0xff,0x2e,0x00,0x00,0x00,0x00,0x14,0xff,0xff,0xff,0x42,0x00,0x00,0x00,0x00,
0x03,0xff,0xff,0xff,0x4a,0x00,0x00,0x00,0x00,0x00,0xf8,0xff,0xff,0x60,0x00,0x00,0x00,0x00,
0x00,0xef,0xff,0xff,0xcf,0x43,0x00,0x00,0x00,0x00,0xda,0xff,0xff,0xff,0xff,0x00,0x00,0x00,
0x00,0x88,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x03,0x7f,0xde,0xf8,0xfe,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xfe,0xf7,0xe3,0x92,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xc5,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0x1f,0x00,0x00,0x00,
0x00,0x00,0x3f,0xad,0xff,0xff,0xff,0x37,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0xff,0xff,0xff,
0x42,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfe,0xff,0xff,0x4d,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xf7,0xff,0xff,0x5f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xe4,0xff,0xff,0x72,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xbf,0xff,0xff,0x9d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xff,
0xff,0xe8,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x1d,0xf3,0xff,0xff,0x7e,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x69,0xff,0xff,0xfd,0x51,0x00,0x00,0x00,0x00,0x00,0x1d,0xf4,0xff,0xff,0x7c,
0x00,0x00,0x00,0x00,0x00,0x00,0x81,0xff,0xff,0xe7,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0xbf,
0xff,0xff,0x9c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xe4,0xff,0xff,0x72,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xf7,0xff,0xff,0x5f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfe,0xff,0xff,0x4d,
0x00,0x00,0x00,0x00,0x00,0x00,0x18,0xff,0xff,0xff,0x42,0x00,0x00,0x00,0x00,0x00,0x3e,0xaa,
0xff,0xff,0xff,0x37,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0x20,0x00,0x00,0x00,
0x00,0x00,0xff,0xff,0xff,0xff,0xca,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xfd,0xe7,0x9e,0x17,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x09,0x1b,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x4b,0xeb,0xff,0x9a,0x04,0x00,0x00,0x2d,0x00,0x00,0xfc,0xff,0xff,
0xff,0xbf,0x45,0x69,0xee,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xd0,
0x36,0x17,0xb2,0xff,0xff,0xff,0xf8,0x00,0x00,0x0b,0x00,0x00,0x02,0x7d,0xf0,0xce,0x39,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x88,0xd0,0xef,0xf8,0xdd,
0x9e,0x39,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x75,0xf8,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xa1,0x06,0x00,0x00,0x00,0x00,0x00,0x81,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xb1,0x05,0x00,0x00,0x00,0x3f,0xfe,0xff,0xff,0xe7,0x74,0x3c,0x44,0x95,0xfc,0xff,0xff,
0xff,0x93,0x00,0x00,0x00,0xcc,0xff,0xff,0xda,0x16,0x00,0x00,0x00,0x00,0x4a,0xfc,0xff,0xff,
0xfe,0x2b,0x00,0x39,0xff,0xff,0xff,0x3f,0x00,0x00,0x00,0x00,0x00,0x00,0x89,0xff,0xff,0xff,
0x90,0x00,0x8a,0xff,0xff,0xd6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1c,0xd4,0xd4,0xd4,0xaa,
0x00,0xc4,0xff,0xff,0x91,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xe8,0xff,0xff,0x64,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfa,
0xff,0xff,0x54,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfa,0xff,
0xff,0x53,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xe9,0xff,0xff,
0x64,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xc6,0xff,0xff,0x8f,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x8c,0xff,0xff,0xd4,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x1e,0xc8,0xc8,0xc8,0x9e,0x00,0x3b,0xff,0xff,0xff,0x4a,0x00,
0x00,0x00,0x00,0x00,0x00,0x89,0xff,0xff,0xff,0x90,0x00,0x00,0xce,0xff,0xff,0xda,0x15,0x00,
0x00,0x00,0x00,0x45,0xfc,0xff,0xff,0xfe,0x2c,0x00,0x00,0x40,0xfe,0xff,0xff,0xe6,0x73,0x3b,
0x3e,0x88,0xf8,0xff,0xff,0xff,0x9a,0x00,0x00,0x00,0x00,0x81,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xb8,0x08,0x00,0x00,0x00,0x00,0x00,0x76,0xf8,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xa6,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x89,0xd1,0xf0,0xf9,0xde,0xa0,
0x3c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x67,0xb4,0x0f,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x98,0xff,0xff,0x9a,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4b,0xff,0xff,0xf0,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0f,0xb4,0xff,0xff,0xd0,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xbc,0xff,0xff,0xe8,0x32,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x1d,0xdd,0x93,0x12,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x49,0xe3,0xe3,0x47,0x00,0x00,0x49,0xe3,0xe3,0x47,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xe4,0xff,0xff,0xe3,0x00,0x00,0xe4,0xff,0xff,0xe3,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xe3,0xff,0xff,0xe3,0x00,0x00,0xe4,0xff,0xff,0xe3,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x47,0xe3,0xe4,0x49,0x00,0x00,0x49,0xe3,0xe4,0x49,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x29,0x90,0xd6,0xf3,0xf4,0xd7,0x92,0x2b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x01,0x82,0xfb,0xff,0xff,0xff,0xff,0xff,0xff,0xfc,0x86,0x01,0x00,0x00,0x00,0x00,0x00,
0x00,0x8c,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x8f,0x00,0x00,0x00,0x00,0x00,
0x44,0xff,0xff,0xff,0xea,0x77,0x3d,0x40,0x79,0xe9,0xff,0xff,0xff,0x47,0x00,0x00,0x00,0x00,
0xcd,0xff,0xff,0xdc,0x19,0x00,0x00,0x00,0x00,0x1b,0xdc,0xff,0xff,0xd0,0x00,0x00,0x00,0x37,
0xff,0xff,0xff,0x43,0x00,0x00,0x00,0x00,0x00,0x00,0x43,0xff,0xff,0xff,0x3c,0x00,0x00,0x89,
0xff,0xff,0xd9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xd5,0xff,0xff,0x8b,0x00,0x00,0xc4,
0xff,0xff,0x95,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x91,0xff,0xff,0xc4,0x00,0x00,0xe8,
0xff,0xff,0x67,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x71,0xff,0xff,0xe8,0x00,0x00,0xfa,
0xff,0xff,0x55,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x59,0xff,0xff,0xf9,0x00,0x00,0xfa,
0xff,0xff,0x54,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x54,0xff,0xff,0xfa,0x00,0x00,0xe9,
0xff,0xff,0x67,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x67,0xff,0xff,0xe9,0x00,0x00,0xc6,
0xff,0xff,0x93,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x93,0xff,0xff,0xc6,0x00,0x00,0x8b,
0xff,0xff,0xd8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xd6,0xff,0xff,0x8d,0x00,0x00,0x39,
0xff,0xff,0xff,0x4e,0x00,0x00,0x00,0x00,0x00,0x00,0x4d,0xff,0xff,0xff,0x3e,0x00,0x00,0x00,
0xcf,0xff,0xff,0xdc,0x17,0x00,0x00,0x00,0x00,0x16,0xdc,0xff,0xff,0xd2,0x00,0x00,0x00,0x00,
0x45,0xff,0xff,0xff,0xe8,0x75,0x3c,0x3c,0x74,0xe7,0xff,0xff,0xff,0x48,0x00,0x00,0x00,0x00,
0x00,0x8c,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x90,0x00,0x00,0x00,0x00,0x00,
0x00,0x01,0x82,0xfb,0xff,0xff,0xff,0xff,0xff,0xff,0xfc,0x86,0x01,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x29,0x91,0xd7,0xf4,0xf4,0xd8,0x93,0x2b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x49,0xe3,0xe3,0x47,0x00,0x00,0x49,0xe3,0xe3,0x47,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xe4,0xff,0xff,0xe2,0x00,0x00,0xe4,0xff,0xff,0xe2,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xe4,0xff,0xff,0xe4,0x00,0x00,0xe3,0xff,0xff,0xe4,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x49,0xe3,0xe4,0x4a,0x00,0x00,0x47,0xe3,0xe4,0x4a,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
0xfe,0xff,0xff,0x4d,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xfe,0x00,0x00,0x00,0x00,
0xee,0xff,0xff,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x5b,0xff,0xff,0xed,0x00,0x00,0x00,0x00,
0xd8,0xff,0xff,0x82,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xff,0xff,0xd7,0x00,0x00,0x00,0x00,
0xa7,0xff,0xff,0xd5,0x00,0x00,0x00,0x00,0x00,0x00,0xce,0xff,0xff,0xa5,0x00,0x00,0x00,0x00,
0x5c,0xff,0xff,0xff,0x55,0x00,0x00,0x00,0x00,0x63,0xff,0xff,0xff,0x58,0x00,0x00,0x00,0x00,
0x09,0xe0,0xff,0xff,0xfa,0x87,0x3e,0x3d,0x90,0xfe,0xff,0xff,0xdc,0x07,0x00,0x00,0x00,0x00,
0x00,0x4b,0xfd,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfc,0x47,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x52,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xf6,0x4f,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x22,0x93,0xd9,0xf8,0xf8,0xd8,0x91,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3d,0xab,0xe7,0xf7,
0xd6,0x82,0x13,0x00,0x00,0x00,0x00,0x00,0x88,0xff,0xff,0xff,0xff,0xff,0xff,0xe5,0x35,0x00,
0x00,0x00,0x76,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xec,0x19,0x00,0x1d,0xf9,0xff,0xff,
0xe9,0x62,0x39,0x7b,0xfa,0xff,0xbf,0x2b,0x00,0x84,0xff,0xff,0xfd,0x31,0x00,0x00,0x00,0x52,
0x42,0x00,0x00,0x00,0xc7,0xff,0xff,0xad,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xed,
0xff,0xff,0x6e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfb,0xff,0xff,0x54,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xef,0xff,0xff,0x6d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xce,0xff,0xff,0xad,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x8e,0xff,0xff,
0xfe,0x3b,0x00,0x00,0x00,0x54,0x48,0x00,0x00,0x00,0x27,0xfd,0xff,0xff,0xf0,0x72,0x36,0x5a,
0xf0,0xff,0xbe,0x27,0x00,0x00,0x87,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe8,0x16,0x00,
0x00,0x02,0x96,0xff,0xff,0xff,0xff,0xff,0xff,0xea,0x32,0x00,0x00,0x00,0x00,0x00,0x3f,0xa8,
0xe4,0xf9,0xe0,0x97,0x1a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x17,0x9f,0x86,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xbf,0xff,0xfe,0x2e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x76,0xff,0xff,0x73,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x25,0xd7,0xff,0xff,
0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0xd5,0xff,0xff,0x9a,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x28,0xcf,0x58,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4b,0xe4,0xe4,0x49,0x00,0x00,0x4b,0xe4,0xe4,0x49,0x00,
0x00,0x00,0x00,0x00,0xe5,0xff,0xff,0xe4,0x00,0x00,0xe5,0xff,0xff,0xe4,0x00,0x00,0x00,0x00,
0x00,0xe3,0xff,0xff,0xe3,0x00,0x00,0xe4,0xff,0xff,0xe3,0x00,0x00,0x00,0x00,0x00,0x47,0xe3,
0xe4,0x49,0x00,0x00,0x49,0xe4,0xe4,0x49,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05,0x6e,0xc7,0xf0,0xf7,0xda,0x91,
0x1a,0x00,0x00,0x00,0x00,0x00,0x00,0x11,0xca,0xff,0xff,0xff,0xff,0xff,0xff,0xf1,0x3b,0x00,
0x00,0x00,0x00,0x00,0xb3,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xec,0x15,0x00,0x00,0x00,
0x40,0xff,0xff,0xff,0xbd,0x48,0x3b,0x90,0xff,0xff,0xff,0x8c,0x00,0x00,0x00,0x9b,0xff,0xff,
0xdd,0x07,0x00,0x00,0x00,0x9b,0xff,0xff,0xe7,0x00,0x00,0x00,0xd4,0xff,0xff,0x83,0x00,0x00,
0x00,0x00,0x39,0xff,0xff,0xff,0x1f,0x00,0x00,0xf1,0xff,0xff,0x59,0x00,0x00,0x00,0x00,0x0f,
0xff,0xff,0xff,0x3c,0x00,0x00,0xfc,0xff,0xff,0x4e,0x00,0x00,0x00,0x00,0x03,0xff,0xff,0xff,
0x47,0x00,0x00,0xf1,0xff,0xff,0x5a,0x00,0x00,0x00,0x00,0x0f,0xff,0xff,0xff,0x3b,0x00,0x00,
0xd4,0xff,0xff,0x84,0x00,0x00,0x00,0x00,0x3a,0xff,0xff,0xff,0x1e,0x00,0x00,0x9c,0xff,0xff,
0xde,0x08,0x00,0x00,0x00,0x9c,0xff,0xff,0xe5,0x00,0x00,0x00,0x41,0xff,0xff,0xff,0xbd,0x47,
0x3a,0x8f,0xff,0xff,0xff,0x89,0x00,0x00,0x00,0x00,0xb6,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xeb,0x13,0x00,0x00,0x00,0x00,0x13,0xcd,0xff,0xff,0xff,0xff,0xff,0xff,0xf0,0x39,0x00,
0x00,0x00,0x00,0x00,0x00,0x06,0x71,0xc9,0xf1,0xf7,0xdb,0x91,0x1a,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x49,0xe3,0xe3,0x47,0x00,0x00,0x49,0xe3,0xe3,0x47,0x00,0x00,
0x00,0x00,0xe4,0xff,0xff,0xe2,0x00,0x00,0xe4,0xff,0xff,0xe2,0x00,0x00,0x00,0x00,0xe3,0xff,
0xff,0xe4,0x00,0x00,0xe4,0xff,0xff,0xe4,0x00,0x00,0x00,0x00,0x47,0xe3,0xe4,0x4a,0x00,0x00,
0x49,0xe3,0xe4,0x4a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,
0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0xfd,0xff,0xff,0x4c,0x00,0x00,0x00,
0x00,0x4f,0xff,0xff,0xff,0x00,0x00,0xf5,0xff,0xff,0x57,0x00,0x00,0x00,0x00,0x65,0xff,0xff,
0xff,0x00,0x00,0xdf,0xff,0xff,0x79,0x00,0x00,0x00,0x00,0x84,0xff,0xff,0xff,0x00,0x00,0xb8,
0xff,0xff,0xc2,0x00,0x00,0x00,0x02,0xd5,0xff,0xff,0xff,0x00,0x00,0x79,0xff,0xff,0xff,0x70,
0x00,0x09,0x99,0xff,0xff,0xff,0xff,0x00,0x00,0x1d,0xfa,0xff,0xff,0xff,0xed,0xf6,0xff,0xf9,
0xff,0xff,0xff,0x00,0x00,0x00,0x7f,0xff,0xff,0xff,0xff,0xff,0xe2,0x70,0xff,0xff,0xff,0x00,
0x00,0x00,0x00,0x6e,0xdd,0xf7,0xd9,0x84,0x10,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xfa,0xf6,0x12,0x00,0x00,0x00,0x7a,0xff,0xf9,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xdb,0xff,0x87,0x00,0x00,0x17,0xf1,0xff,
0xda,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x9b,0xff,0xfc,0x6a,0x39,0xbe,0xff,
0xff,0x9b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x32,0xfe,0xff,0xff,0xff,0xff,
0xff,0xfe,0x32,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x81,0xff,0xff,0xff,
0xff,0xff,0x81,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x56,0xce,
0xf6,0xce,0x56,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x09,0x49,
0x6c,0x7a,0x63,0x27,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x8d,0xf5,
0xff,0xff,0xff,0xff,0xff,0xbe,0x25,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x22,0xdb,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xed,0x3e,0x00,0x00,0x00,0x00,0x00,0x00,0x0d,0xd7,0xff,
0xff,0xff,0xff,0xd5,0xbe,0xf7,0xff,0xff,0xff,0xe9,0x11,0x00,0x00,0x00,0x00,0x00,0x8b,0xff,
0xff,0xff,0xf1,0x4b,0x00,0x00,0x1d,0xc6,0xff,0xff,0xd5,0x44,0x00,0x00,0x00,0x00,0x13,0xf7,
0xff,0xff,0xff,0x4e,0x00,0x00,0x00,0x00,0x15,0x7d,0x29,0x00,0x00,0x00,0x00,0x00,0x00,0x6c,
0xff,0xff,0xff,0xc6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xb1,0xff,0xff,0xff,0x6b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xdd,0xff,0xff,0xff,0x2f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0xf6,0xff,0xff,0xff,0x0c,0x00,0x00,0x00,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,
0x00,0x00,0x00,0xfd,0xff,0xff,0xff,0x03,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0x00,0x00,0x00,0xf3,0xff,0xff,0xff,0x0f,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0x00,0x00,0x00,0xda,0xff,0xff,0xff,0x30,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xee,0x00,0x00,0x00,0xb1,0xff,0xff,0xff,0x66,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xd2,0xff,0xff,0xd7,0x00,0x00,0x00,0x72,0xff,0xff,0xff,0xb4,0x00,0x00,0x00,0x00,0x00,0x00,
0x03,0xf0,0xff,0xff,0xb8,0x00,0x00,0x00,0x1c,0xfd,0xff,0xff,0xfc,0x27,0x00,0x00,0x00,0x00,
0x00,0x42,0xff,0xff,0xff,0x77,0x00,0x00,0x00,0x00,0xa9,0xff,0xff,0xff,0xc7,0x0b,0x00,0x00,
0x00,0x07,0xca,0xff,0xff,0xfc,0x1c,0x00,0x00,0x00,0x00,0x23,0xf5,0xff,0xff,0xff,0xd3,0x5b,
0x37,0x5b,0xcd,0xff,0xff,0xff,0x98,0x00,0x00,0x00,0x00,0x00,0x00,0x5a,0xfe,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xda,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x54,0xee,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xca,0x1c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x12,
0x7a,0xc8,0xec,0xfa,0xe6,0xb2,0x59,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf9,0xf5,0x11,0x00,0x00,0x00,0x6f,0xff,0xf9,0x00,0x00,
0x00,0x00,0x00,0x00,0xdb,0xff,0x88,0x00,0x00,0x13,0xec,0xff,0xda,0x00,0x00,0x00,0x00,0x00,
0x00,0x9b,0xff,0xfc,0x6c,0x38,0xbb,0xff,0xff,0x9b,0x00,0x00,0x00,0x00,0x00,0x00,0x32,0xfe,
0xff,0xff,0xff,0xff,0xff,0xfe,0x32,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x81,0xff,0xff,0xff,
0xff,0xff,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x54,0xcd,0xf6,0xce,0x54,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x36,0xb7,0xf0,0xeb,0xa6,0x26,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x45,0xf9,0xff,0xff,0xff,0xff,0xf3,0x44,0xff,0xff,0xff,0x4c,0x00,0x00,0x07,0xe5,0xff,
0xff,0xff,0xff,0xff,0xff,0xee,0xff,0xff,0xff,0x4c,0x00,0x00,0x5a,0xff,0xff,0xff,0xd2,0x54,
0x48,0xaf,0xff,0xff,0xff,0xff,0x4c,0x00,0x00,0xa5,0xff,0xff,0xea,0x13,0x00,0x00,0x01,0xb8,
0xff,0xff,0xff,0x4c,0x00,0x00,0xd6,0xff,0xff,0x8f,0x00,0x00,0x00,0x00,0x48,0xff,0xff,0xff,
0x4c,0x00,0x00,0xf2,0xff,0xff,0x5d,0x00,0x00,0x00,0x00,0x13,0xff,0xff,0xff,0x4c,0x00,0x00,
0xfc,0xff,0xff,0x4f,0x00,0x00,0x00,0x00,0x04,0xff,0xff,0xff,0x4c,0x00,0x00,0xf4,0xff,0xff,
0x61,0x00,0x00,0x00,0x00,0x13,0xff,0xff,0xff,0x4c,0x00,0x00,0xdb,0xff,0xff,0x9a,0x00,0x00,
0x00,0x00,0x48,0xff,0xff,0xff,0x4c,0x00,0x00,0xac,0xff,0xff,0xf4,0x1f,0x00,0x00,0x01,0xb7,
0xff,0xff,0xff,0x4c,0x00,0x00,0x5f,0xff,0xff,0xff,0xdd,0x52,0x47,0xb6,0xff,0xff,0xff,0xff,
0x4c,0x00,0x00,0x08,0xe8,0xff,0xff,0xff,0xff,0xff,0xff,0xe5,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0x4a,0xfa,0xff,0xff,0xff,0xff,0xee,0x38,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x3a,
0xba,0xf1,0xeb,0xa3,0x22,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x0b,0x1c,0x1c,0x0d,0x00,0x00,
0x00,0x00,0x05,0xff,0xff,0xff,0x47,0x00,0x00,0x4f,0xff,0xff,0xb2,0x00,0x00,0x00,0x00,0x46,
0xff,0xff,0xff,0x2a,0x00,0x00,0x10,0xf1,0xff,0xff,0xa0,0x45,0x3a,0x70,0xeb,0xff,0xff,0xde,
0x00,0x00,0x00,0x00,0x79,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x5c,0x00,0x00,0x00,
0x00,0x01,0xa3,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x87,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x58,0xbd,0xef,0xfa,0xe4,0xa8,0x3d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x49,0xe3,0xe3,
0x47,0x00,0x00,0xe4,0xff,0xff,0xe3,0x00,0x00,0xe3,0xff,0xff,0xe3,0x00,0x00,0x47,0xe3,0xe4,
0x49,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,0xff,0xff,
0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,
0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,
0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,
0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,
0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,
0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x4c,0xff,0xff,
0xff,0x00,0x00,0x4c,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,
0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,
0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,
0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,
0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,
0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0xff,0xff,0xff,0x4c,0x00,0x00,0x00,
0xff,0xff,0xff,0x4c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x15,0x7b,0xc6,0xef,0xfa,0xe6,0xad,0x46,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x4e,0xf0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xaa,0x0a,0x00,0x00,
0x00,0x00,0x2e,0xfa,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xb4,0x00,0x00,0x00,0x00,
0xaa,0xff,0xff,0xfc,0x8e,0x46,0x37,0x5d,0xd4,0xff,0xff,0xff,0x52,0x00,0x00,0x00,0xea,0xff,
0xff,0x84,0x00,0x00,0x00,0x00,0x11,0x9d,0x72,0x41,0x0e,0x00,0x00,0x00,0xf9,0xff,0xff,0x5a,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xda,0xff,0xff,0xd2,0x1a,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7d,0xff,0xff,0xff,0xf2,0x8d,0x24,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05,0xb0,0xff,0xff,0xff,0xff,0xff,0xc3,0x60,0x05,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x72,0xed,0xff,0xff,0xff,0xff,0xff,0xdc,0x47,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0c,0x69,0xd0,0xff,0xff,0xff,0xff,0xfe,0x71,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0xa1,0xfc,0xff,0xff,0xfe,0x40,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x35,0xf3,0xff,0xff,0xb1,0x00,0x00,0x00,0x00,0x12,
0x24,0x00,0x00,0x00,0x00,0x00,0x00,0x77,0xff,0xff,0xe4,0x00,0x00,0x75,0xe5,0xff,0xe4,0x04,
0x00,0x00,0x00,0x00,0x00,0x5a,0xff,0xff,0xf8,0x00,0x00,0x61,0xff,0xff,0xff,0x8a,0x00,0x00,
0x00,0x00,0x00,0xaf,0xff,0xff,0xdb,0x00,0x00,0x0a,0xe7,0xff,0xff,0xff,0xb2,0x53,0x38,0x53,
0xb5,0xff,0xff,0xff,0x8d,0x00,0x00,0x00,0x48,0xfb,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xe4,0x13,0x00,0x00,0x00,0x00,0x4a,0xea,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xd3,0x25,
0x00,0x00,0x00,0x00,0x00,0x00,0x12,0x78,0xed,0xff,0xff,0xff,0xb8,0x62,0x06,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x1d,0xfc,0xff,0xff,0x2c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x0f,0xf4,0xff,0xff,0x51,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x38,0xd8,0xff,0xff,0xdc,0x0c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2e,
0xf1,0xff,0xb5,0x1b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3e,0x40,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x20,0x99,0xdd,0xf9,0xf2,0xbf,0x4c,0x00,0x00,0x00,0x00,0x00,0x31,0xf0,0xff,0xff,0xff,
0xff,0xff,0xff,0x81,0x00,0x00,0x00,0x00,0xbf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x46,
0x00,0x00,0x00,0xf7,0xff,0xff,0xb0,0x3b,0x49,0xd8,0xff,0xff,0xb4,0x00,0x00,0x00,0xf5,0xff,
0xff,0x5f,0x00,0x00,0x41,0x7c,0x50,0x21,0x00,0x00,0x00,0xbb,0xff,0xff,0xec,0x68,0x0d,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x36,0xf5,0xff,0xff,0xff,0xf3,0x94,0x1e,0x00,0x00,0x00,0x00,
0x00,0x00,0x32,0xca,0xff,0xff,0xff,0xff,0xf5,0x64,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x4c,
0xc2,0xff,0xff,0xff,0xfe,0x4e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0xdc,0xff,0xff,
0xc3,0x00,0x00,0x36,0x83,0xae,0x85,0x00,0x00,0x00,0x5f,0xff,0xff,0xef,0x00,0x00,0x4e,0xff,
0xff,0xfe,0x85,0x39,0x43,0xbe,0xff,0xff,0xf1,0x00,0x00,0x04,0xd8,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xa2,0x00,0x00,0x00,0x26,0xed,0xff,0xff,0xff,0xff,0xff,0xff,0xcc,0x13,0x00,
0x00,0x00,0x00,0x1c,0x95,0xff,0xff,0xff,0xe2,0x6b,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x67,0xff,0xff,0x86,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x59,0xff,0xff,0xa1,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x68,0xf4,0xff,0xff,0x47,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x64,0xff,0xef,0x57,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x59,0x15,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  };
  static const struct {
    uint32_t ds;
    uint16_t width;
  } glinfo[]= {

{0,8}, {272,6}, {476,12}, {884,21}, 
{1598,14}, {2074,19}, {2720,17}, {3298,7}, 
{3536,9}, {3842,9}, {4148,15}, {4658,12}, 
{5066,6}, {5270,12}, {5678,6}, {5882,13}, 
{6324,16}, {6868,16}, {7412,16}, {7956,16}, 
{8500,16}, {9044,16}, {9588,16}, {10132,16}, 
{10676,16}, {11220,16}, {11764,6}, {11968,6}, 
{12172,11}, {12546,13}, {12988,11}, {13362,14}, 
{13838,23}, {14620,19}, {15266,17}, {15844,18}, 
{16456,17}, {17034,17}, {17612,16}, {18156,19}, 
{18802,17}, {19380,7}, {19618,16}, {20162,18}, 
{20774,16}, {21318,23}, {22100,18}, {22712,18}, 
{23324,16}, {23868,18}, {24480,17}, {25058,16}, 
{25602,18}, {26214,18}, {26826,17}, {27404,23}, 
{28186,17}, {28764,17}, {29342,19}, {29988,10}, 
{30328,13}, {30770,10}, {31110,14}, {31586,16}, 
{32130,7}, {32368,14}, {32844,15}, {33354,14}, 
{33830,15}, {34340,14}, {34816,11}, {35190,15}, 
{35700,15}, {36210,7}, {36448,9}, {36754,14}, 
{37230,7}, {37468,21}, {38182,15}, {38692,14}, 
{39168,15}, {39678,16}, {40222,12}, {40630,13}, 
{41072,9}, {41378,14}, {41854,14}, {42330,19}, 
{42976,14}, {43452,14}, {43928,14}, {44404,9}, 
{44710,7}, {44948,11}, {45322,10}, {45662,17}, 
{46240,18}, {46852,18}, {47464,13}, {47906,15}, 
{48416,14}, {48892,19}, {49538,15}, {50048,6}, 
{50252,7}, {50490,16}, {51034,13}, 
  };
  // static const int nmap= sizeof(glmap)/sizeof(glmap[0]);
  int i,j,k,e,x,y,sX,eX;
  int W, X, *Xpos;
  char buf[20];
  int *map, *gl;
  int ngl;
  unsigned int C;
  int glyph_width;
  const unsigned char *glyph_data;
  unsigned char *data;

  map= alloca(L*sizeof(int));

  e= 0;
  ngl= 0;
  for(i=0;i<L;i++)
  {
    C= str[i];
    
    if (C&(1<<31)) { ngl+=2; e= 1; continue; }
    map[i]= font_hash(C);
    if (map[i]!=107) { ngl++; continue; }
    sprintf(buf,"%x",C); ngl+= strlen(buf); e= 1;
  }

  if (e) goto fix_encoding_errors;
  else gl= map;

encoding_errors_fixed:

  W= 0;
  for(i=0;i<ngl;i++) W+= glinfo[gl[i]].width;

  if (Rdata) data= malloc(W*34);
  X= 0;
  if (e && Rdata) Xpos= alloca(sizeof(int)*(ngl+1));
  for(i=0;i<ngl;i++)
  {
    if (e && Rdata) Xpos[i]= X;
    glyph_width= glinfo[gl[i]].width;
    if (Rdata) {
      glyph_data= font_data + glinfo[gl[i]].ds;
      for(y=0;y<34;y++)
         for(x=0;x<glyph_width;x++)
            data[y*W+X+x]= glyph_data[y*glyph_width+x];
    }
    X+= glyph_width;
  }
  if (e && Rdata) Xpos[i]= X;
  if (RW) *RW= W;
  if (RA) *RA= 27;
  if (RH) *RH= 34;
  if (Rdata) *Rdata= data;

  if (!e || !Rdata) return ;

  j= 0;
  for(i=0;i<L;i++)
  {
    if (str[i]&(1<<31))
    {
      sX= Xpos[j]; eX= Xpos[j+2];
      for(x=sX;x<eX;x++)
        for(y=0;y<34;y++)
          data[y*W + x] ^= 0xff;
      j+= 2;
      continue;
    }
    if (map[i]==107)
    {
      sprintf(buf,"%x",str[i]);
      sX= Xpos[j]; eX= Xpos[j+strlen(buf)];
      for(x=sX;x<eX;x++) {
        data[ 0*W + x]= 0xff;
        data[ (34-1)*W + x]= 0xff;
      }
      for(y=0;y<34;y++)
      {
        data[y*W+sX] = 0xff;
        data[y*W+eX-1] = 0xff;
      }
      j+= strlen(buf);
      continue;
    }
    j++;
  }
  return ;


fix_encoding_errors:
  j= 0;
  gl= alloca(sizeof(int)*ngl);
  for(i=0;i<L;i++)
  {
    if (str[i]&(1<<31))
    {
      sprintf(buf,"%02x", str[i]&0xff);
      for(k=0;buf[k];k++)
         gl[j++]= font_hash(buf[k]);
      continue;
    }
    if (map[i]==107)
    {
      sprintf(buf,"%x", str[i]);
      for(k=0;buf[k];k++)
         gl[j++]= font_hash(buf[k]);
      continue;
    }
    gl[j++]= map[i];
  }
  goto encoding_errors_fixed;
}

#line 24 "/home/dodo/tmp/gfx-1.2/src/event.u"

static click_handler_t *click_handlers;
static int n_click_handler, s_click_handler;
static click_handler_t release_handler;
static click_handler_t motion_handler;

#line 136 "/home/dodo/tmp/gfx-1.2/src/event.u"

static click_handler_t grabber;

#line 36 "/home/dodo/tmp/gfx-1.2/src/widget.u"

static gui_widget_t **gui_widgets;
static int n_gui_widget, s_gui_widget;

#line 25 "/home/dodo/tmp/gfx-1.2/src/button.u"

static uint32_t button_border_s= 0xaaaaa3, button_border,
                button_light_s=  0xffffff, button_light,
                button_dark_s=   0xd5d5d1, button_dark,
                button_grad1_s=  0xfcfcfb, button_grad1,
                button_grad2_s=  0xdbdbd7, button_grad2,
                button_grad3_s=  0xcccac9, button_grad3,
                button_grad4_s=  0xe9e8e7, button_grad4,
                button_fg_s=     0,        button_fg; 

#line 15 "/home/dodo/tmp/gfx-1.2/src/label.u"

static int n_labels, s_labels;
static gui_label_t *labels;


#line 17 "/home/dodo/tmp/gfx-1.2/src/recsel.u"

static int recsel;
static gfx_point_t recselpt[4];


#line 26 "/home/dodo/tmp/gfx-1.2/src/keyboard.u"
static XIM xim;
static int xim_tried;
static XIMStyle xim_style;

#line 207 "/home/dodo/tmp/gfx-1.2/src/keyboard.u"
/*
 * http://www.unicode.org/mail-arch/unicode-ml/Archives-Old/UML015/0422.html
 *
 * This module converts X Window System keysym values into the
 * corresponding ISO 10646-1 (UCS, Unicode) values.
 *
 * The array keysymtab[] contains pairs of X11 keysym values for graphical
 * characters and the corresponding Unicode value. The function
 * keysym2ucs() maps a keysym onto a Unicode value using a binary search,
 * therefore keysymtab[] must remain SORTED by keysym value.
 *
 * The keysym -> UTF-8 conversion will hopefully one day be provided
 * by Xlib via XmbLookupString() and should ideally not have to be
 * done in X applications. But we are not there yet.
 *
 * NOTE: The comments in the table below contain the actual character
 * encoded in UTF-8, so for viewing and editing best use an editor in
 * UTF-8 mode.
 *
 * Author: Markus G. Kuhn <mkuhn@acm.org>, University of Cambridge, June 1999
 *
 * Special thanks to Richard Verhoeven <river@win.tue.nl> for preparing
 * an initial draft of the mapping table. Suggestions for improvement welcome!
 *
 * This software is in the public domain. Share and enjoy!
 */
/** BEGIN KEYSYMTAB **/

static const struct codepair {
  unsigned short keysym;
  unsigned short ucs;
} keysymtab[] = {
  { 0x01a1, 0x0104 }, /* Aogonek Ą LATIN CAPITAL LETTER A WITH OGONEK */
  { 0x01a2, 0x02d8 }, /* breve ˘ BREVE */
  { 0x01a3, 0x0141 }, /* Lstroke Ł LATIN CAPITAL LETTER L WITH STROKE */
  { 0x01a5, 0x013d }, /* Lcaron Ľ LATIN CAPITAL LETTER L WITH CARON */
  { 0x01a6, 0x015a }, /* Sacute Ś LATIN CAPITAL LETTER S WITH ACUTE */
  { 0x01a9, 0x0160 }, /* Scaron Š LATIN CAPITAL LETTER S WITH CARON */
  { 0x01aa, 0x015e }, /* Scedilla Ş LATIN CAPITAL LETTER S WITH CEDILLA */
  { 0x01ab, 0x0164 }, /* Tcaron Ť LATIN CAPITAL LETTER T WITH CARON */
  { 0x01ac, 0x0179 }, /* Zacute Ź LATIN CAPITAL LETTER Z WITH ACUTE */
  { 0x01ae, 0x017d }, /* Zcaron Ž LATIN CAPITAL LETTER Z WITH CARON */
  { 0x01af, 0x017b }, /* Zabovedot Ż LATIN CAPITAL LETTER Z WITH DOT ABOVE */
  { 0x01b1, 0x0105 }, /* aogonek ą LATIN SMALL LETTER A WITH OGONEK */
  { 0x01b2, 0x02db }, /* ogonek ˛ OGONEK */
  { 0x01b3, 0x0142 }, /* lstroke ł LATIN SMALL LETTER L WITH STROKE */
  { 0x01b5, 0x013e }, /* lcaron ľ LATIN SMALL LETTER L WITH CARON */
  { 0x01b6, 0x015b }, /* sacute ś LATIN SMALL LETTER S WITH ACUTE */
  { 0x01b7, 0x02c7 }, /* caron ˇ CARON */
  { 0x01b9, 0x0161 }, /* scaron š LATIN SMALL LETTER S WITH CARON */
  { 0x01ba, 0x015f }, /* scedilla ş LATIN SMALL LETTER S WITH CEDILLA */
  { 0x01bb, 0x0165 }, /* tcaron ť LATIN SMALL LETTER T WITH CARON */
  { 0x01bc, 0x017a }, /* zacute ź LATIN SMALL LETTER Z WITH ACUTE */
  { 0x01bd, 0x02dd }, /* doubleacute ˝ DOUBLE ACUTE ACCENT */
  { 0x01be, 0x017e }, /* zcaron ž LATIN SMALL LETTER Z WITH CARON */
  { 0x01bf, 0x017c }, /* zabovedot ż LATIN SMALL LETTER Z WITH DOT ABOVE */
  { 0x01c0, 0x0154 }, /* Racute Ŕ LATIN CAPITAL LETTER R WITH ACUTE */
  { 0x01c3, 0x0102 }, /* Abreve Ă LATIN CAPITAL LETTER A WITH BREVE */
  { 0x01c5, 0x0139 }, /* Lacute Ĺ LATIN CAPITAL LETTER L WITH ACUTE */
  { 0x01c6, 0x0106 }, /* Cacute Ć LATIN CAPITAL LETTER C WITH ACUTE */
  { 0x01c8, 0x010c }, /* Ccaron Č LATIN CAPITAL LETTER C WITH CARON */
  { 0x01ca, 0x0118 }, /* Eogonek Ę LATIN CAPITAL LETTER E WITH OGONEK */
  { 0x01cc, 0x011a }, /* Ecaron Ě LATIN CAPITAL LETTER E WITH CARON */
  { 0x01cf, 0x010e }, /* Dcaron Ď LATIN CAPITAL LETTER D WITH CARON */
  { 0x01d0, 0x0110 }, /* Dstroke Đ LATIN CAPITAL LETTER D WITH STROKE */
  { 0x01d1, 0x0143 }, /* Nacute Ń LATIN CAPITAL LETTER N WITH ACUTE */
  { 0x01d2, 0x0147 }, /* Ncaron Ň LATIN CAPITAL LETTER N WITH CARON */
  { 0x01d5, 0x0150 }, /* Odoubleacute Ő LATIN CAPITAL LETTER O WITH DOUBLE ACUTE */
  { 0x01d8, 0x0158 }, /* Rcaron Ř LATIN CAPITAL LETTER R WITH CARON */
  { 0x01d9, 0x016e }, /* Uring Ů LATIN CAPITAL LETTER U WITH RING ABOVE */
  { 0x01db, 0x0170 }, /* Udoubleacute Ű LATIN CAPITAL LETTER U WITH DOUBLE ACUTE */
  { 0x01de, 0x0162 }, /* Tcedilla Ţ LATIN CAPITAL LETTER T WITH CEDILLA */
  { 0x01e0, 0x0155 }, /* racute ŕ LATIN SMALL LETTER R WITH ACUTE */
  { 0x01e3, 0x0103 }, /* abreve ă LATIN SMALL LETTER A WITH BREVE */
  { 0x01e5, 0x013a }, /* lacute ĺ LATIN SMALL LETTER L WITH ACUTE */
  { 0x01e6, 0x0107 }, /* cacute ć LATIN SMALL LETTER C WITH ACUTE */
  { 0x01e8, 0x010d }, /* ccaron č LATIN SMALL LETTER C WITH CARON */
  { 0x01ea, 0x0119 }, /* eogonek ę LATIN SMALL LETTER E WITH OGONEK */
  { 0x01ec, 0x011b }, /* ecaron ě LATIN SMALL LETTER E WITH CARON */
  { 0x01ef, 0x010f }, /* dcaron ď LATIN SMALL LETTER D WITH CARON */
  { 0x01f0, 0x0111 }, /* dstroke đ LATIN SMALL LETTER D WITH STROKE */
  { 0x01f1, 0x0144 }, /* nacute ń LATIN SMALL LETTER N WITH ACUTE */
  { 0x01f2, 0x0148 }, /* ncaron ň LATIN SMALL LETTER N WITH CARON */
  { 0x01f5, 0x0151 }, /* odoubleacute ő LATIN SMALL LETTER O WITH DOUBLE ACUTE */
  { 0x01f8, 0x0159 }, /* rcaron ř LATIN SMALL LETTER R WITH CARON */
  { 0x01f9, 0x016f }, /* uring ů LATIN SMALL LETTER U WITH RING ABOVE */
  { 0x01fb, 0x0171 }, /* udoubleacute ű LATIN SMALL LETTER U WITH DOUBLE ACUTE */
  { 0x01fe, 0x0163 }, /* tcedilla ţ LATIN SMALL LETTER T WITH CEDILLA */
  { 0x01ff, 0x02d9 }, /* abovedot ˙ DOT ABOVE */
  { 0x02a1, 0x0126 }, /* Hstroke Ħ LATIN CAPITAL LETTER H WITH STROKE */
  { 0x02a6, 0x0124 }, /* Hcircumflex Ĥ LATIN CAPITAL LETTER H WITH CIRCUMFLEX */
  { 0x02a9, 0x0130 }, /* Iabovedot İ LATIN CAPITAL LETTER I WITH DOT ABOVE */
  { 0x02ab, 0x011e }, /* Gbreve Ğ LATIN CAPITAL LETTER G WITH BREVE */
  { 0x02ac, 0x0134 }, /* Jcircumflex Ĵ LATIN CAPITAL LETTER J WITH CIRCUMFLEX */
  { 0x02b1, 0x0127 }, /* hstroke ħ LATIN SMALL LETTER H WITH STROKE */
  { 0x02b6, 0x0125 }, /* hcircumflex ĥ LATIN SMALL LETTER H WITH CIRCUMFLEX */
  { 0x02b9, 0x0131 }, /* idotless ı LATIN SMALL LETTER DOTLESS I */
  { 0x02bb, 0x011f }, /* gbreve ğ LATIN SMALL LETTER G WITH BREVE */
  { 0x02bc, 0x0135 }, /* jcircumflex ĵ LATIN SMALL LETTER J WITH CIRCUMFLEX */
  { 0x02c5, 0x010a }, /* Cabovedot Ċ LATIN CAPITAL LETTER C WITH DOT ABOVE */
  { 0x02c6, 0x0108 }, /* Ccircumflex Ĉ LATIN CAPITAL LETTER C WITH CIRCUMFLEX */
  { 0x02d5, 0x0120 }, /* Gabovedot Ġ LATIN CAPITAL LETTER G WITH DOT ABOVE */
  { 0x02d8, 0x011c }, /* Gcircumflex Ĝ LATIN CAPITAL LETTER G WITH CIRCUMFLEX */
  { 0x02dd, 0x016c }, /* Ubreve Ŭ LATIN CAPITAL LETTER U WITH BREVE */
  { 0x02de, 0x015c }, /* Scircumflex Ŝ LATIN CAPITAL LETTER S WITH CIRCUMFLEX */
  { 0x02e5, 0x010b }, /* cabovedot ċ LATIN SMALL LETTER C WITH DOT ABOVE */
  { 0x02e6, 0x0109 }, /* ccircumflex ĉ LATIN SMALL LETTER C WITH CIRCUMFLEX */
  { 0x02f5, 0x0121 }, /* gabovedot ġ LATIN SMALL LETTER G WITH DOT ABOVE */
  { 0x02f8, 0x011d }, /* gcircumflex ĝ LATIN SMALL LETTER G WITH CIRCUMFLEX */
  { 0x02fd, 0x016d }, /* ubreve ŭ LATIN SMALL LETTER U WITH BREVE */
  { 0x02fe, 0x015d }, /* scircumflex ŝ LATIN SMALL LETTER S WITH CIRCUMFLEX */
  { 0x03a2, 0x0138 }, /* kra ĸ LATIN SMALL LETTER KRA */
  { 0x03a3, 0x0156 }, /* Rcedilla Ŗ LATIN CAPITAL LETTER R WITH CEDILLA */
  { 0x03a5, 0x0128 }, /* Itilde Ĩ LATIN CAPITAL LETTER I WITH TILDE */
  { 0x03a6, 0x013b }, /* Lcedilla Ļ LATIN CAPITAL LETTER L WITH CEDILLA */
  { 0x03aa, 0x0112 }, /* Emacron Ē LATIN CAPITAL LETTER E WITH MACRON */
  { 0x03ab, 0x0122 }, /* Gcedilla Ģ LATIN CAPITAL LETTER G WITH CEDILLA */
  { 0x03ac, 0x0166 }, /* Tslash Ŧ LATIN CAPITAL LETTER T WITH STROKE */
  { 0x03b3, 0x0157 }, /* rcedilla ŗ LATIN SMALL LETTER R WITH CEDILLA */
  { 0x03b5, 0x0129 }, /* itilde ĩ LATIN SMALL LETTER I WITH TILDE */
  { 0x03b6, 0x013c }, /* lcedilla ļ LATIN SMALL LETTER L WITH CEDILLA */
  { 0x03ba, 0x0113 }, /* emacron ē LATIN SMALL LETTER E WITH MACRON */
  { 0x03bb, 0x0123 }, /* gcedilla ģ LATIN SMALL LETTER G WITH CEDILLA */
  { 0x03bc, 0x0167 }, /* tslash ŧ LATIN SMALL LETTER T WITH STROKE */
  { 0x03bd, 0x014a }, /* ENG Ŋ LATIN CAPITAL LETTER ENG */
  { 0x03bf, 0x014b }, /* eng ŋ LATIN SMALL LETTER ENG */
  { 0x03c0, 0x0100 }, /* Amacron Ā LATIN CAPITAL LETTER A WITH MACRON */
  { 0x03c7, 0x012e }, /* Iogonek Į LATIN CAPITAL LETTER I WITH OGONEK */
  { 0x03cc, 0x0116 }, /* Eabovedot Ė LATIN CAPITAL LETTER E WITH DOT ABOVE */
  { 0x03cf, 0x012a }, /* Imacron Ī LATIN CAPITAL LETTER I WITH MACRON */
  { 0x03d1, 0x0145 }, /* Ncedilla Ņ LATIN CAPITAL LETTER N WITH CEDILLA */
  { 0x03d2, 0x014c }, /* Omacron Ō LATIN CAPITAL LETTER O WITH MACRON */
  { 0x03d3, 0x0136 }, /* Kcedilla Ķ LATIN CAPITAL LETTER K WITH CEDILLA */
  { 0x03d9, 0x0172 }, /* Uogonek Ų LATIN CAPITAL LETTER U WITH OGONEK */
  { 0x03dd, 0x0168 }, /* Utilde Ũ LATIN CAPITAL LETTER U WITH TILDE */
  { 0x03de, 0x016a }, /* Umacron Ū LATIN CAPITAL LETTER U WITH MACRON */
  { 0x03e0, 0x0101 }, /* amacron ā LATIN SMALL LETTER A WITH MACRON */
  { 0x03e7, 0x012f }, /* iogonek į LATIN SMALL LETTER I WITH OGONEK */
  { 0x03ec, 0x0117 }, /* eabovedot ė LATIN SMALL LETTER E WITH DOT ABOVE */
  { 0x03ef, 0x012b }, /* imacron ī LATIN SMALL LETTER I WITH MACRON */
  { 0x03f1, 0x0146 }, /* ncedilla ņ LATIN SMALL LETTER N WITH CEDILLA */
  { 0x03f2, 0x014d }, /* omacron ō LATIN SMALL LETTER O WITH MACRON */
  { 0x03f3, 0x0137 }, /* kcedilla ķ LATIN SMALL LETTER K WITH CEDILLA */
  { 0x03f9, 0x0173 }, /* uogonek ų LATIN SMALL LETTER U WITH OGONEK */
  { 0x03fd, 0x0169 }, /* utilde ũ LATIN SMALL LETTER U WITH TILDE */
  { 0x03fe, 0x016b }, /* umacron ū LATIN SMALL LETTER U WITH MACRON */
  { 0x047e, 0x203e }, /* overline ‾ OVERLINE */
  { 0x04a1, 0x3002 }, /* kana_fullstop 。 IDEOGRAPHIC FULL STOP */
  { 0x04a2, 0x300c }, /* kana_openingbracket 「 LEFT CORNER BRACKET */
  { 0x04a3, 0x300d }, /* kana_closingbracket 」 RIGHT CORNER BRACKET */
  { 0x04a4, 0x3001 }, /* kana_comma 、 IDEOGRAPHIC COMMA */
  { 0x04a5, 0x30fb }, /* kana_conjunctive ・ KATAKANA MIDDLE DOT */
  { 0x04a6, 0x30f2 }, /* kana_WO ヲ KATAKANA LETTER WO */
  { 0x04a7, 0x30a1 }, /* kana_a ァ KATAKANA LETTER SMALL A */
  { 0x04a8, 0x30a3 }, /* kana_i ィ KATAKANA LETTER SMALL I */
  { 0x04a9, 0x30a5 }, /* kana_u ゥ KATAKANA LETTER SMALL U */
  { 0x04aa, 0x30a7 }, /* kana_e ェ KATAKANA LETTER SMALL E */
  { 0x04ab, 0x30a9 }, /* kana_o ォ KATAKANA LETTER SMALL O */
  { 0x04ac, 0x30e3 }, /* kana_ya ャ KATAKANA LETTER SMALL YA */
  { 0x04ad, 0x30e5 }, /* kana_yu ュ KATAKANA LETTER SMALL YU */
  { 0x04ae, 0x30e7 }, /* kana_yo ョ KATAKANA LETTER SMALL YO */
  { 0x04af, 0x30c3 }, /* kana_tsu ッ KATAKANA LETTER SMALL TU */
  { 0x04b0, 0x30fc }, /* prolongedsound ー KATAKANA-HIRAGANA PROLONGED SOUND MARK */
  { 0x04b1, 0x30a2 }, /* kana_A ア KATAKANA LETTER A */
  { 0x04b2, 0x30a4 }, /* kana_I イ KATAKANA LETTER I */
  { 0x04b3, 0x30a6 }, /* kana_U ウ KATAKANA LETTER U */
  { 0x04b4, 0x30a8 }, /* kana_E エ KATAKANA LETTER E */
  { 0x04b5, 0x30aa }, /* kana_O オ KATAKANA LETTER O */
  { 0x04b6, 0x30ab }, /* kana_KA カ KATAKANA LETTER KA */
  { 0x04b7, 0x30ad }, /* kana_KI キ KATAKANA LETTER KI */
  { 0x04b8, 0x30af }, /* kana_KU ク KATAKANA LETTER KU */
  { 0x04b9, 0x30b1 }, /* kana_KE ケ KATAKANA LETTER KE */
  { 0x04ba, 0x30b3 }, /* kana_KO コ KATAKANA LETTER KO */
  { 0x04bb, 0x30b5 }, /* kana_SA サ KATAKANA LETTER SA */
  { 0x04bc, 0x30b7 }, /* kana_SHI シ KATAKANA LETTER SI */
  { 0x04bd, 0x30b9 }, /* kana_SU ス KATAKANA LETTER SU */
  { 0x04be, 0x30bb }, /* kana_SE セ KATAKANA LETTER SE */
  { 0x04bf, 0x30bd }, /* kana_SO ソ KATAKANA LETTER SO */
  { 0x04c0, 0x30bf }, /* kana_TA タ KATAKANA LETTER TA */
  { 0x04c1, 0x30c1 }, /* kana_CHI チ KATAKANA LETTER TI */
  { 0x04c2, 0x30c4 }, /* kana_TSU ツ KATAKANA LETTER TU */
  { 0x04c3, 0x30c6 }, /* kana_TE テ KATAKANA LETTER TE */
  { 0x04c4, 0x30c8 }, /* kana_TO ト KATAKANA LETTER TO */
  { 0x04c5, 0x30ca }, /* kana_NA ナ KATAKANA LETTER NA */
  { 0x04c6, 0x30cb }, /* kana_NI ニ KATAKANA LETTER NI */
  { 0x04c7, 0x30cc }, /* kana_NU ヌ KATAKANA LETTER NU */
  { 0x04c8, 0x30cd }, /* kana_NE ネ KATAKANA LETTER NE */
  { 0x04c9, 0x30ce }, /* kana_NO ノ KATAKANA LETTER NO */
  { 0x04ca, 0x30cf }, /* kana_HA ハ KATAKANA LETTER HA */
  { 0x04cb, 0x30d2 }, /* kana_HI ヒ KATAKANA LETTER HI */
  { 0x04cc, 0x30d5 }, /* kana_FU フ KATAKANA LETTER HU */
  { 0x04cd, 0x30d8 }, /* kana_HE ヘ KATAKANA LETTER HE */
  { 0x04ce, 0x30db }, /* kana_HO ホ KATAKANA LETTER HO */
  { 0x04cf, 0x30de }, /* kana_MA マ KATAKANA LETTER MA */
  { 0x04d0, 0x30df }, /* kana_MI ミ KATAKANA LETTER MI */
  { 0x04d1, 0x30e0 }, /* kana_MU ム KATAKANA LETTER MU */
  { 0x04d2, 0x30e1 }, /* kana_ME メ KATAKANA LETTER ME */
  { 0x04d3, 0x30e2 }, /* kana_MO モ KATAKANA LETTER MO */
  { 0x04d4, 0x30e4 }, /* kana_YA ヤ KATAKANA LETTER YA */
  { 0x04d5, 0x30e6 }, /* kana_YU ユ KATAKANA LETTER YU */
  { 0x04d6, 0x30e8 }, /* kana_YO ヨ KATAKANA LETTER YO */
  { 0x04d7, 0x30e9 }, /* kana_RA ラ KATAKANA LETTER RA */
  { 0x04d8, 0x30ea }, /* kana_RI リ KATAKANA LETTER RI */
  { 0x04d9, 0x30eb }, /* kana_RU ル KATAKANA LETTER RU */
  { 0x04da, 0x30ec }, /* kana_RE レ KATAKANA LETTER RE */
  { 0x04db, 0x30ed }, /* kana_RO ロ KATAKANA LETTER RO */
  { 0x04dc, 0x30ef }, /* kana_WA ワ KATAKANA LETTER WA */
  { 0x04dd, 0x30f3 }, /* kana_N ン KATAKANA LETTER N */
  { 0x04de, 0x309b }, /* voicedsound ゛ KATAKANA-HIRAGANA VOICED SOUND MARK */
  { 0x04df, 0x309c }, /* semivoicedsound ゜ KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK */
  { 0x05ac, 0x060c }, /* Arabic_comma ، ARABIC COMMA */
  { 0x05bb, 0x061b }, /* Arabic_semicolon ؛ ARABIC SEMICOLON */
  { 0x05bf, 0x061f }, /* Arabic_question_mark ؟ ARABIC QUESTION MARK */
  { 0x05c1, 0x0621 }, /* Arabic_hamza ء ARABIC LETTER HAMZA */
  { 0x05c2, 0x0622 }, /* Arabic_maddaonalef آ ARABIC LETTER ALEF WITH MADDA ABOVE */
  { 0x05c3, 0x0623 }, /* Arabic_hamzaonalef أ ARABIC LETTER ALEF WITH HAMZA ABOVE */
  { 0x05c4, 0x0624 }, /* Arabic_hamzaonwaw ؤ ARABIC LETTER WAW WITH HAMZA ABOVE */
  { 0x05c5, 0x0625 }, /* Arabic_hamzaunderalef إ ARABIC LETTER ALEF WITH HAMZA BELOW */
  { 0x05c6, 0x0626 }, /* Arabic_hamzaonyeh ئ ARABIC LETTER YEH WITH HAMZA ABOVE */
  { 0x05c7, 0x0627 }, /* Arabic_alef ا ARABIC LETTER ALEF */
  { 0x05c8, 0x0628 }, /* Arabic_beh ب ARABIC LETTER BEH */
  { 0x05c9, 0x0629 }, /* Arabic_tehmarbuta ة ARABIC LETTER TEH MARBUTA */
  { 0x05ca, 0x062a }, /* Arabic_teh ت ARABIC LETTER TEH */
  { 0x05cb, 0x062b }, /* Arabic_theh ث ARABIC LETTER THEH */
  { 0x05cc, 0x062c }, /* Arabic_jeem ج ARABIC LETTER JEEM */
  { 0x05cd, 0x062d }, /* Arabic_hah ح ARABIC LETTER HAH */
  { 0x05ce, 0x062e }, /* Arabic_khah خ ARABIC LETTER KHAH */
  { 0x05cf, 0x062f }, /* Arabic_dal د ARABIC LETTER DAL */
  { 0x05d0, 0x0630 }, /* Arabic_thal ذ ARABIC LETTER THAL */
  { 0x05d1, 0x0631 }, /* Arabic_ra ر ARABIC LETTER REH */
  { 0x05d2, 0x0632 }, /* Arabic_zain ز ARABIC LETTER ZAIN */
  { 0x05d3, 0x0633 }, /* Arabic_seen س ARABIC LETTER SEEN */
  { 0x05d4, 0x0634 }, /* Arabic_sheen ش ARABIC LETTER SHEEN */
  { 0x05d5, 0x0635 }, /* Arabic_sad ص ARABIC LETTER SAD */
  { 0x05d6, 0x0636 }, /* Arabic_dad ض ARABIC LETTER DAD */
  { 0x05d7, 0x0637 }, /* Arabic_tah ط ARABIC LETTER TAH */
  { 0x05d8, 0x0638 }, /* Arabic_zah ظ ARABIC LETTER ZAH */
  { 0x05d9, 0x0639 }, /* Arabic_ain ع ARABIC LETTER AIN */
  { 0x05da, 0x063a }, /* Arabic_ghain غ ARABIC LETTER GHAIN */
  { 0x05e0, 0x0640 }, /* Arabic_tatweel ـ ARABIC TATWEEL */
  { 0x05e1, 0x0641 }, /* Arabic_feh ف ARABIC LETTER FEH */
  { 0x05e2, 0x0642 }, /* Arabic_qaf ق ARABIC LETTER QAF */
  { 0x05e3, 0x0643 }, /* Arabic_kaf ك ARABIC LETTER KAF */
  { 0x05e4, 0x0644 }, /* Arabic_lam ل ARABIC LETTER LAM */
  { 0x05e5, 0x0645 }, /* Arabic_meem م ARABIC LETTER MEEM */
  { 0x05e6, 0x0646 }, /* Arabic_noon ن ARABIC LETTER NOON */
  { 0x05e7, 0x0647 }, /* Arabic_ha ه ARABIC LETTER HEH */
  { 0x05e8, 0x0648 }, /* Arabic_waw و ARABIC LETTER WAW */
  { 0x05e9, 0x0649 }, /* Arabic_alefmaksura ى ARABIC LETTER ALEF MAKSURA */
  { 0x05ea, 0x064a }, /* Arabic_yeh ي ARABIC LETTER YEH */
  { 0x05eb, 0x064b }, /* Arabic_fathatan ً ARABIC FATHATAN */
  { 0x05ec, 0x064c }, /* Arabic_dammatan ٌ ARABIC DAMMATAN */
  { 0x05ed, 0x064d }, /* Arabic_kasratan ٍ ARABIC KASRATAN */
  { 0x05ee, 0x064e }, /* Arabic_fatha َ ARABIC FATHA */
  { 0x05ef, 0x064f }, /* Arabic_damma ُ ARABIC DAMMA */
  { 0x05f0, 0x0650 }, /* Arabic_kasra ِ ARABIC KASRA */
  { 0x05f1, 0x0651 }, /* Arabic_shadda ّ ARABIC SHADDA */
  { 0x05f2, 0x0652 }, /* Arabic_sukun ْ ARABIC SUKUN */
  { 0x06a1, 0x0452 }, /* Serbian_dje ђ CYRILLIC SMALL LETTER DJE */
  { 0x06a2, 0x0453 }, /* Macedonia_gje ѓ CYRILLIC SMALL LETTER GJE */
  { 0x06a3, 0x0451 }, /* Cyrillic_io ё CYRILLIC SMALL LETTER IO */
  { 0x06a4, 0x0454 }, /* Ukrainian_ie є CYRILLIC SMALL LETTER UKRAINIAN IE */
  { 0x06a5, 0x0455 }, /* Macedonia_dse ѕ CYRILLIC SMALL LETTER DZE */
  { 0x06a6, 0x0456 }, /* Ukrainian_i і CYRILLIC SMALL LETTER BYELORUSSIAN-UKRAINIAN I */
  { 0x06a7, 0x0457 }, /* Ukrainian_yi ї CYRILLIC SMALL LETTER YI */
  { 0x06a8, 0x0458 }, /* Cyrillic_je ј CYRILLIC SMALL LETTER JE */
  { 0x06a9, 0x0459 }, /* Cyrillic_lje љ CYRILLIC SMALL LETTER LJE */
  { 0x06aa, 0x045a }, /* Cyrillic_nje њ CYRILLIC SMALL LETTER NJE */
  { 0x06ab, 0x045b }, /* Serbian_tshe ћ CYRILLIC SMALL LETTER TSHE */
  { 0x06ac, 0x045c }, /* Macedonia_kje ќ CYRILLIC SMALL LETTER KJE */
  { 0x06ae, 0x045e }, /* Byelorussian_shortu ў CYRILLIC SMALL LETTER SHORT U */
  { 0x06af, 0x045f }, /* Cyrillic_dzhe џ CYRILLIC SMALL LETTER DZHE */
  { 0x06b0, 0x2116 }, /* numerosign № NUMERO SIGN */
  { 0x06b1, 0x0402 }, /* Serbian_DJE Ђ CYRILLIC CAPITAL LETTER DJE */
  { 0x06b2, 0x0403 }, /* Macedonia_GJE Ѓ CYRILLIC CAPITAL LETTER GJE */
  { 0x06b3, 0x0401 }, /* Cyrillic_IO Ё CYRILLIC CAPITAL LETTER IO */
  { 0x06b4, 0x0404 }, /* Ukrainian_IE Є CYRILLIC CAPITAL LETTER UKRAINIAN IE */
  { 0x06b5, 0x0405 }, /* Macedonia_DSE Ѕ CYRILLIC CAPITAL LETTER DZE */
  { 0x06b6, 0x0406 }, /* Ukrainian_I І CYRILLIC CAPITAL LETTER BYELORUSSIAN-UKRAINIAN I */
  { 0x06b7, 0x0407 }, /* Ukrainian_YI Ї CYRILLIC CAPITAL LETTER YI */
  { 0x06b8, 0x0408 }, /* Cyrillic_JE Ј CYRILLIC CAPITAL LETTER JE */
  { 0x06b9, 0x0409 }, /* Cyrillic_LJE Љ CYRILLIC CAPITAL LETTER LJE */
  { 0x06ba, 0x040a }, /* Cyrillic_NJE Њ CYRILLIC CAPITAL LETTER NJE */
  { 0x06bb, 0x040b }, /* Serbian_TSHE Ћ CYRILLIC CAPITAL LETTER TSHE */
  { 0x06bc, 0x040c }, /* Macedonia_KJE Ќ CYRILLIC CAPITAL LETTER KJE */
  { 0x06be, 0x040e }, /* Byelorussian_SHORTU Ў CYRILLIC CAPITAL LETTER SHORT U */
  { 0x06bf, 0x040f }, /* Cyrillic_DZHE Џ CYRILLIC CAPITAL LETTER DZHE */
  { 0x06c0, 0x044e }, /* Cyrillic_yu ю CYRILLIC SMALL LETTER YU */
  { 0x06c1, 0x0430 }, /* Cyrillic_a а CYRILLIC SMALL LETTER A */
  { 0x06c2, 0x0431 }, /* Cyrillic_be б CYRILLIC SMALL LETTER BE */
  { 0x06c3, 0x0446 }, /* Cyrillic_tse ц CYRILLIC SMALL LETTER TSE */
  { 0x06c4, 0x0434 }, /* Cyrillic_de д CYRILLIC SMALL LETTER DE */
  { 0x06c5, 0x0435 }, /* Cyrillic_ie е CYRILLIC SMALL LETTER IE */
  { 0x06c6, 0x0444 }, /* Cyrillic_ef ф CYRILLIC SMALL LETTER EF */
  { 0x06c7, 0x0433 }, /* Cyrillic_ghe г CYRILLIC SMALL LETTER GHE */
  { 0x06c8, 0x0445 }, /* Cyrillic_ha х CYRILLIC SMALL LETTER HA */
  { 0x06c9, 0x0438 }, /* Cyrillic_i и CYRILLIC SMALL LETTER I */
  { 0x06ca, 0x0439 }, /* Cyrillic_shorti й CYRILLIC SMALL LETTER SHORT I */
  { 0x06cb, 0x043a }, /* Cyrillic_ka к CYRILLIC SMALL LETTER KA */
  { 0x06cc, 0x043b }, /* Cyrillic_el л CYRILLIC SMALL LETTER EL */
  { 0x06cd, 0x043c }, /* Cyrillic_em м CYRILLIC SMALL LETTER EM */
  { 0x06ce, 0x043d }, /* Cyrillic_en н CYRILLIC SMALL LETTER EN */
  { 0x06cf, 0x043e }, /* Cyrillic_o о CYRILLIC SMALL LETTER O */
  { 0x06d0, 0x043f }, /* Cyrillic_pe п CYRILLIC SMALL LETTER PE */
  { 0x06d1, 0x044f }, /* Cyrillic_ya я CYRILLIC SMALL LETTER YA */
  { 0x06d2, 0x0440 }, /* Cyrillic_er р CYRILLIC SMALL LETTER ER */
  { 0x06d3, 0x0441 }, /* Cyrillic_es с CYRILLIC SMALL LETTER ES */
  { 0x06d4, 0x0442 }, /* Cyrillic_te т CYRILLIC SMALL LETTER TE */
  { 0x06d5, 0x0443 }, /* Cyrillic_u у CYRILLIC SMALL LETTER U */
  { 0x06d6, 0x0436 }, /* Cyrillic_zhe ж CYRILLIC SMALL LETTER ZHE */
  { 0x06d7, 0x0432 }, /* Cyrillic_ve в CYRILLIC SMALL LETTER VE */
  { 0x06d8, 0x044c }, /* Cyrillic_softsign ь CYRILLIC SMALL LETTER SOFT SIGN */
  { 0x06d9, 0x044b }, /* Cyrillic_yeru ы CYRILLIC SMALL LETTER YERU */
  { 0x06da, 0x0437 }, /* Cyrillic_ze з CYRILLIC SMALL LETTER ZE */
  { 0x06db, 0x0448 }, /* Cyrillic_sha ш CYRILLIC SMALL LETTER SHA */
  { 0x06dc, 0x044d }, /* Cyrillic_e э CYRILLIC SMALL LETTER E */
  { 0x06dd, 0x0449 }, /* Cyrillic_shcha щ CYRILLIC SMALL LETTER SHCHA */
  { 0x06de, 0x0447 }, /* Cyrillic_che ч CYRILLIC SMALL LETTER CHE */
  { 0x06df, 0x044a }, /* Cyrillic_hardsign ъ CYRILLIC SMALL LETTER HARD SIGN */
  { 0x06e0, 0x042e }, /* Cyrillic_YU Ю CYRILLIC CAPITAL LETTER YU */
  { 0x06e1, 0x0410 }, /* Cyrillic_A А CYRILLIC CAPITAL LETTER A */
  { 0x06e2, 0x0411 }, /* Cyrillic_BE Б CYRILLIC CAPITAL LETTER BE */
  { 0x06e3, 0x0426 }, /* Cyrillic_TSE Ц CYRILLIC CAPITAL LETTER TSE */
  { 0x06e4, 0x0414 }, /* Cyrillic_DE Д CYRILLIC CAPITAL LETTER DE */
  { 0x06e5, 0x0415 }, /* Cyrillic_IE Е CYRILLIC CAPITAL LETTER IE */
  { 0x06e6, 0x0424 }, /* Cyrillic_EF Ф CYRILLIC CAPITAL LETTER EF */
  { 0x06e7, 0x0413 }, /* Cyrillic_GHE Г CYRILLIC CAPITAL LETTER GHE */
  { 0x06e8, 0x0425 }, /* Cyrillic_HA Х CYRILLIC CAPITAL LETTER HA */
  { 0x06e9, 0x0418 }, /* Cyrillic_I И CYRILLIC CAPITAL LETTER I */
  { 0x06ea, 0x0419 }, /* Cyrillic_SHORTI Й CYRILLIC CAPITAL LETTER SHORT I */
  { 0x06eb, 0x041a }, /* Cyrillic_KA К CYRILLIC CAPITAL LETTER KA */
  { 0x06ec, 0x041b }, /* Cyrillic_EL Л CYRILLIC CAPITAL LETTER EL */
  { 0x06ed, 0x041c }, /* Cyrillic_EM М CYRILLIC CAPITAL LETTER EM */
  { 0x06ee, 0x041d }, /* Cyrillic_EN Н CYRILLIC CAPITAL LETTER EN */
  { 0x06ef, 0x041e }, /* Cyrillic_O О CYRILLIC CAPITAL LETTER O */
  { 0x06f0, 0x041f }, /* Cyrillic_PE П CYRILLIC CAPITAL LETTER PE */
  { 0x06f1, 0x042f }, /* Cyrillic_YA Я CYRILLIC CAPITAL LETTER YA */
  { 0x06f2, 0x0420 }, /* Cyrillic_ER Р CYRILLIC CAPITAL LETTER ER */
  { 0x06f3, 0x0421 }, /* Cyrillic_ES С CYRILLIC CAPITAL LETTER ES */
  { 0x06f4, 0x0422 }, /* Cyrillic_TE Т CYRILLIC CAPITAL LETTER TE */
  { 0x06f5, 0x0423 }, /* Cyrillic_U У CYRILLIC CAPITAL LETTER U */
  { 0x06f6, 0x0416 }, /* Cyrillic_ZHE Ж CYRILLIC CAPITAL LETTER ZHE */
  { 0x06f7, 0x0412 }, /* Cyrillic_VE В CYRILLIC CAPITAL LETTER VE */
  { 0x06f8, 0x042c }, /* Cyrillic_SOFTSIGN Ь CYRILLIC CAPITAL LETTER SOFT SIGN */
  { 0x06f9, 0x042b }, /* Cyrillic_YERU Ы CYRILLIC CAPITAL LETTER YERU */
  { 0x06fa, 0x0417 }, /* Cyrillic_ZE З CYRILLIC CAPITAL LETTER ZE */
  { 0x06fb, 0x0428 }, /* Cyrillic_SHA Ш CYRILLIC CAPITAL LETTER SHA */
  { 0x06fc, 0x042d }, /* Cyrillic_E Э CYRILLIC CAPITAL LETTER E */
  { 0x06fd, 0x0429 }, /* Cyrillic_SHCHA Щ CYRILLIC CAPITAL LETTER SHCHA */
  { 0x06fe, 0x0427 }, /* Cyrillic_CHE Ч CYRILLIC CAPITAL LETTER CHE */
  { 0x06ff, 0x042a }, /* Cyrillic_HARDSIGN Ъ CYRILLIC CAPITAL LETTER HARD SIGN */
  { 0x07a1, 0x0386 }, /* Greek_ALPHAaccent Ά GREEK CAPITAL LETTER ALPHA WITH TONOS */
  { 0x07a2, 0x0388 }, /* Greek_EPSILONaccent Έ GREEK CAPITAL LETTER EPSILON WITH TONOS */
  { 0x07a3, 0x0389 }, /* Greek_ETAaccent Ή GREEK CAPITAL LETTER ETA WITH TONOS */
  { 0x07a4, 0x038a }, /* Greek_IOTAaccent Ί GREEK CAPITAL LETTER IOTA WITH TONOS */
  { 0x07a5, 0x03aa }, /* Greek_IOTAdiaeresis Ϊ GREEK CAPITAL LETTER IOTA WITH DIALYTIKA */
  { 0x07a7, 0x038c }, /* Greek_OMICRONaccent Ό GREEK CAPITAL LETTER OMICRON WITH TONOS */
  { 0x07a8, 0x038e }, /* Greek_UPSILONaccent Ύ GREEK CAPITAL LETTER UPSILON WITH TONOS */
  { 0x07a9, 0x03ab }, /* Greek_UPSILONdieresis Ϋ GREEK CAPITAL LETTER UPSILON WITH DIALYTIKA */
  { 0x07ab, 0x038f }, /* Greek_OMEGAaccent Ώ GREEK CAPITAL LETTER OMEGA WITH TONOS */
  { 0x07ae, 0x0385 }, /* Greek_accentdieresis ΅ GREEK DIALYTIKA TONOS */
  { 0x07af, 0x2015 }, /* Greek_horizbar ― HORIZONTAL BAR */
  { 0x07b1, 0x03ac }, /* Greek_alphaaccent ά GREEK SMALL LETTER ALPHA WITH TONOS */
  { 0x07b2, 0x03ad }, /* Greek_epsilonaccent έ GREEK SMALL LETTER EPSILON WITH TONOS */
  { 0x07b3, 0x03ae }, /* Greek_etaaccent ή GREEK SMALL LETTER ETA WITH TONOS */
  { 0x07b4, 0x03af }, /* Greek_iotaaccent ί GREEK SMALL LETTER IOTA WITH TONOS */
  { 0x07b5, 0x03ca }, /* Greek_iotadieresis ϊ GREEK SMALL LETTER IOTA WITH DIALYTIKA */
  { 0x07b6, 0x0390 }, /* Greek_iotaaccentdieresis ΐ GREEK SMALL LETTER IOTA WITH DIALYTIKA AND TONOS */
  { 0x07b7, 0x03cc }, /* Greek_omicronaccent ό GREEK SMALL LETTER OMICRON WITH TONOS */
  { 0x07b8, 0x03cd }, /* Greek_upsilonaccent ύ GREEK SMALL LETTER UPSILON WITH TONOS */
  { 0x07b9, 0x03cb }, /* Greek_upsilondieresis ϋ GREEK SMALL LETTER UPSILON WITH DIALYTIKA */
  { 0x07ba, 0x03b0 }, /* Greek_upsilonaccentdieresis ΰ GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND TONOS */
  { 0x07bb, 0x03ce }, /* Greek_omegaaccent ώ GREEK SMALL LETTER OMEGA WITH TONOS */
  { 0x07c1, 0x0391 }, /* Greek_ALPHA Α GREEK CAPITAL LETTER ALPHA */
  { 0x07c2, 0x0392 }, /* Greek_BETA Β GREEK CAPITAL LETTER BETA */
  { 0x07c3, 0x0393 }, /* Greek_GAMMA Γ GREEK CAPITAL LETTER GAMMA */
  { 0x07c4, 0x0394 }, /* Greek_DELTA Δ GREEK CAPITAL LETTER DELTA */
  { 0x07c5, 0x0395 }, /* Greek_EPSILON Ε GREEK CAPITAL LETTER EPSILON */
  { 0x07c6, 0x0396 }, /* Greek_ZETA Ζ GREEK CAPITAL LETTER ZETA */
  { 0x07c7, 0x0397 }, /* Greek_ETA Η GREEK CAPITAL LETTER ETA */
  { 0x07c8, 0x0398 }, /* Greek_THETA Θ GREEK CAPITAL LETTER THETA */
  { 0x07c9, 0x0399 }, /* Greek_IOTA Ι GREEK CAPITAL LETTER IOTA */
  { 0x07ca, 0x039a }, /* Greek_KAPPA Κ GREEK CAPITAL LETTER KAPPA */
  { 0x07cb, 0x039b }, /* Greek_LAMBDA Λ GREEK CAPITAL LETTER LAMDA */
  { 0x07cc, 0x039c }, /* Greek_MU Μ GREEK CAPITAL LETTER MU */
  { 0x07cd, 0x039d }, /* Greek_NU Ν GREEK CAPITAL LETTER NU */
  { 0x07ce, 0x039e }, /* Greek_XI Ξ GREEK CAPITAL LETTER XI */
  { 0x07cf, 0x039f }, /* Greek_OMICRON Ο GREEK CAPITAL LETTER OMICRON */
  { 0x07d0, 0x03a0 }, /* Greek_PI Π GREEK CAPITAL LETTER PI */
  { 0x07d1, 0x03a1 }, /* Greek_RHO Ρ GREEK CAPITAL LETTER RHO */
  { 0x07d2, 0x03a3 }, /* Greek_SIGMA Σ GREEK CAPITAL LETTER SIGMA */
  { 0x07d4, 0x03a4 }, /* Greek_TAU Τ GREEK CAPITAL LETTER TAU */
  { 0x07d5, 0x03a5 }, /* Greek_UPSILON Υ GREEK CAPITAL LETTER UPSILON */
  { 0x07d6, 0x03a6 }, /* Greek_PHI Φ GREEK CAPITAL LETTER PHI */
  { 0x07d7, 0x03a7 }, /* Greek_CHI Χ GREEK CAPITAL LETTER CHI */
  { 0x07d8, 0x03a8 }, /* Greek_PSI Ψ GREEK CAPITAL LETTER PSI */
  { 0x07d9, 0x03a9 }, /* Greek_OMEGA Ω GREEK CAPITAL LETTER OMEGA */
  { 0x07e1, 0x03b1 }, /* Greek_alpha α GREEK SMALL LETTER ALPHA */
  { 0x07e2, 0x03b2 }, /* Greek_beta β GREEK SMALL LETTER BETA */
  { 0x07e3, 0x03b3 }, /* Greek_gamma γ GREEK SMALL LETTER GAMMA */
  { 0x07e4, 0x03b4 }, /* Greek_delta δ GREEK SMALL LETTER DELTA */
  { 0x07e5, 0x03b5 }, /* Greek_epsilon ε GREEK SMALL LETTER EPSILON */
  { 0x07e6, 0x03b6 }, /* Greek_zeta ζ GREEK SMALL LETTER ZETA */
  { 0x07e7, 0x03b7 }, /* Greek_eta η GREEK SMALL LETTER ETA */
  { 0x07e8, 0x03b8 }, /* Greek_theta θ GREEK SMALL LETTER THETA */
  { 0x07e9, 0x03b9 }, /* Greek_iota ι GREEK SMALL LETTER IOTA */
  { 0x07ea, 0x03ba }, /* Greek_kappa κ GREEK SMALL LETTER KAPPA */
  { 0x07eb, 0x03bb }, /* Greek_lambda λ GREEK SMALL LETTER LAMDA */
  { 0x07ec, 0x03bc }, /* Greek_mu μ GREEK SMALL LETTER MU */
  { 0x07ed, 0x03bd }, /* Greek_nu ν GREEK SMALL LETTER NU */
  { 0x07ee, 0x03be }, /* Greek_xi ξ GREEK SMALL LETTER XI */
  { 0x07ef, 0x03bf }, /* Greek_omicron ο GREEK SMALL LETTER OMICRON */
  { 0x07f0, 0x03c0 }, /* Greek_pi π GREEK SMALL LETTER PI */
  { 0x07f1, 0x03c1 }, /* Greek_rho ρ GREEK SMALL LETTER RHO */
  { 0x07f2, 0x03c3 }, /* Greek_sigma σ GREEK SMALL LETTER SIGMA */
  { 0x07f3, 0x03c2 }, /* Greek_finalsmallsigma ς GREEK SMALL LETTER FINAL SIGMA */
  { 0x07f4, 0x03c4 }, /* Greek_tau τ GREEK SMALL LETTER TAU */
  { 0x07f5, 0x03c5 }, /* Greek_upsilon υ GREEK SMALL LETTER UPSILON */
  { 0x07f6, 0x03c6 }, /* Greek_phi φ GREEK SMALL LETTER PHI */
  { 0x07f7, 0x03c7 }, /* Greek_chi χ GREEK SMALL LETTER CHI */
  { 0x07f8, 0x03c8 }, /* Greek_psi ψ GREEK SMALL LETTER PSI */
  { 0x07f9, 0x03c9 }, /* Greek_omega ω GREEK SMALL LETTER OMEGA */
/* 0x08a1 leftradical ? ??? */
/* 0x08a2 topleftradical ? ??? */
/* 0x08a3 horizconnector ? ??? */
  { 0x08a4, 0x2320 }, /* topintegral ⌠ TOP HALF INTEGRAL */
  { 0x08a5, 0x2321 }, /* botintegral ⌡ BOTTOM HALF INTEGRAL */
  { 0x08a6, 0x2502 }, /* vertconnector │ BOX DRAWINGS LIGHT VERTICAL */
/* 0x08a7 topleftsqbracket ? ??? */
/* 0x08a8 botleftsqbracket ? ??? */
/* 0x08a9 toprightsqbracket ? ??? */
/* 0x08aa botrightsqbracket ? ??? */
/* 0x08ab topleftparens ? ??? */
/* 0x08ac botleftparens ? ??? */
/* 0x08ad toprightparens ? ??? */
/* 0x08ae botrightparens ? ??? */
/* 0x08af leftmiddlecurlybrace ? ??? */
/* 0x08b0 rightmiddlecurlybrace ? ??? */
/* 0x08b1 topleftsummation ? ??? */
/* 0x08b2 botleftsummation ? ??? */
/* 0x08b3 topvertsummationconnector ? ??? */
/* 0x08b4 botvertsummationconnector ? ??? */
/* 0x08b5 toprightsummation ? ??? */
/* 0x08b6 botrightsummation ? ??? */
/* 0x08b7 rightmiddlesummation ? ??? */
  { 0x08bc, 0x2264 }, /* lessthanequal ≤ LESS-THAN OR EQUAL TO */
  { 0x08bd, 0x2260 }, /* notequal ≠ NOT EQUAL TO */
  { 0x08be, 0x2265 }, /* greaterthanequal ≥ GREATER-THAN OR EQUAL TO */
  { 0x08bf, 0x222b }, /* integral ∫ INTEGRAL */
  { 0x08c0, 0x2234 }, /* therefore ∴ THEREFORE */
  { 0x08c1, 0x221d }, /* variation ∝ PROPORTIONAL TO */
  { 0x08c2, 0x221e }, /* infinity ∞ INFINITY */
  { 0x08c5, 0x2207 }, /* nabla ∇ NABLA */
  { 0x08c8, 0x2245 }, /* approximate ≅ APPROXIMATELY EQUAL TO */
/* 0x08c9 similarequal ? ??? */
  { 0x08cd, 0x21d4 }, /* ifonlyif ⇔ LEFT RIGHT DOUBLE ARROW */
  { 0x08ce, 0x21d2 }, /* implies ⇒ RIGHTWARDS DOUBLE ARROW */
  { 0x08cf, 0x2261 }, /* identical ≡ IDENTICAL TO */
  { 0x08d6, 0x221a }, /* radical √ SQUARE ROOT */
  { 0x08da, 0x2282 }, /* includedin ⊂ SUBSET OF */
  { 0x08db, 0x2283 }, /* includes ⊃ SUPERSET OF */
  { 0x08dc, 0x2229 }, /* intersection ∩ INTERSECTION */
  { 0x08dd, 0x222a }, /* union ∪ UNION */
  { 0x08de, 0x2227 }, /* logicaland ∧ LOGICAL AND */
  { 0x08df, 0x2228 }, /* logicalor ∨ LOGICAL OR */
  { 0x08ef, 0x2202 }, /* partialderivative ∂ PARTIAL DIFFERENTIAL */
  { 0x08f6, 0x0192 }, /* function ƒ LATIN SMALL LETTER F WITH HOOK */
  { 0x08fb, 0x2190 }, /* leftarrow ← LEFTWARDS ARROW */
  { 0x08fc, 0x2191 }, /* uparrow ↑ UPWARDS ARROW */
  { 0x08fd, 0x2192 }, /* rightarrow → RIGHTWARDS ARROW */
  { 0x08fe, 0x2193 }, /* downarrow ↓ DOWNWARDS ARROW */
  { 0x09df, 0x2422 }, /* blank ␢ BLANK SYMBOL */
  { 0x09e0, 0x25c6 }, /* soliddiamond ◆ BLACK DIAMOND */
  { 0x09e1, 0x2592 }, /* checkerboard ▒ MEDIUM SHADE */
  { 0x09e2, 0x2409 }, /* ht ␉ SYMBOL FOR HORIZONTAL TABULATION */
  { 0x09e3, 0x240c }, /* ff ␌ SYMBOL FOR FORM FEED */
  { 0x09e4, 0x240d }, /* cr ␍ SYMBOL FOR CARRIAGE RETURN */
  { 0x09e5, 0x240a }, /* lf ␊ SYMBOL FOR LINE FEED */
  { 0x09e8, 0x2424 }, /* nl ␤ SYMBOL FOR NEWLINE */
  { 0x09e9, 0x240b }, /* vt ␋ SYMBOL FOR VERTICAL TABULATION */
  { 0x09ea, 0x2518 }, /* lowrightcorner ┘ BOX DRAWINGS LIGHT UP AND LEFT */
  { 0x09eb, 0x2510 }, /* uprightcorner ┐ BOX DRAWINGS LIGHT DOWN AND LEFT */
  { 0x09ec, 0x250c }, /* upleftcorner ┌ BOX DRAWINGS LIGHT DOWN AND RIGHT */
  { 0x09ed, 0x2514 }, /* lowleftcorner └ BOX DRAWINGS LIGHT UP AND RIGHT */
  { 0x09ee, 0x253c }, /* crossinglines ┼ BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL */
/* 0x09ef horizlinescan1 ? ??? */
/* 0x09f0 horizlinescan3 ? ??? */
  { 0x09f1, 0x2500 }, /* horizlinescan5 ─ BOX DRAWINGS LIGHT HORIZONTAL */
/* 0x09f2 horizlinescan7 ? ??? */
/* 0x09f3 horizlinescan9 ? ??? */
  { 0x09f4, 0x251c }, /* leftt ├ BOX DRAWINGS LIGHT VERTICAL AND RIGHT */
  { 0x09f5, 0x2524 }, /* rightt ┤ BOX DRAWINGS LIGHT VERTICAL AND LEFT */
  { 0x09f6, 0x2534 }, /* bott ┴ BOX DRAWINGS LIGHT UP AND HORIZONTAL */
  { 0x09f7, 0x252c }, /* topt ┬ BOX DRAWINGS LIGHT DOWN AND HORIZONTAL */
  { 0x09f8, 0x2502 }, /* vertbar │ BOX DRAWINGS LIGHT VERTICAL */
  { 0x0aa1, 0x2003 }, /* emspace   EM SPACE */
  { 0x0aa2, 0x2002 }, /* enspace   EN SPACE */
  { 0x0aa3, 0x2004 }, /* em3space   THREE-PER-EM SPACE */
  { 0x0aa4, 0x2005 }, /* em4space   FOUR-PER-EM SPACE */
  { 0x0aa5, 0x2007 }, /* digitspace   FIGURE SPACE */
  { 0x0aa6, 0x2008 }, /* punctspace   PUNCTUATION SPACE */
  { 0x0aa7, 0x2009 }, /* thinspace   THIN SPACE */
  { 0x0aa8, 0x200a }, /* hairspace   HAIR SPACE */
  { 0x0aa9, 0x2014 }, /* emdash — EM DASH */
  { 0x0aaa, 0x2013 }, /* endash – EN DASH */
/* 0x0aac signifblank ? ??? */
  { 0x0aae, 0x2026 }, /* ellipsis … HORIZONTAL ELLIPSIS */
/* 0x0aaf doubbaselinedot ? ??? */
  { 0x0ab0, 0x2153 }, /* onethird ⅓ VULGAR FRACTION ONE THIRD */
  { 0x0ab1, 0x2154 }, /* twothirds ⅔ VULGAR FRACTION TWO THIRDS */
  { 0x0ab2, 0x2155 }, /* onefifth ⅕ VULGAR FRACTION ONE FIFTH */
  { 0x0ab3, 0x2156 }, /* twofifths ⅖ VULGAR FRACTION TWO FIFTHS */
  { 0x0ab4, 0x2157 }, /* threefifths ⅗ VULGAR FRACTION THREE FIFTHS */
  { 0x0ab5, 0x2158 }, /* fourfifths ⅘ VULGAR FRACTION FOUR FIFTHS */
  { 0x0ab6, 0x2159 }, /* onesixth ⅙ VULGAR FRACTION ONE SIXTH */
  { 0x0ab7, 0x215a }, /* fivesixths ⅚ VULGAR FRACTION FIVE SIXTHS */
  { 0x0ab8, 0x2105 }, /* careof ℅ CARE OF */
  { 0x0abb, 0x2012 }, /* figdash ‒ FIGURE DASH */
  { 0x0abc, 0x2329 }, /* leftanglebracket 〈 LEFT-POINTING ANGLE BRACKET */
  { 0x0abd, 0x002e }, /* decimalpoint . FULL STOP */
  { 0x0abe, 0x232a }, /* rightanglebracket 〉 RIGHT-POINTING ANGLE BRACKET */
/* 0x0abf marker ? ??? */
  { 0x0ac3, 0x215b }, /* oneeighth ⅛ VULGAR FRACTION ONE EIGHTH */
  { 0x0ac4, 0x215c }, /* threeeighths ⅜ VULGAR FRACTION THREE EIGHTHS */
  { 0x0ac5, 0x215d }, /* fiveeighths ⅝ VULGAR FRACTION FIVE EIGHTHS */
  { 0x0ac6, 0x215e }, /* seveneighths ⅞ VULGAR FRACTION SEVEN EIGHTHS */
  { 0x0ac9, 0x2122 }, /* trademark ™ TRADE MARK SIGN */
  { 0x0aca, 0x2613 }, /* signaturemark ☓ SALTIRE */
/* 0x0acb trademarkincircle ? ??? */
  { 0x0acc, 0x25c1 }, /* leftopentriangle ◁ WHITE LEFT-POINTING TRIANGLE */
  { 0x0acd, 0x25b7 }, /* rightopentriangle ▷ WHITE RIGHT-POINTING TRIANGLE */
  { 0x0ace, 0x25cb }, /* emopencircle ○ WHITE CIRCLE */
  { 0x0acf, 0x25a1 }, /* emopenrectangle □ WHITE SQUARE */
  { 0x0ad0, 0x2018 }, /* leftsinglequotemark ‘ LEFT SINGLE QUOTATION MARK */
  { 0x0ad1, 0x2019 }, /* rightsinglequotemark ’ RIGHT SINGLE QUOTATION MARK */
  { 0x0ad2, 0x201c }, /* leftdoublequotemark “ LEFT DOUBLE QUOTATION MARK */
  { 0x0ad3, 0x201d }, /* rightdoublequotemark ” RIGHT DOUBLE QUOTATION MARK */
  { 0x0ad4, 0x211e }, /* prescription ℞ PRESCRIPTION TAKE */
  { 0x0ad6, 0x2032 }, /* minutes ′ PRIME */
  { 0x0ad7, 0x2033 }, /* seconds ″ DOUBLE PRIME */
  { 0x0ad9, 0x271d }, /* latincross ✝ LATIN CROSS */
/* 0x0ada hexagram ? ??? */
  { 0x0adb, 0x25ac }, /* filledrectbullet ▬ BLACK RECTANGLE */
  { 0x0adc, 0x25c0 }, /* filledlefttribullet ◀ BLACK LEFT-POINTING TRIANGLE */
  { 0x0add, 0x25b6 }, /* filledrighttribullet ▶ BLACK RIGHT-POINTING TRIANGLE */
  { 0x0ade, 0x25cf }, /* emfilledcircle ● BLACK CIRCLE */
  { 0x0adf, 0x25a0 }, /* emfilledrect ■ BLACK SQUARE */
  { 0x0ae0, 0x25e6 }, /* enopencircbullet ◦ WHITE BULLET */
  { 0x0ae1, 0x25ab }, /* enopensquarebullet ▫ WHITE SMALL SQUARE */
  { 0x0ae2, 0x25ad }, /* openrectbullet ▭ WHITE RECTANGLE */
  { 0x0ae3, 0x25b3 }, /* opentribulletup △ WHITE UP-POINTING TRIANGLE */
  { 0x0ae4, 0x25bd }, /* opentribulletdown ▽ WHITE DOWN-POINTING TRIANGLE */
  { 0x0ae5, 0x2606 }, /* openstar ☆ WHITE STAR */
  { 0x0ae6, 0x2022 }, /* enfilledcircbullet • BULLET */
  { 0x0ae7, 0x25aa }, /* enfilledsqbullet ▪ BLACK SMALL SQUARE */
  { 0x0ae8, 0x25b2 }, /* filledtribulletup ▲ BLACK UP-POINTING TRIANGLE */
  { 0x0ae9, 0x25bc }, /* filledtribulletdown ▼ BLACK DOWN-POINTING TRIANGLE */
  { 0x0aea, 0x261c }, /* leftpointer ☜ WHITE LEFT POINTING INDEX */
  { 0x0aeb, 0x261e }, /* rightpointer ☞ WHITE RIGHT POINTING INDEX */
  { 0x0aec, 0x2663 }, /* club ♣ BLACK CLUB SUIT */
  { 0x0aed, 0x2666 }, /* diamond ♦ BLACK DIAMOND SUIT */
  { 0x0aee, 0x2665 }, /* heart ♥ BLACK HEART SUIT */
  { 0x0af0, 0x2720 }, /* maltesecross ✠ MALTESE CROSS */
  { 0x0af1, 0x2020 }, /* dagger † DAGGER */
  { 0x0af2, 0x2021 }, /* doubledagger ‡ DOUBLE DAGGER */
  { 0x0af3, 0x2713 }, /* checkmark ✓ CHECK MARK */
  { 0x0af4, 0x2717 }, /* ballotcross ✗ BALLOT X */
  { 0x0af5, 0x266f }, /* musicalsharp ♯ MUSIC SHARP SIGN */
  { 0x0af6, 0x266d }, /* musicalflat ♭ MUSIC FLAT SIGN */
  { 0x0af7, 0x2642 }, /* malesymbol ♂ MALE SIGN */
  { 0x0af8, 0x2640 }, /* femalesymbol ♀ FEMALE SIGN */
  { 0x0af9, 0x260e }, /* telephone ☎ BLACK TELEPHONE */
  { 0x0afa, 0x2315 }, /* telephonerecorder ⌕ TELEPHONE RECORDER */
  { 0x0afb, 0x2117 }, /* phonographcopyright ℗ SOUND RECORDING COPYRIGHT */
  { 0x0afc, 0x2038 }, /* caret ‸ CARET */
  { 0x0afd, 0x201a }, /* singlelowquotemark ‚ SINGLE LOW-9 QUOTATION MARK */
  { 0x0afe, 0x201e }, /* doublelowquotemark „ DOUBLE LOW-9 QUOTATION MARK */
/* 0x0aff cursor ? ??? */
  { 0x0ba3, 0x003c }, /* leftcaret < LESS-THAN SIGN */
  { 0x0ba6, 0x003e }, /* rightcaret > GREATER-THAN SIGN */
  { 0x0ba8, 0x2228 }, /* downcaret ∨ LOGICAL OR */
  { 0x0ba9, 0x2227 }, /* upcaret ∧ LOGICAL AND */
  { 0x0bc0, 0x00af }, /* overbar ¯ MACRON */
  { 0x0bc2, 0x22a4 }, /* downtack ⊤ DOWN TACK */
  { 0x0bc3, 0x2229 }, /* upshoe ∩ INTERSECTION */
  { 0x0bc4, 0x230a }, /* downstile ⌊ LEFT FLOOR */
  { 0x0bc6, 0x005f }, /* underbar _ LOW LINE */
  { 0x0bca, 0x2218 }, /* jot ∘ RING OPERATOR */
  { 0x0bcc, 0x2395 }, /* quad ⎕ APL FUNCTIONAL SYMBOL QUAD (Unicode 3.0) */
  { 0x0bce, 0x22a5 }, /* uptack ⊥ UP TACK */
  { 0x0bcf, 0x25cb }, /* circle ○ WHITE CIRCLE */
  { 0x0bd3, 0x2308 }, /* upstile ⌈ LEFT CEILING */
  { 0x0bd6, 0x222a }, /* downshoe ∪ UNION */
  { 0x0bd8, 0x2283 }, /* rightshoe ⊃ SUPERSET OF */
  { 0x0bda, 0x2282 }, /* leftshoe ⊂ SUBSET OF */
  { 0x0bdc, 0x22a3 }, /* lefttack ⊣ LEFT TACK */
  { 0x0bfc, 0x22a2 }, /* righttack ⊢ RIGHT TACK */
  { 0x0cdf, 0x2017 }, /* hebrew_doublelowline ‗ DOUBLE LOW LINE */
  { 0x0ce0, 0x05d0 }, /* hebrew_aleph א HEBREW LETTER ALEF */
  { 0x0ce1, 0x05d1 }, /* hebrew_bet ב HEBREW LETTER BET */
  { 0x0ce2, 0x05d2 }, /* hebrew_gimel ג HEBREW LETTER GIMEL */
  { 0x0ce3, 0x05d3 }, /* hebrew_dalet ד HEBREW LETTER DALET */
  { 0x0ce4, 0x05d4 }, /* hebrew_he ה HEBREW LETTER HE */
  { 0x0ce5, 0x05d5 }, /* hebrew_waw ו HEBREW LETTER VAV */
  { 0x0ce6, 0x05d6 }, /* hebrew_zain ז HEBREW LETTER ZAYIN */
  { 0x0ce7, 0x05d7 }, /* hebrew_chet ח HEBREW LETTER HET */
  { 0x0ce8, 0x05d8 }, /* hebrew_tet ט HEBREW LETTER TET */
  { 0x0ce9, 0x05d9 }, /* hebrew_yod י HEBREW LETTER YOD */
  { 0x0cea, 0x05da }, /* hebrew_finalkaph ך HEBREW LETTER FINAL KAF */
  { 0x0ceb, 0x05db }, /* hebrew_kaph כ HEBREW LETTER KAF */
  { 0x0cec, 0x05dc }, /* hebrew_lamed ל HEBREW LETTER LAMED */
  { 0x0ced, 0x05dd }, /* hebrew_finalmem ם HEBREW LETTER FINAL MEM */
  { 0x0cee, 0x05de }, /* hebrew_mem מ HEBREW LETTER MEM */
  { 0x0cef, 0x05df }, /* hebrew_finalnun ן HEBREW LETTER FINAL NUN */
  { 0x0cf0, 0x05e0 }, /* hebrew_nun נ HEBREW LETTER NUN */
  { 0x0cf1, 0x05e1 }, /* hebrew_samech ס HEBREW LETTER SAMEKH */
  { 0x0cf2, 0x05e2 }, /* hebrew_ayin ע HEBREW LETTER AYIN */
  { 0x0cf3, 0x05e3 }, /* hebrew_finalpe ף HEBREW LETTER FINAL PE */
  { 0x0cf4, 0x05e4 }, /* hebrew_pe פ HEBREW LETTER PE */
  { 0x0cf5, 0x05e5 }, /* hebrew_finalzade ץ HEBREW LETTER FINAL TSADI */
  { 0x0cf6, 0x05e6 }, /* hebrew_zade צ HEBREW LETTER TSADI */
  { 0x0cf7, 0x05e7 }, /* hebrew_qoph ק HEBREW LETTER QOF */
  { 0x0cf8, 0x05e8 }, /* hebrew_resh ר HEBREW LETTER RESH */
  { 0x0cf9, 0x05e9 }, /* hebrew_shin ש HEBREW LETTER SHIN */
  { 0x0cfa, 0x05ea }, /* hebrew_taw ת HEBREW LETTER TAV */
  { 0x0da1, 0x0e01 }, /* Thai_kokai ก THAI CHARACTER KO KAI */
  { 0x0da2, 0x0e02 }, /* Thai_khokhai ข THAI CHARACTER KHO KHAI */
  { 0x0da3, 0x0e03 }, /* Thai_khokhuat ฃ THAI CHARACTER KHO KHUAT */
  { 0x0da4, 0x0e04 }, /* Thai_khokhwai ค THAI CHARACTER KHO KHWAI */
  { 0x0da5, 0x0e05 }, /* Thai_khokhon ฅ THAI CHARACTER KHO KHON */
  { 0x0da6, 0x0e06 }, /* Thai_khorakhang ฆ THAI CHARACTER KHO RAKHANG */
  { 0x0da7, 0x0e07 }, /* Thai_ngongu ง THAI CHARACTER NGO NGU */
  { 0x0da8, 0x0e08 }, /* Thai_chochan จ THAI CHARACTER CHO CHAN */
  { 0x0da9, 0x0e09 }, /* Thai_choching ฉ THAI CHARACTER CHO CHING */
  { 0x0daa, 0x0e0a }, /* Thai_chochang ช THAI CHARACTER CHO CHANG */
  { 0x0dab, 0x0e0b }, /* Thai_soso ซ THAI CHARACTER SO SO */
  { 0x0dac, 0x0e0c }, /* Thai_chochoe ฌ THAI CHARACTER CHO CHOE */
  { 0x0dad, 0x0e0d }, /* Thai_yoying ญ THAI CHARACTER YO YING */
  { 0x0dae, 0x0e0e }, /* Thai_dochada ฎ THAI CHARACTER DO CHADA */
  { 0x0daf, 0x0e0f }, /* Thai_topatak ฏ THAI CHARACTER TO PATAK */
  { 0x0db0, 0x0e10 }, /* Thai_thothan ฐ THAI CHARACTER THO THAN */
  { 0x0db1, 0x0e11 }, /* Thai_thonangmontho ฑ THAI CHARACTER THO NANGMONTHO */
  { 0x0db2, 0x0e12 }, /* Thai_thophuthao ฒ THAI CHARACTER THO PHUTHAO */
  { 0x0db3, 0x0e13 }, /* Thai_nonen ณ THAI CHARACTER NO NEN */
  { 0x0db4, 0x0e14 }, /* Thai_dodek ด THAI CHARACTER DO DEK */
  { 0x0db5, 0x0e15 }, /* Thai_totao ต THAI CHARACTER TO TAO */
  { 0x0db6, 0x0e16 }, /* Thai_thothung ถ THAI CHARACTER THO THUNG */
  { 0x0db7, 0x0e17 }, /* Thai_thothahan ท THAI CHARACTER THO THAHAN */
  { 0x0db8, 0x0e18 }, /* Thai_thothong ธ THAI CHARACTER THO THONG */
  { 0x0db9, 0x0e19 }, /* Thai_nonu น THAI CHARACTER NO NU */
  { 0x0dba, 0x0e1a }, /* Thai_bobaimai บ THAI CHARACTER BO BAIMAI */
  { 0x0dbb, 0x0e1b }, /* Thai_popla ป THAI CHARACTER PO PLA */
  { 0x0dbc, 0x0e1c }, /* Thai_phophung ผ THAI CHARACTER PHO PHUNG */
  { 0x0dbd, 0x0e1d }, /* Thai_fofa ฝ THAI CHARACTER FO FA */
  { 0x0dbe, 0x0e1e }, /* Thai_phophan พ THAI CHARACTER PHO PHAN */
  { 0x0dbf, 0x0e1f }, /* Thai_fofan ฟ THAI CHARACTER FO FAN */
  { 0x0dc0, 0x0e20 }, /* Thai_phosamphao ภ THAI CHARACTER PHO SAMPHAO */
  { 0x0dc1, 0x0e21 }, /* Thai_moma ม THAI CHARACTER MO MA */
  { 0x0dc2, 0x0e22 }, /* Thai_yoyak ย THAI CHARACTER YO YAK */
  { 0x0dc3, 0x0e23 }, /* Thai_rorua ร THAI CHARACTER RO RUA */
  { 0x0dc4, 0x0e24 }, /* Thai_ru ฤ THAI CHARACTER RU */
  { 0x0dc5, 0x0e25 }, /* Thai_loling ล THAI CHARACTER LO LING */
  { 0x0dc6, 0x0e26 }, /* Thai_lu ฦ THAI CHARACTER LU */
  { 0x0dc7, 0x0e27 }, /* Thai_wowaen ว THAI CHARACTER WO WAEN */
  { 0x0dc8, 0x0e28 }, /* Thai_sosala ศ THAI CHARACTER SO SALA */
  { 0x0dc9, 0x0e29 }, /* Thai_sorusi ษ THAI CHARACTER SO RUSI */
  { 0x0dca, 0x0e2a }, /* Thai_sosua ส THAI CHARACTER SO SUA */
  { 0x0dcb, 0x0e2b }, /* Thai_hohip ห THAI CHARACTER HO HIP */
  { 0x0dcc, 0x0e2c }, /* Thai_lochula ฬ THAI CHARACTER LO CHULA */
  { 0x0dcd, 0x0e2d }, /* Thai_oang อ THAI CHARACTER O ANG */
  { 0x0dce, 0x0e2e }, /* Thai_honokhuk ฮ THAI CHARACTER HO NOKHUK */
  { 0x0dcf, 0x0e2f }, /* Thai_paiyannoi ฯ THAI CHARACTER PAIYANNOI */
  { 0x0dd0, 0x0e30 }, /* Thai_saraa ะ THAI CHARACTER SARA A */
  { 0x0dd1, 0x0e31 }, /* Thai_maihanakat ั THAI CHARACTER MAI HAN-AKAT */
  { 0x0dd2, 0x0e32 }, /* Thai_saraaa า THAI CHARACTER SARA AA */
  { 0x0dd3, 0x0e33 }, /* Thai_saraam ำ THAI CHARACTER SARA AM */
  { 0x0dd4, 0x0e34 }, /* Thai_sarai ิ THAI CHARACTER SARA I */
  { 0x0dd5, 0x0e35 }, /* Thai_saraii ี THAI CHARACTER SARA II */
  { 0x0dd6, 0x0e36 }, /* Thai_saraue ึ THAI CHARACTER SARA UE */
  { 0x0dd7, 0x0e37 }, /* Thai_sarauee ื THAI CHARACTER SARA UEE */
  { 0x0dd8, 0x0e38 }, /* Thai_sarau ุ THAI CHARACTER SARA U */
  { 0x0dd9, 0x0e39 }, /* Thai_sarauu ู THAI CHARACTER SARA UU */
  { 0x0dda, 0x0e3a }, /* Thai_phinthu ฺ THAI CHARACTER PHINTHU */
  { 0x0dde, 0x0e3e }, /* Thai_maihanakat_maitho ฾ ??? */
  { 0x0ddf, 0x0e3f }, /* Thai_baht ฿ THAI CURRENCY SYMBOL BAHT */
  { 0x0de0, 0x0e40 }, /* Thai_sarae เ THAI CHARACTER SARA E */
  { 0x0de1, 0x0e41 }, /* Thai_saraae แ THAI CHARACTER SARA AE */
  { 0x0de2, 0x0e42 }, /* Thai_sarao โ THAI CHARACTER SARA O */
  { 0x0de3, 0x0e43 }, /* Thai_saraaimaimuan ใ THAI CHARACTER SARA AI MAIMUAN */
  { 0x0de4, 0x0e44 }, /* Thai_saraaimaimalai ไ THAI CHARACTER SARA AI MAIMALAI */
  { 0x0de5, 0x0e45 }, /* Thai_lakkhangyao ๅ THAI CHARACTER LAKKHANGYAO */
  { 0x0de6, 0x0e46 }, /* Thai_maiyamok ๆ THAI CHARACTER MAIYAMOK */
  { 0x0de7, 0x0e47 }, /* Thai_maitaikhu ็ THAI CHARACTER MAITAIKHU */
  { 0x0de8, 0x0e48 }, /* Thai_maiek ่ THAI CHARACTER MAI EK */
  { 0x0de9, 0x0e49 }, /* Thai_maitho ้ THAI CHARACTER MAI THO */
  { 0x0dea, 0x0e4a }, /* Thai_maitri ๊ THAI CHARACTER MAI TRI */
  { 0x0deb, 0x0e4b }, /* Thai_maichattawa ๋ THAI CHARACTER MAI CHATTAWA */
  { 0x0dec, 0x0e4c }, /* Thai_thanthakhat ์ THAI CHARACTER THANTHAKHAT */
  { 0x0ded, 0x0e4d }, /* Thai_nikhahit ํ THAI CHARACTER NIKHAHIT */
  { 0x0df0, 0x0e50 }, /* Thai_leksun ๐ THAI DIGIT ZERO */
  { 0x0df1, 0x0e51 }, /* Thai_leknung ๑ THAI DIGIT ONE */
  { 0x0df2, 0x0e52 }, /* Thai_leksong ๒ THAI DIGIT TWO */
  { 0x0df3, 0x0e53 }, /* Thai_leksam ๓ THAI DIGIT THREE */
  { 0x0df4, 0x0e54 }, /* Thai_leksi ๔ THAI DIGIT FOUR */
  { 0x0df5, 0x0e55 }, /* Thai_lekha ๕ THAI DIGIT FIVE */
  { 0x0df6, 0x0e56 }, /* Thai_lekhok ๖ THAI DIGIT SIX */
  { 0x0df7, 0x0e57 }, /* Thai_lekchet ๗ THAI DIGIT SEVEN */
  { 0x0df8, 0x0e58 }, /* Thai_lekpaet ๘ THAI DIGIT EIGHT */
  { 0x0df9, 0x0e59 }, /* Thai_lekkao ๙ THAI DIGIT NINE */
  { 0x0ea1, 0x3131 }, /* Hangul_Kiyeog ㄱ HANGUL LETTER KIYEOK */
  { 0x0ea2, 0x3132 }, /* Hangul_SsangKiyeog ㄲ HANGUL LETTER SSANGKIYEOK */
  { 0x0ea3, 0x3133 }, /* Hangul_KiyeogSios ㄳ HANGUL LETTER KIYEOK-SIOS */
  { 0x0ea4, 0x3134 }, /* Hangul_Nieun ㄴ HANGUL LETTER NIEUN */
  { 0x0ea5, 0x3135 }, /* Hangul_NieunJieuj ㄵ HANGUL LETTER NIEUN-CIEUC */
  { 0x0ea6, 0x3136 }, /* Hangul_NieunHieuh ㄶ HANGUL LETTER NIEUN-HIEUH */
  { 0x0ea7, 0x3137 }, /* Hangul_Dikeud ㄷ HANGUL LETTER TIKEUT */
  { 0x0ea8, 0x3138 }, /* Hangul_SsangDikeud ㄸ HANGUL LETTER SSANGTIKEUT */
  { 0x0ea9, 0x3139 }, /* Hangul_Rieul ㄹ HANGUL LETTER RIEUL */
  { 0x0eaa, 0x313a }, /* Hangul_RieulKiyeog ㄺ HANGUL LETTER RIEUL-KIYEOK */
  { 0x0eab, 0x313b }, /* Hangul_RieulMieum ㄻ HANGUL LETTER RIEUL-MIEUM */
  { 0x0eac, 0x313c }, /* Hangul_RieulPieub ㄼ HANGUL LETTER RIEUL-PIEUP */
  { 0x0ead, 0x313d }, /* Hangul_RieulSios ㄽ HANGUL LETTER RIEUL-SIOS */
  { 0x0eae, 0x313e }, /* Hangul_RieulTieut ㄾ HANGUL LETTER RIEUL-THIEUTH */
  { 0x0eaf, 0x313f }, /* Hangul_RieulPhieuf ㄿ HANGUL LETTER RIEUL-PHIEUPH */
  { 0x0eb0, 0x3140 }, /* Hangul_RieulHieuh ㅀ HANGUL LETTER RIEUL-HIEUH */
  { 0x0eb1, 0x3141 }, /* Hangul_Mieum ㅁ HANGUL LETTER MIEUM */
  { 0x0eb2, 0x3142 }, /* Hangul_Pieub ㅂ HANGUL LETTER PIEUP */
  { 0x0eb3, 0x3143 }, /* Hangul_SsangPieub ㅃ HANGUL LETTER SSANGPIEUP */
  { 0x0eb4, 0x3144 }, /* Hangul_PieubSios ㅄ HANGUL LETTER PIEUP-SIOS */
  { 0x0eb5, 0x3145 }, /* Hangul_Sios ㅅ HANGUL LETTER SIOS */
  { 0x0eb6, 0x3146 }, /* Hangul_SsangSios ㅆ HANGUL LETTER SSANGSIOS */
  { 0x0eb7, 0x3147 }, /* Hangul_Ieung ㅇ HANGUL LETTER IEUNG */
  { 0x0eb8, 0x3148 }, /* Hangul_Jieuj ㅈ HANGUL LETTER CIEUC */
  { 0x0eb9, 0x3149 }, /* Hangul_SsangJieuj ㅉ HANGUL LETTER SSANGCIEUC */
  { 0x0eba, 0x314a }, /* Hangul_Cieuc ㅊ HANGUL LETTER CHIEUCH */
  { 0x0ebb, 0x314b }, /* Hangul_Khieuq ㅋ HANGUL LETTER KHIEUKH */
  { 0x0ebc, 0x314c }, /* Hangul_Tieut ㅌ HANGUL LETTER THIEUTH */
  { 0x0ebd, 0x314d }, /* Hangul_Phieuf ㅍ HANGUL LETTER PHIEUPH */
  { 0x0ebe, 0x314e }, /* Hangul_Hieuh ㅎ HANGUL LETTER HIEUH */
  { 0x0ebf, 0x314f }, /* Hangul_A ㅏ HANGUL LETTER A */
  { 0x0ec0, 0x3150 }, /* Hangul_AE ㅐ HANGUL LETTER AE */
  { 0x0ec1, 0x3151 }, /* Hangul_YA ㅑ HANGUL LETTER YA */
  { 0x0ec2, 0x3152 }, /* Hangul_YAE ㅒ HANGUL LETTER YAE */
  { 0x0ec3, 0x3153 }, /* Hangul_EO ㅓ HANGUL LETTER EO */
  { 0x0ec4, 0x3154 }, /* Hangul_E ㅔ HANGUL LETTER E */
  { 0x0ec5, 0x3155 }, /* Hangul_YEO ㅕ HANGUL LETTER YEO */
  { 0x0ec6, 0x3156 }, /* Hangul_YE ㅖ HANGUL LETTER YE */
  { 0x0ec7, 0x3157 }, /* Hangul_O ㅗ HANGUL LETTER O */
  { 0x0ec8, 0x3158 }, /* Hangul_WA ㅘ HANGUL LETTER WA */
  { 0x0ec9, 0x3159 }, /* Hangul_WAE ㅙ HANGUL LETTER WAE */
  { 0x0eca, 0x315a }, /* Hangul_OE ㅚ HANGUL LETTER OE */
  { 0x0ecb, 0x315b }, /* Hangul_YO ㅛ HANGUL LETTER YO */
  { 0x0ecc, 0x315c }, /* Hangul_U ㅜ HANGUL LETTER U */
  { 0x0ecd, 0x315d }, /* Hangul_WEO ㅝ HANGUL LETTER WEO */
  { 0x0ece, 0x315e }, /* Hangul_WE ㅞ HANGUL LETTER WE */
  { 0x0ecf, 0x315f }, /* Hangul_WI ㅟ HANGUL LETTER WI */
  { 0x0ed0, 0x3160 }, /* Hangul_YU ㅠ HANGUL LETTER YU */
  { 0x0ed1, 0x3161 }, /* Hangul_EU ㅡ HANGUL LETTER EU */
  { 0x0ed2, 0x3162 }, /* Hangul_YI ㅢ HANGUL LETTER YI */
  { 0x0ed3, 0x3163 }, /* Hangul_I ㅣ HANGUL LETTER I */
  { 0x0ed4, 0x11a8 }, /* Hangul_J_Kiyeog ᆨ HANGUL JONGSEONG KIYEOK */
  { 0x0ed5, 0x11a9 }, /* Hangul_J_SsangKiyeog ᆩ HANGUL JONGSEONG SSANGKIYEOK */
  { 0x0ed6, 0x11aa }, /* Hangul_J_KiyeogSios ᆪ HANGUL JONGSEONG KIYEOK-SIOS */
  { 0x0ed7, 0x11ab }, /* Hangul_J_Nieun ᆫ HANGUL JONGSEONG NIEUN */
  { 0x0ed8, 0x11ac }, /* Hangul_J_NieunJieuj ᆬ HANGUL JONGSEONG NIEUN-CIEUC */
  { 0x0ed9, 0x11ad }, /* Hangul_J_NieunHieuh ᆭ HANGUL JONGSEONG NIEUN-HIEUH */
  { 0x0eda, 0x11ae }, /* Hangul_J_Dikeud ᆮ HANGUL JONGSEONG TIKEUT */
  { 0x0edb, 0x11af }, /* Hangul_J_Rieul ᆯ HANGUL JONGSEONG RIEUL */
  { 0x0edc, 0x11b0 }, /* Hangul_J_RieulKiyeog ᆰ HANGUL JONGSEONG RIEUL-KIYEOK */
  { 0x0edd, 0x11b1 }, /* Hangul_J_RieulMieum ᆱ HANGUL JONGSEONG RIEUL-MIEUM */
  { 0x0ede, 0x11b2 }, /* Hangul_J_RieulPieub ᆲ HANGUL JONGSEONG RIEUL-PIEUP */
  { 0x0edf, 0x11b3 }, /* Hangul_J_RieulSios ᆳ HANGUL JONGSEONG RIEUL-SIOS */
  { 0x0ee0, 0x11b4 }, /* Hangul_J_RieulTieut ᆴ HANGUL JONGSEONG RIEUL-THIEUTH */
  { 0x0ee1, 0x11b5 }, /* Hangul_J_RieulPhieuf ᆵ HANGUL JONGSEONG RIEUL-PHIEUPH */
  { 0x0ee2, 0x11b6 }, /* Hangul_J_RieulHieuh ᆶ HANGUL JONGSEONG RIEUL-HIEUH */
  { 0x0ee3, 0x11b7 }, /* Hangul_J_Mieum ᆷ HANGUL JONGSEONG MIEUM */
  { 0x0ee4, 0x11b8 }, /* Hangul_J_Pieub ᆸ HANGUL JONGSEONG PIEUP */
  { 0x0ee5, 0x11b9 }, /* Hangul_J_PieubSios ᆹ HANGUL JONGSEONG PIEUP-SIOS */
  { 0x0ee6, 0x11ba }, /* Hangul_J_Sios ᆺ HANGUL JONGSEONG SIOS */
  { 0x0ee7, 0x11bb }, /* Hangul_J_SsangSios ᆻ HANGUL JONGSEONG SSANGSIOS */
  { 0x0ee8, 0x11bc }, /* Hangul_J_Ieung ᆼ HANGUL JONGSEONG IEUNG */
  { 0x0ee9, 0x11bd }, /* Hangul_J_Jieuj ᆽ HANGUL JONGSEONG CIEUC */
  { 0x0eea, 0x11be }, /* Hangul_J_Cieuc ᆾ HANGUL JONGSEONG CHIEUCH */
  { 0x0eeb, 0x11bf }, /* Hangul_J_Khieuq ᆿ HANGUL JONGSEONG KHIEUKH */
  { 0x0eec, 0x11c0 }, /* Hangul_J_Tieut ᇀ HANGUL JONGSEONG THIEUTH */
  { 0x0eed, 0x11c1 }, /* Hangul_J_Phieuf ᇁ HANGUL JONGSEONG PHIEUPH */
  { 0x0eee, 0x11c2 }, /* Hangul_J_Hieuh ᇂ HANGUL JONGSEONG HIEUH */
  { 0x0eef, 0x316d }, /* Hangul_RieulYeorinHieuh ㅭ HANGUL LETTER RIEUL-YEORINHIEUH */
  { 0x0ef0, 0x3171 }, /* Hangul_SunkyeongeumMieum ㅱ HANGUL LETTER KAPYEOUNMIEUM */
  { 0x0ef1, 0x3178 }, /* Hangul_SunkyeongeumPieub ㅸ HANGUL LETTER KAPYEOUNPIEUP */
  { 0x0ef2, 0x317f }, /* Hangul_PanSios ㅿ HANGUL LETTER PANSIOS */
/* 0x0ef3 Hangul_KkogjiDalrinIeung ? ??? */
  { 0x0ef4, 0x3184 }, /* Hangul_SunkyeongeumPhieuf ㆄ HANGUL LETTER KAPYEOUNPHIEUPH */
  { 0x0ef5, 0x3186 }, /* Hangul_YeorinHieuh ㆆ HANGUL LETTER YEORINHIEUH */
  { 0x0ef6, 0x318d }, /* Hangul_AraeA ㆍ HANGUL LETTER ARAEA */
  { 0x0ef7, 0x318e }, /* Hangul_AraeAE ㆎ HANGUL LETTER ARAEAE */
  { 0x0ef8, 0x11eb }, /* Hangul_J_PanSios ᇫ HANGUL JONGSEONG PANSIOS */
/* 0x0ef9 Hangul_J_KkogjiDalrinIeung ? ??? */
  { 0x0efa, 0x11f9 }, /* Hangul_J_YeorinHieuh ᇹ HANGUL JONGSEONG YEORINHIEUH */
  { 0x0eff, 0x20a9 }, /* Korean_Won ₩ WON SIGN */
  { 0x13bc, 0x0152 }, /* OE Œ LATIN CAPITAL LIGATURE OE */
  { 0x13bd, 0x0153 }, /* oe œ LATIN SMALL LIGATURE OE */
  { 0x13be, 0x0178 }, /* Ydiaeresis Ÿ LATIN CAPITAL LETTER Y WITH DIAERESIS */
  { 0x20a0, 0x20a0 }, /* EcuSign ₠ EURO-CURRENCY SIGN */
  { 0x20a1, 0x20a1 }, /* ColonSign ₡ COLON SIGN */
  { 0x20a2, 0x20a2 }, /* CruzeiroSign ₢ CRUZEIRO SIGN */
  { 0x20a3, 0x20a3 }, /* FFrancSign ₣ FRENCH FRANC SIGN */
  { 0x20a4, 0x20a4 }, /* LiraSign ₤ LIRA SIGN */
  { 0x20a5, 0x20a5 }, /* MillSign ₥ MILL SIGN */
  { 0x20a6, 0x20a6 }, /* NairaSign ₦ NAIRA SIGN */
  { 0x20a7, 0x20a7 }, /* PesetaSign ₧ PESETA SIGN */
  { 0x20a8, 0x20a8 }, /* RupeeSign ₨ RUPEE SIGN */
  { 0x20a9, 0x20a9 }, /* WonSign ₩ WON SIGN */
  { 0x20aa, 0x20aa }, /* NewSheqelSign ₪ NEW SHEQEL SIGN */
  { 0x20ab, 0x20ab }, /* DongSign ₫ DONG SIGN */
  { 0x20ac, 0x20ac }, /* EuroSign € EURO SIGN */
};

/** END KEYSYMTAB **/

#line 1103 "/home/dodo/tmp/gfx-1.2/src/keyboard.u"

static x_keyboard_t *x_keyboard;

#line 19 "/home/dodo/tmp/gfx-1.2/src/focus.u"

static focusable_t *focusables;
static int n_focusables, s_focusables, focussed=-1, focusable_clicked=-1;

#line 31 "/home/dodo/tmp/gfx-1.2/src/textentry.u"

static uint32_t TE_fg        = 0;
static uint32_t TE_bg        = 0xffffff;
static uint32_t TE_cfg       = 0xffffff;
static uint32_t TE_cbg       = 0x000088;


#line 448 "/home/dodo/tmp/gfx-1.2/src/scrollbar.u"

unsigned int gui_scrollbar_width;
unsigned int gui_scrollbar_height;

#line 79 "/home/dodo/tmp/gfx-1.2/src/dropdown.u"

static int dropdown_pad_left    = 2,
           dropdown_pad_right   = 2,
           dropdown_pad_mid     = 2,
           dropdown_dark1       = 0xd5d5d1,
           dropdown_light1      = 0xffffff,
           dropdown_border1     = 0xaaaaa3,
           dropdown_dark2       = 0xffffff,
           dropdown_light2      = 0xd5d5d1,
           dropdown_border2     = 0xaaaaa3,
           dropdown_gradb1      = 0xfcfcfb,
           dropdown_grade1      = 0xdbdbd7,
           dropdown_gradb2      = 0xcccac9,
           dropdown_grade2      = 0xe9e8e7,
           dropdown_list_padv   = 2,
           dropdown_list_spc    = 2,
           dropdown_list_hcolor = 0xFF0088ff,
           dropdown_list_border = 0xcccac9;

#line 20 "/home/dodo/tmp/gfx-1.2/src/menu-fw.u"

static uint32_t  fwmenu_bg_color= 0xffffff,
                 fwmenu_sep_color= 0x888888,
                 fwmenu_fg_color= 0x000000,
                 fwmenu_scrpad= 20,
                 fwmenu_intpad= 5;

#line 24 "/home/dodo/tmp/gfx-1.2/src/screen.u"

static screen_t *screens;
static int n_screen, s_screen;
static int click_handler_start; /// from now on, the click handler
                                //  will only look at handlers beyond
                                //  this entry.
#line 151 "/home/dodo/tmp/gfx-1.2/src/list.u"

static int gui_list_pad_horz= 2,
           gui_list_pad_vert= 2,
           gui_list_icontext_sep= 2,
           gui_list_spacing= 2,
           gui_list_border= 0x888888;

#line 7054 "gfx.c"

static void init_gsdata();
static void gfx_invert_hline(int x1,int x2, int y);
static void gfx_invert_vline(int x,int y1, int y2);
static uint32_t blend_usr_usr(uint32_t alpha, uint32_t fg, uint32_t bg);
static uint32_t blend_usr_usr_usr(uint32_t alpha, uint32_t fg, uint32_t bg);
static uint32_t blend_usr_svr(uint32_t alpha, uint32_t fg, uint32_t bg);
static void blend_graymap(int flags, int fg, int bg,
                          unsigned char *src, int src_w, int src_h,
                          int src_x, int src_y,
                          int dst_x, int dst_y, int width, int height);
static uint32_t color_s(uint32_t uR, uint32_t uG, uint32_t uB);
static uint32_t u_red(uint32_t C) ;
static uint32_t u_green(uint32_t C) ;
static uint32_t u_blue(uint32_t C) ;
static uint32_t color_u_to_s(uint32_t U);
static unsigned int blend_chan(unsigned int F, double A, unsigned int B);
static unsigned int blend(uint32_t F, double A, uint32_t B);
static void grad_fill(int x,int y, int w, int h, uint32_t start, uint32_t end);
static void hline(int x1,int x2, int y,uint32_t color);
static void vline(int x,int y1, int y2,uint32_t color);
static uint32_t *get_server_pix(int src_x,int src_y,int w,int h);
static void put_server_pix(uint32_t *D,int dst_x,int dst_y,int w, int h);
static void gradfill_left(uint32_t *dst, int dst_w, int dst_h,
                          uint32_t start, uint32_t end,
                          int fill_x, int fill_y,
                          int fill_w, int fill_h);
static void gradfill_top(uint32_t *dst, int dst_w, int dst_h,
                          uint32_t start, uint32_t end,
                          int fill_x, int fill_y,
                          int fill_w, int fill_h);
static void hline_buffer(uint32_t *dst, int dst_w, int dst_h,
                         int x0, int x1, int y, uint32_t color);
static void vline_buffer(uint32_t *dst, int dst_w, int dst_h,
                         int x, int y0, int y1, uint32_t color);
static void shadow_box(uint32_t *dst, int dst_w, int dst_h,
                       uint32_t light, uint32_t dark, uint32_t border,
                       int box_x, int box_y, int box_w, int box_h);
static void blend_graymap_buffer
        (unsigned int fg, unsigned char *src, int src_w, int src_h,
                          int src_x, int src_y,
                          unsigned int *dst, int dst_w, int dst_h,
                          int dst_x, int dst_y, int width, int height);
static void get_text_data(int font, char *str, 
                          int *Rw, int *Rh,int *Ra,unsigned char **Rd);
static int install_click_handler
        (int x,int y,int w,int h,int *enabled,
         void *arg, int (*func)(void*,gfx_event_t*));
static int install_click2_handler
        (int x,int y,int w,int h,int *enabled,
         void *arg, int (*func)(void*,gfx_event_t*),int button);
static void install_release_handler
        (void *arg, int (*func)(void*,gfx_event_t*));
static void install_motion_handler(void *arg,int (*func)(void *,gfx_event_t*));
static void uninstall_motion_handler();
static int handle_click_event(gfx_event_t *event);
static int handle_release_event(gfx_event_t *event);
static int handle_motion_event(gfx_event_t *event);
static int handle_grabbed_event(gfx_event_t *event);
static void grab_mouse(int (*func)(void*,gfx_event_t*), void *arg);
static void ungrab_mouse();
static int register_widget(void *A,int type,int x,int y,int w,int h);
static void *get_widget(int number, int type);
static void widget_destroy(int number);
static void init_button_colors();
static void button_render(int x,int y,int w,int h,
                              int tw, int th, unsigned char *data,
                              uint32_t grad1, uint32_t grad2,
                              uint32_t light, uint32_t dark);
static void button_set_state(gui_button_t *B, int state);
static int gui_button_click(void *arg, gfx_event_t *event);
static int gui_button_release(void *arg, gfx_event_t *event);
static void draw_label(int flags, gui_label_t *G, char *str);
static void checker_pattern(ximage_t *img,int N);
static void *grow_array(int N, int *S, void *ptr, size_t eltsiz);
static int range_test(int v, int s, int w) ;
static int imin2(int a,int b) ;
static int imax2(int a,int b) ;
static int imin3(int a,int b,int c) ;
static int imax3(int a,int b,int c) ;
static double dmin2(double a,double b) ;
static double dmax2(double a,double b) ;
static int utf8_encode_string
    (const uint32_t* wstr,size_t wlen, uint8_t *dst, size_t *dlen);
static uint32_t utf8_decode_single_char(char *src);
static void utf8_encode_single_char(uint32_t wide, char *dst);
static void utf8_decode_alloc(char *str, uint32_t **Rwstr, uint32_t *Rwlen);
static void clip_for_rect(int *start, int *amount, int max);
static void freeNnull(void *A);
static int gfx_recsel_event(XEvent *event);
static void draw_recsel();
static x_keyboard_t *x_keyboard_init(Window window);
static void x_keyboard_free(x_keyboard_t *xk);
static void get_xim();
static int x_keyboard_event
             (x_keyboard_t *xk, XEvent *ev, gfx_event_t *Revent);
static uint32_t keysym2ucs(KeySym keysym);
 
static int lookup_key(KeySym sym, unsigned int modifiers);
static void new_focusable(int x,int y,int w,int h, void *arg,
                          int (*keyhandler)(void *,gfx_event_t*),
                          void (*focus)(void *,int),int getfocus);
static int focusable_event(gfx_event_t *event);
static int focusable_handle_key(focusable_t *F, gfx_event_t *event);
static void set_focus(int f);
static text_entry_t *text_entry_init
    (int flags,int x,int y, int w, int h, char *initstr);
static void make_cursor_visible(int flags,text_entry_t *te, int redraw);
static void render_te(int flags,text_entry_t *te);
static void mk_glyph(glyph_t *G, uint32_t chr);
static int draw_glyph(text_entry_t  *te, int gn, int expose);
static void textentry_focus(void *va, int focus);
static int textentry_key(void* va, gfx_event_t *event) ;
static void move_cursor(text_entry_t *te, int newcurs);
static void insert_char(text_entry_t *te, uint32_t chr);
static void delete_cursor_char(text_entry_t *te);
static void text_entry_free(text_entry_t *te);
static void text_entry_set(int flags,text_entry_t *te, char *str);
static void scrollbar_compute_trough(gui_scrollbar_t *SB);
static void scrollbar_compute_button(gui_scrollbar_t *SB);
static void fill_with_horizontal_gradient
             (int x0,int y0, int y1,
                    unsigned int *graD, int graW, int graH);
static void three_part_assembly_vertical
    (int x0,int y0, int y1,
                    unsigned int *topD, int topW, int topH,
                    unsigned int *midD, int midW, int midH,
                    unsigned int *botD, int botW, int botH);
static void fill_with_vertical_gradient
             (int x0, int x1, int y0,
                    unsigned int *graD, int graW, int graH);
static void three_part_assembly_horizontal
    (int x0, int x1, int y0,
                    unsigned int *lefD, int lefW, int lefH,
                    unsigned int *midD, int midW, int midH,
                    unsigned int *rigD, int rigW, int rigH);
static void scrollbar_draw_trough(gui_scrollbar_t *SB);
static void scrollbar_draw_stepper(gui_scrollbar_t *SB, int sno, int state);
static void scrollbar_draw_all(gui_scrollbar_t *SB);
static void scrollbar_position_buttons
   (gui_scrollbar_t *SB,int x,int y,int w,int h);
static gui_scrollbar_t* new_scrollbar
                          (int flags, int x,int y, int w,int h,
                           double start, double end, double step,
                           int action, void *reportarg, void *reportfunc);
static int scrollbar_click_up(void *A, gfx_event_t *E);
static int scrollbar_release_up(void *A, gfx_event_t *event);
static void scrollbar_update(gui_scrollbar_t *SB);
static int scrollbar_set
    (gui_scrollbar_t *SB,double S, double E, int report, gfx_event_t* event);
static void scrollbar_set_noupdate
    (gui_scrollbar_t *SB,double S, double E, double step);
static int scrollbar_click_down(void *A, gfx_event_t *E);
static int scrollbar_release_down(void *A, gfx_event_t *event);
static int scrollbar_click_tro(void *A,gfx_event_t *event);
static int scrollbar_move_pointer(void *A, gfx_event_t *event);
static int scrollbar_release_tro(void *A, gfx_event_t *E);
static void scrollbar_relayout
   (gui_scrollbar_t *SB, int nx, int ny, int nw,int nh,
    double start, double end, double step);
static void scrollbar_destroy(gui_scrollbar_t *SB);
static void disable_click_handler(int hno);
static void dropdown_render(dropdown_t *DD, int p,uint32_t *dst, int W,int H);
static int dropdown_click(void *arg, gfx_event_t* event);
static int dropdown_release(void *arg, gfx_event_t *event);
static void dropdown_show_list(dropdown_t *DD);
static void dropdown_draw_listbg(dropdown_t *DD);
static void dropdown_get_list_backup(dropdown_t *DD);
static void dropdown_put_list_backup(dropdown_t *DD);
static void dropdown_draw_contents(dropdown_t *DD);
static int dropdown_draw_item(dropdown_t *DD,int idx);
static void print_clipped(int Cx,int Cy,int Cw,int Ch,
                          int x, int y, int font, const char* str);
static int dropdown_item_pos(dropdown_t *DD,int item);
static void dropdown_draw_listframe(dropdown_t *DD,int which);
static void dropdown_scroll(dropdown_t *DD,double S,double E);
static int dropdown_mouse(dropdown_t *DD, gfx_event_t *event);
static int in_rect(int rx,int ry,int rw,int rh, int x,int y);
static void dropdown_hide_list(dropdown_t *DD);
static void dropdown_render_images(dropdown_t *DD);
static void dropdown_scroll_to(dropdown_t *DD,int pos,int report);
static int dropdown_item_at(dropdown_t *DD,int y);
static void dropdown_hilight_item(dropdown_t *DD, int item);
static void fill_clipped_rect
               (int Cx,int Cy,int Cw, int Ch, 
                int dx,int dy,int ow, int oh, unsigned int color);
static void dropdown_destroy(dropdown_t *DD);
static void compute_list_items
    (gui_list_t* LL, int start, int end);
static void compute_list_content_size(gui_list_t *LL,int *Rw, int *Rh);
static int list_max_icon_width(gui_list_t *LL);
static void compute_list_port
  (gui_list_t* LL, int *Rportw, int *Rporth, int *Rhs, int *Rvs);
static int list_render_item(gui_list_t *LL,int ino,int bg);
static void gui_list_scrollbar_click_horz(void *a, double S, double E);
static void gui_list_scrollbar_click_vert(void *a, double S, double E);
static void list_layout_items(gui_list_t *LL,int start);
static void list_draw_borders(gui_list_t *LL,int which);
static void list_draw_contents(gui_list_t *L);
static void list_compute_scroll
    (int pos,int win,int con, double *Rstart, double *Rend, double *Rstep);
static void list_arrange_scrollbars
   (gui_list_t *LL, int have_horz, int have_vert);
static int gui_list_click(void *a, gfx_event_t *ev);
  static int gui_list_click4(void *a, gfx_event_t *ev);
  static int gui_list_click5(void *a, gfx_event_t *ev);
static void list_relayout(int flags, gui_list_t *L);
 
#line 47 "/home/dodo/tmp/gfx-1.2/src/basics.u"

static Display *x_display;
static Window   x_root_window;
static int      x_screen_number;
static uint32_t x_root_width, x_root_height;
static uint32_t x_red_mask, x_red_shift,
                x_green_mask, x_green_shift,
                x_blue_mask, x_blue_shift;
static int      x_depth;
static Visual  *x_visual;

static int      x_window;
static Pixmap   x_pixmap;
static int      x_window_width, x_window_height;

static int      exposock=-1;
static pid_t    expopid;
static  Atom    wm_protocols, wm_delete_window;



static int fork_exposure_process();
static int send_child_params(Window window, Pixmap pixmap,
                             int width, int height);
static void init_button_colors();


static int       can_use_shared_images();
static ximage_t *ximage_create_simple(uint32_t width,uint32_t height);
static ximage_t *create_image(uint32_t width, uint32_t height);
static void      destroy_image(ximage_t *image);
static void      put_image(Drawable draw, int dest_x, int dest_y,
                           ximage_t *image, int src_x, int src_y,
                           int width, int height);

static void checker_pattern(ximage_t *img,int N);
static int gfx_recsel_event(XEvent *event);



/***********************************************************************
  We have only one image.
 ***********************************************************************/
static ximage_t *x_image;
static uint32_t **x_image_data;

/***********************************************************************
  In order to create images etc, we need to find a suitable visual 
  with depth==24 or depth==32.
 ***********************************************************************/

static uint32_t trailing_zero_bits(uint32_t Y)
{
  uint32_t shif;
  for(shif=0;Y%2==0;shif++) Y= Y>>1;
  return shif;
}

static int get_x_visual()
{
  int depth, ndepths, i;
  int *depths;
  XVisualInfo xvinfo;

  depths= XListDepths(x_display, x_screen_number, &ndepths);
  if (!depths) 
  {
    fprintf(stderr,"can't get depth list for display\n");
    return 1;
  }

  depth=0;
  for(i=0;i<ndepths;i++)
    if (depths[i]==32 || depths[i]==24)
    {
      depth= depths[i];
      break;
    }
  XFree(depths);

  if (!depth)
  {
    fprintf(stderr, "display doesn't support 24 or 32 bit depth.\n");
    return 1;
  }

  x_depth= depth;
  x_visual= NULL;
  if (XMatchVisualInfo(x_display, x_screen_number, depth, TrueColor,&xvinfo))
     x_visual= xvinfo.visual;
  else if (XMatchVisualInfo(x_display, x_screen_number,
                                       depth, DirectColor,&xvinfo))
     x_visual= xvinfo.visual;
  else
  {
    fprintf(stderr,"can't find a 24 or 32 bit TrueColor/DirectColor visual\n");
    return 1;
  }
  x_red_mask= x_visual->red_mask;
  x_red_shift= trailing_zero_bits(x_red_mask);
  x_green_mask= x_visual->green_mask;
  x_green_shift= trailing_zero_bits(x_green_mask);
  x_blue_mask= x_visual->blue_mask;
  x_blue_shift= trailing_zero_bits(x_blue_mask);
  return 0;
}

static Window create_window(char *title,int width, int height)
{
  int                  x,y;
  Window               window;
  XSetWindowAttributes attribs;
  XTextProperty        title_prop;
  XSizeHints          *size;

  x= (x_root_width-width)/2;
  y= (x_root_height-height)/2;

  attribs.background_pixmap= None;

  window= XCreateWindow(x_display, x_root_window,
                        x, y, width, height,
                        1, x_depth, InputOutput, x_visual, 
                        CWBackPixmap, &attribs);

  if (XStringListToTextProperty(&title, 1, &title_prop))
  {
    XSetWMName(x_display, window, &title_prop);
  }
  size= XAllocSizeHints();
  size->flags= PMinSize | PMaxSize;
  size->min_width= size->max_width= width;
  size->min_height= size->max_height= height;
  XSetWMNormalHints(x_display,window, size);

  unsigned long protos[4];

  wm_protocols= XInternAtom(x_display, "WM_PROTOCOLS", False);
  wm_delete_window= XInternAtom(x_display, "WM_DELETE_WINDOW", False);
  protos[0]= wm_delete_window;
  protos[1]= 0;
 
  XChangeProperty(x_display, window, wm_protocols, XA_ATOM, 32,
                  PropModeReplace, (unsigned char*)protos, 1);

  XFlush(x_display);
  XFree(size);

  return window;
}

static void get_root_attribs()
{
  x_screen_number= DefaultScreen(x_display);
  x_root_window= DefaultRootWindow(x_display);
  x_root_width= DisplayWidth(x_display, x_screen_number);
  x_root_height= DisplayHeight(x_display, x_screen_number);
}


int gfx_init(char *name, int width, int height, char *title)
{
  int y;
  fork_exposure_process();
  x_display= XOpenDisplay(name);

  if (!x_display) 
  {
    //FIXME: log this
    fprintf(stderr,"can't open display\n");
    return 1;
  }
  get_root_attribs();
  if (get_x_visual())
  {
    XCloseDisplay(x_display);
    x_display= NULL;
    return 1;
  }
  x_window= create_window(title,width, height);
  XSelectInput(x_display, x_window, PointerMotionMask | KeyPressMask |
                                    ButtonPressMask |
                                    ButtonReleaseMask);

  x_pixmap= XCreatePixmap(x_display, x_window, width, height, x_depth);
  x_image= create_image(width, height);

  x_image_data= malloc(sizeof(uint32_t*) * height);
  for(y=0;y<height;y++)
    x_image_data[y]= (uint32_t*) ((char*) x_image->data + y*x_image->bpl);
  checker_pattern(x_image, 17);
  send_child_params(x_window,x_pixmap, width, height);
  x_window_width= width;
  x_window_height= height;
  init_button_colors();
  init_gsdata();
  gfx_update_all();
#line 1107 "/home/dodo/tmp/gfx-1.2/src/keyboard.u"

  x_keyboard= x_keyboard_init(x_window);

#line 457 "/home/dodo/tmp/gfx-1.2/src/scrollbar.u"

  gui_scrollbar_width= GSWscr_up;
  gui_scrollbar_height= GSHscr_left;

#line 245 "/home/dodo/tmp/gfx-1.2/src/basics.u"
  XMapWindow(x_display, x_window);
  return 0;
}


/***********************************************************************
 *                                                                     *
 *                           Image Functions                           *
 *                                                                     *
 ***********************************************************************/

static ximage_t *create_image(uint32_t width, uint32_t height)
{
  ximage_t *image;
  size_t data_size;
  struct shmid_ds dummy_shmid_ds;

  if (!can_use_shared_images()) goto fail_nolib;

  image= calloc(1,sizeof(*image));
  image->width= width;
  image->height= height;
  image->shared= 1;

  // Create the image on the server
  //
  image->x11image= XShmCreateImage(x_display,x_visual, x_depth, ZPixmap,
                                   NULL, &image->shminfo, width, height);
  if (!image->x11image) goto fail_create;

  image->bpl= image->x11image->bytes_per_line;
  data_size= height*image->bpl;

  // Create the shared memory area
  //
  image->shminfo.shmid= shmget(IPC_PRIVATE, data_size, IPC_CREAT | 0777);
  if (image->shminfo.shmid <0)
  {
    fprintf(stderr,"can't shmget shared memory\n");
    goto fail_shmcreate;
  }
  
  image->shminfo.shmaddr= shmat(image->shminfo.shmid,0,0);
   // we remove the ID now, so that when the program exits, the memory
   // will be automatically freed
   //
  shmctl(image->shminfo.shmid, IPC_RMID, &dummy_shmid_ds); 
  if (image->shminfo.shmaddr==(char*) -1) 
  {
    fprintf(stderr,"can't attach shared memory\n");
    goto fail_shmat;
  }

  // bind the area to the image 
  //
  image->data= (uint32_t*) image->shminfo.shmaddr;
  image->x11image->data= (char*) image->shminfo.shmaddr;
  if (!XShmAttach(x_display, &image->shminfo)) 
  {
    fprintf(stderr,"couldn't attach shared memory to the ximage\n");
    goto fail_attach_x;
  }

  return image;

fail_attach_x:
  shmdt(image->shminfo.shmaddr);
fail_shmat:      // We have already removed the ID
fail_shmcreate:
  XDestroyImage(image->x11image);
fail_create:
  free(image);
fail_nolib:
  return ximage_create_simple(width,height);
}



static ximage_t *ximage_create_simple(uint32_t width,uint32_t height)
{
  ximage_t *image;

  image= calloc(1,sizeof(*image));
  image->width= width;
  image->height= height;
  image->data= malloc(sizeof(uint32_t)*width*height);

  image->x11image= XCreateImage(x_display, x_visual, x_depth,
                                ZPixmap, 0, (char*) image->data,
                                width, height, 32, width*sizeof(uint32_t));
      // FIXME: error checking??
  image->bpl= image->x11image->bytes_per_line;
  image->shared= 0;
  return image;
}

/****************************************************************************
 ***************************************************************************/

static void destroy_image(ximage_t *image)
{
  XSync(x_display, False);
  if (image->shared) 
    XShmDetach(x_display, &image->shminfo);
  XDestroyImage(image->x11image);
  if (image->shared)
    shmdt(image->shminfo.shmaddr);
  free(image);
}


/************************************************************
  Putting an image on the screen is also handled differently
  for shared and non-shared images.
 ***********************************************************/

static void put_image(Drawable draw, int dest_x, int dest_y,
               ximage_t *image, int src_x, int src_y,
               int width, int height)
{
  if (src_x >= image->width ) return ;
  if (src_y >= image->height ) return ;
  if (src_x<0) { width+= src_x; src_x= 0; }
  if (src_y<0) { height+= src_y; src_y= 0; }
  
  if (width + src_x> image->width)  width= image->width-src_x;
  if (height+ src_y> image->height) height= image->height-src_y;

  if (image->shared)
    XShmPutImage(x_display, draw, DefaultGC(x_display,0),
      image->x11image, src_x, src_y, dest_x, dest_y,
      width, height, False);
  else
    XPutImage(x_display, draw, DefaultGC(x_display,0),
      image->x11image, src_x, src_y, dest_x, dest_y,
      width, height);
}

/*******************************************************
  Images in X11 can be in shared memory if the server 
  supports the "MIT-SHM" extension.
 ******************************************************/
static int can_use_shared_images()
{
  static int tried;
  static int can;
  if (!tried)
  {
    int ignore, major, minor;
    Bool pixmaps;
    tried= 1;
    can= XQueryExtension(x_display, "MIT-SHM", &ignore, &ignore, &ignore)
         && XShmQueryVersion(x_display, &major, &minor, &pixmaps);
  }
  return can;
}


/***********************************************************************
 *                                                                     *
 *                               EVENTS                                *
 *                                                                     *
 ***********************************************************************
  Exposures should be handled in a separate thread which frees up the
  main control flow to do whatever it pleases until it decides to act
  upon some events.

  I can do the following: handle events retrieval and painting by one
  thread and pass unhandled events to the main thread. When we're dealing
  with the display, disable this events thread and do your X11 calls.
  After you're done, enable it again.

  This is quite a bit of code which I don't really need. There are other
  options:

  - enabling the backing store: this isn't guaranteed to work. As I
    understand it, it's meant as an optimization which can be dropped
    any time the X server wishes to.
    (http://tronche.com/gui/x/xlib/window/attributes/backing-store.html)

  - using the background pixmap: this isn't guaranteed either. The
    X server is allowed to make a copy of the pixmap and updates to
    the original pixmap isn't necessarily propagated.
    (http://tronche.com/gui/x/xlib/window/attributes/background.html)

  - using a different connection object: this can be done. Either in
    a separate thread or a separate process. I'm leaning towards the
    process option since I don't know how well the Xlib works with
    multiple threads accessing multiple connections. Here is an excerpt
    from 
                   http://www.remlab.net/op/xlib.shtml

                  Multiple displays

       But first, a well behaved X11 error handler needs to check which
       Display generated the error, because the Xlib error handler is
       set per process, not per display. In the good old days, most
       applications could assume that they had only one display in
       their process space. The main user interface toolkit, e.g. Qt,
       GTK, would create the only display connection. But this is not
       so true anymore:

       Media frameworks such as LibVLC or gstreamer need to create their
       own displays for rendering, Rendering libraries like Cairo, EGL,
       SDL also create their own connection, Even non-graphical libraries
       like PulseAudio or D-Bus create short-lived display connections
       to identify the session that they run in, and connect to the
       right instance of the corresponding daemon.

       And then, the error handler need to pass the error down to the
       previous error handler that might have been registered by another
       component, as returned by XSetErrorHandler() earlier.

       If you are smart and fast, you might already have found a major
       flaw. To unregister an error handler, XSetErrorHandler() is called
       a second time with the previous return value as parameter, just
       like with the POSIX signal() function. And just like POSIX signal
       handlers, this cannot work unless the handlers are unregistered
       in the exact reverse order that they were registered.

                  Multiple threads

       The error handling functions are atomic, or at least can be
       configured to behave so. Even then, the error events are not
       locked. Therefore, there is always a risk that an error in one
       thread triggers an undefined situation in the error handler of
       another thread. If you think this might still work, I humbly advise
       that you refresh your knowledge on the topic of the POSIX threaded
       memory model, until you understand why it cannot operate safely.

       As the VLC bug master, I can tell that has been one of the worse
       crash source on VLC for GNU/Linux. Fortunately, we have now fixed
       the problem: We got rid of Xlib and used XCB wherever we needed
       X11 error handling. And if multiple threads are involved, there
       is more-or-less no safe way to an error handler at all.

                  Consequences

       If XInitThreads() is not called anywhere in a multi-tasked program,
       the program will usually work. But weird crashes and other race
       conditions are bound to happen over time, as Xlib maintains some
       global data that is shared across all threads and all "displays".

       If XInitThreads() is called too late, then the process will crash,
       but only some time later in obscure ways. In my experience, the
       most common case is for the process to hit a segmentation fault
       within XCloseDisplay(), which usually happens at exit.
   
   So, I should better do the process thing. The main process will create
   a pixmap and then send its ID. The exposure process will select the
   ExposureMask on the window and do its stuff. 

   It would make more sense if I had used shared pixmaps instead of 
   shared images. Right now, there are two copies: from image to pixmap
   and then pixmap to window. Later on maybe I can do that, but I don't
   need it right now.
 ************************************************************************/


/***********************************************************************
   The following forks a process and starts waiting for a window and a
   pixmap from the main process.
 ***********************************************************************/


static void child_loop();

static int fork_exposure_process()
{
  int fd[2]; 
  if (socketpair(AF_UNIX, SOCK_STREAM, 0, fd)) 
  {
    fprintf(stderr,"socketpair failed: %s\n",strerror(errno));
    return 1;
  }
  signal(SIGCHLD, SIG_IGN);
  expopid= fork();
  if (expopid==-1)
  {
    fprintf(stderr,"fork failed: %s\n",strerror(errno));
    close(fd[0]);
    close(fd[1]);
    return 1;
  }
  if (!expopid)
  {
    close(fd[1]);
    exposock= fd[0];
    child_loop();
  }
  close(fd[0]);
  exposock=fd[1];
  return 0;
}


/***********************************************************************
  We communicate exactly once during the whole thing. We just get the
  window ID and the pixmap ID and then go to work. If the window was
  resizable, we'd create a new pixmap and send that to the child process
  as well, but this is not necessary right now. The data is encoded as:
 ***********************************************************************/
typedef struct
{
  Window window;
  Pixmap pixmap;
  int width,height;
} gfx_child_params_t;

static int send_child_params(Window window, Pixmap pixmap,
                             int width, int height)
{
  gfx_child_params_t cp;
  char *buf;
  int len,R;

  if (exposock==-1) return 1;
  cp.window= window;
  cp.pixmap= pixmap;
  cp.width= width;
  cp.height= height;

  len= sizeof(cp);
  buf= (void*) &cp;
  while(len)
  {
    R= send(exposock, buf, len,MSG_NOSIGNAL);
    if (R<0)
    {
      if (errno==EINTR) continue;
       // When we kill the child, we don't wait for it. 
       // This lets the user see that there is something
       // wrong with the update process.
      kill(expopid, SIGKILL);
      close(exposock);
      exposock= -1;
      return 1;
    }
    len-= R;
    buf+= R;
  }
  close(exposock);
  exposock= -1;
  return 0;
}

static void recv_child_params(Window *window, Pixmap *pixmap, int *w, int *h)
{
  gfx_child_params_t cp;
  char *buf;
  int len,R;

  buf= (void*) &cp;
  len= sizeof(cp);

  while(len)
  {
    R= recv(exposock,buf,len, 0);
    if (R<0)
    {
      if (errno==EINTR) continue;
      exit(1);
    }
    buf+= R;
    len-= R;
  }
  *window= cp.window;
  *pixmap= cp.pixmap;
  *w= cp.width;
  *h= cp.height;
  close(exposock);
}


/***********************************************************************
  Now we can handle the child loop.
 ***********************************************************************/

static void child_loop()
{
  Display      *display;
  XEvent        event;
  XExposeEvent *expose;
  Window        window;
  int           width,height;
  Pixmap        pixmap;

  display= XOpenDisplay(NULL);
  if (!display) exit(1);
  recv_child_params(&window, &pixmap, &width, &height);
  XSelectInput(display, window, ExposureMask | StructureNotifyMask);
  expose= &event.xexpose;
  while(1)
  {
    XNextEvent(display, &event);
    if (event.type==DestroyNotify && event.xdestroywindow.window==window)
          exit(0);
    if (event.type!=Expose) continue;
                                      // FIXME:
                                      // This zero should be something else
    XCopyArea(display, pixmap, window, DefaultGC(display,0), 
               expose->x, expose->y, expose->width, expose->height,
               expose->x, expose->y);
  }
}

static void tv2msecs(struct timeval *tv, unsigned int* msecs)
{
  if (!msecs) return ;
  *msecs= tv->tv_sec*1000 + tv->tv_usec/1000;
}

static int event_noprocess(unsigned int *msecs,gfx_event_t *Revent)
{
  int x,R;
  XEvent event;
  struct timeval tv;
  fd_set rfd, xfd, wfd;

again:
  if (!msecs || !*msecs || XPending(x_display)) goto have_event;

retry:

  if (XPending(x_display)) goto have_event;

  tv.tv_sec= *msecs/1000;
  tv.tv_usec= (*msecs%1000)*1000+1;
  if (tv.tv_sec==0 && tv.tv_usec==0) return 0;

  x= ConnectionNumber(x_display);
  XSync(x_display,False);

  FD_ZERO(&rfd); FD_ZERO(&xfd); FD_ZERO(&wfd);
  FD_SET(x, &rfd); FD_SET(x, &xfd);

  R= select( x+1, &rfd, &wfd, &xfd, &tv);
  if (R<0)
  {
    if (errno==EINTR)
    {
       usleep(1000);
       tv2msecs(&tv, msecs);
       goto retry;
    }
    return -1; // FIXME: log this stuff.
  }
  if (FD_ISSET(x, &xfd)) return -1; // FIXME: log this stuff.

  tv2msecs(&tv, msecs);
  if (!FD_ISSET(x, &rfd)) goto retry;

have_event:
  XNextEvent(x_display, &event);

  switch(x_keyboard_event(x_keyboard,&event,Revent))
  {
  case 0: break;
  case 1: goto handle_widget_event;
  case -1: goto again;
  }

  switch(event.type)
  {
   case MotionNotify:
     if (gfx_recsel_event(&event)) goto again;
     Revent->type= GFXEV_POINTER_MOVE; 
     Revent->x= event.xmotion.x; 
     Revent->y= event.xmotion.y; 
     Revent->modifiers= event.xmotion.state; 
     break;
   case ButtonPress:
     Revent->type= GFXEV_BUTTON_PRESS; 
     Revent->x= event.xbutton.x; 
     Revent->y= event.xbutton.y; 
     Revent->modifiers= event.xbutton.state; 
     Revent->button= event.xbutton.button;
     break;
   case ButtonRelease:
     Revent->type= GFXEV_BUTTON_RELEASE; 
     Revent->x= event.xbutton.x; 
     Revent->y= event.xbutton.y; 
     Revent->modifiers= event.xbutton.state; 
     Revent->button= event.xbutton.button;
     break;
   case ClientMessage: 
     if (event.xclient.message_type!=wm_protocols) goto again;
     if (event.xclient.data.l[0]!=wm_delete_window) goto again;
     Revent->type= GFXEV_QUIT;
     return 1;
   default:
     printf("unknown event type: %d\n", event.type);
     goto again;
  }
handle_widget_event:

  return 1; 
}

/* The event routine returns an event from the queue. It waits a maximum
   of 'msecs' milliseconds for the event. If msecs is zero, it waits 
   until an event is received. 

   The return value is one if an event is returned. It's zero if the
   return was due to timeout.

   In case of an event, *msecs is updated to reflect the remaining
   wait time.  */
   
int gfx_event(unsigned int *msecs,gfx_event_t *Revent)
{
  int K;

again:
  K= event_noprocess(msecs, Revent);
  if (!K) return 0;
  
  switch(Revent->type)
  {
  case GFXEV_BUTTON_PRESS:
  case GFXEV_BUTTON_RELEASE:
  case GFXEV_POINTER_MOVE:
    if (handle_grabbed_event(Revent)==2) goto again; break;
  }

  switch(Revent->type)
  {
  case GFXEV_BUTTON_PRESS:
     if (handle_click_event(Revent)==2) goto again; break;
  case GFXEV_BUTTON_RELEASE:
     if (handle_release_event(Revent)==2) goto again; break;
  case GFXEV_POINTER_MOVE:
     if (handle_motion_event(Revent)==2) goto again; break;
  }

  if (focusable_event(Revent)) goto again;

  return 1; 
}


void gfx_update_all()
{
  gfx_update(0,0,x_window_width, x_window_height);
}


void gfx_update(int x,int y,int width,int height)
{
  clip_for_rect(&x, &width, x_window_width);
  clip_for_rect(&y, &height, x_window_height);
  if (width<=0 || height<=0) return ;
  put_image(x_pixmap, x, y, x_image, x,y, width, height); 
  XClearArea(x_display, x_window, x,y, width, height, True);
}

void gfx_close()
{
#line 1111 "/home/dodo/tmp/gfx-1.2/src/keyboard.u"

  x_keyboard_free(x_keyboard);
  x_keyboard= NULL;

#line 804 "/home/dodo/tmp/gfx-1.2/src/basics.u"
  if (x_image) destroy_image(x_image);
  XDestroyWindow(x_display, x_window);
  XFreePixmap(x_display, x_pixmap);
  if (exposock!=-1) close(exposock);
  x_display= NULL;
  x_window= None;
  x_pixmap= None;
  x_image= NULL;
  exposock= -1;
}


/***********************************************************************
  More things to do:
  - buttons.
  - proper handling of the keyboard.
  - mouse position indicator in pixels
 ***********************************************************************/

#line 832 "/home/dodo/tmp/gfx-1.2/src/basics.u"

static void init_gsdata()
{
  int i;
  for(i=0;i<_GSSIZE;i++) _GSDATA[i]= color_u_to_s(_GSDATA[i]);
}

#line 127 "/home/dodo/tmp/gfx-1.2/src/graphics.u"

static void gfx_invert_hline(int x1,int x2, int y)
{
  uint32_t all_mask;

  if (y<0 || y>=x_window_height || x1>x2 || x1>=x_window_width) return ;
  if (x2>=x_window_width) x2= x_window_width-1;

  all_mask= x_red_mask | x_green_mask | x_blue_mask;
  for(;x1<=x2;x1++)
    x_image_data[y][x1] ^= all_mask;
}

static void gfx_invert_vline(int x,int y1, int y2)
{
  uint32_t all_mask;

  if (x<0 || x>=x_window_width || y1>y2 || y1>=x_window_height) return ;
  if (y2>=x_window_height) y2= x_window_height-1;

  all_mask= x_red_mask | x_green_mask | x_blue_mask;
  for(;y1<=y2;y1++)
    x_image_data[y1][x] ^= all_mask;
}

static uint32_t blend_usr_usr(uint32_t alpha, uint32_t fg, uint32_t bg)
{
  uint32_t fR, fG, fB; 
  uint32_t bR, bG, bB; 
  uint32_t pR, pG, pB; 
  double A,B;

  fR= (fg>>16)&0xff; fG= (fg>>8)&0xff; fB= fg&0xff;

  if (alpha==0xff) { pR= fR; pG= fG; pB= fB; goto OK;}

  bR= (bg>>16)&0xff; bG= (bg>>8)&0xff; bB= bg&0xff;
  if (alpha==0) { pR= bR; pG= bG; pB= bB; goto OK; }

  A= (double) alpha / 255.0;
  B= 1.0-A;

  pR= A*fR + B*bR;
  pG= A*fG + B*bG;
  pB= A*fB + B*bB;

OK:
  return   ((pR<<x_red_shift)&x_red_mask)
         | ((pG<<x_green_shift)&x_green_mask)
         | ((pB<<x_blue_shift)&x_blue_mask);
}

static uint32_t blend_usr_usr_usr(uint32_t alpha, uint32_t fg, uint32_t bg)
{
  uint32_t fR, fG, fB; 
  uint32_t bR, bG, bB; 
  uint32_t pR, pG, pB; 
  double A,B;

  if (alpha==0xff)  return fg; 
  if (alpha==0)    return bg;  

  fR= (fg>>16)&0xff; fG= (fg>>8)&0xff; fB= fg&0xff;


  bR= (bg>>16)&0xff; bG= (bg>>8)&0xff; bB= bg&0xff;

  A= (double) alpha / 255.0;
  B= 1.0-A;

  pR= A*fR + B*bR;
  pG= A*fG + B*bG;
  pB= A*fB + B*bB;

  return  (pR<<16) | (pG<<8) | (pB<<0);
}

static uint32_t blend_usr_svr(uint32_t alpha, uint32_t fg, uint32_t bg)
{
  uint32_t fR, fG, fB; 
  uint32_t bR, bG, bB; 
  uint32_t pR, pG, pB; 
  double A,B;

  if (alpha==0) return bg;

  fR= (fg>>16)&0xff; fG= (fg>>8)&0xff; fB= fg&0xff;

  if (alpha==0xff) { pR= fR; pG= fG; pB= fB; goto OK;}

  bR= (bg&x_red_mask)>>x_red_shift; 
  bG= (bg&x_green_mask)>>x_green_shift;
  bB= (bg&x_blue_mask)>>x_blue_shift;

  A= (double) alpha / 255.0;
  B= 1.0-A;

  pR= A*fR + B*bR;
  pG= A*fG + B*bG;
  pB= A*fB + B*bB;

OK:
  return   ((pR<<x_red_shift)&x_red_mask)
         | ((pG<<x_green_shift)&x_green_mask)
         | ((pB<<x_blue_shift)&x_blue_mask);
}

static void blend_graymap(int flags, int fg, int bg,
                          unsigned char *src, int src_w, int src_h,
                          int src_x, int src_y,
                          int dst_x, int dst_y, int width, int height)
{
  int x,y;
  uint32_t A;

  clip_for_rect( &src_x, &width, src_w);
  clip_for_rect( &src_y, &height, src_h);
  clip_for_rect( &dst_x, &width, x_window_width);
  clip_for_rect( &dst_y, &height, x_window_height);
  if (width<=0 || height<=0) return ;

  if (flags&GFX_BACKGND) // blend with fg,bg pair
  {
    for(y=0;y<height;y++)
      for(x=0;x<width;x++)   
      {
        A= src[(x+src_x) + (y+src_y)*src_w];
        x_image_data[y+dst_y][x+dst_x]= blend_usr_usr(A,fg, bg);
      }
  } 
  else
  {
    for(y=0;y<height;y++)
      for(x=0;x<width;x++)   
      {
        A= src[(x+src_x) + (y+src_y)*src_w];
        x_image_data[y+dst_y][x+dst_x]= 
             blend_usr_svr(A,fg, x_image_data[y+dst_y][x+dst_x]);
      }
  } 

  if (flags&GFX_UPDATE)
    gfx_update(dst_x, dst_y, width, height);
}

static uint32_t color_s(uint32_t uR, uint32_t uG, uint32_t uB)
{
  return ((uR<<x_red_shift)&x_red_mask)
        |((uG<<x_green_shift)&x_green_mask)
        |((uB<<x_blue_shift)&x_blue_mask);
}

static uint32_t u_red(uint32_t C) { return (C>>16)&0xff; }
static uint32_t u_green(uint32_t C) { return (C>>8)&0xff; }
static uint32_t u_blue(uint32_t C) { return (C)&0xff; }

static uint32_t color_u_to_s(uint32_t U)
{
  return color_s(u_red(U), u_green(U), u_blue(U));
}

static unsigned int blend_chan(unsigned int F, double A, unsigned int B)
{
  return  (unsigned int) ((F&0xff)*A + (B&0xff)*(1-A));
}


static unsigned int blend(uint32_t F, double A, uint32_t B)
{
  return color_s(
            blend_chan( u_red(F), A, u_red(B)),
            blend_chan( u_green(F), A, u_green(B)),
            blend_chan( u_blue(F), A, u_blue(B))
                );
}

static void grad_fill(int x,int y, int w, int h, uint32_t start, uint32_t end)
{
  int fx, fy, fw, fh,x0,y0,dx,dy;
  fx= x; fy= y; fw= w; fh= h;

  clip_for_rect(&x, &w, x_window_width);
  clip_for_rect(&y, &h, x_window_height);
  if (w<=0 || h<=0) return;

  for(y0=0;y0<h;y0++)
    for(x0=0;x0<w;x0++)
    {
      dx= (x0+x)-fx; dy= (y0+y)-fy;
      x_image_data[y0+y][x0+x]= blend(start, 1.0-(double)(dx+dy)/(fw+fh), end);
    }
}

static void hline(int x1,int x2, int y,uint32_t color)
{
  if (y<0 || y>=x_window_height || x1>x2 || x1>=x_window_width) return ;
  if (x2>=x_window_width) x2= x_window_width-1;

  for(;x1<=x2;x1++)
    x_image_data[y][x1]= color;
}

static void vline(int x,int y1, int y2,uint32_t color)
{
  if (x<0 || x>=x_window_width || y1>y2 || y1>=x_window_height) return ;
  if (y2>=x_window_height) y2= x_window_height-1;

  for(;y1<=y2;y1++)
    x_image_data[y1][x]= color;
}

static uint32_t *get_server_pix(int src_x,int src_y,int w,int h)
{
  uint32_t *D; int dw;
  int x,y;
  D= calloc(1,sizeof(uint32_t*)*w*h);
  dw= w;
  clip_for_rect(&src_x, &w, x_window_width);
  clip_for_rect(&src_y, &h, x_window_height);

  for(y=0;y<h;y++)
    for(x=0;x<w;x++)
      D[x+y*dw]= x_image_data[y+src_y][x+src_x];
  return D;
}

static void put_server_pix(uint32_t *D,int dst_x,int dst_y,int w, int h)
{
  int dw;
  int x,y;
  dw= w;
  clip_for_rect(&dst_x, &w, x_window_width);
  clip_for_rect(&dst_y, &h, x_window_height);

  for(y=0;y<h;y++)
    for(x=0;x<w;x++)
      x_image_data[y+dst_y][x+dst_x]= D[x+y*dw];
}



#line 402 "/home/dodo/tmp/gfx-1.2/src/graphics.u"

static void gradfill_left(uint32_t *dst, int dst_w, int dst_h,
                          uint32_t start, uint32_t end,
                          int fill_x, int fill_y,
                          int fill_w, int fill_h)
{
   int x,y;
   uint32_t *row;
   clip_for_rect(&fill_x, &fill_w, dst_w);
   clip_for_rect(&fill_y, &fill_h, dst_h);
   if (fill_w<=1 || fill_h<=0) return ;
   row= alloca(fill_w*sizeof(uint32_t));
   for(x=0;x<fill_w;x++)
     row[x]= blend(start, 1.0-(double)x/(fill_w-1), end);
   for(y=0;y<fill_h;y++)
     for(x=0;x<fill_w;x++)
        dst[ (x+fill_x) + (y+fill_y)*dst_w ]= row[x];
}

static void gradfill_top(uint32_t *dst, int dst_w, int dst_h,
                          uint32_t start, uint32_t end,
                          int fill_x, int fill_y,
                          int fill_w, int fill_h)
{
   int x,y;
   uint32_t *col;
   clip_for_rect(&fill_x, &fill_w, dst_w);
   clip_for_rect(&fill_y, &fill_h, dst_h);
   if (fill_w<=0 || fill_h<=1) return ;
   col= alloca(fill_h*sizeof(uint32_t));
   for(y=0;y<fill_h;y++)
     col[y]= blend(start, 1.0-(double)y/(fill_h-1), end);
   for(y=0;y<fill_h;y++)
     for(x=0;x<fill_w;x++)
        dst[ (x+fill_x) + (y+fill_y)*dst_w ]= col[y];
}


static void hline_buffer(uint32_t *dst, int dst_w, int dst_h,
                         int x0, int x1, int y, uint32_t color)
{
  int x;
  if (x0<0) x0=0;
  if (x1>=dst_w) x1= dst_w-1;
  if (x0>x1 || y<0 || y>=dst_h) return ;
  for(x=x0;x<=x1;x++) dst[x+y*dst_w]= color;
}

static void vline_buffer(uint32_t *dst, int dst_w, int dst_h,
                         int x, int y0, int y1, uint32_t color)
{
  int y;
  if (y0<0) y0=0;
  if (y1>=dst_h) y1= dst_h-1;
  if (y0>y1 || x<0 || x>=dst_w) return ;
  for(y=y0;y<=y1;y++) dst[x+y*dst_w]= color;
}

static void shadow_box(uint32_t *dst, int dst_w, int dst_h,
                       uint32_t light, uint32_t dark, uint32_t border,
                       int box_x, int box_y, int box_w, int box_h)
{
  int sX,sY,eX,eY;

  light= color_u_to_s(light);
  dark= color_u_to_s(dark);
  border= color_u_to_s(border);

  sX= box_x; eX= box_x + box_w - 1;
  sY= box_y; eY= box_y + box_h - 1;


  hline_buffer(dst, dst_w, dst_h, sX, eX, sY,     border);
  hline_buffer(dst, dst_w, dst_h, sX, eX, eY,     border);
  vline_buffer(dst, dst_w, dst_h, sX, sY+1, eY-1, border);
  vline_buffer(dst, dst_w, dst_h, eX, sY+1, eY-1, border);

  hline_buffer(dst, dst_w, dst_h, sX+1, eX-2, sY+1, light);
  vline_buffer(dst, dst_w, dst_h, sX+1, sY+1, eY-2, light);
  hline_buffer(dst, dst_w, dst_h, sX+1, eX-1, eY-1, dark);
  vline_buffer(dst, dst_w, dst_h, eX-1, sY+1, eY-1, dark);
}

static void blend_graymap_buffer
        (unsigned int fg, unsigned char *src, int src_w, int src_h,
                          int src_x, int src_y,
                          unsigned int *dst, int dst_w, int dst_h,
                          int dst_x, int dst_y, int width, int height)
{
  int x,y;
  uint32_t A,D;

  clip_for_rect( &src_x, &width, src_w);
  clip_for_rect( &src_y, &height, src_h);
  clip_for_rect( &dst_x, &width, dst_w);
  clip_for_rect( &dst_y, &height, dst_h);
  if (width<=0 || height<=0) return ;

  for(y=0;y<height;y++)
  {
    for(x=0;x<width;x++)   
    {
       A= src[(x+src_x) + (y+src_y)*src_w];
       D= (y+dst_y)*dst_w + (x+dst_x);
       dst[D]= blend_usr_usr_usr(A,fg, dst[D]);
    }
  }
}

#line 10 "/home/dodo/tmp/gfx-1.2/src/text.u"

static void get_text_data(int font, char *str, 
                          int *Rw, int *Rh,int *Ra,unsigned char **Rd)
{
  uint32_t *wtr;
  size_t L= strlen(str);
  wtr= alloca((L+1)*sizeof(uint32_t));
  utf8_decode_string((uint8_t*) str, L, wtr, &L);

  if (font<1) font=1;
  if (font>3) font=3;
  switch(font)
  {
  case 1: font1_render(wtr, L, Rw, Rh, Ra, Rd); break;
  case 2: font2_render(wtr, L, Rw, Rh, Ra, Rd); break;
  case 3: font3_render(wtr, L, Rw, Rh, Ra, Rd); break;
  }
}

#line 31 "/home/dodo/tmp/gfx-1.2/src/event.u"

static int install_click_handler
        (int x,int y,int w,int h,int *enabled,
         void *arg, int (*func)(void*,gfx_event_t*))
{
  install_click2_handler(x,y,w,h,enabled, arg,func, 1);
}

static int install_click2_handler
        (int x,int y,int w,int h,int *enabled,
         void *arg, int (*func)(void*,gfx_event_t*),int button)
{
  click_handler_t *C;
  click_handlers= grow_array(n_click_handler, &s_click_handler,
                             click_handlers, sizeof(click_handlers[0]));
  C= click_handlers + n_click_handler++;
  C->x= x;
  C->y= y;
  C->w= w;
  C->h= h;
  C->enabled= enabled;
  C->arg= arg;
  C->func= func;
  C->button= button;
  return n_click_handler-1;
}


static void install_release_handler
        (void *arg, int (*func)(void*,gfx_event_t*))
{
  release_handler.func= func;
  release_handler.arg= arg;
}

static void install_motion_handler(void *arg,int (*func)(void *,gfx_event_t*))
{
  motion_handler.func= func;
  motion_handler.arg= arg;
}

static void uninstall_motion_handler()
{
  motion_handler.func= NULL;
  motion_handler.arg= NULL;
}

#line 86 "/home/dodo/tmp/gfx-1.2/src/event.u"

static int handle_click_event(gfx_event_t *event)
{
  int i;
  click_handler_t *C;

  if (event->type!=GFXEV_BUTTON_PRESS) return 0;
  for(i=click_handler_start;i<n_click_handler;i++)
  {
    C= click_handlers+i;
    if (C->button!=event->button) continue;
    if (range_test(event->x,C->x, C->w) && range_test(event->y,C->y, C->h))
    {
             // if the widget was disabled, look for something else
      if ((!C->enabled || C->enabled[0])&& C->func)
           return (*C->func)(C->arg, event);
    }
  }
  return 0;
}

static int handle_release_event(gfx_event_t *event)
{
  void *A; int (*F)(void *,gfx_event_t*);
  if (event->type!=GFXEV_BUTTON_RELEASE || event->button!=1) return 0;
  if (release_handler.func)
  {
    A= release_handler.arg;
    F= release_handler.func;
    release_handler.arg= NULL;
    release_handler.func= NULL;
    return (*F)(A, event);
  }
  return 0;
}

static int handle_motion_event(gfx_event_t *event)
{
  if (event->type!=GFXEV_POINTER_MOVE) return 0;
  if (motion_handler.func)
     return (*motion_handler.func)(motion_handler.arg,event);
  return 0;
}

#line 140 "/home/dodo/tmp/gfx-1.2/src/event.u"

static int handle_grabbed_event(gfx_event_t *event)
{
  if (!grabber.func) return 0;
  return (*grabber.func)(grabber.arg, event);
}

static void grab_mouse(int (*func)(void*,gfx_event_t*), void *arg)
{
  grabber.func= func;
  grabber.arg= arg;
}

static void ungrab_mouse()
{
  grabber.func= NULL;
  grabber.arg= NULL;
}
#line 41 "/home/dodo/tmp/gfx-1.2/src/widget.u"

static int register_widget(void *A,int type,int x,int y,int w,int h)
{
  int R;
  gui_widget_t *W;
  W= A;
  gui_widgets= grow_array(n_gui_widget, &s_gui_widget,
                          gui_widgets, sizeof(gui_widgets[0]));
  R= n_gui_widget++;
  gui_widgets[R]= W;
  W->type= type;
  W->x= x;
  W->y= y;
  W->w= w;
  W->h= h;
  return R;   
}

static void *get_widget(int number, int type)
{
  gui_widget_t *W;
  if (number<0 || number>=n_gui_widget) return NULL;
  W= gui_widgets[number];
  if (W->type!=type) return NULL;
  return W;
}

static void widget_destroy(int number)
{
  gui_widget_t *W;
  if (number<0 || number>=n_gui_widget) return ;
  W= gui_widgets[number];
  if (W && W->destroy)
  {
    (*W->destroy)(W);
    gui_widgets[number]= NULL;
  }
}

#line 36 "/home/dodo/tmp/gfx-1.2/src/button.u"

static void init_button_colors()
{
  button_border= color_u_to_s(button_border_s);
  button_light= color_u_to_s(button_light_s);
  button_dark= color_u_to_s(button_dark_s);
  button_grad1= color_u_to_s(button_grad1_s);
  button_grad2= color_u_to_s(button_grad2_s);
  button_grad3= color_u_to_s(button_grad3_s);
  button_grad4= color_u_to_s(button_grad4_s);
  button_fg= color_u_to_s(button_fg_s);
}

static void button_render(int x,int y,int w,int h,
                              int tw, int th, unsigned char *data,
                              uint32_t grad1, uint32_t grad2,
                              uint32_t light, uint32_t dark)
{
  int copy_w, copy_h,src_x,src_y, text_x, text_y;
  int aw, ah;

  aw= w-4; ah= h-4;
  grad_fill(x+2,y+2,aw,ah, grad1, grad2);

  if (tw>aw) { src_x= (tw-aw)/2; copy_w= aw; text_x= x+2; }
        else { src_x= 0; copy_w= tw; text_x= x+2+(aw-tw)/2; }
  if (th>ah) { src_y= (th-ah)/2; copy_h= ah; text_y= y+2; }
        else { src_y= 0; copy_h= th; text_y= y+2+(ah-th)/2; }

  blend_graymap(0, button_fg, 0, data, tw,th, src_x,src_y,
                                 text_x,text_y,copy_w,copy_h);

  hline(x, x+w-1, y, button_border);
  hline(x, x+w-1, y+h-1, button_border);
  vline(x, y, y+h-1, button_border);
  vline(x+w-1, y, y+h-1, button_border);

  hline(x+1, x+w-3, y+1, light); 
  vline(x+1, y+1, y+h-3, light);

  hline(x+1, x+w-2, y+h-2, dark);
  vline(x+w-2, y+1, y+h-2, dark);
}

#line 121 "/home/dodo/tmp/gfx-1.2/src/button.u"

static void button_set_state(gui_button_t *B, int state)
{
  if (state<0 || state>2) state= 0;
  B->state= state;
  put_server_pix( B->pic[B->state], B->widget.x, B->widget.y,
                                    B->widget.w, B->widget.h);
  gfx_update(B->widget.x, B->widget.y, B->widget.w, B->widget.h);
  if (B->state==2) B->enabled= 0;
              else B->enabled= 1;
}

#line 146 "/home/dodo/tmp/gfx-1.2/src/button.u"

static int gui_button_click(void *arg, gfx_event_t *event)
{
  gui_button_t *B;
  B= arg;
  if (B->state==2) return 0; // shouldn't happen, but you never know
  button_set_state(arg, 1);
  install_release_handler(arg, gui_button_release);
  return 2;
}

static int gui_button_release(void *arg, gfx_event_t *event)
{
  gui_button_t *B;
  B= arg;
  event->type= B->action;
  button_set_state(B,0);
  return 1;
}

#line 21 "/home/dodo/tmp/gfx-1.2/src/label.u"

static void draw_label(int flags, gui_label_t *G, char *str)
{
  int tw, th; unsigned char *td;
  int dst_x, dst_y, copy_w, copy_h, src_x, src_y;
  
  get_text_data(G->font, str, &tw, &th, NULL, &td);
  gfx_fill_rect(0, G->x, G->y, G->w, G->h, G->bg);

  if (th<=G->h)
  {
    src_y= 0; dst_y= G->y + (G->h-th)/2; copy_h= th;
  }
  else
  {
    src_y= (th-G->h)/2; dst_y= G->y; copy_h= G->h;
  }

  if (tw<G->w)
  {
    src_x= 0; copy_w= tw;
    if (G->flags&GFX_JUST_CENTER)
      dst_x= G->x+(G->w-tw)/2;
    else if (G->flags&GFX_JUST_RIGHT)
      dst_x= G->x+G->w-tw;
    else
      dst_x= G->x;
  }
  else
  {
    dst_x= G->x; copy_w= G->w;
    if (G->flags&GFX_CUT_LEFT)
      src_x= tw - G->h;
    else
      src_x= 0;
  }

  blend_graymap(GFX_BACKGND, G->fg, G->bg, td, tw, th,
                src_x, src_y, dst_x, dst_y, copy_w, copy_h);

  if (flags&GFX_UPDATE) gfx_update(G->x,G->y,G->w,G->h);
}

#line 2 "/home/dodo/tmp/gfx-1.2/src/gfx-linux.u"

static void checker_pattern(ximage_t *img,int N)
{
  int x,y;
  uint32_t all_mask;
  if (N<=0) N= 4;
  all_mask= x_red_mask | x_green_mask | x_blue_mask;
  for(y=0;y<img->height;y++)
   for(x=0;x<img->width;x++)
     *(uint32_t*)  ((unsigned char*) img->data + y*img->bpl + 4*x)= 
            (x%(2*N)/N ^ y%(2*N)/N)  ? all_mask : 0;
}
#line 5 "/home/dodo/tmp/gfx-1.2/src/util.u"

static void *grow_array(int N, int *S, void *ptr, size_t eltsiz)
{
  if (N<*S) return ptr;
  if (!*S)
  {
    *S= 20;
    ptr= malloc(*S*eltsiz);
  }
  else
  {
    *S+= *S/2;
    ptr= realloc(ptr, *S*eltsiz);
  }
  return ptr;
}

static int range_test(int v, int s, int w) { return v>=s && v<(s+w); }


static int imin2(int a,int b) { return a < b ? a : b; }
static int imax2(int a,int b) { return a > b ? a : b; }

static int imin3(int a,int b,int c) { return imin2(imin2(a,b),c); }
static int imax3(int a,int b,int c) { return imax2(imax2(a,b),c); }

static double dmin2(double a,double b) { return a<b?a:b; }
static double dmax2(double a,double b) { return a>b?a:b; }

static int utf8_encode_string
    (const uint32_t* wstr,size_t wlen, uint8_t *dst, size_t *dlen)
{
/*
  This is all from
  http://www.cl.cam.ac.uk/~mgk25/unicode.html

  TODO: what to do if the input has invalid
  unicode chars such as unassigned chars etc?
  pass them thru?
*/

/* Encoding Table
                  Start-Byte    
 Min Value    8421 8421   hex     Length
0x04000000    1111 110x   fc        6
0x00200000    1111 10xx   f8        5
0x00010000    1111 0xxx   f0        4
0x00000800    1110 xxxx   e0        3
0x00000080    110x xxxx   c0        2 */
  int i,k,len;
  uint32_t chr;
  unsigned char *odst;

  static const unsigned int lowerlimit[]=
    { 0x04000000, 0x00200000, 0x00010000, 0x00000800, 0x00000080 };
  static const unsigned char topbits []= { 0xfc, 0xf8, 0xf0, 0xe0, 0xc0 };
  const unsigned char lower6=  0x3f; // binary 0011 1111
  const unsigned char seventh= 0x80; // binary 1000 0000
  const unsigned int bit31=    0x80000000; 

  odst= dst;

  while(wlen)
  {
    chr= *(wstr++); wlen--;
    if (chr<=0x7f)   { *(dst++)= chr; continue; }
    if (chr & bit31) { *(dst++)= chr & ~bit31; continue; }

    for(i=0;i<4;i++) if (chr >= lowerlimit[i]) break;
    len= 4-i+2;

    for(k=len-1;k>0;k--)
    {
      dst[k]= seventh | (chr & lower6);
      chr >>= 6;
    }
    dst[k]= chr | topbits[i];
    dst+= len;
  }

  *dlen= dst-odst;
  return 0;
}

static uint32_t utf8_decode_single_char(char *src)
{
  uint32_t *dst;
  size_t L;
  L= strlen(src);
  dst= alloca(sizeof(*dst)*(L+1));
  utf8_decode_string((uint8_t*) src, L, dst, &L);
  if (L==0) return ' ';
  return dst[0];
}


static void utf8_encode_single_char(uint32_t wide, char *dst)
{
  /* This assumes that dst is big enough, at least 6 bytes. */
  size_t L;
  L= 6;
  utf8_encode_string(&wide,1, (uint8_t*) dst, &L);
}

static void utf8_decode_alloc(char *str, uint32_t **Rwstr, uint32_t *Rwlen)
{
  uint32_t *S;
  size_t L,SL;
  L= strlen(str);
  S= malloc((L+1)*sizeof(uint32_t));
  utf8_decode_string((uint8_t*)str, L, S, &SL);
  *Rwstr= S;
  *Rwlen= SL;
}


static void clip_for_rect(int *start, int *amount, int max)
{
  int end;
  if (*amount<=0) return ;
  end= *start + *amount;
  if (end>max) end= max;
  if (*start<0) *start= 0;
  *amount= end - *start;
}

static void freeNnull(void *A)
{
  if (A) free(A);
}
#line 71 "/home/dodo/tmp/gfx-1.2/src/recsel.u"

static int gfx_recsel_event(XEvent *event)
{
  gfx_point_t P;
  int x,y,minx,miny,maxx,maxy;
  if (!recsel || event->type!=MotionNotify) return 0;
  x= event->xmotion.x;
  y= event->xmotion.y;

  x= imin2(imax2(x,recselpt[2].x), recselpt[3].x); 
  y= imin2(imax2(y,recselpt[2].y), recselpt[3].y); 

  if (x==recselpt[1].x && y==recselpt[1].y) return 1;
  
  draw_recsel();
  minx= imin3( recselpt[0].x, recselpt[1].x, x);
  maxx= imax3( recselpt[0].x, recselpt[1].x, x);

  miny= imin3( recselpt[0].y, recselpt[1].y, y);
  maxy= imax3( recselpt[0].y, recselpt[1].y, y);

  recselpt[1].x= x;
  recselpt[1].y= y;
  draw_recsel();
  gfx_update(minx, miny, maxx-minx+1, maxy-miny+1);
  return 1;
}


static void draw_recsel()
{
  int x,y,w,h,C;

  x= imin2(recselpt[0].x, recselpt[1].x);
  y= imin2(recselpt[0].y, recselpt[1].y);

  w= imax2(recselpt[0].x, recselpt[1].x) - x+1;
  h= imax2(recselpt[0].y, recselpt[1].y) - y+1;

  C= (w<2) ? 0 : 1;
  C|= (h<2) ? 0 : 2;
  switch(C)
  {
  case 0: break ;
  case 1: gfx_invert_hline(x, x+w-1, y); break ;
  case 2: gfx_invert_vline(x, y, y+h-1); break ;
  case 3: gfx_invert_hline(x, x+w-1, y);
          gfx_invert_hline(x, x+w-1, y+h-1);
          gfx_invert_vline(x, y+1, y+h-2);
          gfx_invert_vline(x+w-1, y+1, y+h-2);
          break;
  }
}

#line 45 "/home/dodo/tmp/gfx-1.2/src/keyboard.u"

static x_keyboard_t *x_keyboard_init(Window window)
{
  x_keyboard_t *xk;

  xk= calloc(1,sizeof(*xk));

  xk->method= 'S';
  xk->window= window;
  xk->sbuf= 20;   xk->buf= malloc(xk->sbuf);
  xk->swbuf= 20;  xk->wbuf= malloc(sizeof(uint32_t)*xk->swbuf);
  get_xim();

  if (xim)
  {
    xk->ic= XCreateIC(xim, XNInputStyle, xim_style, 
                      XNClientWindow, window, 
                      XNFocusWindow, window, 
                      NULL);
    if (xk->ic!=NULL)
       xk->method= 'M'; 
  }
  return xk;
}

static void x_keyboard_free(x_keyboard_t *xk)
{
  free(xk->buf);
  free(xk->wbuf);
  if (xk->method=='M') XDestroyIC(xk->ic);
  free(xk);
}

static void get_xim()
{
  int i;
  XIMStyles *xim_styles;
  XIMStyle simple_style;
  char *failed_param;

  if (xim_tried) return ;
  xim_tried= 1;

  xim_styles= NULL;
  
  xim= XOpenIM(x_display, NULL, NULL, NULL);
  if (xim==NULL) return ;

  failed_param= XGetIMValues (xim, XNQueryInputStyle, &xim_styles, NULL);
  if (failed_param || !xim_styles)
     goto fail_no_styles;

  simple_style= (XIMPreeditNothing | XIMStatusNothing);
  for(i=0;i<xim_styles->count_styles;i++) 
    if (xim_styles->supported_styles[i] == simple_style)
       break;

  if (i==xim_styles->count_styles)
     goto fail_no_styles;

  xim_style= simple_style;
  XFree(xim_styles);

  return ;

fail_no_styles:
  if (xim_styles) XFree(xim_styles);
  
  XCloseIM(xim);
  xim= NULL;
}

#line 128 "/home/dodo/tmp/gfx-1.2/src/keyboard.u"

static int x_keyboard_event
             (x_keyboard_t *xk, XEvent *ev, gfx_event_t *Revent)
{
  Status status;
  KeySym sym;
  int lk;

  sym= NoSymbol;

  Revent->type= GFXEV_KEY_PRESS;

  if (xk->method=='S') goto simple;
  if (XFilterEvent(ev, xk->window)) return 1;
  if (ev->type!=KeyPress) return 0;


retry:
  lk= Xutf8LookupString(xk->ic, (XKeyPressedEvent *) ev,
                        xk->buf, xk->sbuf-1, &sym, &status);
  switch(status)
  {
    case XBufferOverflow:
      free(xk->buf);
      xk->sbuf= lk+lk/2;
      xk->buf= malloc(xk->sbuf);
      goto retry;
    case XLookupBoth:
      if ((Revent->key=lookup_key(sym,ev->xkey.state))) return 1;
      Revent->key= GFX_K_PRT;
      Revent->string= xk->buf;
      Revent->string[lk]= 0;
      Revent->wide= utf8_decode_single_char(Revent->string);
      return 1;
    case XLookupChars: 
      if (xk->buf[0]>0 && xk->buf[0]<0x20) // control character
      { // I don't know what to do here.
        return -1;
      }
      Revent->key= GFX_K_PRT;
      Revent->string= xk->buf;
      Revent->string[lk]= 0;
      Revent->wide= utf8_decode_single_char(Revent->string);
      return 1;
      
    case XLookupKeySym:
      if ((Revent->key=lookup_key(sym,ev->xkey.state))) return 1;
      if ((Revent->wide= keysym2ucs(sym)))
      {
        utf8_encode_single_char(Revent->wide, xk->buf);
        Revent->string= xk->buf;
        Revent->string[lk]= 0;
        Revent->key= GFX_K_PRT;
        return 1;
      }
  }

  return -1;

simple:
  sym= NoSymbol;
  lk= XLookupString(&ev->xkey, xk->buf, xk->sbuf-1, &sym, NULL);
  if ((Revent->key=lookup_key(sym,ev->xkey.state))) return 1;
  if (lk>0) 
  {
    Revent->string= xk->buf;
    Revent->string[lk]= 0;
    Revent->wide= utf8_decode_single_char(Revent->string);
    Revent->key= GFX_K_PRT; 
    return 1;
  } 
  return -1;
}

#line 1028 "/home/dodo/tmp/gfx-1.2/src/keyboard.u"

static uint32_t keysym2ucs(KeySym keysym)
{
    int min = 0;
    int max = sizeof(keysymtab) / sizeof(struct codepair);
    int mid;

    if (keysym<=0xff) return keysym;

    if (keysym & 0x1000000) return keysym ^0x1000000;

    /* binary search */
    while (max > min) {
        mid = (min + max) / 2;
        if (keysymtab[mid].keysym < keysym)
            min = mid + 1;
        else if (keysymtab[mid].keysym > keysym)
            max = mid - 1;
        else {
            /* found it */
            return keysymtab[mid].ucs;
        }
    }

    /* no matching Unicode value found */
    return 0;
} 

#line 1061 "/home/dodo/tmp/gfx-1.2/src/keyboard.u"

static int lookup_key(KeySym sym, unsigned int modifiers)
{
   static const struct { KeySym sym; int meaning; } all[]=
   {
     { XK_BackSpace , GFX_K_BACKSPACE },
     { XK_Tab,        GFX_K_TAB },
     { XK_Linefeed,   GFX_K_RETURN },
     { XK_Return,     GFX_K_RETURN },
     { XK_Escape,     GFX_K_ESCAPE },
     { XK_Insert,     GFX_K_INSERT },
     { XK_Delete,     GFX_K_DELETE }, 
     { XK_Home,       GFX_K_HOME },
     { XK_End,        GFX_K_END },
     { XK_Page_Up,    GFX_K_PAGEUP },
     { XK_Page_Down,  GFX_K_PAGEDOWN },
     { XK_Left,       GFX_K_LEFT },
     { XK_Right,      GFX_K_RIGHT },
     { XK_Down,       GFX_K_DOWN },
     { XK_Up,         GFX_K_UP },
     { XK_VoidSymbol, 0 }
   };
   int i,B;
   B= 0;
   if (sym>=0x20 && sym<=0x7e && (modifiers&ControlMask))
      return sym | GFX_K_CONTROL; 
   for(i=0;all[i].sym!=XK_VoidSymbol;i++)
      if (all[i].sym==sym) 
       {
         B= all[i].meaning; 
         if (modifiers & ControlMask) B |= GFX_K_CONTROL;
         if (modifiers & ShiftMask) B |= GFX_K_SHIFT;
         return B;
       }
   return 0;
}


#line 24 "/home/dodo/tmp/gfx-1.2/src/focus.u"

static void new_focusable(int x,int y,int w,int h, void *arg,
                          int (*keyhandler)(void *,gfx_event_t*),
                          void (*focus)(void *,int),int getfocus)
{
  focusable_t *F;
  focusables= grow_array(n_focusables, &s_focusables, 
                         focusables, sizeof(focusable_t));
  F= focusables + n_focusables;
  F->x= x; F->y= y; F->w= w; F->h= h;
  F->keyhandler= keyhandler; F->focus= focus;
  F->arg= arg;
  if (getfocus) focussed= n_focusables;
  n_focusables++;
}

#line 45 "/home/dodo/tmp/gfx-1.2/src/focus.u"

static int focusable_event(gfx_event_t *event)
{
  int i;
  if (event->type==GFXEV_BUTTON_PRESS) 
  { 
    // FIXME: check for modifiers
    if (event->button!=1) return 0;
    for(i=0;i<n_focusables;i++)
      if (range_test(event->x, focusables[i].x, focusables[i].w) &&
          range_test(event->y, focusables[i].y, focusables[i].h)) break;
    if (i==n_focusables || i==focussed) return 0;
    focusable_clicked= i;
    return 1;
  }
  if (event->type==GFXEV_BUTTON_RELEASE)
  {
    // FIXME: check for modifiers
    if (event->button!=1 || focusable_clicked==-1) return 0;
    if (focusable_clicked>=n_focusables) { focusable_clicked= -1; return 0; }
    set_focus(focusable_clicked);
    focusable_clicked= -1;
    return 1;
  }
  if (event->type==GFXEV_KEY_PRESS)
  {
    if (focussed==-1) return 0;
    if (focussed>=n_focusables || n_focusables==0) { focussed= -1; return 0; }
    if (focusable_handle_key(focusables+focussed, event)) return 1;
    switch(event->key)
    {
    case GFX_K_TAB:
      set_focus( (focussed+1)%n_focusables );
      return 1;
    // FIXME: do Shift+TAB
    }
    return 0; 
  }
  return 0;
}

static int focusable_handle_key(focusable_t *F, gfx_event_t *event)
{
  return (*F->keyhandler)(F->arg, event);
}

static void set_focus(int f)
{
  if (focussed==f) return ;
  if (focussed>=0 && focussed<n_focusables) 
     focusables[focussed].focus( focusables[focussed].arg, 0 );
  focussed= f;
  if (focussed>=0 && focussed<n_focusables) 
     focusables[focussed].focus( focusables[focussed].arg, 1 );
  else
     focussed= -1;
}

#line 39 "/home/dodo/tmp/gfx-1.2/src/textentry.u"

static text_entry_t *text_entry_init
    (int flags,int x,int y, int w, int h, char *initstr)
{
  text_entry_t *te;
  uint32_t i;
  uint32_t *wide_str, wide_str_len;
  int size;

  te= malloc(sizeof(*te));
  te->x= x; te->y= y; te->w= w; te->h= h;
  te->has_focus= (flags&GFX_FOCUS) ? 1:0;
  flags &= ~GFX_FOCUS;

  if (!initstr) initstr= "";
  utf8_decode_alloc(initstr, &wide_str, &wide_str_len);

  size= wide_str_len + wide_str_len/2 + 2;
  if (size<50) size= 50;

  te->size= size;
  te->len= wide_str_len+1;
  te->glyphs= malloc(sizeof(te->glyphs[0])*te->size);
  
  for(i=0;i<te->len-1;i++) mk_glyph(te->glyphs+i, wide_str[i]);
  mk_glyph(te->glyphs+i, ' ');

  x= 0;
  for(i=0;i<te->len;i++)
  {
    te->glyphs[i].x= x;
    x+= te->glyphs[i].w;
  }
  
  font1_render(wide_str,1, NULL, &te->fonth, NULL, NULL);
  free(wide_str);
  
  te->cursor= te->len-1;
  te->left= 0;
  make_cursor_visible(flags,te, 1);

  new_focusable(te->x, te->y, te->w, te->h, te,
                textentry_key, textentry_focus, te->has_focus);

  te->widget.destroy= (void*) text_entry_free;
  return te;
}

#line 98 "/home/dodo/tmp/gfx-1.2/src/textentry.u"

static void make_cursor_visible(int flags,text_entry_t *te, int redraw)
{
  int cx, cw;
  cx= te->glyphs[te->cursor].x;
  cw= te->glyphs[te->cursor].w;

  if (cx<te->left) { te->left= cx; goto render; }
  if (cx+cw-te->left>te->w) { te->left= cx+cw-te->w; goto render; }
  if (!redraw) return ;
render:
  render_te(flags,te);
}

static void render_te(int flags,text_entry_t *te)
{
  int i;
  gfx_fill_rect(0, te->x, te->y, te->w, te->h, TE_bg);
  for(i=0;i<te->len;i++) if (draw_glyph(te, i,0)) break;
  if (flags&GFX_UPDATE)
    gfx_update(te->x, te->y, te->w, te->h);
}

static void mk_glyph(glyph_t *G, uint32_t chr)
{
  // We don't store the height, they all have the same height.
  font1_render(&chr, 1, &G->w, NULL, NULL, &G->d);
  G->chr= chr;
}

static int draw_glyph(text_entry_t  *te, int gn, int expose)
{
  int ws, we, sx, sy, cw, ch, dx,dy, gs,ge;
  uint32_t fg, bg;
  glyph_t *G;

  ws= te->left; 
  we= te->left+te->w;
  G= te->glyphs+gn;

  if (te->fonth>te->h)
  {
    sy= (te->fonth-te->h)/2;
    ch= te->h;
    dy= 0;
  } else { dy= (te->h-te->fonth)/2; sy=0; ch= te->fonth; }

  gs= G->x;
  ge= gs + G->w;

  if (ge<=ws) return 0;
  if (gs>=we) return 1;
    
  sx= 0; cw= te->glyphs[gn].w;
  if (gs<ws) { sx= ws-gs; cw-= ws-gs; }
  if (ge>we) { cw-= ge-we; }

  dx= sx + gs - ws;
  if (te->has_focus && gn==te->cursor) { fg= TE_cfg; bg= TE_cbg; }
                                  else { fg= TE_fg;  bg= TE_bg; }

  blend_graymap( (expose ? GFX_UPDATE : 0) | GFX_BACKGND, 
                 fg, bg, G->d, G->w, te->fonth, sx, sy,
                         dx + te->x, dy + te->y, cw, ch );
  return 0;
}


static void textentry_focus(void *va, int focus)
{
  text_entry_t *te;
  te= va;
  if (te->has_focus==focus) return ;
  te->has_focus= focus;
  draw_glyph(te, te->cursor, 1);
}

static int textentry_key(void* va, gfx_event_t *event) 
{
  text_entry_t *te;
  te= va;
  switch(event->key)
  {
   case GFX_K_LEFT:
     if (te->cursor!=0) move_cursor(te, te->cursor-1);
     return 1;
   case GFX_K_RIGHT:
     if (te->cursor!=te->len-1) move_cursor(te,te->cursor+1);
     return 1;
   case GFX_K_HOME: move_cursor(te, 0); return 1;
   case GFX_K_END:  move_cursor(te, te->len-1); return 1;
   case GFX_K_DELETE:
     if (te->cursor!=te->len-1) delete_cursor_char(te);
     return 1;
   case GFX_K_BACKSPACE:
     if (te->cursor!=0)
     {
       te->cursor--;
       delete_cursor_char(te);
     }
     return 1;
   case GFX_K_PRT:
     insert_char(te, event->wide);
     return 1;
  }
  return 0;
}


static void move_cursor(text_entry_t *te, int newcurs)
{
  int ws, we, gs,ge;
  int C;

  if (newcurs<0 || newcurs>=te->len || newcurs==te->cursor) return ;  

  gs= te->glyphs[newcurs].x;
  ge= gs + te->glyphs[newcurs].w;

  ws= te->left; 
  we= te->left+te->w;

  if (gs<ws|| ge>we)
  {
    te->cursor= newcurs;
    make_cursor_visible(GFX_UPDATE,te, 1);
    return ;
  }

  C= te->cursor;
  te->cursor= newcurs;
  draw_glyph(te, C,1);
  draw_glyph(te, te->cursor,1);
}

static void insert_char(text_entry_t *te, uint32_t chr)
{
  int i;
  if (te->len==te->size)
  {
    te->size+= te->size/2;
    te->glyphs= realloc(te->glyphs, sizeof(te->glyphs[0])*te->size);
  }
  for(i=te->len;i>te->cursor;i--)
    te->glyphs[i]= te->glyphs[i-1];
  mk_glyph(te->glyphs+ te->cursor, chr);
  
  te->cursor++;
  te->len++;
  for(i=te->cursor;i<te->len;i++)
    te->glyphs[i].x= te->glyphs[i-1].x + te->glyphs[i-1].w;

  make_cursor_visible(GFX_UPDATE,te, 1);
}

static void delete_cursor_char(text_entry_t *te)
{
  int i,x;
  free(te->glyphs[te->cursor].d);
  x= te->glyphs[te->cursor].x;
  for(i=te->cursor;i<te->len-1;i++)
  {
    te->glyphs[i]= te->glyphs[i+1];
    te->glyphs[i].x= x;
    x+= te->glyphs[i].w;
  }
  te->len--;
  te->glyphs[i].x= x;
  make_cursor_visible(GFX_UPDATE,te, 1);
}

#line 295 "/home/dodo/tmp/gfx-1.2/src/textentry.u"

static void text_entry_free(text_entry_t *te)
{
  int i;
  for(i=0;i<te->len;i++)
   free(te->glyphs[i].d);
  free(te->glyphs);
  free(te);
}


static void text_entry_set(int flags,text_entry_t *te, char *str)
{
  uint32_t i;
  uint32_t *wide_str, wide_str_len;
  int x;

  utf8_decode_alloc(str, &wide_str, &wide_str_len);

  if (wide_str_len>te->size)
  {
    te->size= wide_str_len + wide_str_len/2 + 2;
    if (te->size<50) te->size= 50;
    te->glyphs= realloc(te->glyphs,sizeof(te->glyphs[0])*te->size);
  }

  for(i=0;i<te->len;i++) free(te->glyphs[i].d);

  te->len= wide_str_len+1;
  
  for(i=0;i<te->len-1;i++) mk_glyph(te->glyphs+i, wide_str[i]);
  mk_glyph(te->glyphs+i, ' ');

  x= 0;
  for(i=0;i<te->len;i++)
  {
    te->glyphs[i].x= x;
    x+= te->glyphs[i].w;
  }
  
  free(wide_str);
  
  te->cursor= te->len-1;
  te->left= 0;
  make_cursor_visible(flags,te, 1);
}

#line 63 "/home/dodo/tmp/gfx-1.2/src/scrollbar.u"

static void scrollbar_compute_trough(gui_scrollbar_t *SB)
{
  if (SB->orient=='V')
  {
    SB->tro_h= SB->widget.h - GSHscr_up - GSHscr_down;

    SB->tro_c0= SB->widget.y+ GSHscr_up;
    SB->tro_c1= SB->tro_c0+SB->tro_h-1;
    SB->tro_dc= SB->tro_h-1;

    SB->tro_x= SB->widget.x;
    SB->tro_y= SB->tro_c0;
    SB->tro_w= SB->widget.w;
  }
  else
  {
    SB->tro_w= SB->widget.w - GSWscr_left - GSWscr_right;

    SB->tro_c0= SB->widget.x + GSWscr_left;
    SB->tro_c1= SB->tro_c0 + SB->tro_w - 1;
    SB->tro_dc= SB->tro_w-1;

    SB->tro_x= SB->tro_c0;
    SB->tro_y= SB->widget.y;
    SB->tro_h= SB->widget.h;
  }
  if (SB->tro_dc<1) SB->tro_dc= 1;
}

static void scrollbar_compute_button(gui_scrollbar_t *SB)
{
  SB->but_c0= SB->tro_dc*SB->start + SB->tro_c0;
  SB->but_c1= SB->tro_dc*SB->end   + SB->tro_c0;
}

static void fill_with_horizontal_gradient
             (int x0,int y0, int y1,
                    unsigned int *graD, int graW, int graH)
{
  int y;
  for(y=y0;y<=y1;y++)
    put_server_pix(graD, x0, y, graW, 1);
}

static void three_part_assembly_vertical
    (int x0,int y0, int y1,
                    unsigned int *topD, int topW, int topH,
                    unsigned int *midD, int midW, int midH,
                    unsigned int *botD, int botW, int botH)
{
  int mid_start_y, mid_end_y,y;
  mid_start_y= y0 + topH;
  mid_end_y=   y1 - botH;
  put_server_pix(topD, x0, y0, topW, topH);
  fill_with_horizontal_gradient(x0,mid_start_y, mid_end_y, midD, midW, midH);
  put_server_pix(botD, x0, mid_end_y+1, botW, botH);
}

static void fill_with_vertical_gradient
             (int x0, int x1, int y0,
                    unsigned int *graD, int graW, int graH)
{
  int x;
  for(x=x0;x<=x1;x++)
    put_server_pix(graD, x, y0, 1, graH);
}

static void three_part_assembly_horizontal
    (int x0, int x1, int y0,
                    unsigned int *lefD, int lefW, int lefH,
                    unsigned int *midD, int midW, int midH,
                    unsigned int *rigD, int rigW, int rigH)
{
  int mid_start_x, mid_end_x;
  mid_start_x= x0 + lefW;
  mid_end_x=   x1 - rigW;
  put_server_pix(lefD, x0, y0, lefW, lefH);
  fill_with_vertical_gradient(mid_start_x,mid_end_x, y0, midD, midW, midH);
  put_server_pix(rigD, mid_end_x+1, y0, rigW, rigH);
}

static void scrollbar_draw_trough(gui_scrollbar_t *SB)
{
  int y,x;
  if (SB->orient=='V')
  {
    x= SB->widget.x;
    fill_with_horizontal_gradient
             (x, SB->tro_c0, SB->but_c0-1,
              GSDtro_vert, GSWtro_vert, GSHtro_vert);

    fill_with_horizontal_gradient
             (x, SB->but_c1+1, SB->tro_c1,
              GSDtro_vert, GSWtro_vert, GSHtro_vert);

    three_part_assembly_vertical
             (x, SB->but_c0, SB->but_c1,
              GSDsbut_ver_top, GSWsbut_ver_top, GSHsbut_ver_top,
              GSDsbut_ver_mid, GSWsbut_ver_mid, GSHsbut_ver_mid,
              GSDsbut_ver_bot, GSWsbut_ver_bot, GSHsbut_ver_bot);
  }
  else
  {
    y= SB->widget.y;
    fill_with_vertical_gradient
             (SB->tro_c0, SB->but_c0-1, y, 
              GSDtro_horz, GSWtro_horz, GSHtro_horz);                       

    fill_with_vertical_gradient
             (SB->but_c1+1, SB->tro_c1, y, 
              GSDtro_horz, GSWtro_horz, GSHtro_horz);                       

    three_part_assembly_horizontal
             (SB->but_c0, SB->but_c1, y,
              GSDsbut_hor_left, GSWsbut_hor_left, GSHsbut_hor_left,
              GSDsbut_hor_mid, GSWsbut_hor_mid, GSHsbut_hor_mid,
              GSDsbut_hor_right, GSWsbut_hor_right, GSHsbut_hor_right);
  }
}

static void scrollbar_draw_stepper(gui_scrollbar_t *SB, int sno, int state)
{
  int img;
  img= sno*2 + state;
  put_server_pix(SB->SD[img], SB->SX[sno], SB->SY[sno],
                              SB->SW[img], SB->SH[img]);
}

static void scrollbar_draw_all(gui_scrollbar_t *SB)
{
  scrollbar_draw_stepper(SB, 0,0);
  scrollbar_draw_stepper(SB, 1,0);
  scrollbar_draw_trough(SB);
}

static void scrollbar_position_buttons
   (gui_scrollbar_t *SB,int x,int y,int w,int h)
{
  if (SB->orient=='V')
  {
    SB->SD[0]= GSDscr_up; SB->SD[1]= GSDrcs_up;
    SB->SW[0]= GSWscr_up; SB->SW[1]= GSWrcs_up;
    SB->SH[0]= GSHscr_up; SB->SH[1]= GSHrcs_up;

    SB->SD[2]= GSDscr_down; SB->SD[3]= GSDrcs_down;
    SB->SW[2]= GSWscr_down; SB->SW[3]= GSWrcs_down;
    SB->SH[2]= GSHscr_down; SB->SH[3]= GSHrcs_down;

    SB->SX[0]= x; SB->SX[1]= x;
    SB->SY[0]= y; SB->SY[1]= y+h-SB->SH[2];
  }
  else
  {
    SB->SD[0]= GSDscr_left; SB->SD[1]= GSDrcs_left;
    SB->SW[0]= GSWscr_left; SB->SW[1]= GSWrcs_left;
    SB->SH[0]= GSHscr_left; SB->SH[1]= GSHrcs_left;

    SB->SD[2]= GSDscr_right; SB->SD[3]= GSDrcs_right;
    SB->SW[2]= GSWscr_right; SB->SW[3]= GSWrcs_right;
    SB->SH[2]= GSHscr_right; SB->SH[3]= GSHrcs_right;

    SB->SY[0]= y;  SB->SY[1]= y;
    SB->SX[0]= x;  SB->SX[1]= x+w-SB->SW[2];
  }
}

static gui_scrollbar_t* new_scrollbar
                          (int flags, int x,int y, int w,int h,
                           double start, double end, double step,
                           int action, void *reportarg, void *reportfunc)
{
  gui_scrollbar_t *SB;

  SB= calloc(1,sizeof(*SB));

  SB->widget.x= x;
  SB->widget.y= y;
  SB->widget.w= w;
  SB->widget.h= h;
  SB->start= start;
  SB->end= end;
  SB->step= step;
  SB->reportarg= reportarg;
  SB->reportfunc= reportfunc;
  SB->action= action;

  SB->orient= (flags&GFX_VERTICAL)? 'V': 'H';
  SB->enabled= 1;

  scrollbar_position_buttons(SB,x,y,w,h);
  scrollbar_compute_trough(SB);
  scrollbar_compute_button(SB);
  scrollbar_draw_all(SB);

  if (flags & GFX_UPDATE)
     gfx_update(x,y,w,h);

  SB->ch0=install_click_handler(SB->SX[0], SB->SY[0], SB->SW[0], SB->SH[0],
                        &SB->enabled, SB, scrollbar_click_up);
  SB->ch1=install_click_handler(SB->SX[1], SB->SY[1], SB->SW[2], SB->SH[2], 
                        &SB->enabled, SB, scrollbar_click_down);
  SB->ch2=install_click_handler(SB->tro_x, SB->tro_y, SB->tro_w, SB->tro_h,
                        &SB->enabled, SB, scrollbar_click_tro);
  return SB;
}


static int scrollbar_click_up(void *A, gfx_event_t *E)
{
  gui_scrollbar_t *SB= A;
  scrollbar_draw_stepper(SB, 0, 1);
  install_release_handler(A, scrollbar_release_up);
  gfx_update(SB->SX[0], SB->SY[0], SB->SW[0], SB->SH[0]);
  return 2;
}

static int scrollbar_release_up(void *A, gfx_event_t *event)
{
  gui_scrollbar_t *SB= A;
  scrollbar_draw_stepper(SB, 0, 0);
  gfx_update(SB->SX[0], SB->SY[0], SB->SW[0], SB->SH[0]);
  if (SB->start>0.0)
  {
    double S;
    S= dmax2(0.0, SB->start - SB->step);
    return scrollbar_set(SB, S, S-SB->start+SB->end, 1, event);
  }
  return 2;
}

static void scrollbar_update(gui_scrollbar_t *SB)
{
  scrollbar_compute_button(SB);
  scrollbar_draw_trough(SB);
  gfx_update(SB->tro_x, SB->tro_y, SB->tro_w, SB->tro_h);
}

static int scrollbar_set
    (gui_scrollbar_t *SB,double S, double E, int report, gfx_event_t* event)
{
  if (SB->start==S && SB->end==E) return 2;
  SB->start= S;
  SB->end= E;
  scrollbar_update(SB);
  if (!report) return 2;
  if (SB->action && event) 
  {
    event->type= SB->action;
    event->flo0= S;
    event->flo1= E;
    return 1;
  }
  if (SB->reportfunc)
    (*SB->reportfunc)(SB->reportarg, S, E);
  return 2;
}

static void scrollbar_set_noupdate
    (gui_scrollbar_t *SB,double S, double E, double step)
{
  SB->start= S;
  SB->end= E;
  SB->step= step;
  scrollbar_compute_button(SB);
}

static int scrollbar_click_down(void *A, gfx_event_t *E)
{
  gui_scrollbar_t *SB= A;
  scrollbar_draw_stepper(SB, 1, 1);
  gfx_update(SB->SX[1],SB->SY[1], SB->SW[2], SB->SH[2]);
  install_release_handler(A, scrollbar_release_down);
  return 2;
}

static int scrollbar_release_down(void *A, gfx_event_t *event)
{
  gui_scrollbar_t *SB= A;
  scrollbar_draw_stepper(SB, 1, 0);
  gfx_update(SB->SX[1],SB->SY[1], SB->SW[2], SB->SH[2]);
  if (SB->end<1.0)
  {
    double E;
    E= dmin2(1.0,SB->end + SB->step);
    return scrollbar_set(SB,E-SB->end+SB->start,E, 1, event);
  }
  return 2;
}

static int scrollbar_click_tro(void *A,gfx_event_t *event)
{
  gui_scrollbar_t *SB= A;
  double L,K, S, E;
  int C;

  if (SB->orient=='V') C= event->y; else C= event->x;
  if (C>=SB->but_c0 && C<=SB->but_c1)
  {
    install_release_handler(A, scrollbar_release_tro);
    install_motion_handler(A, scrollbar_move_pointer);
    SB->last_seen_c= C;
    return 2;
  }
  if (C<SB->tro_c0 || C>SB->tro_c1) return 0;
  C -= SB->tro_c0;
  L= SB->end - SB->start;

  K= (double) C / SB->tro_dc;
  S= K-L/2;
  E= S+L;

  if (S<0.0) { S= 0.0; E= S+L; }
  if (E>1.0) { E= 1.0; S= E-L;  }

  return scrollbar_set(SB,S,E,1,event);
}

static int scrollbar_move_pointer(void *A, gfx_event_t *event)
{
  gui_scrollbar_t *SB= A;
  int D;
  double L, S, E;
  int C;

  if (SB->orient=='V') C= event->y; else C= event->x;

  if (C>SB->tro_c1 || C<SB->tro_c0) return 2;

  D= C - SB->last_seen_c;
  if (D==0) return 2;

  SB->last_seen_c= C;
 
  L= SB->end - SB->start;
  if (D>0)
  {
    if (SB->end==1.0) return 2;
    E= dmin2(1.0,SB->end + (double) D / SB->tro_dc);
    S= E - L;
  } else {
    if (SB->start==0.0) return 2;
    S= dmax2(0.0, SB->start + (double) D / SB->tro_dc);
    E= S + L;
  }

  return scrollbar_set(SB, S,E, 1, event);
}

static int scrollbar_release_tro(void *A, gfx_event_t *E)
{
  uninstall_motion_handler();
  return 2;
}

#line 479 "/home/dodo/tmp/gfx-1.2/src/scrollbar.u"

static void scrollbar_relayout
   (gui_scrollbar_t *SB, int nx, int ny, int nw,int nh,
    double start, double end, double step)
{
  int resiz;
  resiz= 0;
  SB->start= dmin2(1.0,dmax2(0.0, start));
  SB->end= dmax2(0.0,dmin2(1.0,end));
  SB->step= step;
  if (step<0.0 || step>=1.0) SB->step= 0.1;

  if (nw!=SB->widget.w || nh!=SB->widget.h 
       || nx!=SB->widget.x
       || ny!=SB->widget.y)
  {
    SB->widget.w= nw;
    SB->widget.h= nh;
    SB->widget.x= nx;
    SB->widget.y= ny;
    resiz= 1;
  }

  if (resiz)
    scrollbar_position_buttons(SB,SB->widget.x,SB->widget.y,nw,nh);

  scrollbar_compute_trough(SB);
  scrollbar_compute_button(SB);
  scrollbar_draw_all(SB);

  if (resiz)
  {
    click_handlers[SB->ch0].x= SB->SX[0];
    click_handlers[SB->ch0].y= SB->SY[0];
    click_handlers[SB->ch0].w= SB->SW[0];
    click_handlers[SB->ch0].h= SB->SH[0];

    click_handlers[SB->ch1].x= SB->SX[1];
    click_handlers[SB->ch1].y= SB->SY[1];
    click_handlers[SB->ch1].w= SB->SW[1];
    click_handlers[SB->ch1].h= SB->SH[1];

    click_handlers[SB->ch2].x= SB->tro_x;
    click_handlers[SB->ch2].y= SB->tro_y;
    click_handlers[SB->ch2].w= SB->tro_w;
    click_handlers[SB->ch2].h= SB->tro_h;
  }
}

static void scrollbar_destroy(gui_scrollbar_t *SB)
{
  disable_click_handler(SB->ch0);
  disable_click_handler(SB->ch1);
  disable_click_handler(SB->ch2);
  free(SB);
}

static void disable_click_handler(int hno)
{
  if (hno>=0 && hno<n_click_handler)
  {
    click_handlers[hno].x= 0;
    click_handlers[hno].y= 0;
    click_handlers[hno].w= -1;
    click_handlers[hno].h= -1;
    click_handlers[hno].enabled= NULL;
    click_handlers[hno].func= NULL;
    click_handlers[hno].arg= NULL;
  }
}

#line 99 "/home/dodo/tmp/gfx-1.2/src/dropdown.u"

static void dropdown_render(dropdown_t *DD, int p,uint32_t *dst, int W,int H)
{
  char *text;
  int ix,iy, tx,ty;
  int tcw, tch, tsx, tsy, tw,th;
  int w,h; // W and H minus the border
  unsigned char *tdata;
#line 9905 "gfx.c"
  static const unsigned char GMdropd_but[]= {
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x7f,0xef,0xef,0xef,0xef,0xef,0xef,0xef,
    0x7f,0x00,0x00,0x01,0x9a,0xef,0xef,0xef,0xef,0xef,
    0x9a,0x01,0x00,0x00,0x00,0x06,0xb1,0xef,0xef,0xef,
    0xb1,0x06,0x00,0x00,0x00,0x00,0x00,0x0e,0xbb,0xef,
    0xbb,0x0e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x14,
    0xab,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  };
  static const unsigned int GMWdropd_but= 11, GMHdropd_but=7;
#line 109 "/home/dodo/tmp/gfx-1.2/src/dropdown.u"

  if (W<4 || H<4)
  {
    int i;
    // the border doesn't fit!
    for(i=0;i<W*H;i++) dst[i]= 0xffff0000;
    return ;
  }
  if (p)
    shadow_box(dst, W,H, dropdown_light2, dropdown_dark2, dropdown_border2,
                    0,0,W,H);
  else
    shadow_box(dst, W,H, dropdown_light1, dropdown_dark1, dropdown_border1,
                    0,0,W,H);
  w= W-4;
  h= H-4;
  if (w<=0 || h<=0) return ;
  if (p)
    gradfill_top(dst,W,H, dropdown_gradb2, dropdown_grade2, 2,2,w,h);
  else
    gradfill_top(dst,W,H, dropdown_gradb1, dropdown_grade1, 2,2,w,h);

  ix= W -2 -dropdown_pad_right -GMWdropd_but;
  iy= (h - GMHdropd_but)/2;
    // no space for button. in fact, the text won't fit here also
    // so we simply display an empty area.
  if (ix<2 || iy<2) return ;
  
  blend_graymap_buffer(0x00, 
              (unsigned char*) GMdropd_but, GMWdropd_but, GMHdropd_but, 0,0,
              dst, W,H, ix, iy+2, GMWdropd_but, GMHdropd_but);

  if (DD->selected<0 || DD->selected>=DD->n_items) return ;
  text= DD->items[DD->selected].str;
  if (!text || !text[0]) return ;

  get_text_data(1,text, &tw, &th, NULL, &tdata);

  tx= 2 + dropdown_pad_left;
  tsx= 0;
  tcw= imax2(0,imin2(tw, ix-dropdown_pad_mid-tx));
  if (tcw==0) goto done;

  ty= 2 + imax2( 0, (h-th)/2 );
  tsy= imax2(0, (th-h)/2); 
  tch= imin2(th, h);

  if (tch==0) goto done;

  blend_graymap_buffer(0x00, tdata, tw, th, tsx,tsy,
                             dst, W,H, tx, ty, tcw, tch);
done:
  free(tdata);
}

static int dropdown_click(void *arg, gfx_event_t* event)
{
  dropdown_t *DD= arg;
  if (event->type!=GFXEV_BUTTON_PRESS || event->button!=1) return 0;
  gfx_put(GFX_UPDATE, DD->img_pressed, DD->widget.w, DD->widget.h, 0,0,
                      DD->widget.x, DD->widget.y, DD->widget.w, DD->widget.h);
  install_release_handler(DD, dropdown_release);
  return 2;
}

static int dropdown_release(void *arg, gfx_event_t *event)
{
  dropdown_t *DD= arg;
  gfx_put(GFX_UPDATE, DD->img_normal, DD->widget.w, DD->widget.h, 0,0,
                      DD->widget.x, DD->widget.y, DD->widget.w, DD->widget.h);
  dropdown_show_list(DD);
  return 2;
}

#line 187 "/home/dodo/tmp/gfx-1.2/src/dropdown.u"

static void dropdown_show_list(dropdown_t *DD)
{
  if (DD->list_backup) { free(DD->list_backup); DD->list_backup= NULL; }

  DD->list_w= DD->widget.w;
  DD->list_x= DD->widget.x;

  DD->list_y= DD->widget.y + DD->widget.h;

  get_text_data(1,"M",NULL,&DD->fh,NULL,NULL);
  int ni;
  ni= imax2(DD->n_items, 1);
  DD->list_cont_h= dropdown_list_padv*2 + ni*DD->fh + (ni-1)*dropdown_list_spc;

  DD->posy= 0;
  if (DD->list_y+DD->list_cont_h+2<=x_window_height)
  {
    // no scrollbar needed
    DD->list_ph= DD->list_cont_h;
    DD->list_h= DD->list_ph+2;
    DD->list_pw= DD->list_w-2;
    DD->list_px= DD->list_x+1;
    DD->list_py= DD->list_y+1;

    if (DD->scroll) DD->scroll->enabled= 0;
    dropdown_get_list_backup(DD);
    dropdown_draw_listframe(DD,0xf);
  }
  else
  {
    DD->list_px= DD->list_x+1;
    DD->list_pw= DD->list_w - 1 - gui_scrollbar_width;
    DD->list_h= x_window_height - DD->list_y;
    if (DD->list_h<(DD->fh+dropdown_list_padv*2+2))
    {
      DD->list_y= DD->widget.y;
      DD->list_h= x_window_height - DD->list_y;
    }
    DD->list_ph= DD->list_h-2;
    DD->list_py= DD->list_y+1;
    if (DD->list_ph<=0) goto impossible;
    if (DD->selected!=-1)
    {
      DD->posy= dropdown_item_pos(DD,DD->selected) - DD->list_ph/2;
      if (DD->posy<0) DD->posy= 0;
      else if (DD->posy+DD->list_ph > DD->list_cont_h)
      {
        DD->posy= DD->list_cont_h - DD->list_ph;
        if (DD->posy<0) DD->posy= 0;
      }
    }
    dropdown_get_list_backup(DD);
     // scrollbar parameters
    int Sx, Sy, Sw, Sh;  
    double Sb, Se, Ss;

    Sx= DD->list_x+DD->list_w-gui_scrollbar_width;
    Sy= DD->list_y;
    Sw= gui_scrollbar_width;
    Sh= DD->list_h;
    Sb= (double)DD->posy/DD->list_cont_h;
    Se= (double)(DD->posy+DD->list_ph)/DD->list_cont_h;
    Ss= DD->list_ph*0.9/DD->list_cont_h;
    if (DD->scroll)
    {
      DD->scroll->enabled= 1;
      scrollbar_relayout(DD->scroll, Sx, Sy,Sw, Sh, Sb, Se, Ss);
    }
    else
    {
      DD->scroll= new_scrollbar(GFX_VERTICAL, Sx, Sy, Sw, Sh, Sb, Se, Ss,
                                 0, DD, dropdown_scroll);
    }
    dropdown_draw_listframe(DD,0xe);
  }
  dropdown_draw_listbg(DD);
  dropdown_draw_contents(DD);
  gfx_update(DD->list_x,DD->list_y,DD->list_w,DD->list_h);
  DD->selitem= -1;
  DD->but1clicked= 0;
  grab_mouse((void*)dropdown_mouse, DD);
  DD->click_enabled= 0;

impossible:
  return ; // FIXME
}

static void dropdown_draw_listbg(dropdown_t *DD)
{
  gfx_fill_rect(0,DD->list_px,DD->list_py,DD->list_pw,DD->list_ph, 0xffffffff);
}

static void dropdown_get_list_backup(dropdown_t *DD)
{
  if (DD->list_w<=0 || DD->list_h<=0) return ;
  DD->list_backup= get_server_pix(DD->list_x,DD->list_y,DD->list_w,DD->list_h);
}

static void dropdown_put_list_backup(dropdown_t *DD)
{
  if (!DD->list_backup || DD->list_w<=0 || DD->list_h<=0) return ;
  put_server_pix(DD->list_backup, DD->list_x,DD->list_y,DD->list_w,DD->list_h);
  free(DD->list_backup);
  DD->list_backup= NULL;
}

static void dropdown_draw_contents(dropdown_t *DD)
{
  int i,j,k;
  if (DD->n_items==0) return ;
  i= 0; 
  j= DD->n_items-1;
  while(i<=j)
  {
    k= (i+j)/2;
    switch(dropdown_draw_item(DD,k))
    {
     case 1: j= k-1; break;
     case 0: goto found;
     case -1: i= k+1; break;
    }
  }

  return;
found:
  for(i=k-1;i>=0;i--)         if (dropdown_draw_item(DD,i)) break;
  for(j=k+1;j<DD->n_items;j++) if (dropdown_draw_item(DD,j)) break;
}

static int dropdown_draw_item(dropdown_t *DD,int idx)
{
  int P;
  P= dropdown_item_pos(DD,idx);
  if (P>=DD->posy+DD->list_ph) return 1;
  if (P+DD->fh<DD->posy) return -1;
  print_clipped(DD->list_px,DD->list_py,DD->list_pw,DD->list_ph,
           DD->list_px, P-DD->posy+DD->list_py, 1, DD->items[idx].str); 
  return 0;
}

static void print_clipped(int Cx,int Cy,int Cw,int Ch,
                          int x, int y, int font, const char* str)
{
  unsigned char *tdata;
  int tw,th;

  int sx,sy, dx,dy, ow, oh;

  if (x>=Cx+Cw || y>=Cy+Ch || Cw<=0 || Ch<=0) return ;

  get_text_data(font, (char*) str,&tw,&th,NULL,&tdata);

  sx= 0; sy=0; dx= x; dy= y; ow= tw; oh= th;
  if (dx<Cx)
  {
    sx+= (Cx-dx);
    ow-= (Cx-dx);
    dx= Cx;
  }

  if (dy<Cy)
  {
    sy+= (Cy-dy);
    oh-= (Cy-dy);
    dy= Cy;
  }

  if (ow<=0 || oh<=0) goto done;

  if (dx+ow>Cx+Cw)
  {
    ow= (Cx+Cw-dx);
  }
  if (dy+oh>Cy+Ch)
  {
    oh= (Cy+Ch-dy);
  }
  if (ow<=0 || oh<=0) goto done;

  blend_graymap(0, 0xff000000, 0xffFFFFFF, tdata, tw,th, sx, sy, dx,dy,ow,oh);
done:
  free(tdata);
}

static int dropdown_item_pos(dropdown_t *DD,int item)
{
  return item*(dropdown_list_spc+DD->fh) + dropdown_list_padv;
}

static void dropdown_draw_listframe(dropdown_t *DD,int which)
{
  int l,r,t,b;
  l= DD->list_x;
  r= DD->list_x+DD->list_w-1;
  t= DD->list_y;
  b= DD->list_y+DD->list_h-1;
  if (which&1) vline(r, t,b, dropdown_list_border);
  if (which&2) vline(l, t,b, dropdown_list_border);
  if (which&4) hline(l, r,t, dropdown_list_border);
  if (which&8) hline(l, r,b, dropdown_list_border);
}

static void dropdown_scroll(dropdown_t *DD,double S,double E)
{
  dropdown_scroll_to(DD, DD->list_cont_h*S,0);
}

static int dropdown_mouse(dropdown_t *DD, gfx_event_t *event)
{
  switch(event->type)
  {
  case GFXEV_BUTTON_PRESS:
    switch(event->button)
    {
    case 1: 
      if (!in_rect(DD->list_x,DD->list_y,DD->list_w,DD->list_h,
           event->x,event->y))
      {
        DD->but1clicked= 1;
        DD->selitem= -1;
        return 2;
      }
      if (in_rect(DD->list_px,DD->list_py,DD->list_pw,DD->list_ph,
           event->x,event->y))
      {
        DD->but1clicked= 1;
        DD->selitem= dropdown_item_at(DD,event->y);
        dropdown_hilight_item(DD, DD->selitem);
        return 2;
      }
      return 0;
    case 4:
      dropdown_scroll_to(DD, DD->posy-0.9*DD->list_ph, 1);
      return 2;
    case 5:
      dropdown_scroll_to(DD, DD->posy+0.9*DD->list_ph, 1);
      return 2;
    }
    return 0;
  case GFXEV_BUTTON_RELEASE:
    if (event->button==1 && DD->but1clicked)
    {
      DD->but1clicked= 0;
      if (DD->selitem!=-1)
        DD->selected= DD->selitem;
      dropdown_hide_list(DD);
      ungrab_mouse();
      if (DD->selitem!=-1 && DD->action)
      {
        event->type= DD->action;
        event->key= DD->selitem;
        event->usr= DD->items[DD->selitem].ptr;
        DD->selitem= -1;
        return 1;
      }
      DD->selitem= -1;
      return 2;
    }
    return 0;
  }
  return 0;
}

static int in_rect(int rx,int ry,int rw,int rh, int x,int y)
{
  if (x<rx || y<ry || x>=(rx+rw) || y>=(ry+rh)) return 0;
  return 1;
}

static void dropdown_hide_list(dropdown_t *DD)
{
  dropdown_render_images(DD);
  dropdown_put_list_backup(DD);
  gfx_update(DD->list_x,DD->list_y,DD->list_w,DD->list_h);
  DD->click_enabled= 1;
  if (DD->scroll) DD->scroll->enabled= 0;
  gfx_put(GFX_UPDATE, DD->img_normal, DD->widget.w, DD->widget.h, 0,0,
                       DD->widget.x, DD->widget.y, DD->widget.w, DD->widget.h);
}

static void dropdown_render_images(dropdown_t *DD)
{
  int w,h;
  w= DD->widget.w; h= DD->widget.h;

  if (DD->img_normal) free(DD->img_normal);

  DD->img_normal= malloc(sizeof(uint32_t)*w*h);
  dropdown_render(DD, 0, DD->img_normal, w,h);

  if (DD->img_pressed) free(DD->img_pressed);

  DD->img_pressed= malloc(sizeof(uint32_t)*w*h);
  dropdown_render(DD, 1, DD->img_pressed, w,h);
}

static void dropdown_scroll_to(dropdown_t *DD,int pos,int report)
{
  if (pos<0) pos= 0;
  if (pos+DD->list_ph>DD->list_cont_h) pos= DD->list_cont_h-DD->list_ph;
  if (pos<0) pos= 0;
  if (DD->posy==pos) return ;
  
  DD->posy= pos;
  dropdown_draw_listbg(DD);
  dropdown_draw_contents(DD);
  if (report && DD->scroll) 
    scrollbar_set(DD->scroll, (double) DD->posy/DD->list_cont_h, 
                              (double) (DD->posy+DD->list_ph)/DD->list_cont_h, 
                              0, NULL);
  gfx_update(DD->list_x,DD->list_y,DD->list_w,DD->list_h);
}

static int dropdown_item_at(dropdown_t *DD,int y)
{
  int K;
  if (DD->n_items<=0) return -1;
  
  y= y - DD->list_py + DD->posy;
  if (y<DD->fh+dropdown_list_padv)
     K= 0;
  else
     K= (y-dropdown_list_padv+dropdown_list_spc)/(DD->fh+dropdown_list_spc);
  if (K>=DD->n_items) return -1;
  return K;
}

static void dropdown_hilight_item(dropdown_t *DD, int item)
{
  int x,y,w,h;

  if (item<0 || item>=DD->n_items) return ;
  x= DD->list_px;
  y= dropdown_item_pos(DD,item)-dropdown_list_spc+DD->list_py-DD->posy;
  w= DD->list_pw;
  h= DD->fh+dropdown_list_spc;
  fill_clipped_rect(DD->list_px, DD->list_py, DD->list_pw, DD->list_ph,
                    x,y,w,h, dropdown_list_hcolor);
  dropdown_draw_item(DD,item);
  gfx_update(x,y,w,h);
}

static void fill_clipped_rect
               (int Cx,int Cy,int Cw, int Ch, 
                int dx,int dy,int ow, int oh, unsigned int color)
{
  if (ow<=0 || oh<=0) return ;
  if (dx>=(Cx+Cw) || dy>=(Cy+Ch) || (dx+ow<=Cx) || (dy+oh<=Cy)) return ;

  if (dx<Cx)
  {
    ow-= (Cx-dx);
    dx= Cx;
  }

  if (dy<Cy)
  {
    oh-= (Cy-dy);
    dy= Cy;
  }
  if (ow<=0 || oh<=0) return ;

  if ((dy+oh)>=(Cy+Ch))
  {
    oh= Cy+Ch-dy;
  }
  if ((dx+ow)>=(Cx+Cw))
  {
    ow= Cx+Cw-dx;
  }
  if (ow<=0 || oh<=0) return ;
  gfx_fill_rect(0,dx,dy,ow,oh,color);
}

#line 636 "/home/dodo/tmp/gfx-1.2/src/dropdown.u"

static void dropdown_destroy(dropdown_t *DD)
{
  int i;
  if (DD->scroll)
     scrollbar_destroy(DD->scroll);
  freeNnull(DD->img_pressed);
  freeNnull(DD->img_normal);
  disable_click_handler(DD->click);
  freeNnull(DD->list_backup);

  for(i=0;i<DD->n_items;i++)
    free(DD->items[i].str);
  freeNnull(DD->items);
  free(DD);
}

#line 159 "/home/dodo/tmp/gfx-1.2/src/list.u"

static void compute_list_items
    (gui_list_t* LL, int start, int end)
{
  int tw,th;
  int i;

  start= imax2(0,start);
  end= imin2(end,LL->n_items-1);

  for(i=start;i<=end;i++)
  {
    TUPscip_t *item= LL->items+ i;
    gui_list_item_extra_t *ex= LL->extra+i;

    get_text_data(1, item->str, &tw, &th, NULL, NULL);
    if (LL->uses_icons)
      ex->text_x= gui_list_pad_horz+gui_list_icontext_sep + LL->max_icon_width;
    else
      ex->text_x= gui_list_pad_horz;

    ex->w= ex->text_x + tw + gui_list_pad_horz;

    if (LL->uses_icons&&item->icon_data)
    {
      ex->h= imax2(item->icon_height, th);
      ex->icon_y= (ex->h-item->icon_height)/2;
      ex->icon_x= (LL->max_icon_width-item->icon_width)/2 + gui_list_pad_horz;
    }
    else
    {
      ex->h= th;
    }
    ex->text_y= (ex->h-th)/2;

    ex->text_w= tw;
    ex->text_h= th;
  }
}

static void compute_list_content_size(gui_list_t *LL,int *Rw, int *Rh)
{
  int i;
  int w,h;
  w= h= 0;
  for(i=0;i<LL->n_items;i++)
  {
    h+= LL->extra[i].h;
    if (i>0 && i<LL->n_items-1) h+= gui_list_spacing;
    w= imax2(w, LL->extra[i].w);
  }
  h+= 2*gui_list_pad_horz;
  if (Rw) *Rw= w;
  if (Rh) *Rh= h;
}

static int list_max_icon_width(gui_list_t *LL)
{
  int i,w;
  w= 0;
  if (!LL->uses_icons) return 0;
  for(i=0;i<LL->n_items;i++)
    if (LL->items[i].icon_data)
      w= imax2(w, LL->items[i].icon_width);
  return w;
}

static void compute_list_port
  (gui_list_t* LL, int *Rportw, int *Rporth, int *Rhs, int *Rvs)
{
  int portw,porth, wA,wB, hA, hB;

  wA= LL->w - 2 ;
  wB= LL->w - 1 - gui_scrollbar_width;

  hA= LL->h - 2; 
  hB= LL->h - 1 - gui_scrollbar_height;

  portw= wA;
  porth= hA;
  if (portw<LL->content_w) porth= hB;
  if (porth<LL->content_h) portw= wB;
  if (portw<LL->content_w) porth= hB;
 
  if (Rportw) *Rportw= portw;
  if (Rporth) *Rporth= porth;
  if (Rhs)    *Rhs= (porth==hB);
  if (Rvs)    *Rvs= (portw==wB);
}

static int list_render_item(gui_list_t *LL,int ino,int bg)
{
  TUPscip_t *item= LL->items+ino;
  gui_list_item_extra_t *ex= LL->extra+ino;

  int src_x,src_y, copy_w, copy_h;
  unsigned char *tdata;
  
  int cW = item->icon_width,
      cH = item->icon_height,
      cX = ex->icon_x,
      cY = ex->icon_y + ex->y;

  int tW= ex->text_w,
      tH= ex->text_h,
      tX= ex->text_x,
      tY= ex->text_y + ex->y;

  int iX= 0,
      iY= ex->y,
      iW= ex->w,
      iH= ex->h;

  int sY= LL->posy, 
      sX= LL->posx,
      sW= LL->port_w,
      sH= LL->port_h;

  if ((iY+iH)<=sY)  return -1;
  if (iY>=(sY+sH))  return 1;

  if (item->iv || bg)
  {
    int bY= iY-sY+LL->port_y,
        bW= LL->port_w,
        bX= LL->port_x,
        bH= iH;
    int color;

    if (bY<LL->port_y) 
    {
      bH-= LL->port_y-bY;
      if (bH<=0) goto bg_done;
      bY= LL->port_y;
    }

    if ((bY+bH)>(LL->port_y+LL->port_h))
    {
      bH= (LL->port_y+LL->port_h) - bY;
      if (bH<=0) goto bg_done;
    }
    if (item->iv) color= 0xaabbff;
             else color= 0xffffff;
    gfx_fill_rect(0, bX, bY, bW, bH, color);
  }

bg_done:
  if (!LL->uses_icons || !item->icon_data) goto icon_done;

  src_x= 0;
  src_y= 0;
  copy_w= cW;
  copy_h= cH;

  if (cX<sX)
  {
    src_x += sX-cX;
    copy_w-= sX-cX;
    cX= sX;
  }

  if (cY<sY)
  {
    src_y+= sY-cY;
    copy_h-= sY-cY;
    cY= sY;
  }

  if ((cX+copy_w)>(sX+sW))
    copy_w-= (cX+copy_w) - (sX+sW);

  if ((cY+copy_h)>(sY+sH))
    copy_h-= (cY+copy_h) - (sY+sH);

    if (copy_w<=0) goto icon_done;
    if (copy_h<=0) goto icon_done;
  if (cY>=(sY+sH)) goto icon_done;
  if (cX>=(sX+sW)) goto icon_done;

  // now, cX and cY contain the document coordinates for copy.

  gfx_put(GFX_ALPHA, item->icon_data, cW, cH, src_x, src_y,
                                      cX-sX+LL->port_x, cY-sY+LL->port_y,
                                      copy_w, copy_h);
icon_done:
  src_x= 0;
  src_y= 0;
  copy_w= tW;
  copy_h= tH;

  if (tX<sX)
  {
    src_x += sX-tX;
    copy_w-= sX-tX;
    tX= sX;
  }

  if (tY<sY)
  {
    src_y += sY-tY;
    copy_h-= sY-tY;
    tY= sY;
  }

  if ((tX+copy_w)>(sX+sW))
  {
    copy_w -= (tX+copy_w)-(sX+sW);
  }
  if ((tY+copy_h)>(sY+sH))
  {
    copy_h -= (tY+copy_h)-(sY+sH);
  }

  if (copy_h<=0) goto text_done;
  if (copy_w<=0) goto text_done;
  if (tY>=(sY+sH)) goto text_done;
  if (tX>=(sX+sW)) goto text_done;

  get_text_data(1, item->str, NULL, NULL, NULL,&tdata);
  blend_graymap(0, 0x00, 0xffffff, tdata, tW, tH, src_x, src_y,
                             tX-sX+LL->port_x, tY-sY+LL->port_y,
                             copy_w, copy_h);
  free(tdata);

text_done:
  return 0;
}

#line 388 "/home/dodo/tmp/gfx-1.2/src/list.u"

static void gui_list_scrollbar_click_horz(void *a, double S, double E)
{
  int posx;
  gui_list_t *L;
  L= a;

  posx= S*L->content_w;
  if (posx+L->port_w>L->content_w)
    posx= L->content_w - L->port_w;
  if (posx<0) posx= 0;
  if (posx!=L->posx)
  {
    L->posx= posx;
    list_draw_contents(L);
    gfx_update(L->port_x,L->port_y,L->port_w,L->port_h);
  }
}

static void gui_list_scrollbar_click_vert(void *a, double S, double E)
{
  int posy;
  gui_list_t *L;
  L= a;

  posy= S*L->content_h;
  if (posy+L->port_h>L->content_h)
    posy= L->content_h - L->port_h;
  if (posy<0) posy= 0;
  if (posy!=L->posy)
  {
    L->posy= posy;
    list_draw_contents(L);
    gfx_update(L->port_x,L->port_y,L->port_w,L->port_h);
  }
}



#line 428 "/home/dodo/tmp/gfx-1.2/src/list.u"

static void list_layout_items(gui_list_t *LL,int start)
{
  int i,y;
  start= imax2(0,start);
  if (start==0) y= gui_list_pad_vert;
           else y= LL->extra[start-1].y+LL->extra[start-1].h+gui_list_spacing;
 
  for(i=start;i<LL->n_items;i++)
  {
    LL->extra[i].y= y;
    y+= LL->extra[i].h + gui_list_spacing;
  }
}

static void list_draw_borders(gui_list_t *LL,int which)
{
  int x,y,w,h;
  unsigned int border;
  x= LL->x; y= LL->y; w= LL->w; h= LL->h;

  border= color_u_to_s(gui_list_border);
  if (which & 8) hline(x, x+w-1, y, border);
  if (which & 2) hline(x, x+w-1, y+h-1, border);
  if (which & 4) vline(x, y, y+h-1, border);
  if (which & 1) vline(x+w-1, y, y+h-1, border);
}

static void list_draw_contents(gui_list_t *L)
{
  int i,j,k;
  gfx_fill_rect(0,L->port_x,L->port_y,L->port_w,L->port_h, 0xffffff);
  if (L->n_items==0) return ;
  i= 0; 
  j= L->n_items-1;
  while(i<=j)
  {
    k= (i+j)/2;
    switch(list_render_item(L,k,0))
    {
     case 1: j= k-1; break;
     case 0: goto found;
     case -1: i= k+1; break;
    }
  }

  return;
found:
  for(i=k-1;i>=0;i--)         if (list_render_item(L,i,0)) break;
  for(j=k+1;j<L->n_items;j++) if (list_render_item(L,j,0)) break;
}

static void list_compute_scroll
    (int pos,int win,int con, double *Rstart, double *Rend, double *Rstep)
{
  if (con<=0) con= 1;
  *Rstart=  dmax2(0.0,dmin2((double)pos/con,1.0));
  *Rend=    dmin2(1.0,dmax2((double)(pos+win)/con,0.0));
  *Rstep=   dmax2(0.0,dmin2(1.0,(double)win/con*0.9));
}

static void list_arrange_scrollbars
   (gui_list_t *LL, int have_horz, int have_vert)
{
  int ver_scroll_h, hor_scroll_w;
  double start,end,step;
  int changev,changeh;

  changev= changeh= 0;

  hor_scroll_w= LL->w;
  if (have_vert) hor_scroll_w-= gui_scrollbar_width;
  ver_scroll_h= LL->h;
  if (have_horz) ver_scroll_h-= gui_scrollbar_height;

  switch((have_vert ? 2: 0) | (LL->has_scrollv ?1:0))
  {
  case 0: break;
  case 1: list_draw_borders(LL, 1); break;
  case 3:
  case 2: 
    list_compute_scroll(LL->posy, LL->port_h, LL->content_h,
                        &start,&end,&step);
    if (LL->scrollv)
      scrollbar_relayout(LL->scrollv, 
                   LL->scrollv->widget.x, LL->scrollv->widget.y,
                   gui_scrollbar_width, ver_scroll_h, start, end,step);
    else
      LL->scrollv= 
        new_scrollbar(GFX_VERTICAL,
             LL->x+LL->w-gui_scrollbar_width, LL->y,
             gui_scrollbar_width, ver_scroll_h,
             start, end, step, 
             0, LL, gui_list_scrollbar_click_vert);
    LL->scrollv->enabled= 1;
    break;
  }

  switch( (have_horz?2:1)  | (LL->has_scrollh?1:0))
  {
  case 0: break;
  case 1: list_draw_borders(LL,2); break;
  case 3:
  case 2: 
    list_compute_scroll(LL->posx, LL->port_w, LL->content_w,
                        &start,&end,&step);
    if (LL->scrollh)
      scrollbar_relayout(LL->scrollh, 
                   LL->scrollh->widget.x, LL->scrollh->widget.y,
                   hor_scroll_w, gui_scrollbar_height, start,end,step);
    else 
      LL->scrollh= 
        new_scrollbar(GFX_HORIZONTAL,
             LL->x,LL->y+LL->h-gui_scrollbar_height,
             hor_scroll_w, gui_scrollbar_height,
             start, end, step, 
             0, LL, gui_list_scrollbar_click_horz);
    LL->scrollh->enabled= 1;
    break;
  }

  if (!have_vert && LL->scrollv) LL->scrollv->enabled= 0;
  if (!have_horz && LL->scrollh) LL->scrollh->enabled= 0;

  if (have_vert && have_horz)
  {
    if (!LL->has_scrollv || !LL->has_scrollh)
      gfx_fill_rect(0, LL->scrollh->widget.x+ LL->scrollh->widget.w,
                       LL->scrollv->widget.y+ LL->scrollv->widget.h,
                       gui_scrollbar_width, gui_scrollbar_height, 0xdddddd);
  }

  if (have_horz)
    gfx_update(LL->x,LL->scrollh->widget.y, LL->w, gui_scrollbar_height);
  if (have_vert)
    gfx_update(LL->scrollv->widget.x, LL->y, gui_scrollbar_width, LL->h);
  LL->has_scrollh= have_horz;
  LL->has_scrollv= have_vert;
}

#line 585 "/home/dodo/tmp/gfx-1.2/src/list.u"

static int gui_list_click(void *a, gfx_event_t *ev)
{
  int i,j,k;
  gui_list_t *L;
  int upd;
  
  L= a;
  if (L->click_action==0) return 0;
  i= 0; j= L->n_items-1;

  while(i<=j)
  {
    int iY, iH;
    k= (i+j)/2;
    iY= L->extra[k].y - L->posy + L->port_y; 
    iH= L->extra[k].h;

    if (ev->y<iY) { j= k-1; continue; } 
    if (ev->y>=(iY+iH)) { i= k+1; continue; }
    goto found;
  }
  return 0;
found:
  upd=1;
  if (!L->multiselect)
  {
    for(i=0;i<L->n_items;i++)
      if (i!=k && L->items[i].iv)
      {
        L->items[i].iv= 0;
        upd*= list_render_item(L, i, 1);
      }
    if (!L->items[k].iv)
    {
       L->items[k].iv= 1;
       upd*= list_render_item(L,k,1);
    }
  }
  else
  {
    L->items[k].iv= L->items[k].iv ? 0:1;
    list_render_item(L,k,1);
    upd= 0;
  }

  if (!upd)
    gfx_update(L->port_x,L->port_y,L->port_w,L->port_h);

  ev->type= L->click_action;
  ev->key= k;
  return 1;
}

 // mouse button 4: scroll up
static int gui_list_click4(void *a, gfx_event_t *ev)
{
  gui_list_t *L;
  int posy;
  L= a;

  posy= imax2(L->posy - L->port_h/2,0);
  if (posy!=L->posy)
  {
    L->posy= posy;
    list_draw_contents(L);
    if (L->has_scrollv) 
       scrollbar_set( L->scrollv,
                      (double) L->posy/L->content_h, 
                      (double)(L->posy+L->port_h)/L->content_h,
                      0, NULL );
    gfx_update(L->port_x,L->port_y,L->port_w,L->port_h);
  }
  return 2;
}

 // mouse button 5: scroll down
static int gui_list_click5(void *a, gfx_event_t *ev)
{
  gui_list_t *L;
  int posy;
  L= a;

  posy= imax2(0, imin2(L->posy + L->port_h/2, L->content_h - L->port_h));
  if (posy!=L->posy)
  {
    L->posy= posy;
    list_draw_contents(L);
    if (L->has_scrollv) 
       scrollbar_set( L->scrollv,
                      (double) L->posy/L->content_h, 
                      (double)(L->posy+L->port_h)/L->content_h,
                      0, NULL );
    gfx_update(L->port_x,L->port_y,L->port_w,L->port_h);
  }
  return 2;
}

#line 711 "/home/dodo/tmp/gfx-1.2/src/list.u"
static void list_relayout(int flags, gui_list_t *L)
{
  int hh, hv;
  compute_list_content_size(L, &L->content_w, &L->content_h);
  compute_list_port(L, &L->port_w, &L->port_h,&hh, &hv);

  L->posy= imax2(0, imin2(L->posy, L->content_h-L->port_h));
  L->posx= imax2(0, imin2(L->posx, L->content_w-L->port_w));

  list_arrange_scrollbars(L,hh,hv);
  click_handlers[L->ch0].w= L->port_w;
  click_handlers[L->ch1].w= L->port_w;
  click_handlers[L->ch2].w= L->port_w;

  click_handlers[L->ch0].h= L->port_h;
  click_handlers[L->ch1].h= L->port_h;
  click_handlers[L->ch2].h= L->port_h;

  list_draw_contents(L);

  if (flags&GFX_UPDATE)
    gfx_update(L->x,L->y,L->w,L->h);
}
 
#line 854 "/home/dodo/tmp/gfx-1.2/src/basics.u"

void gfx_geometry(unsigned int *W, unsigned int *H)
{
  if (W) *W= x_window_width;
  if (H) *H= x_window_height;
}


#line 95 "/home/dodo/tmp/gfx-1.2/src/graphics.u"

void gfx_get(unsigned int *buffer, int dst_w, int dst_h,
             int dst_x, int dst_y,
             int src_x, int src_y,
             int width, int height)
{
   int x,y;

   clip_for_rect( &src_x, &width, x_window_width);
   clip_for_rect( &src_y, &height, x_window_height);
   clip_for_rect( &dst_x, &width, dst_w);
   clip_for_rect( &dst_y, &height, dst_h);
   if (width<=0 || height<=0) return ;
   
   for(y=0;y<height;y++)
     for(x=0;x<width;x++)
     {
         uint32_t sP;
         uint32_t dR, dG, dB, dP;

         sP= x_image_data[y+src_y][x+src_x];

         dR= (sP & x_red_mask)>>x_red_shift;
         dG= (sP & x_green_mask)>>x_green_shift;
         dB= (sP & x_blue_mask)>>x_blue_shift;
 
         dP= (0xff<<24) | (dR<<16) | (dG<<8) | (dB);
         buffer[ (x+dst_x) + (y+dst_y)*dst_w ]= dP;
     }
}

#line 369 "/home/dodo/tmp/gfx-1.2/src/graphics.u"

void gfx_fill_rect(int flags, int dst_x,int dst_y,
                   int w,int h, unsigned int color)
{
  int x,y;
  uint32_t sv;
  clip_for_rect(&dst_x, &w, x_window_width);
  clip_for_rect(&dst_y, &h, x_window_height);
  if (w<=0 || h<=0) return ;
  sv= color_u_to_s(color);
  for(y=0;y<h;y++)
   for(x=0;x<w;x++)
     x_image_data[y+dst_y][x+dst_x]= sv;
  if (flags&GFX_UPDATE) gfx_update(dst_x, dst_y, w,h);
}


void gfx_draw_rect(int flags, int dst_x,int dst_y,
                   int w,int h, unsigned int color)
{
  uint32_t sv;
  sv= color_u_to_s(color);
  hline(dst_x, dst_x+w-1, dst_y, sv);
  hline(dst_x, dst_x+w-1, dst_y+h-1, sv);
  vline(dst_x, dst_y, dst_y+h-1, sv);
  vline(dst_x+w-1, dst_y, dst_y+h-1, sv);
  if (flags&GFX_UPDATE) gfx_update(dst_x, dst_y, w,h);
}
#line 512 "/home/dodo/tmp/gfx-1.2/src/graphics.u"

void gfx_put_graymap(int flags,
             unsigned char *buffer, int src_w, int src_h,
             int src_x, int src_y,
             int dst_x, int dst_y,
             int width, int height)
{
   int x,y;

   clip_for_rect( &src_x, &width, src_w);
   clip_for_rect( &src_y, &height, src_h);
   clip_for_rect( &dst_x, &width, x_window_width);
   clip_for_rect( &dst_y, &height, x_window_height);
   if (width<=0 || height<=0) return ;

   for(y=0;y<height;y++)
     for(x=0;x<width;x++)
     {
       uint8_t sP;
       uint32_t dP;
       sP= buffer[ (x+src_x) + (y+src_y)*src_w ];

       dP=  (sP << x_red_shift)&x_red_mask;
       dP|= (sP << x_green_shift)&x_green_mask;
       dP|= (sP << x_blue_shift)&x_blue_mask;

       x_image_data[y+dst_y][x+dst_x]= dP;
     }

   if (flags & GFX_UPDATE)
      gfx_update(dst_x,dst_y,width,height);
}

#line 546 "/home/dodo/tmp/gfx-1.2/src/graphics.u"

void gfx_put(int flags,
             unsigned int *buffer, int src_w, int src_h,
             int src_x, int src_y,
             int dst_x, int dst_y,
             int width, int height)
{
  int x,y;

  clip_for_rect( &src_x, &width, src_w);
  clip_for_rect( &src_y, &height, src_h);
  clip_for_rect( &dst_x, &width, x_window_width);
  clip_for_rect( &dst_y, &height, x_window_height);
  if (width<=0 || height<=0) return ;

  if (!(flags&GFX_ALPHA)) 
  {
    for(y=0;y<height;y++)
      for(x=0;x<width;x++)
      {
         uint32_t sR, sG, sB, sP;
         uint32_t dP;
         sP= buffer[ (x+src_x) + (y+src_y)*src_w ];
         sR= (sP >> 16)&0xff;
         sG= (sP >> 8 )&0xff;
         sB= (sP      )&0xff;

         dP= (sR << x_red_shift)&x_red_mask;
         dP|= (sG << x_green_shift)&x_green_mask;
         dP|= (sB << x_blue_shift)&x_blue_mask;

         x_image_data[y+dst_y][x+dst_x]= dP;
       }
  }
  else
  {
    for(y=0;y<height;y++)
      for(x=0;x<width;x++)
    {
        uint32_t sA, sR, sG, sB, sP;
        uint32_t     dR, dG, dB, dP;

        sP= buffer[ (x+src_x) + (y+src_y)*src_w ];
        sA= (sP >> 24)&0xff;
        if (!sA) continue;

        sR= (sP >> 16)&0xff;
        sG= (sP >> 8 )&0xff;
        sB= (sP      )&0xff;

        if (sA==0xff)
        {
           dR= sR;
           dG= sG;
           dB= sB;
        }
        else 
        {
            double R,V;

            dP= x_image_data[y+dst_y][x+dst_x];

            dR= (dP & x_red_mask)>>x_red_shift;
            dG= (dP & x_green_mask)>>x_green_shift;
            dB= (dP & x_blue_mask)>>x_blue_shift;

            V= sA/255.0; R= 1.0 - V;

            dR=  dR*R + sR*V;
            dG=  dG*R + sG*V;
            dB=  dB*R + sB*V;
         }

         dP= (dR << x_red_shift)&x_red_mask;
         dP|= (dG << x_green_shift)&x_green_mask;
         dP|= (dB << x_blue_shift)&x_blue_mask;

         x_image_data[y+dst_y][x+dst_x]= dP;
     }
  }

  if (flags & GFX_UPDATE)
      gfx_update(dst_x,dst_y,width,height);
}

#line 30 "/home/dodo/tmp/gfx-1.2/src/text.u"

void gfx_text_size(int font, char *str, int *W, int *H)
{
  get_text_data(font, str, W, H, NULL, NULL);
}

void gfx_print(int flags, int font, int fg, int bg, int x, int y, 
               char *str,int *Rw, int *Rh)
{
  int w,h; unsigned char *data;
  get_text_data(font, str, &w, &h, NULL, &data);

  blend_graymap(flags, fg, bg, data, w,h, 0,0, x,y,w,h);
  if (data) free(data);
  if (Rw) *Rw= w;
  if (Rh) *Rh= h;
}

#line 81 "/home/dodo/tmp/gfx-1.2/src/button.u"

int gfx_button(int flags,int x,int y, int w, int h, char *str, int action)
{
  int tw,th; unsigned char *data;
  int bno;
  gui_button_t *B;

  B= calloc(1,sizeof(*B));
  bno= register_widget(B,GFXCLASS_BUTTON,x,y,w,h);
  B->action= action;
  B->state= 0;

  B->pic[2]= get_server_pix(x,y,w,h);

  get_text_data(1, str, &tw, &th, NULL, &data);

  button_render(x,y,w,h, tw, th, data, 
                button_grad3, button_grad4, 
                button_dark, button_light);

  B->pic[1]= get_server_pix(x,y,w,h);
  
  button_render(x,y,w,h, tw, th, data, 
                button_grad1, button_grad2, 
                button_light, button_dark);

  B->pic[0]= get_server_pix(x,y,w,h);
  B->enabled= 1;

  free(data);

  if (flags&GFX_UPDATE)
    gfx_update(x,y,w,h);

  install_click_handler(x,y,w,h, &B->enabled, B, gui_button_click);
  return bno;
}


#line 134 "/home/dodo/tmp/gfx-1.2/src/button.u"

void gfx_button_enable(int btn,int a)
{
  gui_button_t *B;
  if ((B= get_widget(btn, GFXCLASS_BUTTON)))
     button_set_state(B, a ? 0 : 2);
}

#line 65 "/home/dodo/tmp/gfx-1.2/src/label.u"

int gfx_label(int flags, int font, int fg, int bg,
              int x,int y, int w, int h, char *str)
{
  gui_label_t *G;
  int R;
  labels= grow_array(n_labels, &s_labels, labels, sizeof(labels[0]));
  G= labels + n_labels;
  R= n_labels;
  n_labels++;
  G->font= font;
  G->fg= fg;
  G->bg= bg;
  G->x= x;
  G->y= y;
  G->w= w;
  G->h= h;
  G->flags= (GFX_JUST_RIGHT | GFX_JUST_CENTER | GFX_CUT_LEFT) & flags;
  draw_label(flags,G, str);
  return R;
}

void gfx_label_set_text(int flags,int labno, char *str)
{
  if (labno<0 || labno>=n_labels) return ;
  draw_label(flags, labels + labno,str);
}
#line 23 "/home/dodo/tmp/gfx-1.2/src/recsel.u"

void gfx_recsel_begin(int x,int y,int cox,int coy,int cow,int coh)
{
  recselpt[0].x= x;
  recselpt[0].y= y;
  recselpt[1]= recselpt[0];
  recsel= 1;

  if (x<0 || x>=x_window_width) x= 0;
  if (y<0 || y>=x_window_height) y= 0;
  if (cow<0) cow= x_window_width - cox;
  if (coh<0) coh= x_window_height - coy;
  recselpt[2].x= cox;       recselpt[2].y= coy;
  recselpt[3].x= cox+cow-1; recselpt[3].y= coy+coh-1;
}

void gfx_recsel_end(int flags,int *Rx1, int *Ry1, int *Rx2, int *Ry2)
{
  int minx,miny,maxx,maxy,Z;

  draw_recsel();
  minx= imin2( recselpt[0].x, recselpt[1].x);
  maxx= imax2( recselpt[0].x, recselpt[1].x);
  miny= imin2( recselpt[0].y, recselpt[1].y);
  maxy= imax2( recselpt[0].y, recselpt[1].y);
  gfx_update(minx, miny, maxx-minx+1, maxy-miny+1);

  Rx1= Rx1 ? Rx1 : &Z;
  Ry1= Ry1 ? Ry1 : &Z;
  Rx2= Rx2 ? Rx2 : &Z;
  Ry2= Ry2 ? Ry2 : &Z;

  if (flags & GFX_ORDER)
  {
    *Rx1= minx; *Rx2= maxx;
    *Ry1= miny; *Ry2= maxy;
  }
  else
  {
    *Rx1= recselpt[0].x;
    *Ry1= recselpt[0].y;
    *Rx2= recselpt[1].x;
    *Ry2= recselpt[1].y;
  }
  recsel= 0;
}

#line 88 "/home/dodo/tmp/gfx-1.2/src/textentry.u"

int gfx_text_entry(int flags, int x, int y, int w, int h, char *initstr)
{
  text_entry_t *te;
  te= text_entry_init(flags, x,y,w,h, initstr);
  return register_widget(te, GFXCLASS_TEXTENTRY,x,y,w,h);
}


#line 270 "/home/dodo/tmp/gfx-1.2/src/textentry.u"

char *gfx_text_entry_get(int no)
{
  text_entry_t *te;
  uint32_t *wide, widelen;
  uint8_t *str;
  int i;
  size_t slen;

  te= get_widget(no, GFXCLASS_TEXTENTRY);
  if (!te) return strdup("");

  widelen= te->len;
  wide= malloc(sizeof(uint32_t)*widelen);
  for(i=0;i<te->len;i++)
    wide[i]= te->glyphs[i].chr;

  str= malloc(widelen+1);
  utf8_encode_string(wide, widelen, str, &slen);
  if (slen) str[slen-1]= 0; // eat up the space we added
  free(wide);
  return (char*) str;
}

#line 343 "/home/dodo/tmp/gfx-1.2/src/textentry.u"

void gfx_text_entry_set(int flags, int no, char *str)
{
  text_entry_t *te;
  te= get_widget(no, GFXCLASS_TEXTENTRY);
  if (!te) return ;
  text_entry_set(flags, te, str);
}

#line 419 "/home/dodo/tmp/gfx-1.2/src/scrollbar.u"

int gfx_scrollbar(int flags, int x,int y, int w,int h, 
                  double start, double end, double step,int action)
{
  gui_scrollbar_t *SB;
  SB= new_scrollbar(flags, x,y,w,h, 
                    start, end, step, action, NULL, NULL);
  SB->widget.destroy= (void*) scrollbar_destroy;
  return register_widget(SB, GFXCLASS_SCROLLBAR, x,y,w,h);
}

void gfx_scrollbar_set(int flags, int wno,
                       double start, double end, double step)
{
  gui_scrollbar_t *SB;
  SB= get_widget(wno, GFXCLASS_SCROLLBAR);
  if (!SB) return ;
  SB->start= dmin2(1.0,dmax2(0.0, start));
  SB->end=   dmax2(SB->start+0.000001,dmin2(1.0,dmax2(0.0, end)));
  SB->step=  dmin2(1.0,dmax2(0.0,step));
  if (flags&GFX_UPDATE) scrollbar_update(SB);
                else    scrollbar_compute_button(SB);
}

#line 39 "/home/dodo/tmp/gfx-1.2/src/dropdown.u"

int gfx_dropdown(int x,int y,int w,int h,int action)
{
  dropdown_t *DD;
  DD= calloc(1,sizeof(*DD));
  DD->selected= -1;
  DD->click= -1;
  DD->action= action;
  DD->widget.destroy= (void*) dropdown_destroy;
  return register_widget(DD, GFXCLASS_DROPDOWN, x,y,w,h);
}

void gfx_dropdown_show(int wno,int show)
{
  dropdown_t *DD;
  if (!(DD=get_widget(wno,GFXCLASS_DROPDOWN))) return ;
  show= show?1:0;
  if (show==DD->shown) return ;
  if (show)
  {
    if (!DD->img_normal)
    {
      dropdown_render_images(DD);
    }
    if (DD->click==-1)
      DD->click= install_click_handler(DD->widget.x,DD->widget.y,
                           DD->widget.w,DD->widget.h,
                           &DD->click_enabled, DD, dropdown_click);
    DD->click_enabled= 1;
    gfx_put(GFX_UPDATE, DD->img_normal, DD->widget.w, DD->widget.h, 0,0,
                        DD->widget.x, DD->widget.y, DD->widget.w, DD->widget.h);
  }

  DD->shown= show;
}

#line 566 "/home/dodo/tmp/gfx-1.2/src/dropdown.u"

void gfx_dropdown_insert(int wno, int pos, const char *str, void *usr)
{
  dropdown_t* DD;
  TUPsp_t *src, *dst;
  int i;
  
  if (!(DD=get_widget(wno,GFXCLASS_DROPDOWN))) return ;
  if (pos<0 || pos>DD->n_items) pos= DD->n_items;
  src= DD->items;
  if (DD->n_items==DD->s_items)
  {
    if (DD->s_items==0) DD->s_items= 10;
    else DD->s_items+= DD->s_items/2;
    DD->items= dst= malloc(DD->s_items*sizeof(DD->items[0]));
  }
  else dst= DD->items;

  if (src)
  {
    for(i=DD->n_items;i>pos;i--) dst[i]= src[i-1];
    if (src!=dst)
      for(i=0;i<pos;i++) dst[i]= src[i];
    if (src!=dst) free(src);
  }
  dst[pos].str= strdup(str);
  dst[pos].ptr= usr;
  DD->n_items++;
  if (pos<=DD->selected) DD->selected++;
}

int gfx_dropdown_remove(int wno, int pos, void **Rusr)
{
  dropdown_t* DD;
  TUPsp_t *src, *dst;
  int i;
  
  if (!(DD=get_widget(wno,GFXCLASS_DROPDOWN))) return 0;
  if (DD->n_items==0) return 0; 
  if (pos<0 || pos>=DD->n_items) pos= DD->n_items-1;
  if (Rusr) *Rusr= DD->items[pos].ptr;
  // actually, the string is always gotten from strdup, if is unncessary
  if (DD->items[pos].str) free(DD->items[pos].str); 
  for(i=pos;i<DD->n_items-1;i++)
    DD->items[i]= DD->items[i+1];
  if (pos==DD->selected) DD->selected= -1;
  else if (pos<DD->selected) DD->selected--;
  DD->n_items--;
  return 1;
}

void gfx_dropdown_select(int wno, int pos)
{
  dropdown_t* DD;
  
  if (!(DD=get_widget(wno,GFXCLASS_DROPDOWN))) return ;
  if (pos<0 || pos>=DD->n_items) pos= -1;
  if (DD->selected==pos) return ;
  DD->selected= pos;
  dropdown_render_images(DD);

  if (DD->shown)
    gfx_put(GFX_UPDATE, DD->img_normal, DD->widget.w, DD->widget.h, 0,0,
                        DD->widget.x, DD->widget.y, DD->widget.w, DD->widget.h);
}

#line 657 "/home/dodo/tmp/gfx-1.2/src/dropdown.u"

int gfx_dropdown_selected(int wno)
{
  dropdown_t* DD;
  if (!(DD=get_widget(wno,GFXCLASS_DROPDOWN))) return -1;
  return DD->selected;
}

int gfx_dropdown_get(int wno, int pos, char **Rstr, void **Rusr)
{
  dropdown_t* DD;
  if (!(DD=get_widget(wno,GFXCLASS_DROPDOWN))) return 0;
  if (pos<0 || pos>=DD->n_items) return 0;
  if (Rstr) *Rstr= DD->items[pos].str;
  if (Rusr) *Rusr= DD->items[pos].ptr;
  return 1;
}


#line 28 "/home/dodo/tmp/gfx-1.2/src/menu-fw.u"

int gfx_fwmenu(int font,int nentries, TUPiis_t *entries)
{
  int i;
  int R;
  int maxtextw;
  int texth,fonth;

  int maxwindoww, maxwindowh,my,dy,window_x,window_y,window_w,window_h;

  if (nentries<=0) return -1;

#line 11460 "gfx.c"
  static const unsigned char GMfwmenu_sub[]= {
    0x61,0x3c,0x00,0x00,0x00,0x00,0x4b,0x80,0x48,0x00,
    0x00,0x00,0x00,0x41,0x80,0x51,0x02,0x00,0x00,0x00,
    0x36,0x7f,0x59,0x04,0x00,0x00,0x00,0x2c,0x7d,0x56,
    0x00,0x00,0x00,0x2c,0x7d,0x5c,0x00,0x00,0x36,0x7f,
    0x60,0x07,0x00,0x41,0x80,0x56,0x03,0x00,0x48,0x80,
    0x4b,0x01,0x00,0x00,0x60,0x3e,0x00,0x00,0x00,0x00,
  };
  static const unsigned int GMWfwmenu_sub= 6, GMHfwmenu_sub=10;
#line 42 "/home/dodo/tmp/gfx-1.2/src/menu-fw.u"

  maxtextw= 0;
  texth= 0;
  for(i=0;i<nentries;i++)
  {
    int w,h;
    gfx_text_size(font,entries[i].sv,&w,&h);
    maxtextw= imax2(w, maxtextw);
    texth+= h;
    fonth= h;
  }

  maxwindoww= x_window_width - 2*fwmenu_scrpad;
  maxwindowh= x_window_height - 2*fwmenu_scrpad;

  unsigned int *img, img_w, img_h;

  img_w= imin2(maxwindoww, maxtextw+GMWfwmenu_sub+1+2*fwmenu_intpad);
  img_h= texth+nentries-1;
  img= malloc(img_w*img_h*sizeof(uint32_t));

  for(i=0;i<img_w*img_h;i++) img[i]= fwmenu_bg_color;

  int y;
  y= 0;
  for(i=0;i<nentries;i++)
  {
    unsigned char *line; int linew, lineh;
    int cp_w;

    get_text_data(font, entries[i].sv, &linew,&lineh,NULL,&line);

    cp_w= imin2(img_w - 2*fwmenu_intpad- GMWfwmenu_sub-1, linew);

    blend_graymap_buffer(fwmenu_fg_color, line, linew,lineh, 0,0,
                         img, img_w, img_h, fwmenu_intpad, y, cp_w, lineh);

    free(line);
    if (entries[i].iv2)
      blend_graymap_buffer(fwmenu_fg_color, 
                    (unsigned char*) GMfwmenu_sub, GMWfwmenu_sub,
                                            GMHfwmenu_sub, 0,0,
                         img, img_w, img_h,
                         img_w - fwmenu_intpad - GMWfwmenu_sub, 
                         y + (lineh-GMHfwmenu_sub)/2, 
                            GMWfwmenu_sub, GMHfwmenu_sub);
    y+= lineh;
    hline_buffer(img, img_w,img_h, fwmenu_intpad, img_w-fwmenu_intpad,y,
                            fwmenu_sep_color);
    y+= 1;
  }

  window_w= img_w;
  window_h= imin2(maxwindowh, img_h);

  window_x= (x_window_width - window_w)/2;
  window_y= (x_window_height - window_h)/2;

  int pos, dirty, dragging, down;
  gfx_event_t event;
  uint32_t *backstore;

  R= -1;
  down= dragging= 0; dirty= 1;
  pos= 0;

  backstore= get_server_pix(window_x-2,window_y-2,window_w+4,window_h+4);

  gfx_draw_rect(0,window_x-1,window_y-1,window_w+2,window_h+2, 0x888888);
  gfx_draw_rect(GFX_UPDATE,window_x-2,window_y-2,window_w+4,window_h+4, 0x00);

  while(1)
  {
    if (dirty)
    {
     gfx_put(GFX_UPDATE, img, img_w, img_h,
                         0, pos, window_x, window_y,
                        img_w, window_h);
                         
     dirty= 0;
    }
    if (!event_noprocess(NULL,&event)) continue;
#if 0
   char buf[2000];
#endif
    switch(event.type)
    {
    case GFXEV_BUTTON_PRESS:
#if 0
    sprintf(buf,"event: %d,%d window: %d,%d - %dx%d",event.x, event.y,
                           window_x,window_y, window_w,window_h);
     gfx_print(GFX_UPDATE,2, 0x00, 0xffffff, 20,300, buf,NULL,NULL);
#endif
        if (event.button!=1) continue;
        if (event.x<window_x || event.x>=(window_x+window_w) ||
            event.y<window_y || event.y>=(window_y+window_h)) goto cancelled;
        my= event.y;
        down= 1;
        dragging= 0;
        break;
    case GFXEV_BUTTON_RELEASE:
        if (event.button!=1) continue;
        down= 0;
        if (dragging)
        {
          dragging= 0;
          break;
        }
        R= (my - window_y + pos)/(fonth+1);
        goto done;
    case GFXEV_POINTER_MOVE:
        if (!down || window_h>=img_h) break;
        if (!dragging)
        {
          if (abs(event.y-my)<=20) break;
          dragging= 1;
        }
        dy= event.y - my;
        if (!dy) break;
        my= event.y;
        if (dy<0) {  // dragging finger upwards
          if (pos+window_h>=img_h) break;
          pos -= dy; 
          if (pos+window_h>img_h) pos= img_h-window_h;
        } else
        {
          if (pos==0) break;
          pos-= dy;
          if (pos<0) pos= 0;
        }
        dirty= 1;
        break;
    }
  }

cancelled:

  R= -1;
  while(1)
  {
    if (!event_noprocess(NULL,&event)) continue;
    switch(event.type)
    {
    case GFXEV_BUTTON_RELEASE:
        if (event.button==1) goto done;
    }
  }

done:
  free(img);
  put_server_pix(backstore, window_x-2,window_y-2,window_w+4,window_h+4);
  free(backstore);
  gfx_update(window_x-2,window_y-2,window_w+4,window_h+4);
  if (R>=0 && R<nentries)
     return entries[R].iv1; 
  else return -1;
}
#line 31 "/home/dodo/tmp/gfx-1.2/src/screen.u"

int gfx_push_screen()
{
  screen_t *SC;
  int R;
  screens= grow_array(n_screen, &s_screen, screens, sizeof(screens[0]));
  SC= screens+n_screen;
  R= n_screen;
  n_screen++;

  SC->n_gui_widget= n_gui_widget;
  SC->n_click_handler= n_click_handler;
  SC->click_handler_start= click_handler_start;
  SC->release_handler= release_handler;
  SC->motion_handler= motion_handler;

  SC->backstore= get_server_pix(0,0,x_window_width,x_window_height);
  SC->backw= x_window_width;
  SC->backh= x_window_height;

  click_handler_start= n_click_handler;
  memset(&release_handler,0,sizeof(release_handler));
  memset(&motion_handler,0,sizeof(motion_handler));

  return R;
}

void gfx_restore_screen(int sn)
{
  int i;
  screen_t *SC;
  if (sn<0 || sn>=n_screen) return ;
  
  SC= screens+sn;

  for(i=SC->n_gui_widget;i<n_gui_widget;i++)
    widget_destroy(i);
  n_gui_widget= SC->n_gui_widget;
  n_click_handler= SC->n_click_handler;
  click_handler_start= SC->click_handler_start;
  release_handler= SC->release_handler;
  motion_handler= SC->motion_handler;
  
  put_server_pix(SC->backstore, 0,0,SC->backw,SC->backh);
  gfx_update(0,0,x_window_width,x_window_height);
  for(i=sn;i<n_screen;i++)
  {
    free(screens[i].backstore);
    memset(screens+i, 0, sizeof(screens[i]));
  }
  n_screen= sn;
}
#line 88 "/home/dodo/tmp/gfx-1.2/src/list.u"

int gfx_list(int flags, int x,int y,int w,int h, 
                int n_items, TUPscip_t *items, int click_action)
{
  gui_list_t *LL;
  int R;

  LL= calloc(1,sizeof(*LL));

  LL->x= x; LL->y= y; LL->w= w; LL->h= h;
  LL->items= items;
  LL->n_items= n_items;

  LL->s_extra= imax2(n_items + n_items/3,10);
  LL->extra= malloc(sizeof(LL->extra[0])*LL->s_extra);

  LL->posx= 0;
  LL->posy= 0;
  LL->enabled= 1;
  if (flags&GFX_NOICON)
    LL->uses_icons= 0;
  else
    LL->uses_icons= 1;
  LL->click_action= click_action;

  if (flags&GFX_MULTISELECT)
    LL->multiselect= 1;
  else
    LL->multiselect= 0;

  LL->port_x= LL->x+1;
  LL->port_y= LL->y+1;

  LL->max_icon_width= list_max_icon_width(LL);
  compute_list_items(LL, 0, n_items-1);
  compute_list_content_size(LL, &LL->content_w, &LL->content_h);

  int hv,hh;
  compute_list_port(LL, &LL->port_w, &LL->port_h, &hh, &hv);

  list_layout_items(LL,0);
  list_draw_borders(LL, 0xf);
  list_arrange_scrollbars(LL, hh, hv);
  list_draw_contents(LL);

  if (flags&GFX_UPDATE)
    gfx_update(LL->x,LL->y,LL->w,LL->h);

  LL->ch0= install_click_handler(LL->port_x,LL->port_y,LL->port_w,LL->port_h,
                                 &LL->enabled, LL, gui_list_click);
  LL->ch1= install_click2_handler(LL->port_x,LL->port_y,LL->port_w,LL->port_h,
                                 &LL->enabled, LL, gui_list_click4, 4);
  LL->ch2= install_click2_handler(LL->port_x,LL->port_y,LL->port_w,LL->port_h,
                                 &LL->enabled, LL, gui_list_click5, 5);
  return register_widget(LL, GFXCLASS_LIST, LL->x, LL->y, LL->w, LL->h);
}

#line 569 "/home/dodo/tmp/gfx-1.2/src/list.u"

void gfx_list_redraw(int widget, int item)
{
  gui_list_t *L;
  L= get_widget(widget, GFXCLASS_LIST);
  if (L) list_render_item(L, item,1);
}

void gfx_list_update_screen(int widget)
{
  gui_list_t *L;
  L= get_widget(widget, GFXCLASS_LIST);
  if (L) gfx_update(L->x,L->y,L->w,L->h);
}

#line 687 "/home/dodo/tmp/gfx-1.2/src/list.u"

void gfx_list_delete(int flags, int widget, int pos, int N)
{
  gui_list_t *L;
  int cp;

  if (N<=0 || pos<0) return ;
  L= get_widget(widget, GFXCLASS_LIST);
  if (!L || pos>=L->n_items) return ;

  N= imin2(N, L->n_items - pos);

  cp= L->n_items - pos - N;
  if (cp)
    memmove(L->extra+pos, L->extra+pos+N, cp*sizeof(L->extra[0]));

  L->n_items-= N;

  if (pos<L->n_items)
    list_layout_items(L, pos);
  list_relayout(flags,L);
}

#line 736 "/home/dodo/tmp/gfx-1.2/src/list.u"

void gfx_list_insert(int flags,int widget, TUPscip_t *items, int pos, int N)
{
  gui_list_t *L;
  int cp;

  if (N<=0 || pos<0) return ;
  L= get_widget(widget, GFXCLASS_LIST);
  if (!L || pos>L->n_items) return ;

  cp= L->n_items - pos;
  if (cp)
    memmove(L->extra+pos+N, L->extra+pos, cp*sizeof(L->extra[0]));

  L->n_items+= N;
  if (items) L->items= items;

  L->max_icon_width= list_max_icon_width(L);
  compute_list_items(L, pos, pos+N-1);
  list_layout_items(L, pos);
  list_relayout(flags,L);
}

void gfx_list_replace(int flags, int widget, int pos, int N)
{
  gui_list_t *L;
  int cp;

  if (N<=0 || pos<0) return ;
  L= get_widget(widget, GFXCLASS_LIST);
  if (!L || pos>=L->n_items) return ;
  L->max_icon_width= list_max_icon_width(L);
  compute_list_items(L, pos, pos+N-1);
  list_layout_items(L, pos);
  list_relayout(flags,L);
}
#line 825 "/home/dodo/tmp/gfx-1.2/src/basics.u"


